// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `CatalogData.ice'

#include <Freeze/CatalogData.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

bool
Freeze::CatalogData::operator==(const CatalogData& __rhs) const
{
    return !operator!=(__rhs);
}

bool
Freeze::CatalogData::operator!=(const CatalogData& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(evictor != __rhs.evictor)
    {
        return true;
    }
    if(key != __rhs.key)
    {
        return true;
    }
    if(value != __rhs.value)
    {
        return true;
    }
    return false;
}

bool
Freeze::CatalogData::operator<(const CatalogData& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(evictor < __rhs.evictor)
    {
        return true;
    }
    else if(__rhs.evictor < evictor)
    {
        return false;
    }
    if(key < __rhs.key)
    {
        return true;
    }
    else if(__rhs.key < key)
    {
        return false;
    }
    if(value < __rhs.value)
    {
        return true;
    }
    else if(__rhs.value < value)
    {
        return false;
    }
    return false;
}

void
Freeze::CatalogData::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(evictor);
    __os->write(key);
    __os->write(value);
}

void
Freeze::CatalogData::__read(::IceInternal::BasicStream* __is)
{
    __is->read(evictor);
    __is->read(key);
    __is->read(value);
}
