// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `Evictor.ice'

#include <Freeze/Evictor.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __Freeze__ServantInitializer__initialize_name = "initialize";

static const ::std::string __Freeze__EvictorIterator__hasNext_name = "hasNext";

static const ::std::string __Freeze__EvictorIterator__next_name = "next";

static const ::std::string __Freeze__Evictor__setSize_name = "setSize";

static const ::std::string __Freeze__Evictor__getSize_name = "getSize";

static const ::std::string __Freeze__Evictor__add_name = "add";

static const ::std::string __Freeze__Evictor__addFacet_name = "addFacet";

static const ::std::string __Freeze__Evictor__remove_name = "remove";

static const ::std::string __Freeze__Evictor__removeFacet_name = "removeFacet";

static const ::std::string __Freeze__Evictor__keep_name = "keep";

static const ::std::string __Freeze__Evictor__keepFacet_name = "keepFacet";

static const ::std::string __Freeze__Evictor__release_name = "release";

static const ::std::string __Freeze__Evictor__releaseFacet_name = "releaseFacet";

static const ::std::string __Freeze__Evictor__hasObject_name = "hasObject";

static const ::std::string __Freeze__Evictor__hasFacet_name = "hasFacet";

static const ::std::string __Freeze__Evictor__getIterator_name = "getIterator";

void
IceInternal::incRef(::Freeze::ServantInitializer* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::Freeze::ServantInitializer* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::Freeze::EvictorIterator* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::Freeze::EvictorIterator* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::Freeze::Evictor* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::Freeze::Evictor* p)
{
    p->__decRef();
}

Freeze::NoSuchElementException::NoSuchElementException(const char* __file, int __line) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    LocalException(__file, __line)
#else
    ::Ice::LocalException(__file, __line)
#endif
{
}

Freeze::NoSuchElementException::~NoSuchElementException() throw()
{
}

static const char* __Freeze__NoSuchElementException_name = "Freeze::NoSuchElementException";

::std::string
Freeze::NoSuchElementException::ice_name() const
{
    return __Freeze__NoSuchElementException_name;
}

::Ice::Exception*
Freeze::NoSuchElementException::ice_clone() const
{
    return new NoSuchElementException(*this);
}

void
Freeze::NoSuchElementException::ice_throw() const
{
    throw *this;
}

Freeze::EvictorDeactivatedException::EvictorDeactivatedException(const char* __file, int __line) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    LocalException(__file, __line)
#else
    ::Ice::LocalException(__file, __line)
#endif
{
}

Freeze::EvictorDeactivatedException::~EvictorDeactivatedException() throw()
{
}

static const char* __Freeze__EvictorDeactivatedException_name = "Freeze::EvictorDeactivatedException";

::std::string
Freeze::EvictorDeactivatedException::ice_name() const
{
    return __Freeze__EvictorDeactivatedException_name;
}

::Ice::Exception*
Freeze::EvictorDeactivatedException::ice_clone() const
{
    return new EvictorDeactivatedException(*this);
}

void
Freeze::EvictorDeactivatedException::ice_throw() const
{
    throw *this;
}

bool
Freeze::operator==(const ::Freeze::ServantInitializer& l, const ::Freeze::ServantInitializer& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) == static_cast<const ::Ice::LocalObject&>(r);
}

bool
Freeze::operator!=(const ::Freeze::ServantInitializer& l, const ::Freeze::ServantInitializer& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) != static_cast<const ::Ice::LocalObject&>(r);
}

bool
Freeze::operator<(const ::Freeze::ServantInitializer& l, const ::Freeze::ServantInitializer& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) < static_cast<const ::Ice::LocalObject&>(r);
}

bool
Freeze::operator<=(const ::Freeze::ServantInitializer& l, const ::Freeze::ServantInitializer& r)
{
    return l < r || l == r;
}

bool
Freeze::operator>(const ::Freeze::ServantInitializer& l, const ::Freeze::ServantInitializer& r)
{
    return !(l < r) && !(l == r);
}

bool
Freeze::operator>=(const ::Freeze::ServantInitializer& l, const ::Freeze::ServantInitializer& r)
{
    return !(l < r);
}

bool
Freeze::operator==(const ::Freeze::EvictorIterator& l, const ::Freeze::EvictorIterator& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) == static_cast<const ::Ice::LocalObject&>(r);
}

bool
Freeze::operator!=(const ::Freeze::EvictorIterator& l, const ::Freeze::EvictorIterator& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) != static_cast<const ::Ice::LocalObject&>(r);
}

bool
Freeze::operator<(const ::Freeze::EvictorIterator& l, const ::Freeze::EvictorIterator& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) < static_cast<const ::Ice::LocalObject&>(r);
}

bool
Freeze::operator<=(const ::Freeze::EvictorIterator& l, const ::Freeze::EvictorIterator& r)
{
    return l < r || l == r;
}

bool
Freeze::operator>(const ::Freeze::EvictorIterator& l, const ::Freeze::EvictorIterator& r)
{
    return !(l < r) && !(l == r);
}

bool
Freeze::operator>=(const ::Freeze::EvictorIterator& l, const ::Freeze::EvictorIterator& r)
{
    return !(l < r);
}

bool
Freeze::operator==(const ::Freeze::Evictor& l, const ::Freeze::Evictor& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) == static_cast<const ::Ice::LocalObject&>(r);
}

bool
Freeze::operator!=(const ::Freeze::Evictor& l, const ::Freeze::Evictor& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) != static_cast<const ::Ice::LocalObject&>(r);
}

bool
Freeze::operator<(const ::Freeze::Evictor& l, const ::Freeze::Evictor& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) < static_cast<const ::Ice::LocalObject&>(r);
}

bool
Freeze::operator<=(const ::Freeze::Evictor& l, const ::Freeze::Evictor& r)
{
    return l < r || l == r;
}

bool
Freeze::operator>(const ::Freeze::Evictor& l, const ::Freeze::Evictor& r)
{
    return !(l < r) && !(l == r);
}

bool
Freeze::operator>=(const ::Freeze::Evictor& l, const ::Freeze::Evictor& r)
{
    return !(l < r);
}
