// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `PermissionsVerifier.ice'

#include <Glacier2/PermissionsVerifier.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __Glacier2__PermissionsVerifier__checkPermissions_name = "checkPermissions";

static const ::std::string __Glacier2__SSLPermissionsVerifier__authorize_name = "authorize";

void
IceInternal::incRef(::Glacier2::PermissionsVerifier* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::Glacier2::PermissionsVerifier* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::Glacier2::PermissionsVerifier* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::Glacier2::PermissionsVerifier* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::Glacier2::SSLPermissionsVerifier* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::Glacier2::SSLPermissionsVerifier* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::Glacier2::SSLPermissionsVerifier* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::Glacier2::SSLPermissionsVerifier* p)
{
    p->__decRef();
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::PermissionsVerifierPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::PermissionsVerifierPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::PermissionsVerifier;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::PermissionsVerifierPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::SSLPermissionsVerifierPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::SSLPermissionsVerifierPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::SSLPermissionsVerifier;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::SSLPermissionsVerifierPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
Glacier2::__addObject(const PermissionsVerifierPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
Glacier2::__usesClasses(const PermissionsVerifierPtr& p)
{
    return p->__usesClasses();
}

void
Glacier2::__decRefUnsafe(const PermissionsVerifierPtr& p)
{
    p->__decRefUnsafe();
}

void
Glacier2::__clearHandleUnsafe(PermissionsVerifierPtr& p)
{
    p.__clearHandleUnsafe();
}

void
Glacier2::__addObject(const SSLPermissionsVerifierPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
Glacier2::__usesClasses(const SSLPermissionsVerifierPtr& p)
{
    return p->__usesClasses();
}

void
Glacier2::__decRefUnsafe(const SSLPermissionsVerifierPtr& p)
{
    p->__decRefUnsafe();
}

void
Glacier2::__clearHandleUnsafe(SSLPermissionsVerifierPtr& p)
{
    p.__clearHandleUnsafe();
}

bool
IceProxy::Glacier2::PermissionsVerifier::checkPermissions(const ::std::string& userId, const ::std::string& password, ::std::string& reason, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Glacier2__PermissionsVerifier__checkPermissions_name);
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::PermissionsVerifier* __del = dynamic_cast< ::IceDelegate::Glacier2::PermissionsVerifier*>(__delBase.get());
            return __del->checkPermissions(userId, password, reason, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Glacier2::PermissionsVerifier::ice_staticId()
{
    return ::Glacier2::PermissionsVerifier::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::PermissionsVerifier::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::PermissionsVerifier);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::PermissionsVerifier::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::PermissionsVerifier);
}

bool
IceProxy::Glacier2::operator==(const ::IceProxy::Glacier2::PermissionsVerifier& l, const ::IceProxy::Glacier2::PermissionsVerifier& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator!=(const ::IceProxy::Glacier2::PermissionsVerifier& l, const ::IceProxy::Glacier2::PermissionsVerifier& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<(const ::IceProxy::Glacier2::PermissionsVerifier& l, const ::IceProxy::Glacier2::PermissionsVerifier& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<=(const ::IceProxy::Glacier2::PermissionsVerifier& l, const ::IceProxy::Glacier2::PermissionsVerifier& r)
{
    return l < r || l == r;
}

bool
IceProxy::Glacier2::operator>(const ::IceProxy::Glacier2::PermissionsVerifier& l, const ::IceProxy::Glacier2::PermissionsVerifier& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::Glacier2::operator>=(const ::IceProxy::Glacier2::PermissionsVerifier& l, const ::IceProxy::Glacier2::PermissionsVerifier& r)
{
    return !(l < r);
}

bool
IceProxy::Glacier2::SSLPermissionsVerifier::authorize(const ::Glacier2::SSLInfo& info, ::std::string& reason, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Glacier2__SSLPermissionsVerifier__authorize_name);
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::SSLPermissionsVerifier* __del = dynamic_cast< ::IceDelegate::Glacier2::SSLPermissionsVerifier*>(__delBase.get());
            return __del->authorize(info, reason, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Glacier2::SSLPermissionsVerifier::ice_staticId()
{
    return ::Glacier2::SSLPermissionsVerifier::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::SSLPermissionsVerifier::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::SSLPermissionsVerifier);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::SSLPermissionsVerifier::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::SSLPermissionsVerifier);
}

bool
IceProxy::Glacier2::operator==(const ::IceProxy::Glacier2::SSLPermissionsVerifier& l, const ::IceProxy::Glacier2::SSLPermissionsVerifier& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator!=(const ::IceProxy::Glacier2::SSLPermissionsVerifier& l, const ::IceProxy::Glacier2::SSLPermissionsVerifier& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<(const ::IceProxy::Glacier2::SSLPermissionsVerifier& l, const ::IceProxy::Glacier2::SSLPermissionsVerifier& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<=(const ::IceProxy::Glacier2::SSLPermissionsVerifier& l, const ::IceProxy::Glacier2::SSLPermissionsVerifier& r)
{
    return l < r || l == r;
}

bool
IceProxy::Glacier2::operator>(const ::IceProxy::Glacier2::SSLPermissionsVerifier& l, const ::IceProxy::Glacier2::SSLPermissionsVerifier& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::Glacier2::operator>=(const ::IceProxy::Glacier2::SSLPermissionsVerifier& l, const ::IceProxy::Glacier2::SSLPermissionsVerifier& r)
{
    return !(l < r);
}

bool
IceDelegateM::Glacier2::PermissionsVerifier::checkPermissions(const ::std::string& userId, const ::std::string& password, ::std::string& reason, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__PermissionsVerifier__checkPermissions_name, ::Ice::Nonmutating, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(userId);
        __os->write(password);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        bool __ret;
        __is->read(reason);
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

bool
IceDelegateM::Glacier2::SSLPermissionsVerifier::authorize(const ::Glacier2::SSLInfo& info, ::std::string& reason, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__SSLPermissionsVerifier__authorize_name, ::Ice::Nonmutating, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        info.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        bool __ret;
        __is->read(reason);
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

bool
IceDelegateD::Glacier2::PermissionsVerifier::checkPermissions(const ::std::string& userId, const ::std::string& password, ::std::string& reason, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__PermissionsVerifier__checkPermissions_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        bool __ret;
        try
        {
            ::Glacier2::PermissionsVerifier* __servant = dynamic_cast< ::Glacier2::PermissionsVerifier*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->checkPermissions(userId, password, reason, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

bool
IceDelegateD::Glacier2::SSLPermissionsVerifier::authorize(const ::Glacier2::SSLInfo& info, ::std::string& reason, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SSLPermissionsVerifier__authorize_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        bool __ret;
        try
        {
            ::Glacier2::SSLPermissionsVerifier* __servant = dynamic_cast< ::Glacier2::SSLPermissionsVerifier*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->authorize(info, reason, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::ObjectPtr
Glacier2::PermissionsVerifier::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__PermissionsVerifier_ids[2] =
{
    "::Glacier2::PermissionsVerifier",
    "::Ice::Object"
};

bool
Glacier2::PermissionsVerifier::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__PermissionsVerifier_ids, __Glacier2__PermissionsVerifier_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::PermissionsVerifier::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__PermissionsVerifier_ids[0], &__Glacier2__PermissionsVerifier_ids[2]);
}

const ::std::string&
Glacier2::PermissionsVerifier::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__PermissionsVerifier_ids[0];
}

const ::std::string&
Glacier2::PermissionsVerifier::ice_staticId()
{
    return __Glacier2__PermissionsVerifier_ids[0];
}

::IceInternal::DispatchStatus
Glacier2::PermissionsVerifier::___checkPermissions(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string userId;
    ::std::string password;
    __is->read(userId);
    __is->read(password);
    ::std::string reason;
    bool __ret = checkPermissions(userId, password, reason, __current);
    __os->write(reason);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

static ::std::string __Glacier2__PermissionsVerifier_all[] =
{
    "checkPermissions",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
Glacier2::PermissionsVerifier::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__PermissionsVerifier_all, __Glacier2__PermissionsVerifier_all + 5, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __Glacier2__PermissionsVerifier_all)
    {
        case 0:
        {
            return ___checkPermissions(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
Glacier2::PermissionsVerifier::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::PermissionsVerifier::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::PermissionsVerifier::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::PermissionsVerifier was not generated with stream support";
    throw ex;
}

void
Glacier2::PermissionsVerifier::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::PermissionsVerifier was not generated with stream support";
    throw ex;
}

void GLACIER2_API 
Glacier2::__patch__PermissionsVerifierPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::PermissionsVerifierPtr* p = static_cast< ::Glacier2::PermissionsVerifierPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::PermissionsVerifierPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::Glacier2::PermissionsVerifier::ice_staticId();
        throw e;
    }
}

bool
Glacier2::operator==(const ::Glacier2::PermissionsVerifier& l, const ::Glacier2::PermissionsVerifier& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator!=(const ::Glacier2::PermissionsVerifier& l, const ::Glacier2::PermissionsVerifier& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::PermissionsVerifier& l, const ::Glacier2::PermissionsVerifier& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<=(const ::Glacier2::PermissionsVerifier& l, const ::Glacier2::PermissionsVerifier& r)
{
    return l < r || l == r;
}

bool
Glacier2::operator>(const ::Glacier2::PermissionsVerifier& l, const ::Glacier2::PermissionsVerifier& r)
{
    return !(l < r) && !(l == r);
}

bool
Glacier2::operator>=(const ::Glacier2::PermissionsVerifier& l, const ::Glacier2::PermissionsVerifier& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
Glacier2::SSLPermissionsVerifier::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__SSLPermissionsVerifier_ids[2] =
{
    "::Glacier2::SSLPermissionsVerifier",
    "::Ice::Object"
};

bool
Glacier2::SSLPermissionsVerifier::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__SSLPermissionsVerifier_ids, __Glacier2__SSLPermissionsVerifier_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::SSLPermissionsVerifier::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__SSLPermissionsVerifier_ids[0], &__Glacier2__SSLPermissionsVerifier_ids[2]);
}

const ::std::string&
Glacier2::SSLPermissionsVerifier::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__SSLPermissionsVerifier_ids[0];
}

const ::std::string&
Glacier2::SSLPermissionsVerifier::ice_staticId()
{
    return __Glacier2__SSLPermissionsVerifier_ids[0];
}

::IceInternal::DispatchStatus
Glacier2::SSLPermissionsVerifier::___authorize(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Glacier2::SSLInfo info;
    info.__read(__is);
    ::std::string reason;
    bool __ret = authorize(info, reason, __current);
    __os->write(reason);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

static ::std::string __Glacier2__SSLPermissionsVerifier_all[] =
{
    "authorize",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
Glacier2::SSLPermissionsVerifier::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__SSLPermissionsVerifier_all, __Glacier2__SSLPermissionsVerifier_all + 5, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __Glacier2__SSLPermissionsVerifier_all)
    {
        case 0:
        {
            return ___authorize(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
Glacier2::SSLPermissionsVerifier::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::SSLPermissionsVerifier::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::SSLPermissionsVerifier::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SSLPermissionsVerifier was not generated with stream support";
    throw ex;
}

void
Glacier2::SSLPermissionsVerifier::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SSLPermissionsVerifier was not generated with stream support";
    throw ex;
}

void GLACIER2_API 
Glacier2::__patch__SSLPermissionsVerifierPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::SSLPermissionsVerifierPtr* p = static_cast< ::Glacier2::SSLPermissionsVerifierPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::SSLPermissionsVerifierPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::Glacier2::SSLPermissionsVerifier::ice_staticId();
        throw e;
    }
}

bool
Glacier2::operator==(const ::Glacier2::SSLPermissionsVerifier& l, const ::Glacier2::SSLPermissionsVerifier& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator!=(const ::Glacier2::SSLPermissionsVerifier& l, const ::Glacier2::SSLPermissionsVerifier& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::SSLPermissionsVerifier& l, const ::Glacier2::SSLPermissionsVerifier& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<=(const ::Glacier2::SSLPermissionsVerifier& l, const ::Glacier2::SSLPermissionsVerifier& r)
{
    return l < r || l == r;
}

bool
Glacier2::operator>(const ::Glacier2::SSLPermissionsVerifier& l, const ::Glacier2::SSLPermissionsVerifier& r)
{
    return !(l < r) && !(l == r);
}

bool
Glacier2::operator>=(const ::Glacier2::SSLPermissionsVerifier& l, const ::Glacier2::SSLPermissionsVerifier& r)
{
    return !(l < r);
}
