// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `Router.ice'

#include <Glacier2/Router.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __Glacier2__Router__getCategoryForClient_name = "getCategoryForClient";

static const ::std::string __Glacier2__Router__createSession_name = "createSession";

static const ::std::string __Glacier2__Router__createSessionFromSecureConnection_name = "createSessionFromSecureConnection";

static const ::std::string __Glacier2__Router__destroySession_name = "destroySession";

static const ::std::string __Glacier2__Router__getSessionTimeout_name = "getSessionTimeout";

static const ::std::string __Glacier2__Admin__shutdown_name = "shutdown";

void
IceInternal::incRef(::Glacier2::Router* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::Glacier2::Router* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::Glacier2::Router* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::Glacier2::Router* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::Glacier2::Admin* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::Glacier2::Admin* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::Glacier2::Admin* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::Glacier2::Admin* p)
{
    p->__decRef();
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::RouterPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::RouterPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::Router;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::RouterPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::AdminPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::AdminPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::Admin;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::AdminPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

Glacier2::PermissionDeniedException::PermissionDeniedException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

Glacier2::PermissionDeniedException::~PermissionDeniedException() throw()
{
}

static const char* __Glacier2__PermissionDeniedException_name = "Glacier2::PermissionDeniedException";

::std::string
Glacier2::PermissionDeniedException::ice_name() const
{
    return __Glacier2__PermissionDeniedException_name;
}

::Ice::Exception*
Glacier2::PermissionDeniedException::ice_clone() const
{
    return new PermissionDeniedException(*this);
}

void
Glacier2::PermissionDeniedException::ice_throw() const
{
    throw *this;
}

void
Glacier2::PermissionDeniedException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Glacier2::PermissionDeniedException"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
Glacier2::PermissionDeniedException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
Glacier2::PermissionDeniedException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Glacier2::PermissionDeniedException was not generated with stream support";
    throw ex;
}

void
Glacier2::PermissionDeniedException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Glacier2::PermissionDeniedException was not generated with stream support";
    throw ex;
}

struct __F__Glacier2__PermissionDeniedException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Glacier2::PermissionDeniedException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Glacier2__PermissionDeniedException__Ptr = new __F__Glacier2__PermissionDeniedException;

const ::IceInternal::UserExceptionFactoryPtr&
Glacier2::PermissionDeniedException::ice_factory()
{
    return __F__Glacier2__PermissionDeniedException__Ptr;
}

class __F__Glacier2__PermissionDeniedException__Init
{
public:

    __F__Glacier2__PermissionDeniedException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Glacier2::PermissionDeniedException", ::Glacier2::PermissionDeniedException::ice_factory());
    }

    ~__F__Glacier2__PermissionDeniedException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Glacier2::PermissionDeniedException");
    }
};

static __F__Glacier2__PermissionDeniedException__Init __F__Glacier2__PermissionDeniedException__i;

#ifdef __APPLE__
extern "C" { void __F__Glacier2__PermissionDeniedException__initializer() {} }
#endif

Glacier2::SessionNotExistException::~SessionNotExistException() throw()
{
}

static const char* __Glacier2__SessionNotExistException_name = "Glacier2::SessionNotExistException";

::std::string
Glacier2::SessionNotExistException::ice_name() const
{
    return __Glacier2__SessionNotExistException_name;
}

::Ice::Exception*
Glacier2::SessionNotExistException::ice_clone() const
{
    return new SessionNotExistException(*this);
}

void
Glacier2::SessionNotExistException::ice_throw() const
{
    throw *this;
}

void
Glacier2::SessionNotExistException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Glacier2::SessionNotExistException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
}

void
Glacier2::SessionNotExistException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
}

void
Glacier2::SessionNotExistException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Glacier2::SessionNotExistException was not generated with stream support";
    throw ex;
}

void
Glacier2::SessionNotExistException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Glacier2::SessionNotExistException was not generated with stream support";
    throw ex;
}

struct __F__Glacier2__SessionNotExistException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Glacier2::SessionNotExistException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Glacier2__SessionNotExistException__Ptr = new __F__Glacier2__SessionNotExistException;

const ::IceInternal::UserExceptionFactoryPtr&
Glacier2::SessionNotExistException::ice_factory()
{
    return __F__Glacier2__SessionNotExistException__Ptr;
}

class __F__Glacier2__SessionNotExistException__Init
{
public:

    __F__Glacier2__SessionNotExistException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Glacier2::SessionNotExistException", ::Glacier2::SessionNotExistException::ice_factory());
    }

    ~__F__Glacier2__SessionNotExistException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Glacier2::SessionNotExistException");
    }
};

static __F__Glacier2__SessionNotExistException__Init __F__Glacier2__SessionNotExistException__i;

#ifdef __APPLE__
extern "C" { void __F__Glacier2__SessionNotExistException__initializer() {} }
#endif

void
Glacier2::__addObject(const RouterPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
Glacier2::__usesClasses(const RouterPtr& p)
{
    return p->__usesClasses();
}

void
Glacier2::__decRefUnsafe(const RouterPtr& p)
{
    p->__decRefUnsafe();
}

void
Glacier2::__clearHandleUnsafe(RouterPtr& p)
{
    p.__clearHandleUnsafe();
}

void
Glacier2::__addObject(const AdminPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
Glacier2::__usesClasses(const AdminPtr& p)
{
    return p->__usesClasses();
}

void
Glacier2::__decRefUnsafe(const AdminPtr& p)
{
    p->__decRefUnsafe();
}

void
Glacier2::__clearHandleUnsafe(AdminPtr& p)
{
    p.__clearHandleUnsafe();
}

::std::string
IceProxy::Glacier2::Router::getCategoryForClient(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Glacier2__Router__getCategoryForClient_name);
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::Router* __del = dynamic_cast< ::IceDelegate::Glacier2::Router*>(__delBase.get());
            return __del->getCategoryForClient(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Glacier2::SessionPrx
IceProxy::Glacier2::Router::createSession(const ::std::string& userId, const ::std::string& password, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Glacier2__Router__createSession_name);
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::Router* __del = dynamic_cast< ::IceDelegate::Glacier2::Router*>(__delBase.get());
            return __del->createSession(userId, password, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Glacier2::SessionPrx
IceProxy::Glacier2::Router::createSessionFromSecureConnection(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Glacier2__Router__createSessionFromSecureConnection_name);
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::Router* __del = dynamic_cast< ::IceDelegate::Glacier2::Router*>(__delBase.get());
            return __del->createSessionFromSecureConnection(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::Glacier2::Router::destroySession(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Glacier2__Router__destroySession_name);
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::Router* __del = dynamic_cast< ::IceDelegate::Glacier2::Router*>(__delBase.get());
            __del->destroySession(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Ice::Long
IceProxy::Glacier2::Router::getSessionTimeout(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Glacier2__Router__getSessionTimeout_name);
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::Router* __del = dynamic_cast< ::IceDelegate::Glacier2::Router*>(__delBase.get());
            return __del->getSessionTimeout(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Glacier2::Router::ice_staticId()
{
    return ::Glacier2::Router::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::Router::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::Router);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::Router::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::Router);
}

bool
IceProxy::Glacier2::operator==(const ::IceProxy::Glacier2::Router& l, const ::IceProxy::Glacier2::Router& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator!=(const ::IceProxy::Glacier2::Router& l, const ::IceProxy::Glacier2::Router& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<(const ::IceProxy::Glacier2::Router& l, const ::IceProxy::Glacier2::Router& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<=(const ::IceProxy::Glacier2::Router& l, const ::IceProxy::Glacier2::Router& r)
{
    return l < r || l == r;
}

bool
IceProxy::Glacier2::operator>(const ::IceProxy::Glacier2::Router& l, const ::IceProxy::Glacier2::Router& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::Glacier2::operator>=(const ::IceProxy::Glacier2::Router& l, const ::IceProxy::Glacier2::Router& r)
{
    return !(l < r);
}

void
IceProxy::Glacier2::Admin::shutdown(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::Admin* __del = dynamic_cast< ::IceDelegate::Glacier2::Admin*>(__delBase.get());
            __del->shutdown(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Glacier2::Admin::ice_staticId()
{
    return ::Glacier2::Admin::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::Admin::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::Admin);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::Admin::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::Admin);
}

bool
IceProxy::Glacier2::operator==(const ::IceProxy::Glacier2::Admin& l, const ::IceProxy::Glacier2::Admin& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator!=(const ::IceProxy::Glacier2::Admin& l, const ::IceProxy::Glacier2::Admin& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<(const ::IceProxy::Glacier2::Admin& l, const ::IceProxy::Glacier2::Admin& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<=(const ::IceProxy::Glacier2::Admin& l, const ::IceProxy::Glacier2::Admin& r)
{
    return l < r || l == r;
}

bool
IceProxy::Glacier2::operator>(const ::IceProxy::Glacier2::Admin& l, const ::IceProxy::Glacier2::Admin& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::Glacier2::operator>=(const ::IceProxy::Glacier2::Admin& l, const ::IceProxy::Glacier2::Admin& r)
{
    return !(l < r);
}

::std::string
IceDelegateM::Glacier2::Router::getCategoryForClient(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__Router__getCategoryForClient_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::std::string __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Glacier2::SessionPrx
IceDelegateM::Glacier2::Router::createSession(const ::std::string& userId, const ::std::string& password, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__Router__createSession_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(userId);
        __os->write(password);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Glacier2::CannotCreateSessionException&)
            {
                throw;
            }
            catch(const ::Glacier2::PermissionDeniedException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Glacier2::SessionPrx __ret;
        ::Glacier2::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Glacier2::SessionPrx
IceDelegateM::Glacier2::Router::createSessionFromSecureConnection(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__Router__createSessionFromSecureConnection_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Glacier2::CannotCreateSessionException&)
            {
                throw;
            }
            catch(const ::Glacier2::PermissionDeniedException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Glacier2::SessionPrx __ret;
        ::Glacier2::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Glacier2::Router::destroySession(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__Router__destroySession_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Glacier2::SessionNotExistException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::Long
IceDelegateM::Glacier2::Router::getSessionTimeout(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__Router__getSessionTimeout_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::Long __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Glacier2::Admin::shutdown(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__Admin__shutdown_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::std::string
IceDelegateD::Glacier2::Router::getCategoryForClient(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__Router__getCategoryForClient_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::std::string __ret;
        try
        {
            ::Glacier2::Router* __servant = dynamic_cast< ::Glacier2::Router*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getCategoryForClient(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Glacier2::SessionPrx
IceDelegateD::Glacier2::Router::createSession(const ::std::string& userId, const ::std::string& password, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__Router__createSession_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Glacier2::SessionPrx __ret;
        try
        {
            ::Glacier2::Router* __servant = dynamic_cast< ::Glacier2::Router*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->createSession(userId, password, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Glacier2::SessionPrx
IceDelegateD::Glacier2::Router::createSessionFromSecureConnection(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__Router__createSessionFromSecureConnection_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Glacier2::SessionPrx __ret;
        try
        {
            ::Glacier2::Router* __servant = dynamic_cast< ::Glacier2::Router*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->createSessionFromSecureConnection(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::Glacier2::Router::destroySession(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__Router__destroySession_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::Glacier2::Router* __servant = dynamic_cast< ::Glacier2::Router*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->destroySession(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::Ice::Long
IceDelegateD::Glacier2::Router::getSessionTimeout(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__Router__getSessionTimeout_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::Long __ret;
        try
        {
            ::Glacier2::Router* __servant = dynamic_cast< ::Glacier2::Router*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getSessionTimeout(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::Glacier2::Admin::shutdown(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__Admin__shutdown_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::Glacier2::Admin* __servant = dynamic_cast< ::Glacier2::Admin*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->shutdown(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::Ice::ObjectPtr
Glacier2::Router::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__Router_ids[3] =
{
    "::Glacier2::Router",
    "::Ice::Object",
    "::Ice::Router"
};

bool
Glacier2::Router::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__Router_ids, __Glacier2__Router_ids + 3, _s);
}

::std::vector< ::std::string>
Glacier2::Router::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__Router_ids[0], &__Glacier2__Router_ids[3]);
}

const ::std::string&
Glacier2::Router::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__Router_ids[0];
}

const ::std::string&
Glacier2::Router::ice_staticId()
{
    return __Glacier2__Router_ids[0];
}

::IceInternal::DispatchStatus
Glacier2::Router::___getCategoryForClient(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string __ret = getCategoryForClient(__current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
Glacier2::Router::___createSession(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string userId;
    ::std::string password;
    __is->read(userId);
    __is->read(password);
    try
    {
        ::Glacier2::SessionPrx __ret = createSession(userId, password, __current);
        ::Glacier2::__write(__os, __ret);
    }
    catch(const ::Glacier2::CannotCreateSessionException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    catch(const ::Glacier2::PermissionDeniedException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
Glacier2::Router::___createSessionFromSecureConnection(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Glacier2::SessionPrx __ret = createSessionFromSecureConnection(__current);
        ::Glacier2::__write(__os, __ret);
    }
    catch(const ::Glacier2::CannotCreateSessionException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    catch(const ::Glacier2::PermissionDeniedException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
Glacier2::Router::___destroySession(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        destroySession(__current);
    }
    catch(const ::Glacier2::SessionNotExistException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
Glacier2::Router::___getSessionTimeout(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Long __ret = getSessionTimeout(__current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

static ::std::string __Glacier2__Router_all[] =
{
    "addProxies",
    "addProxy",
    "createSession",
    "createSessionFromSecureConnection",
    "destroySession",
    "getCategoryForClient",
    "getClientProxy",
    "getServerProxy",
    "getSessionTimeout",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
Glacier2::Router::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__Router_all, __Glacier2__Router_all + 13, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __Glacier2__Router_all)
    {
        case 0:
        {
            return ___addProxies(in, current);
        }
        case 1:
        {
            return ___addProxy(in, current);
        }
        case 2:
        {
            return ___createSession(in, current);
        }
        case 3:
        {
            return ___createSessionFromSecureConnection(in, current);
        }
        case 4:
        {
            return ___destroySession(in, current);
        }
        case 5:
        {
            return ___getCategoryForClient(in, current);
        }
        case 6:
        {
            return ___getClientProxy(in, current);
        }
        case 7:
        {
            return ___getServerProxy(in, current);
        }
        case 8:
        {
            return ___getSessionTimeout(in, current);
        }
        case 9:
        {
            return ___ice_id(in, current);
        }
        case 10:
        {
            return ___ice_ids(in, current);
        }
        case 11:
        {
            return ___ice_isA(in, current);
        }
        case 12:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
Glacier2::Router::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::Router::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::Router::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::Router was not generated with stream support";
    throw ex;
}

void
Glacier2::Router::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::Router was not generated with stream support";
    throw ex;
}

void GLACIER2_API 
Glacier2::__patch__RouterPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::RouterPtr* p = static_cast< ::Glacier2::RouterPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::RouterPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::Glacier2::Router::ice_staticId();
        throw e;
    }
}

bool
Glacier2::operator==(const ::Glacier2::Router& l, const ::Glacier2::Router& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator!=(const ::Glacier2::Router& l, const ::Glacier2::Router& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::Router& l, const ::Glacier2::Router& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<=(const ::Glacier2::Router& l, const ::Glacier2::Router& r)
{
    return l < r || l == r;
}

bool
Glacier2::operator>(const ::Glacier2::Router& l, const ::Glacier2::Router& r)
{
    return !(l < r) && !(l == r);
}

bool
Glacier2::operator>=(const ::Glacier2::Router& l, const ::Glacier2::Router& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
Glacier2::Admin::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__Admin_ids[2] =
{
    "::Glacier2::Admin",
    "::Ice::Object"
};

bool
Glacier2::Admin::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__Admin_ids, __Glacier2__Admin_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::Admin::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__Admin_ids[0], &__Glacier2__Admin_ids[2]);
}

const ::std::string&
Glacier2::Admin::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__Admin_ids[0];
}

const ::std::string&
Glacier2::Admin::ice_staticId()
{
    return __Glacier2__Admin_ids[0];
}

::IceInternal::DispatchStatus
Glacier2::Admin::___shutdown(::IceInternal::Incoming&, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    shutdown(__current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __Glacier2__Admin_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "shutdown"
};

::IceInternal::DispatchStatus
Glacier2::Admin::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__Admin_all, __Glacier2__Admin_all + 5, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __Glacier2__Admin_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___shutdown(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
Glacier2::Admin::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::Admin::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::Admin::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::Admin was not generated with stream support";
    throw ex;
}

void
Glacier2::Admin::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::Admin was not generated with stream support";
    throw ex;
}

void GLACIER2_API 
Glacier2::__patch__AdminPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::AdminPtr* p = static_cast< ::Glacier2::AdminPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::AdminPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::Glacier2::Admin::ice_staticId();
        throw e;
    }
}

bool
Glacier2::operator==(const ::Glacier2::Admin& l, const ::Glacier2::Admin& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator!=(const ::Glacier2::Admin& l, const ::Glacier2::Admin& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::Admin& l, const ::Glacier2::Admin& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<=(const ::Glacier2::Admin& l, const ::Glacier2::Admin& r)
{
    return l < r || l == r;
}

bool
Glacier2::operator>(const ::Glacier2::Admin& l, const ::Glacier2::Admin& r)
{
    return !(l < r) && !(l == r);
}

bool
Glacier2::operator>=(const ::Glacier2::Admin& l, const ::Glacier2::Admin& r)
{
    return !(l < r);
}
