// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `Session.ice'

#include <Glacier2/Session.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __Glacier2__Session__destroy_name = "destroy";

static const ::std::string __Glacier2__StringSet__add_name = "add";

static const ::std::string __Glacier2__StringSet__remove_name = "remove";

static const ::std::string __Glacier2__StringSet__get_name = "get";

static const ::std::string __Glacier2__IdentitySet__add_name = "add";

static const ::std::string __Glacier2__IdentitySet__remove_name = "remove";

static const ::std::string __Glacier2__IdentitySet__get_name = "get";

static const ::std::string __Glacier2__SessionControl__categories_name = "categories";

static const ::std::string __Glacier2__SessionControl__adapterIds_name = "adapterIds";

static const ::std::string __Glacier2__SessionControl__identities_name = "identities";

static const ::std::string __Glacier2__SessionControl__getSessionTimeout_name = "getSessionTimeout";

static const ::std::string __Glacier2__SessionControl__destroy_name = "destroy";

static const ::std::string __Glacier2__SessionManager__create_name = "create";

static const ::std::string __Glacier2__SSLSessionManager__create_name = "create";

void
IceInternal::incRef(::Glacier2::Session* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::Glacier2::Session* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::Glacier2::Session* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::Glacier2::Session* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::Glacier2::StringSet* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::Glacier2::StringSet* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::Glacier2::StringSet* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::Glacier2::StringSet* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::Glacier2::IdentitySet* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::Glacier2::IdentitySet* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::Glacier2::IdentitySet* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::Glacier2::IdentitySet* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::Glacier2::SessionControl* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::Glacier2::SessionControl* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::Glacier2::SessionControl* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::Glacier2::SessionControl* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::Glacier2::SessionManager* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::Glacier2::SessionManager* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::Glacier2::SessionManager* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::Glacier2::SessionManager* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::Glacier2::SSLSessionManager* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::Glacier2::SSLSessionManager* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::Glacier2::SSLSessionManager* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::Glacier2::SSLSessionManager* p)
{
    p->__decRef();
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::SessionPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::SessionPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::Session;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::SessionPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::StringSetPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::StringSetPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::StringSet;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::StringSetPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::IdentitySetPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::IdentitySetPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::IdentitySet;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::IdentitySetPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::SessionControlPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::SessionControlPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::SessionControl;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::SessionControlPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::SessionManagerPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::SessionManagerPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::SessionManager;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::SessionManagerPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::SSLSessionManagerPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
Glacier2::__read(::IceInternal::BasicStream* __is, ::Glacier2::SSLSessionManagerPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Glacier2::SSLSessionManager;
        v->__copyFrom(proxy);
    }
}

void
Glacier2::__write(::IceInternal::BasicStream* __os, const ::Glacier2::SSLSessionManagerPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

Glacier2::CannotCreateSessionException::CannotCreateSessionException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

Glacier2::CannotCreateSessionException::~CannotCreateSessionException() throw()
{
}

static const char* __Glacier2__CannotCreateSessionException_name = "Glacier2::CannotCreateSessionException";

::std::string
Glacier2::CannotCreateSessionException::ice_name() const
{
    return __Glacier2__CannotCreateSessionException_name;
}

::Ice::Exception*
Glacier2::CannotCreateSessionException::ice_clone() const
{
    return new CannotCreateSessionException(*this);
}

void
Glacier2::CannotCreateSessionException::ice_throw() const
{
    throw *this;
}

void
Glacier2::CannotCreateSessionException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Glacier2::CannotCreateSessionException"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
Glacier2::CannotCreateSessionException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
Glacier2::CannotCreateSessionException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Glacier2::CannotCreateSessionException was not generated with stream support";
    throw ex;
}

void
Glacier2::CannotCreateSessionException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Glacier2::CannotCreateSessionException was not generated with stream support";
    throw ex;
}

struct __F__Glacier2__CannotCreateSessionException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Glacier2::CannotCreateSessionException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Glacier2__CannotCreateSessionException__Ptr = new __F__Glacier2__CannotCreateSessionException;

const ::IceInternal::UserExceptionFactoryPtr&
Glacier2::CannotCreateSessionException::ice_factory()
{
    return __F__Glacier2__CannotCreateSessionException__Ptr;
}

class __F__Glacier2__CannotCreateSessionException__Init
{
public:

    __F__Glacier2__CannotCreateSessionException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Glacier2::CannotCreateSessionException", ::Glacier2::CannotCreateSessionException::ice_factory());
    }

    ~__F__Glacier2__CannotCreateSessionException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Glacier2::CannotCreateSessionException");
    }
};

static __F__Glacier2__CannotCreateSessionException__Init __F__Glacier2__CannotCreateSessionException__i;

#ifdef __APPLE__
extern "C" { void __F__Glacier2__CannotCreateSessionException__initializer() {} }
#endif

void
Glacier2::__addObject(const SessionPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
Glacier2::__usesClasses(const SessionPtr& p)
{
    return p->__usesClasses();
}

void
Glacier2::__decRefUnsafe(const SessionPtr& p)
{
    p->__decRefUnsafe();
}

void
Glacier2::__clearHandleUnsafe(SessionPtr& p)
{
    p.__clearHandleUnsafe();
}

void
Glacier2::__addObject(const StringSetPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
Glacier2::__usesClasses(const StringSetPtr& p)
{
    return p->__usesClasses();
}

void
Glacier2::__decRefUnsafe(const StringSetPtr& p)
{
    p->__decRefUnsafe();
}

void
Glacier2::__clearHandleUnsafe(StringSetPtr& p)
{
    p.__clearHandleUnsafe();
}

void
Glacier2::__addObject(const IdentitySetPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
Glacier2::__usesClasses(const IdentitySetPtr& p)
{
    return p->__usesClasses();
}

void
Glacier2::__decRefUnsafe(const IdentitySetPtr& p)
{
    p->__decRefUnsafe();
}

void
Glacier2::__clearHandleUnsafe(IdentitySetPtr& p)
{
    p.__clearHandleUnsafe();
}

void
Glacier2::__addObject(const SessionControlPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
Glacier2::__usesClasses(const SessionControlPtr& p)
{
    return p->__usesClasses();
}

void
Glacier2::__decRefUnsafe(const SessionControlPtr& p)
{
    p->__decRefUnsafe();
}

void
Glacier2::__clearHandleUnsafe(SessionControlPtr& p)
{
    p.__clearHandleUnsafe();
}

void
Glacier2::__addObject(const SessionManagerPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
Glacier2::__usesClasses(const SessionManagerPtr& p)
{
    return p->__usesClasses();
}

void
Glacier2::__decRefUnsafe(const SessionManagerPtr& p)
{
    p->__decRefUnsafe();
}

void
Glacier2::__clearHandleUnsafe(SessionManagerPtr& p)
{
    p.__clearHandleUnsafe();
}

void
Glacier2::__addObject(const SSLSessionManagerPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
Glacier2::__usesClasses(const SSLSessionManagerPtr& p)
{
    return p->__usesClasses();
}

void
Glacier2::__decRefUnsafe(const SSLSessionManagerPtr& p)
{
    p->__decRefUnsafe();
}

void
Glacier2::__clearHandleUnsafe(SSLSessionManagerPtr& p)
{
    p.__clearHandleUnsafe();
}

void
Glacier2::AMI_SessionControl_destroy::__invoke(const ::Glacier2::SessionControlPrx& __prx, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __Glacier2__SessionControl__destroy_name, ::Ice::Normal, __ctx);
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
Glacier2::AMI_SessionControl_destroy::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
}

void
IceProxy::Glacier2::Session::destroy(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::Session* __del = dynamic_cast< ::IceDelegate::Glacier2::Session*>(__delBase.get());
            __del->destroy(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Glacier2::Session::ice_staticId()
{
    return ::Glacier2::Session::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::Session::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::Session);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::Session::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::Session);
}

bool
IceProxy::Glacier2::operator==(const ::IceProxy::Glacier2::Session& l, const ::IceProxy::Glacier2::Session& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator!=(const ::IceProxy::Glacier2::Session& l, const ::IceProxy::Glacier2::Session& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<(const ::IceProxy::Glacier2::Session& l, const ::IceProxy::Glacier2::Session& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<=(const ::IceProxy::Glacier2::Session& l, const ::IceProxy::Glacier2::Session& r)
{
    return l < r || l == r;
}

bool
IceProxy::Glacier2::operator>(const ::IceProxy::Glacier2::Session& l, const ::IceProxy::Glacier2::Session& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::Glacier2::operator>=(const ::IceProxy::Glacier2::Session& l, const ::IceProxy::Glacier2::Session& r)
{
    return !(l < r);
}

void
IceProxy::Glacier2::StringSet::add(const ::Ice::StringSeq& additions, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::StringSet* __del = dynamic_cast< ::IceDelegate::Glacier2::StringSet*>(__delBase.get());
            __del->add(additions, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::Glacier2::StringSet::remove(const ::Ice::StringSeq& deletions, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::StringSet* __del = dynamic_cast< ::IceDelegate::Glacier2::StringSet*>(__delBase.get());
            __del->remove(deletions, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Ice::StringSeq
IceProxy::Glacier2::StringSet::get(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Glacier2__StringSet__get_name);
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::StringSet* __del = dynamic_cast< ::IceDelegate::Glacier2::StringSet*>(__delBase.get());
            return __del->get(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Glacier2::StringSet::ice_staticId()
{
    return ::Glacier2::StringSet::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::StringSet::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::StringSet);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::StringSet::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::StringSet);
}

bool
IceProxy::Glacier2::operator==(const ::IceProxy::Glacier2::StringSet& l, const ::IceProxy::Glacier2::StringSet& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator!=(const ::IceProxy::Glacier2::StringSet& l, const ::IceProxy::Glacier2::StringSet& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<(const ::IceProxy::Glacier2::StringSet& l, const ::IceProxy::Glacier2::StringSet& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<=(const ::IceProxy::Glacier2::StringSet& l, const ::IceProxy::Glacier2::StringSet& r)
{
    return l < r || l == r;
}

bool
IceProxy::Glacier2::operator>(const ::IceProxy::Glacier2::StringSet& l, const ::IceProxy::Glacier2::StringSet& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::Glacier2::operator>=(const ::IceProxy::Glacier2::StringSet& l, const ::IceProxy::Glacier2::StringSet& r)
{
    return !(l < r);
}

void
IceProxy::Glacier2::IdentitySet::add(const ::Ice::IdentitySeq& additions, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::IdentitySet* __del = dynamic_cast< ::IceDelegate::Glacier2::IdentitySet*>(__delBase.get());
            __del->add(additions, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::Glacier2::IdentitySet::remove(const ::Ice::IdentitySeq& deletions, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::IdentitySet* __del = dynamic_cast< ::IceDelegate::Glacier2::IdentitySet*>(__delBase.get());
            __del->remove(deletions, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Ice::IdentitySeq
IceProxy::Glacier2::IdentitySet::get(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Glacier2__IdentitySet__get_name);
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::IdentitySet* __del = dynamic_cast< ::IceDelegate::Glacier2::IdentitySet*>(__delBase.get());
            return __del->get(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Glacier2::IdentitySet::ice_staticId()
{
    return ::Glacier2::IdentitySet::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::IdentitySet::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::IdentitySet);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::IdentitySet::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::IdentitySet);
}

bool
IceProxy::Glacier2::operator==(const ::IceProxy::Glacier2::IdentitySet& l, const ::IceProxy::Glacier2::IdentitySet& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator!=(const ::IceProxy::Glacier2::IdentitySet& l, const ::IceProxy::Glacier2::IdentitySet& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<(const ::IceProxy::Glacier2::IdentitySet& l, const ::IceProxy::Glacier2::IdentitySet& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<=(const ::IceProxy::Glacier2::IdentitySet& l, const ::IceProxy::Glacier2::IdentitySet& r)
{
    return l < r || l == r;
}

bool
IceProxy::Glacier2::operator>(const ::IceProxy::Glacier2::IdentitySet& l, const ::IceProxy::Glacier2::IdentitySet& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::Glacier2::operator>=(const ::IceProxy::Glacier2::IdentitySet& l, const ::IceProxy::Glacier2::IdentitySet& r)
{
    return !(l < r);
}

::Glacier2::StringSetPrx
IceProxy::Glacier2::SessionControl::categories(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Glacier2__SessionControl__categories_name);
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::SessionControl* __del = dynamic_cast< ::IceDelegate::Glacier2::SessionControl*>(__delBase.get());
            return __del->categories(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Glacier2::StringSetPrx
IceProxy::Glacier2::SessionControl::adapterIds(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Glacier2__SessionControl__adapterIds_name);
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::SessionControl* __del = dynamic_cast< ::IceDelegate::Glacier2::SessionControl*>(__delBase.get());
            return __del->adapterIds(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Glacier2::IdentitySetPrx
IceProxy::Glacier2::SessionControl::identities(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Glacier2__SessionControl__identities_name);
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::SessionControl* __del = dynamic_cast< ::IceDelegate::Glacier2::SessionControl*>(__delBase.get());
            return __del->identities(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Ice::Int
IceProxy::Glacier2::SessionControl::getSessionTimeout(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Glacier2__SessionControl__getSessionTimeout_name);
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::SessionControl* __del = dynamic_cast< ::IceDelegate::Glacier2::SessionControl*>(__delBase.get());
            return __del->getSessionTimeout(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::Glacier2::SessionControl::destroy(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::SessionControl* __del = dynamic_cast< ::IceDelegate::Glacier2::SessionControl*>(__delBase.get());
            __del->destroy(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::Glacier2::SessionControl::destroy_async(const ::Glacier2::AMI_SessionControl_destroyPtr& __cb)
{
    __cb->__invoke(this, 0);
}

void
IceProxy::Glacier2::SessionControl::destroy_async(const ::Glacier2::AMI_SessionControl_destroyPtr& __cb, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, &__ctx);
}

const ::std::string&
IceProxy::Glacier2::SessionControl::ice_staticId()
{
    return ::Glacier2::SessionControl::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::SessionControl::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::SessionControl);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::SessionControl::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::SessionControl);
}

bool
IceProxy::Glacier2::operator==(const ::IceProxy::Glacier2::SessionControl& l, const ::IceProxy::Glacier2::SessionControl& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator!=(const ::IceProxy::Glacier2::SessionControl& l, const ::IceProxy::Glacier2::SessionControl& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<(const ::IceProxy::Glacier2::SessionControl& l, const ::IceProxy::Glacier2::SessionControl& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<=(const ::IceProxy::Glacier2::SessionControl& l, const ::IceProxy::Glacier2::SessionControl& r)
{
    return l < r || l == r;
}

bool
IceProxy::Glacier2::operator>(const ::IceProxy::Glacier2::SessionControl& l, const ::IceProxy::Glacier2::SessionControl& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::Glacier2::operator>=(const ::IceProxy::Glacier2::SessionControl& l, const ::IceProxy::Glacier2::SessionControl& r)
{
    return !(l < r);
}

::Glacier2::SessionPrx
IceProxy::Glacier2::SessionManager::create(const ::std::string& userId, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Glacier2__SessionManager__create_name);
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::SessionManager* __del = dynamic_cast< ::IceDelegate::Glacier2::SessionManager*>(__delBase.get());
            return __del->create(userId, control, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Glacier2::SessionManager::ice_staticId()
{
    return ::Glacier2::SessionManager::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::SessionManager::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::SessionManager);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::SessionManager::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::SessionManager);
}

bool
IceProxy::Glacier2::operator==(const ::IceProxy::Glacier2::SessionManager& l, const ::IceProxy::Glacier2::SessionManager& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator!=(const ::IceProxy::Glacier2::SessionManager& l, const ::IceProxy::Glacier2::SessionManager& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<(const ::IceProxy::Glacier2::SessionManager& l, const ::IceProxy::Glacier2::SessionManager& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<=(const ::IceProxy::Glacier2::SessionManager& l, const ::IceProxy::Glacier2::SessionManager& r)
{
    return l < r || l == r;
}

bool
IceProxy::Glacier2::operator>(const ::IceProxy::Glacier2::SessionManager& l, const ::IceProxy::Glacier2::SessionManager& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::Glacier2::operator>=(const ::IceProxy::Glacier2::SessionManager& l, const ::IceProxy::Glacier2::SessionManager& r)
{
    return !(l < r);
}

::Glacier2::SessionPrx
IceProxy::Glacier2::SSLSessionManager::create(const ::Glacier2::SSLInfo& info, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Glacier2__SSLSessionManager__create_name);
            __delBase = __getDelegate();
            ::IceDelegate::Glacier2::SSLSessionManager* __del = dynamic_cast< ::IceDelegate::Glacier2::SSLSessionManager*>(__delBase.get());
            return __del->create(info, control, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Glacier2::SSLSessionManager::ice_staticId()
{
    return ::Glacier2::SSLSessionManager::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Glacier2::SSLSessionManager::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Glacier2::SSLSessionManager);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Glacier2::SSLSessionManager::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Glacier2::SSLSessionManager);
}

bool
IceProxy::Glacier2::operator==(const ::IceProxy::Glacier2::SSLSessionManager& l, const ::IceProxy::Glacier2::SSLSessionManager& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator!=(const ::IceProxy::Glacier2::SSLSessionManager& l, const ::IceProxy::Glacier2::SSLSessionManager& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<(const ::IceProxy::Glacier2::SSLSessionManager& l, const ::IceProxy::Glacier2::SSLSessionManager& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::Glacier2::operator<=(const ::IceProxy::Glacier2::SSLSessionManager& l, const ::IceProxy::Glacier2::SSLSessionManager& r)
{
    return l < r || l == r;
}

bool
IceProxy::Glacier2::operator>(const ::IceProxy::Glacier2::SSLSessionManager& l, const ::IceProxy::Glacier2::SSLSessionManager& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::Glacier2::operator>=(const ::IceProxy::Glacier2::SSLSessionManager& l, const ::IceProxy::Glacier2::SSLSessionManager& r)
{
    return !(l < r);
}

void
IceDelegateM::Glacier2::Session::destroy(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__Session__destroy_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Glacier2::StringSet::add(const ::Ice::StringSeq& additions, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__StringSet__add_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(additions.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            __os->write(&additions[0], &additions[0] + additions.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Glacier2::StringSet::remove(const ::Ice::StringSeq& deletions, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__StringSet__remove_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(deletions.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            __os->write(&deletions[0], &deletions[0] + deletions.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::StringSeq
IceDelegateM::Glacier2::StringSet::get(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__StringSet__get_name, ::Ice::Idempotent, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::StringSeq __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Glacier2::IdentitySet::add(const ::Ice::IdentitySeq& additions, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__IdentitySet__add_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(additions.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Ice::__write(__os, &additions[0], &additions[0] + additions.size(), ::Ice::__U__IdentitySeq());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Glacier2::IdentitySet::remove(const ::Ice::IdentitySeq& deletions, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__IdentitySet__remove_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(deletions.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Ice::__write(__os, &deletions[0], &deletions[0] + deletions.size(), ::Ice::__U__IdentitySeq());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::IdentitySeq
IceDelegateM::Glacier2::IdentitySet::get(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__IdentitySet__get_name, ::Ice::Idempotent, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::IdentitySeq __ret;
        ::Ice::__read(__is, __ret, ::Ice::__U__IdentitySeq());
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Glacier2::StringSetPrx
IceDelegateM::Glacier2::SessionControl::categories(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__SessionControl__categories_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Glacier2::StringSetPrx __ret;
        ::Glacier2::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Glacier2::StringSetPrx
IceDelegateM::Glacier2::SessionControl::adapterIds(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__SessionControl__adapterIds_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Glacier2::StringSetPrx __ret;
        ::Glacier2::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Glacier2::IdentitySetPrx
IceDelegateM::Glacier2::SessionControl::identities(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__SessionControl__identities_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Glacier2::IdentitySetPrx __ret;
        ::Glacier2::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::Int
IceDelegateM::Glacier2::SessionControl::getSessionTimeout(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__SessionControl__getSessionTimeout_name, ::Ice::Idempotent, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::Int __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Glacier2::SessionControl::destroy(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__SessionControl__destroy_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Glacier2::SessionPrx
IceDelegateM::Glacier2::SessionManager::create(const ::std::string& userId, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__SessionManager__create_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(userId);
        ::Glacier2::__write(__os, control);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Glacier2::CannotCreateSessionException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Glacier2::SessionPrx __ret;
        ::Glacier2::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Glacier2::SessionPrx
IceDelegateM::Glacier2::SSLSessionManager::create(const ::Glacier2::SSLInfo& info, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __Glacier2__SSLSessionManager__create_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        info.__write(__os);
        ::Glacier2::__write(__os, control);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Glacier2::CannotCreateSessionException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Glacier2::SessionPrx __ret;
        ::Glacier2::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateD::Glacier2::Session::destroy(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__Session__destroy_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::Glacier2::Session* __servant = dynamic_cast< ::Glacier2::Session*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->destroy(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::Glacier2::StringSet::add(const ::Ice::StringSeq& additions, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__StringSet__add_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::Glacier2::StringSet* __servant = dynamic_cast< ::Glacier2::StringSet*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->add(additions, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::Glacier2::StringSet::remove(const ::Ice::StringSeq& deletions, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__StringSet__remove_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::Glacier2::StringSet* __servant = dynamic_cast< ::Glacier2::StringSet*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->remove(deletions, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::Ice::StringSeq
IceDelegateD::Glacier2::StringSet::get(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__StringSet__get_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::StringSeq __ret;
        try
        {
            ::Glacier2::StringSet* __servant = dynamic_cast< ::Glacier2::StringSet*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->get(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::Glacier2::IdentitySet::add(const ::Ice::IdentitySeq& additions, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__IdentitySet__add_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::Glacier2::IdentitySet* __servant = dynamic_cast< ::Glacier2::IdentitySet*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->add(additions, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::Glacier2::IdentitySet::remove(const ::Ice::IdentitySeq& deletions, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__IdentitySet__remove_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::Glacier2::IdentitySet* __servant = dynamic_cast< ::Glacier2::IdentitySet*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->remove(deletions, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::Ice::IdentitySeq
IceDelegateD::Glacier2::IdentitySet::get(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__IdentitySet__get_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::IdentitySeq __ret;
        try
        {
            ::Glacier2::IdentitySet* __servant = dynamic_cast< ::Glacier2::IdentitySet*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->get(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Glacier2::StringSetPrx
IceDelegateD::Glacier2::SessionControl::categories(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SessionControl__categories_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Glacier2::StringSetPrx __ret;
        try
        {
            ::Glacier2::SessionControl* __servant = dynamic_cast< ::Glacier2::SessionControl*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->categories(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Glacier2::StringSetPrx
IceDelegateD::Glacier2::SessionControl::adapterIds(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SessionControl__adapterIds_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Glacier2::StringSetPrx __ret;
        try
        {
            ::Glacier2::SessionControl* __servant = dynamic_cast< ::Glacier2::SessionControl*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->adapterIds(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Glacier2::IdentitySetPrx
IceDelegateD::Glacier2::SessionControl::identities(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SessionControl__identities_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Glacier2::IdentitySetPrx __ret;
        try
        {
            ::Glacier2::SessionControl* __servant = dynamic_cast< ::Glacier2::SessionControl*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->identities(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::Int
IceDelegateD::Glacier2::SessionControl::getSessionTimeout(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SessionControl__getSessionTimeout_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::Int __ret;
        try
        {
            ::Glacier2::SessionControl* __servant = dynamic_cast< ::Glacier2::SessionControl*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getSessionTimeout(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::Glacier2::SessionControl::destroy(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SessionControl__destroy_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::Glacier2::SessionControl* __servant = dynamic_cast< ::Glacier2::SessionControl*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->destroy(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::Glacier2::SessionPrx
IceDelegateD::Glacier2::SessionManager::create(const ::std::string& userId, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SessionManager__create_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Glacier2::SessionPrx __ret;
        try
        {
            ::Glacier2::SessionManager* __servant = dynamic_cast< ::Glacier2::SessionManager*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->create(userId, control, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Glacier2::SessionPrx
IceDelegateD::Glacier2::SSLSessionManager::create(const ::Glacier2::SSLInfo& info, const ::Glacier2::SessionControlPrx& control, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __Glacier2__SSLSessionManager__create_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Glacier2::SessionPrx __ret;
        try
        {
            ::Glacier2::SSLSessionManager* __servant = dynamic_cast< ::Glacier2::SSLSessionManager*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->create(info, control, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::ObjectPtr
Glacier2::Session::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__Session_ids[2] =
{
    "::Glacier2::Session",
    "::Ice::Object"
};

bool
Glacier2::Session::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__Session_ids, __Glacier2__Session_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::Session::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__Session_ids[0], &__Glacier2__Session_ids[2]);
}

const ::std::string&
Glacier2::Session::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__Session_ids[0];
}

const ::std::string&
Glacier2::Session::ice_staticId()
{
    return __Glacier2__Session_ids[0];
}

::IceInternal::DispatchStatus
Glacier2::Session::___destroy(::IceInternal::Incoming&, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    destroy(__current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __Glacier2__Session_all[] =
{
    "destroy",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
Glacier2::Session::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__Session_all, __Glacier2__Session_all + 5, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __Glacier2__Session_all)
    {
        case 0:
        {
            return ___destroy(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
Glacier2::Session::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::Session::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::Session::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::Session was not generated with stream support";
    throw ex;
}

void
Glacier2::Session::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::Session was not generated with stream support";
    throw ex;
}

void GLACIER2_API 
Glacier2::__patch__SessionPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::SessionPtr* p = static_cast< ::Glacier2::SessionPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::SessionPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::Glacier2::Session::ice_staticId();
        throw e;
    }
}

bool
Glacier2::operator==(const ::Glacier2::Session& l, const ::Glacier2::Session& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator!=(const ::Glacier2::Session& l, const ::Glacier2::Session& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::Session& l, const ::Glacier2::Session& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<=(const ::Glacier2::Session& l, const ::Glacier2::Session& r)
{
    return l < r || l == r;
}

bool
Glacier2::operator>(const ::Glacier2::Session& l, const ::Glacier2::Session& r)
{
    return !(l < r) && !(l == r);
}

bool
Glacier2::operator>=(const ::Glacier2::Session& l, const ::Glacier2::Session& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
Glacier2::StringSet::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__StringSet_ids[2] =
{
    "::Glacier2::StringSet",
    "::Ice::Object"
};

bool
Glacier2::StringSet::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__StringSet_ids, __Glacier2__StringSet_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::StringSet::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__StringSet_ids[0], &__Glacier2__StringSet_ids[2]);
}

const ::std::string&
Glacier2::StringSet::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__StringSet_ids[0];
}

const ::std::string&
Glacier2::StringSet::ice_staticId()
{
    return __Glacier2__StringSet_ids[0];
}

::IceInternal::DispatchStatus
Glacier2::StringSet::___add(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::Ice::StringSeq additions;
    __is->read(additions);
    add(additions, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
Glacier2::StringSet::___remove(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::Ice::StringSeq deletions;
    __is->read(deletions);
    remove(deletions, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
Glacier2::StringSet::___get(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::StringSeq __ret = get(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&__ret[0], &__ret[0] + __ret.size());
    }
    return ::IceInternal::DispatchOK;
}

static ::std::string __Glacier2__StringSet_all[] =
{
    "add",
    "get",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "remove"
};

::IceInternal::DispatchStatus
Glacier2::StringSet::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__StringSet_all, __Glacier2__StringSet_all + 7, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __Glacier2__StringSet_all)
    {
        case 0:
        {
            return ___add(in, current);
        }
        case 1:
        {
            return ___get(in, current);
        }
        case 2:
        {
            return ___ice_id(in, current);
        }
        case 3:
        {
            return ___ice_ids(in, current);
        }
        case 4:
        {
            return ___ice_isA(in, current);
        }
        case 5:
        {
            return ___ice_ping(in, current);
        }
        case 6:
        {
            return ___remove(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
Glacier2::StringSet::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::StringSet::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::StringSet::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::StringSet was not generated with stream support";
    throw ex;
}

void
Glacier2::StringSet::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::StringSet was not generated with stream support";
    throw ex;
}

void GLACIER2_API 
Glacier2::__patch__StringSetPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::StringSetPtr* p = static_cast< ::Glacier2::StringSetPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::StringSetPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::Glacier2::StringSet::ice_staticId();
        throw e;
    }
}

bool
Glacier2::operator==(const ::Glacier2::StringSet& l, const ::Glacier2::StringSet& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator!=(const ::Glacier2::StringSet& l, const ::Glacier2::StringSet& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::StringSet& l, const ::Glacier2::StringSet& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<=(const ::Glacier2::StringSet& l, const ::Glacier2::StringSet& r)
{
    return l < r || l == r;
}

bool
Glacier2::operator>(const ::Glacier2::StringSet& l, const ::Glacier2::StringSet& r)
{
    return !(l < r) && !(l == r);
}

bool
Glacier2::operator>=(const ::Glacier2::StringSet& l, const ::Glacier2::StringSet& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
Glacier2::IdentitySet::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__IdentitySet_ids[2] =
{
    "::Glacier2::IdentitySet",
    "::Ice::Object"
};

bool
Glacier2::IdentitySet::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__IdentitySet_ids, __Glacier2__IdentitySet_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::IdentitySet::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__IdentitySet_ids[0], &__Glacier2__IdentitySet_ids[2]);
}

const ::std::string&
Glacier2::IdentitySet::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__IdentitySet_ids[0];
}

const ::std::string&
Glacier2::IdentitySet::ice_staticId()
{
    return __Glacier2__IdentitySet_ids[0];
}

::IceInternal::DispatchStatus
Glacier2::IdentitySet::___add(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::Ice::IdentitySeq additions;
    ::Ice::__read(__is, additions, ::Ice::__U__IdentitySeq());
    add(additions, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
Glacier2::IdentitySet::___remove(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::Ice::IdentitySeq deletions;
    ::Ice::__read(__is, deletions, ::Ice::__U__IdentitySeq());
    remove(deletions, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
Glacier2::IdentitySet::___get(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::IdentitySeq __ret = get(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::Ice::__write(__os, &__ret[0], &__ret[0] + __ret.size(), ::Ice::__U__IdentitySeq());
    }
    return ::IceInternal::DispatchOK;
}

static ::std::string __Glacier2__IdentitySet_all[] =
{
    "add",
    "get",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "remove"
};

::IceInternal::DispatchStatus
Glacier2::IdentitySet::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__IdentitySet_all, __Glacier2__IdentitySet_all + 7, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __Glacier2__IdentitySet_all)
    {
        case 0:
        {
            return ___add(in, current);
        }
        case 1:
        {
            return ___get(in, current);
        }
        case 2:
        {
            return ___ice_id(in, current);
        }
        case 3:
        {
            return ___ice_ids(in, current);
        }
        case 4:
        {
            return ___ice_isA(in, current);
        }
        case 5:
        {
            return ___ice_ping(in, current);
        }
        case 6:
        {
            return ___remove(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
Glacier2::IdentitySet::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::IdentitySet::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::IdentitySet::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::IdentitySet was not generated with stream support";
    throw ex;
}

void
Glacier2::IdentitySet::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::IdentitySet was not generated with stream support";
    throw ex;
}

void GLACIER2_API 
Glacier2::__patch__IdentitySetPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::IdentitySetPtr* p = static_cast< ::Glacier2::IdentitySetPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::IdentitySetPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::Glacier2::IdentitySet::ice_staticId();
        throw e;
    }
}

bool
Glacier2::operator==(const ::Glacier2::IdentitySet& l, const ::Glacier2::IdentitySet& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator!=(const ::Glacier2::IdentitySet& l, const ::Glacier2::IdentitySet& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::IdentitySet& l, const ::Glacier2::IdentitySet& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<=(const ::Glacier2::IdentitySet& l, const ::Glacier2::IdentitySet& r)
{
    return l < r || l == r;
}

bool
Glacier2::operator>(const ::Glacier2::IdentitySet& l, const ::Glacier2::IdentitySet& r)
{
    return !(l < r) && !(l == r);
}

bool
Glacier2::operator>=(const ::Glacier2::IdentitySet& l, const ::Glacier2::IdentitySet& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
Glacier2::SessionControl::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__SessionControl_ids[2] =
{
    "::Glacier2::SessionControl",
    "::Ice::Object"
};

bool
Glacier2::SessionControl::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__SessionControl_ids, __Glacier2__SessionControl_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::SessionControl::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__SessionControl_ids[0], &__Glacier2__SessionControl_ids[2]);
}

const ::std::string&
Glacier2::SessionControl::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__SessionControl_ids[0];
}

const ::std::string&
Glacier2::SessionControl::ice_staticId()
{
    return __Glacier2__SessionControl_ids[0];
}

::IceInternal::DispatchStatus
Glacier2::SessionControl::___categories(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Glacier2::StringSetPrx __ret = categories(__current);
    ::Glacier2::__write(__os, __ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
Glacier2::SessionControl::___adapterIds(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Glacier2::StringSetPrx __ret = adapterIds(__current);
    ::Glacier2::__write(__os, __ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
Glacier2::SessionControl::___identities(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Glacier2::IdentitySetPrx __ret = identities(__current);
    ::Glacier2::__write(__os, __ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
Glacier2::SessionControl::___getSessionTimeout(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Int __ret = getSessionTimeout(__current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
Glacier2::SessionControl::___destroy(::IceInternal::Incoming&, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    destroy(__current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __Glacier2__SessionControl_all[] =
{
    "adapterIds",
    "categories",
    "destroy",
    "getSessionTimeout",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "identities"
};

::IceInternal::DispatchStatus
Glacier2::SessionControl::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__SessionControl_all, __Glacier2__SessionControl_all + 9, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __Glacier2__SessionControl_all)
    {
        case 0:
        {
            return ___adapterIds(in, current);
        }
        case 1:
        {
            return ___categories(in, current);
        }
        case 2:
        {
            return ___destroy(in, current);
        }
        case 3:
        {
            return ___getSessionTimeout(in, current);
        }
        case 4:
        {
            return ___ice_id(in, current);
        }
        case 5:
        {
            return ___ice_ids(in, current);
        }
        case 6:
        {
            return ___ice_isA(in, current);
        }
        case 7:
        {
            return ___ice_ping(in, current);
        }
        case 8:
        {
            return ___identities(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
Glacier2::SessionControl::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::SessionControl::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::SessionControl::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SessionControl was not generated with stream support";
    throw ex;
}

void
Glacier2::SessionControl::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SessionControl was not generated with stream support";
    throw ex;
}

void GLACIER2_API 
Glacier2::__patch__SessionControlPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::SessionControlPtr* p = static_cast< ::Glacier2::SessionControlPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::SessionControlPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::Glacier2::SessionControl::ice_staticId();
        throw e;
    }
}

bool
Glacier2::operator==(const ::Glacier2::SessionControl& l, const ::Glacier2::SessionControl& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator!=(const ::Glacier2::SessionControl& l, const ::Glacier2::SessionControl& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::SessionControl& l, const ::Glacier2::SessionControl& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<=(const ::Glacier2::SessionControl& l, const ::Glacier2::SessionControl& r)
{
    return l < r || l == r;
}

bool
Glacier2::operator>(const ::Glacier2::SessionControl& l, const ::Glacier2::SessionControl& r)
{
    return !(l < r) && !(l == r);
}

bool
Glacier2::operator>=(const ::Glacier2::SessionControl& l, const ::Glacier2::SessionControl& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
Glacier2::SessionManager::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__SessionManager_ids[2] =
{
    "::Glacier2::SessionManager",
    "::Ice::Object"
};

bool
Glacier2::SessionManager::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__SessionManager_ids, __Glacier2__SessionManager_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::SessionManager::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__SessionManager_ids[0], &__Glacier2__SessionManager_ids[2]);
}

const ::std::string&
Glacier2::SessionManager::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__SessionManager_ids[0];
}

const ::std::string&
Glacier2::SessionManager::ice_staticId()
{
    return __Glacier2__SessionManager_ids[0];
}

::IceInternal::DispatchStatus
Glacier2::SessionManager::___create(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string userId;
    ::Glacier2::SessionControlPrx control;
    __is->read(userId);
    ::Glacier2::__read(__is, control);
    try
    {
        ::Glacier2::SessionPrx __ret = create(userId, control, __current);
        ::Glacier2::__write(__os, __ret);
    }
    catch(const ::Glacier2::CannotCreateSessionException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

static ::std::string __Glacier2__SessionManager_all[] =
{
    "create",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
Glacier2::SessionManager::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__SessionManager_all, __Glacier2__SessionManager_all + 5, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __Glacier2__SessionManager_all)
    {
        case 0:
        {
            return ___create(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
Glacier2::SessionManager::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::SessionManager::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::SessionManager::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SessionManager was not generated with stream support";
    throw ex;
}

void
Glacier2::SessionManager::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SessionManager was not generated with stream support";
    throw ex;
}

void GLACIER2_API 
Glacier2::__patch__SessionManagerPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::SessionManagerPtr* p = static_cast< ::Glacier2::SessionManagerPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::SessionManagerPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::Glacier2::SessionManager::ice_staticId();
        throw e;
    }
}

bool
Glacier2::operator==(const ::Glacier2::SessionManager& l, const ::Glacier2::SessionManager& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator!=(const ::Glacier2::SessionManager& l, const ::Glacier2::SessionManager& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::SessionManager& l, const ::Glacier2::SessionManager& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<=(const ::Glacier2::SessionManager& l, const ::Glacier2::SessionManager& r)
{
    return l < r || l == r;
}

bool
Glacier2::operator>(const ::Glacier2::SessionManager& l, const ::Glacier2::SessionManager& r)
{
    return !(l < r) && !(l == r);
}

bool
Glacier2::operator>=(const ::Glacier2::SessionManager& l, const ::Glacier2::SessionManager& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
Glacier2::SSLSessionManager::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Glacier2__SSLSessionManager_ids[2] =
{
    "::Glacier2::SSLSessionManager",
    "::Ice::Object"
};

bool
Glacier2::SSLSessionManager::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Glacier2__SSLSessionManager_ids, __Glacier2__SSLSessionManager_ids + 2, _s);
}

::std::vector< ::std::string>
Glacier2::SSLSessionManager::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Glacier2__SSLSessionManager_ids[0], &__Glacier2__SSLSessionManager_ids[2]);
}

const ::std::string&
Glacier2::SSLSessionManager::ice_id(const ::Ice::Current&) const
{
    return __Glacier2__SSLSessionManager_ids[0];
}

const ::std::string&
Glacier2::SSLSessionManager::ice_staticId()
{
    return __Glacier2__SSLSessionManager_ids[0];
}

::IceInternal::DispatchStatus
Glacier2::SSLSessionManager::___create(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Glacier2::SSLInfo info;
    ::Glacier2::SessionControlPrx control;
    info.__read(__is);
    ::Glacier2::__read(__is, control);
    try
    {
        ::Glacier2::SessionPrx __ret = create(info, control, __current);
        ::Glacier2::__write(__os, __ret);
    }
    catch(const ::Glacier2::CannotCreateSessionException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

static ::std::string __Glacier2__SSLSessionManager_all[] =
{
    "create",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
Glacier2::SSLSessionManager::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Glacier2__SSLSessionManager_all, __Glacier2__SSLSessionManager_all + 5, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __Glacier2__SSLSessionManager_all)
    {
        case 0:
        {
            return ___create(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
Glacier2::SSLSessionManager::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Glacier2::SSLSessionManager::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Glacier2::SSLSessionManager::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SSLSessionManager was not generated with stream support";
    throw ex;
}

void
Glacier2::SSLSessionManager::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Glacier2::SSLSessionManager was not generated with stream support";
    throw ex;
}

void GLACIER2_API 
Glacier2::__patch__SSLSessionManagerPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Glacier2::SSLSessionManagerPtr* p = static_cast< ::Glacier2::SSLSessionManagerPtr*>(__addr);
    assert(p);
    *p = ::Glacier2::SSLSessionManagerPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::Glacier2::SSLSessionManager::ice_staticId();
        throw e;
    }
}

bool
Glacier2::operator==(const ::Glacier2::SSLSessionManager& l, const ::Glacier2::SSLSessionManager& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator!=(const ::Glacier2::SSLSessionManager& l, const ::Glacier2::SSLSessionManager& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<(const ::Glacier2::SSLSessionManager& l, const ::Glacier2::SSLSessionManager& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
Glacier2::operator<=(const ::Glacier2::SSLSessionManager& l, const ::Glacier2::SSLSessionManager& r)
{
    return l < r || l == r;
}

bool
Glacier2::operator>(const ::Glacier2::SSLSessionManager& l, const ::Glacier2::SSLSessionManager& r)
{
    return !(l < r) && !(l == r);
}

bool
Glacier2::operator>=(const ::Glacier2::SSLSessionManager& l, const ::Glacier2::SSLSessionManager& r)
{
    return !(l < r);
}
