// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `IceBox.ice'

#include <IceBox/IceBox.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceBox__Service__start_name = "start";

static const ::std::string __IceBox__Service__stop_name = "stop";

static const ::std::string __IceBox__ServiceManager__getSliceChecksums_name = "getSliceChecksums";

static const ::std::string __IceBox__ServiceManager__startService_name = "startService";

static const ::std::string __IceBox__ServiceManager__stopService_name = "stopService";

static const ::std::string __IceBox__ServiceManager__shutdown_name = "shutdown";

void
IceInternal::incRef(::IceBox::Service* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceBox::Service* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceBox::ServiceManager* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceBox::ServiceManager* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceBox::ServiceManager* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceBox::ServiceManager* p)
{
    p->__decRef();
}

void
IceBox::__write(::IceInternal::BasicStream* __os, const ::IceBox::ServiceManagerPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceBox::__read(::IceInternal::BasicStream* __is, ::IceBox::ServiceManagerPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceBox::ServiceManager;
        v->__copyFrom(proxy);
    }
}

void
IceBox::__write(::IceInternal::BasicStream* __os, const ::IceBox::ServiceManagerPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

IceBox::FailureException::FailureException(const char* __file, int __line) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    LocalException(__file, __line)
#else
    ::Ice::LocalException(__file, __line)
#endif
{
}

IceBox::FailureException::FailureException(const char* __file, int __line, const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    LocalException(__file, __line),
#else
    ::Ice::LocalException(__file, __line),
#endif
    reason(__ice_reason)
{
}

IceBox::FailureException::~FailureException() throw()
{
}

static const char* __IceBox__FailureException_name = "IceBox::FailureException";

::std::string
IceBox::FailureException::ice_name() const
{
    return __IceBox__FailureException_name;
}

::Ice::Exception*
IceBox::FailureException::ice_clone() const
{
    return new FailureException(*this);
}

void
IceBox::FailureException::ice_throw() const
{
    throw *this;
}

IceBox::AlreadyStartedException::~AlreadyStartedException() throw()
{
}

static const char* __IceBox__AlreadyStartedException_name = "IceBox::AlreadyStartedException";

::std::string
IceBox::AlreadyStartedException::ice_name() const
{
    return __IceBox__AlreadyStartedException_name;
}

::Ice::Exception*
IceBox::AlreadyStartedException::ice_clone() const
{
    return new AlreadyStartedException(*this);
}

void
IceBox::AlreadyStartedException::ice_throw() const
{
    throw *this;
}

void
IceBox::AlreadyStartedException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceBox::AlreadyStartedException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
}

void
IceBox::AlreadyStartedException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
}

void
IceBox::AlreadyStartedException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceBox::AlreadyStartedException was not generated with stream support";
    throw ex;
}

void
IceBox::AlreadyStartedException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceBox::AlreadyStartedException was not generated with stream support";
    throw ex;
}

struct __F__IceBox__AlreadyStartedException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceBox::AlreadyStartedException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceBox__AlreadyStartedException__Ptr = new __F__IceBox__AlreadyStartedException;

const ::IceInternal::UserExceptionFactoryPtr&
IceBox::AlreadyStartedException::ice_factory()
{
    return __F__IceBox__AlreadyStartedException__Ptr;
}

class __F__IceBox__AlreadyStartedException__Init
{
public:

    __F__IceBox__AlreadyStartedException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceBox::AlreadyStartedException", ::IceBox::AlreadyStartedException::ice_factory());
    }

    ~__F__IceBox__AlreadyStartedException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceBox::AlreadyStartedException");
    }
};

static __F__IceBox__AlreadyStartedException__Init __F__IceBox__AlreadyStartedException__i;

#ifdef __APPLE__
extern "C" { void __F__IceBox__AlreadyStartedException__initializer() {} }
#endif

IceBox::AlreadyStoppedException::~AlreadyStoppedException() throw()
{
}

static const char* __IceBox__AlreadyStoppedException_name = "IceBox::AlreadyStoppedException";

::std::string
IceBox::AlreadyStoppedException::ice_name() const
{
    return __IceBox__AlreadyStoppedException_name;
}

::Ice::Exception*
IceBox::AlreadyStoppedException::ice_clone() const
{
    return new AlreadyStoppedException(*this);
}

void
IceBox::AlreadyStoppedException::ice_throw() const
{
    throw *this;
}

void
IceBox::AlreadyStoppedException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceBox::AlreadyStoppedException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
}

void
IceBox::AlreadyStoppedException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
}

void
IceBox::AlreadyStoppedException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceBox::AlreadyStoppedException was not generated with stream support";
    throw ex;
}

void
IceBox::AlreadyStoppedException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceBox::AlreadyStoppedException was not generated with stream support";
    throw ex;
}

struct __F__IceBox__AlreadyStoppedException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceBox::AlreadyStoppedException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceBox__AlreadyStoppedException__Ptr = new __F__IceBox__AlreadyStoppedException;

const ::IceInternal::UserExceptionFactoryPtr&
IceBox::AlreadyStoppedException::ice_factory()
{
    return __F__IceBox__AlreadyStoppedException__Ptr;
}

class __F__IceBox__AlreadyStoppedException__Init
{
public:

    __F__IceBox__AlreadyStoppedException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceBox::AlreadyStoppedException", ::IceBox::AlreadyStoppedException::ice_factory());
    }

    ~__F__IceBox__AlreadyStoppedException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceBox::AlreadyStoppedException");
    }
};

static __F__IceBox__AlreadyStoppedException__Init __F__IceBox__AlreadyStoppedException__i;

#ifdef __APPLE__
extern "C" { void __F__IceBox__AlreadyStoppedException__initializer() {} }
#endif

IceBox::NoSuchServiceException::~NoSuchServiceException() throw()
{
}

static const char* __IceBox__NoSuchServiceException_name = "IceBox::NoSuchServiceException";

::std::string
IceBox::NoSuchServiceException::ice_name() const
{
    return __IceBox__NoSuchServiceException_name;
}

::Ice::Exception*
IceBox::NoSuchServiceException::ice_clone() const
{
    return new NoSuchServiceException(*this);
}

void
IceBox::NoSuchServiceException::ice_throw() const
{
    throw *this;
}

void
IceBox::NoSuchServiceException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceBox::NoSuchServiceException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
}

void
IceBox::NoSuchServiceException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
}

void
IceBox::NoSuchServiceException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceBox::NoSuchServiceException was not generated with stream support";
    throw ex;
}

void
IceBox::NoSuchServiceException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceBox::NoSuchServiceException was not generated with stream support";
    throw ex;
}

struct __F__IceBox__NoSuchServiceException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceBox::NoSuchServiceException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceBox__NoSuchServiceException__Ptr = new __F__IceBox__NoSuchServiceException;

const ::IceInternal::UserExceptionFactoryPtr&
IceBox::NoSuchServiceException::ice_factory()
{
    return __F__IceBox__NoSuchServiceException__Ptr;
}

class __F__IceBox__NoSuchServiceException__Init
{
public:

    __F__IceBox__NoSuchServiceException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceBox::NoSuchServiceException", ::IceBox::NoSuchServiceException::ice_factory());
    }

    ~__F__IceBox__NoSuchServiceException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceBox::NoSuchServiceException");
    }
};

static __F__IceBox__NoSuchServiceException__Init __F__IceBox__NoSuchServiceException__i;

#ifdef __APPLE__
extern "C" { void __F__IceBox__NoSuchServiceException__initializer() {} }
#endif

void
IceBox::__addObject(const ServiceManagerPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceBox::__usesClasses(const ServiceManagerPtr& p)
{
    return p->__usesClasses();
}

void
IceBox::__decRefUnsafe(const ServiceManagerPtr& p)
{
    p->__decRefUnsafe();
}

void
IceBox::__clearHandleUnsafe(ServiceManagerPtr& p)
{
    p.__clearHandleUnsafe();
}

::Ice::SliceChecksumDict
IceProxy::IceBox::ServiceManager::getSliceChecksums(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceBox__ServiceManager__getSliceChecksums_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceBox::ServiceManager* __del = dynamic_cast< ::IceDelegate::IceBox::ServiceManager*>(__delBase.get());
            return __del->getSliceChecksums(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceBox::ServiceManager::startService(const ::std::string& service, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceBox__ServiceManager__startService_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceBox::ServiceManager* __del = dynamic_cast< ::IceDelegate::IceBox::ServiceManager*>(__delBase.get());
            __del->startService(service, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceBox::ServiceManager::stopService(const ::std::string& service, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceBox__ServiceManager__stopService_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceBox::ServiceManager* __del = dynamic_cast< ::IceDelegate::IceBox::ServiceManager*>(__delBase.get());
            __del->stopService(service, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceBox::ServiceManager::shutdown(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceBox::ServiceManager* __del = dynamic_cast< ::IceDelegate::IceBox::ServiceManager*>(__delBase.get());
            __del->shutdown(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceBox::ServiceManager::ice_staticId()
{
    return ::IceBox::ServiceManager::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceBox::ServiceManager::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceBox::ServiceManager);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceBox::ServiceManager::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceBox::ServiceManager);
}

bool
IceProxy::IceBox::operator==(const ::IceProxy::IceBox::ServiceManager& l, const ::IceProxy::IceBox::ServiceManager& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceBox::operator!=(const ::IceProxy::IceBox::ServiceManager& l, const ::IceProxy::IceBox::ServiceManager& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceBox::operator<(const ::IceProxy::IceBox::ServiceManager& l, const ::IceProxy::IceBox::ServiceManager& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceBox::operator<=(const ::IceProxy::IceBox::ServiceManager& l, const ::IceProxy::IceBox::ServiceManager& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceBox::operator>(const ::IceProxy::IceBox::ServiceManager& l, const ::IceProxy::IceBox::ServiceManager& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceBox::operator>=(const ::IceProxy::IceBox::ServiceManager& l, const ::IceProxy::IceBox::ServiceManager& r)
{
    return !(l < r);
}

::Ice::SliceChecksumDict
IceDelegateM::IceBox::ServiceManager::getSliceChecksums(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceBox__ServiceManager__getSliceChecksums_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::SliceChecksumDict __ret;
        ::Ice::__read(__is, __ret, ::Ice::__U__SliceChecksumDict());
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceBox::ServiceManager::startService(const ::std::string& service, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceBox__ServiceManager__startService_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(service);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceBox::AlreadyStartedException&)
            {
                throw;
            }
            catch(const ::IceBox::NoSuchServiceException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceBox::ServiceManager::stopService(const ::std::string& service, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceBox__ServiceManager__stopService_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(service);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceBox::AlreadyStoppedException&)
            {
                throw;
            }
            catch(const ::IceBox::NoSuchServiceException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceBox::ServiceManager::shutdown(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceBox__ServiceManager__shutdown_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::SliceChecksumDict
IceDelegateD::IceBox::ServiceManager::getSliceChecksums(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceBox__ServiceManager__getSliceChecksums_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::SliceChecksumDict __ret;
        try
        {
            ::IceBox::ServiceManager* __servant = dynamic_cast< ::IceBox::ServiceManager*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getSliceChecksums(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::IceBox::ServiceManager::startService(const ::std::string& service, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceBox__ServiceManager__startService_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceBox::ServiceManager* __servant = dynamic_cast< ::IceBox::ServiceManager*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->startService(service, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceBox::ServiceManager::stopService(const ::std::string& service, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceBox__ServiceManager__stopService_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceBox::ServiceManager* __servant = dynamic_cast< ::IceBox::ServiceManager*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->stopService(service, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceBox::ServiceManager::shutdown(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceBox__ServiceManager__shutdown_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceBox::ServiceManager* __servant = dynamic_cast< ::IceBox::ServiceManager*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->shutdown(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

bool
IceBox::operator==(const ::IceBox::Service& l, const ::IceBox::Service& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) == static_cast<const ::Ice::LocalObject&>(r);
}

bool
IceBox::operator!=(const ::IceBox::Service& l, const ::IceBox::Service& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) != static_cast<const ::Ice::LocalObject&>(r);
}

bool
IceBox::operator<(const ::IceBox::Service& l, const ::IceBox::Service& r)
{
    return static_cast<const ::Ice::LocalObject&>(l) < static_cast<const ::Ice::LocalObject&>(r);
}

bool
IceBox::operator<=(const ::IceBox::Service& l, const ::IceBox::Service& r)
{
    return l < r || l == r;
}

bool
IceBox::operator>(const ::IceBox::Service& l, const ::IceBox::Service& r)
{
    return !(l < r) && !(l == r);
}

bool
IceBox::operator>=(const ::IceBox::Service& l, const ::IceBox::Service& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceBox::ServiceManager::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceBox__ServiceManager_ids[2] =
{
    "::Ice::Object",
    "::IceBox::ServiceManager"
};

bool
IceBox::ServiceManager::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceBox__ServiceManager_ids, __IceBox__ServiceManager_ids + 2, _s);
}

::std::vector< ::std::string>
IceBox::ServiceManager::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceBox__ServiceManager_ids[0], &__IceBox__ServiceManager_ids[2]);
}

const ::std::string&
IceBox::ServiceManager::ice_id(const ::Ice::Current&) const
{
    return __IceBox__ServiceManager_ids[1];
}

const ::std::string&
IceBox::ServiceManager::ice_staticId()
{
    return __IceBox__ServiceManager_ids[1];
}

::IceInternal::DispatchStatus
IceBox::ServiceManager::___getSliceChecksums(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::SliceChecksumDict __ret = getSliceChecksums(__current);
    ::Ice::__write(__os, __ret, ::Ice::__U__SliceChecksumDict());
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceBox::ServiceManager::___startService(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string service;
    __is->read(service);
    try
    {
        startService(service, __current);
    }
    catch(const ::IceBox::AlreadyStartedException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    catch(const ::IceBox::NoSuchServiceException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceBox::ServiceManager::___stopService(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string service;
    __is->read(service);
    try
    {
        stopService(service, __current);
    }
    catch(const ::IceBox::AlreadyStoppedException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    catch(const ::IceBox::NoSuchServiceException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceBox::ServiceManager::___shutdown(::IceInternal::Incoming&, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    shutdown(__current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceBox__ServiceManager_all[] =
{
    "getSliceChecksums",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "shutdown",
    "startService",
    "stopService"
};

::IceInternal::DispatchStatus
IceBox::ServiceManager::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceBox__ServiceManager_all, __IceBox__ServiceManager_all + 8, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceBox__ServiceManager_all)
    {
        case 0:
        {
            return ___getSliceChecksums(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
        case 5:
        {
            return ___shutdown(in, current);
        }
        case 6:
        {
            return ___startService(in, current);
        }
        case 7:
        {
            return ___stopService(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceBox::ServiceManager::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceBox::ServiceManager::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceBox::ServiceManager::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceBox::ServiceManager was not generated with stream support";
    throw ex;
}

void
IceBox::ServiceManager::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceBox::ServiceManager was not generated with stream support";
    throw ex;
}

void ICE_BOX_API 
IceBox::__patch__ServiceManagerPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceBox::ServiceManagerPtr* p = static_cast< ::IceBox::ServiceManagerPtr*>(__addr);
    assert(p);
    *p = ::IceBox::ServiceManagerPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceBox::ServiceManager::ice_staticId();
        throw e;
    }
}

bool
IceBox::operator==(const ::IceBox::ServiceManager& l, const ::IceBox::ServiceManager& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceBox::operator!=(const ::IceBox::ServiceManager& l, const ::IceBox::ServiceManager& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceBox::operator<(const ::IceBox::ServiceManager& l, const ::IceBox::ServiceManager& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceBox::operator<=(const ::IceBox::ServiceManager& l, const ::IceBox::ServiceManager& r)
{
    return l < r || l == r;
}

bool
IceBox::operator>(const ::IceBox::ServiceManager& l, const ::IceBox::ServiceManager& r)
{
    return !(l < r) && !(l == r);
}

bool
IceBox::operator>=(const ::IceBox::ServiceManager& l, const ::IceBox::ServiceManager& r)
{
    return !(l < r);
}

static const char* __sliceChecksums[] =
{
    "::IceBox::AlreadyStartedException", "d5b097af3221b37482d5f175502abf62",
    "::IceBox::AlreadyStoppedException", "281d493a84d674b3a4335d6afc2c16",
    "::IceBox::NoSuchServiceException", "5957f1c582d9aebad557cbdb7820d4",
    "::IceBox::ServiceManager", "bddccbbf39fa7fb676510d582159c",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
