// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `FileParser.ice'

#include <IceGrid/FileParser.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceGrid__FileParser__parse_name = "parse";

void
IceInternal::incRef(::IceGrid::FileParser* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::FileParser* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::FileParser* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::FileParser* p)
{
    p->__decRef();
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::FileParserPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::FileParserPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::FileParser;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::FileParserPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

IceGrid::ParseException::ParseException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

IceGrid::ParseException::~ParseException() throw()
{
}

static const char* __IceGrid__ParseException_name = "IceGrid::ParseException";

::std::string
IceGrid::ParseException::ice_name() const
{
    return __IceGrid__ParseException_name;
}

::Ice::Exception*
IceGrid::ParseException::ice_clone() const
{
    return new ParseException(*this);
}

void
IceGrid::ParseException::ice_throw() const
{
    throw *this;
}

void
IceGrid::ParseException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::ParseException"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
IceGrid::ParseException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
IceGrid::ParseException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ParseException was not generated with stream support";
    throw ex;
}

void
IceGrid::ParseException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ParseException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__ParseException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::ParseException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__ParseException__Ptr = new __F__IceGrid__ParseException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::ParseException::ice_factory()
{
    return __F__IceGrid__ParseException__Ptr;
}

class __F__IceGrid__ParseException__Init
{
public:

    __F__IceGrid__ParseException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::ParseException", ::IceGrid::ParseException::ice_factory());
    }

    ~__F__IceGrid__ParseException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::ParseException");
    }
};

static __F__IceGrid__ParseException__Init __F__IceGrid__ParseException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__ParseException__initializer() {} }
#endif

void
IceGrid::__addObject(const FileParserPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const FileParserPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const FileParserPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(FileParserPtr& p)
{
    p.__clearHandleUnsafe();
}

::IceGrid::ApplicationDescriptor
IceProxy::IceGrid::FileParser::parse(const ::std::string& xmlFile, const ::IceGrid::AdminPrx& adminProxy, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__FileParser__parse_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::FileParser* __del = dynamic_cast< ::IceDelegate::IceGrid::FileParser*>(__delBase.get());
            return __del->parse(xmlFile, adminProxy, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::FileParser::ice_staticId()
{
    return ::IceGrid::FileParser::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::FileParser::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::FileParser);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::FileParser::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::FileParser);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::FileParser& l, const ::IceProxy::IceGrid::FileParser& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::FileParser& l, const ::IceProxy::IceGrid::FileParser& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::FileParser& l, const ::IceProxy::IceGrid::FileParser& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::FileParser& l, const ::IceProxy::IceGrid::FileParser& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::FileParser& l, const ::IceProxy::IceGrid::FileParser& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::FileParser& l, const ::IceProxy::IceGrid::FileParser& r)
{
    return !(l < r);
}

::IceGrid::ApplicationDescriptor
IceDelegateM::IceGrid::FileParser::parse(const ::std::string& xmlFile, const ::IceGrid::AdminPrx& adminProxy, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__FileParser__parse_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(xmlFile);
        ::IceGrid::__write(__os, adminProxy);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::ParseException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::ApplicationDescriptor __ret;
        __ret.__read(__is);
        __is->readPendingObjects();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::ApplicationDescriptor
IceDelegateD::IceGrid::FileParser::parse(const ::std::string& xmlFile, const ::IceGrid::AdminPrx& adminProxy, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__FileParser__parse_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceGrid::ApplicationDescriptor __ret;
        try
        {
            ::IceGrid::FileParser* __servant = dynamic_cast< ::IceGrid::FileParser*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->parse(xmlFile, adminProxy, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::ObjectPtr
IceGrid::FileParser::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__FileParser_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::FileParser"
};

bool
IceGrid::FileParser::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__FileParser_ids, __IceGrid__FileParser_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::FileParser::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__FileParser_ids[0], &__IceGrid__FileParser_ids[2]);
}

const ::std::string&
IceGrid::FileParser::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__FileParser_ids[1];
}

const ::std::string&
IceGrid::FileParser::ice_staticId()
{
    return __IceGrid__FileParser_ids[1];
}

::IceInternal::DispatchStatus
IceGrid::FileParser::___parse(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string xmlFile;
    ::IceGrid::AdminPrx adminProxy;
    __is->read(xmlFile);
    ::IceGrid::__read(__is, adminProxy);
    try
    {
        ::IceGrid::ApplicationDescriptor __ret = parse(xmlFile, adminProxy, __current);
        __ret.__write(__os);
        __os->writePendingObjects();
    }
    catch(const ::IceGrid::ParseException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__FileParser_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "parse"
};

::IceInternal::DispatchStatus
IceGrid::FileParser::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__FileParser_all, __IceGrid__FileParser_all + 5, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__FileParser_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___parse(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::FileParser::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::FileParser::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::FileParser::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::FileParser was not generated with stream support";
    throw ex;
}

void
IceGrid::FileParser::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::FileParser was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__FileParserPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::FileParserPtr* p = static_cast< ::IceGrid::FileParserPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::FileParserPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::FileParser::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::FileParser& l, const ::IceGrid::FileParser& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::FileParser& l, const ::IceGrid::FileParser& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::FileParser& l, const ::IceGrid::FileParser& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::FileParser& l, const ::IceGrid::FileParser& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::FileParser& l, const ::IceGrid::FileParser& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::FileParser& l, const ::IceGrid::FileParser& r)
{
    return !(l < r);
}

static const char* __sliceChecksums[] =
{
    "::IceGrid::FileParser", "b847ccf3e3db7cbba649ec7cc464faf",
    "::IceGrid::ParseException", "dec9aacba8b3ba76afc5de1cc3489598",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
