// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `Locator.ice'

#include <IceGrid/Locator.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceGrid__Locator__getLocalRegistry_name = "getLocalRegistry";

static const ::std::string __IceGrid__Locator__getLocalQuery_name = "getLocalQuery";

void
IceInternal::incRef(::IceGrid::Locator* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::Locator* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::Locator* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::Locator* p)
{
    p->__decRef();
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::LocatorPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::LocatorPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::Locator;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::LocatorPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__addObject(const LocatorPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const LocatorPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const LocatorPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(LocatorPtr& p)
{
    p.__clearHandleUnsafe();
}

::IceGrid::RegistryPrx
IceProxy::IceGrid::Locator::getLocalRegistry(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Locator__getLocalRegistry_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Locator* __del = dynamic_cast< ::IceDelegate::IceGrid::Locator*>(__delBase.get());
            return __del->getLocalRegistry(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::IceGrid::QueryPrx
IceProxy::IceGrid::Locator::getLocalQuery(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Locator__getLocalQuery_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Locator* __del = dynamic_cast< ::IceDelegate::IceGrid::Locator*>(__delBase.get());
            return __del->getLocalQuery(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::Locator::ice_staticId()
{
    return ::IceGrid::Locator::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::Locator::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::Locator);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::Locator::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::Locator);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::Locator& l, const ::IceProxy::IceGrid::Locator& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::Locator& l, const ::IceProxy::IceGrid::Locator& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::Locator& l, const ::IceProxy::IceGrid::Locator& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::Locator& l, const ::IceProxy::IceGrid::Locator& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::Locator& l, const ::IceProxy::IceGrid::Locator& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::Locator& l, const ::IceProxy::IceGrid::Locator& r)
{
    return !(l < r);
}

::IceGrid::RegistryPrx
IceDelegateM::IceGrid::Locator::getLocalRegistry(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Locator__getLocalRegistry_name, ::Ice::Idempotent, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::RegistryPrx __ret;
        ::IceGrid::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::QueryPrx
IceDelegateM::IceGrid::Locator::getLocalQuery(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Locator__getLocalQuery_name, ::Ice::Idempotent, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::QueryPrx __ret;
        ::IceGrid::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::RegistryPrx
IceDelegateD::IceGrid::Locator::getLocalRegistry(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Locator__getLocalRegistry_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceGrid::RegistryPrx __ret;
        try
        {
            ::IceGrid::Locator* __servant = dynamic_cast< ::IceGrid::Locator*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getLocalRegistry(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::IceGrid::QueryPrx
IceDelegateD::IceGrid::Locator::getLocalQuery(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Locator__getLocalQuery_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceGrid::QueryPrx __ret;
        try
        {
            ::IceGrid::Locator* __servant = dynamic_cast< ::IceGrid::Locator*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getLocalQuery(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::ObjectPtr
IceGrid::Locator::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__Locator_ids[3] =
{
    "::Ice::Locator",
    "::Ice::Object",
    "::IceGrid::Locator"
};

bool
IceGrid::Locator::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__Locator_ids, __IceGrid__Locator_ids + 3, _s);
}

::std::vector< ::std::string>
IceGrid::Locator::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__Locator_ids[0], &__IceGrid__Locator_ids[3]);
}

const ::std::string&
IceGrid::Locator::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__Locator_ids[2];
}

const ::std::string&
IceGrid::Locator::ice_staticId()
{
    return __IceGrid__Locator_ids[2];
}

::IceInternal::DispatchStatus
IceGrid::Locator::___getLocalRegistry(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceGrid::RegistryPrx __ret = getLocalRegistry(__current);
    ::IceGrid::__write(__os, __ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Locator::___getLocalQuery(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceGrid::QueryPrx __ret = getLocalQuery(__current);
    ::IceGrid::__write(__os, __ret);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__Locator_all[] =
{
    "findAdapterById",
    "findObjectById",
    "getLocalQuery",
    "getLocalRegistry",
    "getRegistry",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
IceGrid::Locator::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__Locator_all, __IceGrid__Locator_all + 9, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__Locator_all)
    {
        case 0:
        {
            return ___findAdapterById(in, current);
        }
        case 1:
        {
            return ___findObjectById(in, current);
        }
        case 2:
        {
            return ___getLocalQuery(in, current);
        }
        case 3:
        {
            return ___getLocalRegistry(in, current);
        }
        case 4:
        {
            return ___getRegistry(in, current);
        }
        case 5:
        {
            return ___ice_id(in, current);
        }
        case 6:
        {
            return ___ice_ids(in, current);
        }
        case 7:
        {
            return ___ice_isA(in, current);
        }
        case 8:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::Locator::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::Locator::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::Locator::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Locator was not generated with stream support";
    throw ex;
}

void
IceGrid::Locator::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Locator was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__LocatorPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::LocatorPtr* p = static_cast< ::IceGrid::LocatorPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::LocatorPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::Locator::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::Locator& l, const ::IceGrid::Locator& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::Locator& l, const ::IceGrid::Locator& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::Locator& l, const ::IceGrid::Locator& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::Locator& l, const ::IceGrid::Locator& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::Locator& l, const ::IceGrid::Locator& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::Locator& l, const ::IceGrid::Locator& r)
{
    return !(l < r);
}

static const char* __sliceChecksums[] =
{
    "::IceGrid::Locator", "816e9d7a3cb39b8c80fe342e7f18ae",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
