// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `Observer.ice'

#include <IceGrid/Observer.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceGrid__NodeObserver__nodeInit_name = "nodeInit";

static const ::std::string __IceGrid__NodeObserver__nodeUp_name = "nodeUp";

static const ::std::string __IceGrid__NodeObserver__nodeDown_name = "nodeDown";

static const ::std::string __IceGrid__NodeObserver__updateServer_name = "updateServer";

static const ::std::string __IceGrid__NodeObserver__updateAdapter_name = "updateAdapter";

static const ::std::string __IceGrid__ApplicationObserver__applicationInit_name = "applicationInit";

static const ::std::string __IceGrid__ApplicationObserver__applicationAdded_name = "applicationAdded";

static const ::std::string __IceGrid__ApplicationObserver__applicationRemoved_name = "applicationRemoved";

static const ::std::string __IceGrid__ApplicationObserver__applicationUpdated_name = "applicationUpdated";

static const ::std::string __IceGrid__AdapterObserver__adapterInit_name = "adapterInit";

static const ::std::string __IceGrid__AdapterObserver__adapterAdded_name = "adapterAdded";

static const ::std::string __IceGrid__AdapterObserver__adapterUpdated_name = "adapterUpdated";

static const ::std::string __IceGrid__AdapterObserver__adapterRemoved_name = "adapterRemoved";

static const ::std::string __IceGrid__ObjectObserver__objectInit_name = "objectInit";

static const ::std::string __IceGrid__ObjectObserver__objectAdded_name = "objectAdded";

static const ::std::string __IceGrid__ObjectObserver__objectUpdated_name = "objectUpdated";

static const ::std::string __IceGrid__ObjectObserver__objectRemoved_name = "objectRemoved";

static const ::std::string __IceGrid__RegistryObserver__registryInit_name = "registryInit";

static const ::std::string __IceGrid__RegistryObserver__registryUp_name = "registryUp";

static const ::std::string __IceGrid__RegistryObserver__registryDown_name = "registryDown";

void
IceInternal::incRef(::IceGrid::NodeObserver* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::NodeObserver* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::NodeObserver* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::NodeObserver* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::ApplicationObserver* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::ApplicationObserver* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::ApplicationObserver* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::ApplicationObserver* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::AdapterObserver* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::AdapterObserver* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::AdapterObserver* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::AdapterObserver* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::ObjectObserver* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::ObjectObserver* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::ObjectObserver* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::ObjectObserver* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::RegistryObserver* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::RegistryObserver* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::RegistryObserver* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::RegistryObserver* p)
{
    p->__decRef();
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::NodeObserverPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::NodeObserverPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::NodeObserver;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::NodeObserverPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::ApplicationObserverPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::ApplicationObserverPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::ApplicationObserver;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::ApplicationObserverPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::AdapterObserverPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::AdapterObserverPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::AdapterObserver;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::AdapterObserverPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::ObjectObserverPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::ObjectObserverPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::ObjectObserver;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::ObjectObserverPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::RegistryObserverPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::RegistryObserverPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::RegistryObserver;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::RegistryObserverPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

bool
IceGrid::ServerDynamicInfo::operator==(const ServerDynamicInfo& __rhs) const
{
    return !operator!=(__rhs);
}

bool
IceGrid::ServerDynamicInfo::operator!=(const ServerDynamicInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(id != __rhs.id)
    {
        return true;
    }
    if(state != __rhs.state)
    {
        return true;
    }
    if(pid != __rhs.pid)
    {
        return true;
    }
    if(enabled != __rhs.enabled)
    {
        return true;
    }
    return false;
}

bool
IceGrid::ServerDynamicInfo::operator<(const ServerDynamicInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(id < __rhs.id)
    {
        return true;
    }
    else if(__rhs.id < id)
    {
        return false;
    }
    if(state < __rhs.state)
    {
        return true;
    }
    else if(__rhs.state < state)
    {
        return false;
    }
    if(pid < __rhs.pid)
    {
        return true;
    }
    else if(__rhs.pid < pid)
    {
        return false;
    }
    if(enabled < __rhs.enabled)
    {
        return true;
    }
    else if(__rhs.enabled < enabled)
    {
        return false;
    }
    return false;
}

void
IceGrid::ServerDynamicInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(id);
    ::IceGrid::__write(__os, state);
    __os->write(pid);
    __os->write(enabled);
}

void
IceGrid::ServerDynamicInfo::__read(::IceInternal::BasicStream* __is)
{
    __is->read(id);
    ::IceGrid::__read(__is, state);
    __is->read(pid);
    __is->read(enabled);
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::ServerDynamicInfo* begin, const ::IceGrid::ServerDynamicInfo* end, ::IceGrid::__U__ServerDynamicInfoSeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::ServerDynamicInfoSeq& v, ::IceGrid::__U__ServerDynamicInfoSeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 7);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

bool
IceGrid::AdapterDynamicInfo::operator==(const AdapterDynamicInfo& __rhs) const
{
    return !operator!=(__rhs);
}

bool
IceGrid::AdapterDynamicInfo::operator!=(const AdapterDynamicInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(id != __rhs.id)
    {
        return true;
    }
    if(proxy != __rhs.proxy)
    {
        return true;
    }
    return false;
}

bool
IceGrid::AdapterDynamicInfo::operator<(const AdapterDynamicInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(id < __rhs.id)
    {
        return true;
    }
    else if(__rhs.id < id)
    {
        return false;
    }
    if(proxy < __rhs.proxy)
    {
        return true;
    }
    else if(__rhs.proxy < proxy)
    {
        return false;
    }
    return false;
}

void
IceGrid::AdapterDynamicInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(id);
    __os->write(proxy);
}

void
IceGrid::AdapterDynamicInfo::__read(::IceInternal::BasicStream* __is)
{
    __is->read(id);
    __is->read(proxy);
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::AdapterDynamicInfo* begin, const ::IceGrid::AdapterDynamicInfo* end, ::IceGrid::__U__AdapterDynamicInfoSeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::AdapterDynamicInfoSeq& v, ::IceGrid::__U__AdapterDynamicInfoSeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 3);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

bool
IceGrid::NodeDynamicInfo::operator==(const NodeDynamicInfo& __rhs) const
{
    return !operator!=(__rhs);
}

bool
IceGrid::NodeDynamicInfo::operator!=(const NodeDynamicInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(info != __rhs.info)
    {
        return true;
    }
    if(servers != __rhs.servers)
    {
        return true;
    }
    if(adapters != __rhs.adapters)
    {
        return true;
    }
    return false;
}

bool
IceGrid::NodeDynamicInfo::operator<(const NodeDynamicInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(info < __rhs.info)
    {
        return true;
    }
    else if(__rhs.info < info)
    {
        return false;
    }
    if(servers < __rhs.servers)
    {
        return true;
    }
    else if(__rhs.servers < servers)
    {
        return false;
    }
    if(adapters < __rhs.adapters)
    {
        return true;
    }
    else if(__rhs.adapters < adapters)
    {
        return false;
    }
    return false;
}

void
IceGrid::NodeDynamicInfo::__write(::IceInternal::BasicStream* __os) const
{
    info.__write(__os);
    if(servers.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceGrid::__write(__os, &servers[0], &servers[0] + servers.size(), ::IceGrid::__U__ServerDynamicInfoSeq());
    }
    if(adapters.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceGrid::__write(__os, &adapters[0], &adapters[0] + adapters.size(), ::IceGrid::__U__AdapterDynamicInfoSeq());
    }
}

void
IceGrid::NodeDynamicInfo::__read(::IceInternal::BasicStream* __is)
{
    info.__read(__is);
    ::IceGrid::__read(__is, servers, ::IceGrid::__U__ServerDynamicInfoSeq());
    ::IceGrid::__read(__is, adapters, ::IceGrid::__U__AdapterDynamicInfoSeq());
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::NodeDynamicInfo* begin, const ::IceGrid::NodeDynamicInfo* end, ::IceGrid::__U__NodeDynamicInfoSeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::NodeDynamicInfoSeq& v, ::IceGrid::__U__NodeDynamicInfoSeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 13);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
IceGrid::__addObject(const NodeObserverPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const NodeObserverPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const NodeObserverPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(NodeObserverPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__addObject(const ApplicationObserverPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const ApplicationObserverPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const ApplicationObserverPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(ApplicationObserverPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__addObject(const AdapterObserverPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const AdapterObserverPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const AdapterObserverPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(AdapterObserverPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__addObject(const ObjectObserverPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const ObjectObserverPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const ObjectObserverPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(ObjectObserverPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__addObject(const RegistryObserverPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const RegistryObserverPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const RegistryObserverPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(RegistryObserverPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::AMI_NodeObserver_nodeInit::__invoke(const ::IceGrid::NodeObserverPrx& __prx, const ::IceGrid::NodeDynamicInfoSeq& nodes, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__NodeObserver__nodeInit_name, ::Ice::Normal, __ctx);
        if(nodes.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__write(__os, &nodes[0], &nodes[0] + nodes.size(), ::IceGrid::__U__NodeDynamicInfoSeq());
        }
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_NodeObserver_nodeInit::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
}

void
IceGrid::AMI_ApplicationObserver_applicationInit::__invoke(const ::IceGrid::ApplicationObserverPrx& __prx, ::Ice::Int serial, const ::IceGrid::ApplicationInfoSeq& applications, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__ApplicationObserver__applicationInit_name, ::Ice::Normal, __ctx);
        __os->write(serial);
        if(applications.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__write(__os, &applications[0], &applications[0] + applications.size(), ::IceGrid::__U__ApplicationInfoSeq());
        }
        __os->writePendingObjects();
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_ApplicationObserver_applicationInit::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
}

void
IceGrid::AMI_AdapterObserver_adapterInit::__invoke(const ::IceGrid::AdapterObserverPrx& __prx, const ::IceGrid::AdapterInfoSeq& adpts, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__AdapterObserver__adapterInit_name, ::Ice::Normal, __ctx);
        if(adpts.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__write(__os, &adpts[0], &adpts[0] + adpts.size(), ::IceGrid::__U__AdapterInfoSeq());
        }
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_AdapterObserver_adapterInit::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
}

void
IceGrid::AMI_ObjectObserver_objectInit::__invoke(const ::IceGrid::ObjectObserverPrx& __prx, const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__ObjectObserver__objectInit_name, ::Ice::Normal, __ctx);
        if(objects.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__write(__os, &objects[0], &objects[0] + objects.size(), ::IceGrid::__U__ObjectInfoSeq());
        }
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_ObjectObserver_objectInit::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
}

void
IceGrid::AMI_RegistryObserver_registryInit::__invoke(const ::IceGrid::RegistryObserverPrx& __prx, const ::IceGrid::RegistryInfoSeq& registries, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__RegistryObserver__registryInit_name, ::Ice::Normal, __ctx);
        if(registries.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__write(__os, &registries[0], &registries[0] + registries.size(), ::IceGrid::__U__RegistryInfoSeq());
        }
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_RegistryObserver_registryInit::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
}

void
IceProxy::IceGrid::NodeObserver::nodeInit(const ::IceGrid::NodeDynamicInfoSeq& nodes, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::NodeObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeObserver*>(__delBase.get());
            __del->nodeInit(nodes, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::NodeObserver::nodeInit_async(const ::IceGrid::AMI_NodeObserver_nodeInitPtr& __cb, const ::IceGrid::NodeDynamicInfoSeq& nodes)
{
    __cb->__invoke(this, nodes, 0);
}

void
IceProxy::IceGrid::NodeObserver::nodeInit_async(const ::IceGrid::AMI_NodeObserver_nodeInitPtr& __cb, const ::IceGrid::NodeDynamicInfoSeq& nodes, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, nodes, &__ctx);
}

void
IceProxy::IceGrid::NodeObserver::nodeUp(const ::IceGrid::NodeDynamicInfo& node, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::NodeObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeObserver*>(__delBase.get());
            __del->nodeUp(node, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::NodeObserver::nodeDown(const ::std::string& name, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::NodeObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeObserver*>(__delBase.get());
            __del->nodeDown(name, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::NodeObserver::updateServer(const ::std::string& node, const ::IceGrid::ServerDynamicInfo& updatedInfo, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::NodeObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeObserver*>(__delBase.get());
            __del->updateServer(node, updatedInfo, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::NodeObserver::updateAdapter(const ::std::string& node, const ::IceGrid::AdapterDynamicInfo& updatedInfo, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::NodeObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeObserver*>(__delBase.get());
            __del->updateAdapter(node, updatedInfo, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::NodeObserver::ice_staticId()
{
    return ::IceGrid::NodeObserver::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::NodeObserver::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::NodeObserver);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::NodeObserver::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::NodeObserver);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::NodeObserver& l, const ::IceProxy::IceGrid::NodeObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::NodeObserver& l, const ::IceProxy::IceGrid::NodeObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::NodeObserver& l, const ::IceProxy::IceGrid::NodeObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::NodeObserver& l, const ::IceProxy::IceGrid::NodeObserver& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::NodeObserver& l, const ::IceProxy::IceGrid::NodeObserver& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::NodeObserver& l, const ::IceProxy::IceGrid::NodeObserver& r)
{
    return !(l < r);
}

void
IceProxy::IceGrid::ApplicationObserver::applicationInit(::Ice::Int serial, const ::IceGrid::ApplicationInfoSeq& applications, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ApplicationObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ApplicationObserver*>(__delBase.get());
            __del->applicationInit(serial, applications, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ApplicationObserver::applicationInit_async(const ::IceGrid::AMI_ApplicationObserver_applicationInitPtr& __cb, ::Ice::Int serial, const ::IceGrid::ApplicationInfoSeq& applications)
{
    __cb->__invoke(this, serial, applications, 0);
}

void
IceProxy::IceGrid::ApplicationObserver::applicationInit_async(const ::IceGrid::AMI_ApplicationObserver_applicationInitPtr& __cb, ::Ice::Int serial, const ::IceGrid::ApplicationInfoSeq& applications, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, serial, applications, &__ctx);
}

void
IceProxy::IceGrid::ApplicationObserver::applicationAdded(::Ice::Int serial, const ::IceGrid::ApplicationInfo& desc, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ApplicationObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ApplicationObserver*>(__delBase.get());
            __del->applicationAdded(serial, desc, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ApplicationObserver::applicationRemoved(::Ice::Int serial, const ::std::string& name, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ApplicationObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ApplicationObserver*>(__delBase.get());
            __del->applicationRemoved(serial, name, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ApplicationObserver::applicationUpdated(::Ice::Int serial, const ::IceGrid::ApplicationUpdateInfo& desc, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ApplicationObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ApplicationObserver*>(__delBase.get());
            __del->applicationUpdated(serial, desc, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::ApplicationObserver::ice_staticId()
{
    return ::IceGrid::ApplicationObserver::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::ApplicationObserver::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::ApplicationObserver);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::ApplicationObserver::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::ApplicationObserver);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::ApplicationObserver& l, const ::IceProxy::IceGrid::ApplicationObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::ApplicationObserver& l, const ::IceProxy::IceGrid::ApplicationObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::ApplicationObserver& l, const ::IceProxy::IceGrid::ApplicationObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::ApplicationObserver& l, const ::IceProxy::IceGrid::ApplicationObserver& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::ApplicationObserver& l, const ::IceProxy::IceGrid::ApplicationObserver& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::ApplicationObserver& l, const ::IceProxy::IceGrid::ApplicationObserver& r)
{
    return !(l < r);
}

void
IceProxy::IceGrid::AdapterObserver::adapterInit(const ::IceGrid::AdapterInfoSeq& adpts, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::AdapterObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::AdapterObserver*>(__delBase.get());
            __del->adapterInit(adpts, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::AdapterObserver::adapterInit_async(const ::IceGrid::AMI_AdapterObserver_adapterInitPtr& __cb, const ::IceGrid::AdapterInfoSeq& adpts)
{
    __cb->__invoke(this, adpts, 0);
}

void
IceProxy::IceGrid::AdapterObserver::adapterInit_async(const ::IceGrid::AMI_AdapterObserver_adapterInitPtr& __cb, const ::IceGrid::AdapterInfoSeq& adpts, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, adpts, &__ctx);
}

void
IceProxy::IceGrid::AdapterObserver::adapterAdded(const ::IceGrid::AdapterInfo& info, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::AdapterObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::AdapterObserver*>(__delBase.get());
            __del->adapterAdded(info, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::AdapterObserver::adapterUpdated(const ::IceGrid::AdapterInfo& info, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::AdapterObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::AdapterObserver*>(__delBase.get());
            __del->adapterUpdated(info, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::AdapterObserver::adapterRemoved(const ::std::string& id, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::AdapterObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::AdapterObserver*>(__delBase.get());
            __del->adapterRemoved(id, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::AdapterObserver::ice_staticId()
{
    return ::IceGrid::AdapterObserver::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::AdapterObserver::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::AdapterObserver);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::AdapterObserver::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::AdapterObserver);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::AdapterObserver& l, const ::IceProxy::IceGrid::AdapterObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::AdapterObserver& l, const ::IceProxy::IceGrid::AdapterObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::AdapterObserver& l, const ::IceProxy::IceGrid::AdapterObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::AdapterObserver& l, const ::IceProxy::IceGrid::AdapterObserver& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::AdapterObserver& l, const ::IceProxy::IceGrid::AdapterObserver& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::AdapterObserver& l, const ::IceProxy::IceGrid::AdapterObserver& r)
{
    return !(l < r);
}

void
IceProxy::IceGrid::ObjectObserver::objectInit(const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ObjectObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ObjectObserver*>(__delBase.get());
            __del->objectInit(objects, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ObjectObserver::objectInit_async(const ::IceGrid::AMI_ObjectObserver_objectInitPtr& __cb, const ::IceGrid::ObjectInfoSeq& objects)
{
    __cb->__invoke(this, objects, 0);
}

void
IceProxy::IceGrid::ObjectObserver::objectInit_async(const ::IceGrid::AMI_ObjectObserver_objectInitPtr& __cb, const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, objects, &__ctx);
}

void
IceProxy::IceGrid::ObjectObserver::objectAdded(const ::IceGrid::ObjectInfo& info, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ObjectObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ObjectObserver*>(__delBase.get());
            __del->objectAdded(info, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ObjectObserver::objectUpdated(const ::IceGrid::ObjectInfo& info, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ObjectObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ObjectObserver*>(__delBase.get());
            __del->objectUpdated(info, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ObjectObserver::objectRemoved(const ::Ice::Identity& id, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ObjectObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ObjectObserver*>(__delBase.get());
            __del->objectRemoved(id, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::ObjectObserver::ice_staticId()
{
    return ::IceGrid::ObjectObserver::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::ObjectObserver::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::ObjectObserver);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::ObjectObserver::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::ObjectObserver);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::ObjectObserver& l, const ::IceProxy::IceGrid::ObjectObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::ObjectObserver& l, const ::IceProxy::IceGrid::ObjectObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::ObjectObserver& l, const ::IceProxy::IceGrid::ObjectObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::ObjectObserver& l, const ::IceProxy::IceGrid::ObjectObserver& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::ObjectObserver& l, const ::IceProxy::IceGrid::ObjectObserver& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::ObjectObserver& l, const ::IceProxy::IceGrid::ObjectObserver& r)
{
    return !(l < r);
}

void
IceProxy::IceGrid::RegistryObserver::registryInit(const ::IceGrid::RegistryInfoSeq& registries, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::RegistryObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::RegistryObserver*>(__delBase.get());
            __del->registryInit(registries, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::RegistryObserver::registryInit_async(const ::IceGrid::AMI_RegistryObserver_registryInitPtr& __cb, const ::IceGrid::RegistryInfoSeq& registries)
{
    __cb->__invoke(this, registries, 0);
}

void
IceProxy::IceGrid::RegistryObserver::registryInit_async(const ::IceGrid::AMI_RegistryObserver_registryInitPtr& __cb, const ::IceGrid::RegistryInfoSeq& registries, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, registries, &__ctx);
}

void
IceProxy::IceGrid::RegistryObserver::registryUp(const ::IceGrid::RegistryInfo& node, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::RegistryObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::RegistryObserver*>(__delBase.get());
            __del->registryUp(node, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::RegistryObserver::registryDown(const ::std::string& name, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::RegistryObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::RegistryObserver*>(__delBase.get());
            __del->registryDown(name, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::RegistryObserver::ice_staticId()
{
    return ::IceGrid::RegistryObserver::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::RegistryObserver::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::RegistryObserver);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::RegistryObserver::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::RegistryObserver);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::RegistryObserver& l, const ::IceProxy::IceGrid::RegistryObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::RegistryObserver& l, const ::IceProxy::IceGrid::RegistryObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::RegistryObserver& l, const ::IceProxy::IceGrid::RegistryObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::RegistryObserver& l, const ::IceProxy::IceGrid::RegistryObserver& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::RegistryObserver& l, const ::IceProxy::IceGrid::RegistryObserver& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::RegistryObserver& l, const ::IceProxy::IceGrid::RegistryObserver& r)
{
    return !(l < r);
}

void
IceDelegateM::IceGrid::NodeObserver::nodeInit(const ::IceGrid::NodeDynamicInfoSeq& nodes, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__NodeObserver__nodeInit_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(nodes.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__write(__os, &nodes[0], &nodes[0] + nodes.size(), ::IceGrid::__U__NodeDynamicInfoSeq());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::NodeObserver::nodeUp(const ::IceGrid::NodeDynamicInfo& node, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__NodeObserver__nodeUp_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        node.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::NodeObserver::nodeDown(const ::std::string& name, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__NodeObserver__nodeDown_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(name);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::NodeObserver::updateServer(const ::std::string& node, const ::IceGrid::ServerDynamicInfo& updatedInfo, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__NodeObserver__updateServer_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(node);
        updatedInfo.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::NodeObserver::updateAdapter(const ::std::string& node, const ::IceGrid::AdapterDynamicInfo& updatedInfo, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__NodeObserver__updateAdapter_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(node);
        updatedInfo.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ApplicationObserver::applicationInit(::Ice::Int serial, const ::IceGrid::ApplicationInfoSeq& applications, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ApplicationObserver__applicationInit_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(serial);
        if(applications.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__write(__os, &applications[0], &applications[0] + applications.size(), ::IceGrid::__U__ApplicationInfoSeq());
        }
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ApplicationObserver::applicationAdded(::Ice::Int serial, const ::IceGrid::ApplicationInfo& desc, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ApplicationObserver__applicationAdded_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(serial);
        desc.__write(__os);
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ApplicationObserver::applicationRemoved(::Ice::Int serial, const ::std::string& name, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ApplicationObserver__applicationRemoved_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(serial);
        __os->write(name);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ApplicationObserver::applicationUpdated(::Ice::Int serial, const ::IceGrid::ApplicationUpdateInfo& desc, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ApplicationObserver__applicationUpdated_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(serial);
        desc.__write(__os);
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::AdapterObserver::adapterInit(const ::IceGrid::AdapterInfoSeq& adpts, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__AdapterObserver__adapterInit_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(adpts.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__write(__os, &adpts[0], &adpts[0] + adpts.size(), ::IceGrid::__U__AdapterInfoSeq());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::AdapterObserver::adapterAdded(const ::IceGrid::AdapterInfo& info, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__AdapterObserver__adapterAdded_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        info.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::AdapterObserver::adapterUpdated(const ::IceGrid::AdapterInfo& info, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__AdapterObserver__adapterUpdated_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        info.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::AdapterObserver::adapterRemoved(const ::std::string& id, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__AdapterObserver__adapterRemoved_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(id);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ObjectObserver::objectInit(const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ObjectObserver__objectInit_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(objects.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__write(__os, &objects[0], &objects[0] + objects.size(), ::IceGrid::__U__ObjectInfoSeq());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ObjectObserver::objectAdded(const ::IceGrid::ObjectInfo& info, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ObjectObserver__objectAdded_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        info.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ObjectObserver::objectUpdated(const ::IceGrid::ObjectInfo& info, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ObjectObserver__objectUpdated_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        info.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ObjectObserver::objectRemoved(const ::Ice::Identity& id, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ObjectObserver__objectRemoved_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        id.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::RegistryObserver::registryInit(const ::IceGrid::RegistryInfoSeq& registries, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__RegistryObserver__registryInit_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(registries.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__write(__os, &registries[0], &registries[0] + registries.size(), ::IceGrid::__U__RegistryInfoSeq());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::RegistryObserver::registryUp(const ::IceGrid::RegistryInfo& node, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__RegistryObserver__registryUp_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        node.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::RegistryObserver::registryDown(const ::std::string& name, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__RegistryObserver__registryDown_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(name);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateD::IceGrid::NodeObserver::nodeInit(const ::IceGrid::NodeDynamicInfoSeq& nodes, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeObserver__nodeInit_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::NodeObserver* __servant = dynamic_cast< ::IceGrid::NodeObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->nodeInit(nodes, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::NodeObserver::nodeUp(const ::IceGrid::NodeDynamicInfo& node, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeObserver__nodeUp_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::NodeObserver* __servant = dynamic_cast< ::IceGrid::NodeObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->nodeUp(node, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::NodeObserver::nodeDown(const ::std::string& name, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeObserver__nodeDown_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::NodeObserver* __servant = dynamic_cast< ::IceGrid::NodeObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->nodeDown(name, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::NodeObserver::updateServer(const ::std::string& node, const ::IceGrid::ServerDynamicInfo& updatedInfo, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeObserver__updateServer_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::NodeObserver* __servant = dynamic_cast< ::IceGrid::NodeObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->updateServer(node, updatedInfo, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::NodeObserver::updateAdapter(const ::std::string& node, const ::IceGrid::AdapterDynamicInfo& updatedInfo, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeObserver__updateAdapter_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::NodeObserver* __servant = dynamic_cast< ::IceGrid::NodeObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->updateAdapter(node, updatedInfo, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ApplicationObserver::applicationInit(::Ice::Int serial, const ::IceGrid::ApplicationInfoSeq& applications, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ApplicationObserver__applicationInit_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ApplicationObserver* __servant = dynamic_cast< ::IceGrid::ApplicationObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->applicationInit(serial, applications, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ApplicationObserver::applicationAdded(::Ice::Int serial, const ::IceGrid::ApplicationInfo& desc, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ApplicationObserver__applicationAdded_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ApplicationObserver* __servant = dynamic_cast< ::IceGrid::ApplicationObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->applicationAdded(serial, desc, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ApplicationObserver::applicationRemoved(::Ice::Int serial, const ::std::string& name, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ApplicationObserver__applicationRemoved_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ApplicationObserver* __servant = dynamic_cast< ::IceGrid::ApplicationObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->applicationRemoved(serial, name, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ApplicationObserver::applicationUpdated(::Ice::Int serial, const ::IceGrid::ApplicationUpdateInfo& desc, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ApplicationObserver__applicationUpdated_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ApplicationObserver* __servant = dynamic_cast< ::IceGrid::ApplicationObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->applicationUpdated(serial, desc, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::AdapterObserver::adapterInit(const ::IceGrid::AdapterInfoSeq& adpts, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__AdapterObserver__adapterInit_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::AdapterObserver* __servant = dynamic_cast< ::IceGrid::AdapterObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->adapterInit(adpts, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::AdapterObserver::adapterAdded(const ::IceGrid::AdapterInfo& info, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__AdapterObserver__adapterAdded_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::AdapterObserver* __servant = dynamic_cast< ::IceGrid::AdapterObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->adapterAdded(info, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::AdapterObserver::adapterUpdated(const ::IceGrid::AdapterInfo& info, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__AdapterObserver__adapterUpdated_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::AdapterObserver* __servant = dynamic_cast< ::IceGrid::AdapterObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->adapterUpdated(info, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::AdapterObserver::adapterRemoved(const ::std::string& id, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__AdapterObserver__adapterRemoved_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::AdapterObserver* __servant = dynamic_cast< ::IceGrid::AdapterObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->adapterRemoved(id, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ObjectObserver::objectInit(const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ObjectObserver__objectInit_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ObjectObserver* __servant = dynamic_cast< ::IceGrid::ObjectObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->objectInit(objects, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ObjectObserver::objectAdded(const ::IceGrid::ObjectInfo& info, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ObjectObserver__objectAdded_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ObjectObserver* __servant = dynamic_cast< ::IceGrid::ObjectObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->objectAdded(info, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ObjectObserver::objectUpdated(const ::IceGrid::ObjectInfo& info, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ObjectObserver__objectUpdated_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ObjectObserver* __servant = dynamic_cast< ::IceGrid::ObjectObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->objectUpdated(info, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ObjectObserver::objectRemoved(const ::Ice::Identity& id, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ObjectObserver__objectRemoved_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ObjectObserver* __servant = dynamic_cast< ::IceGrid::ObjectObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->objectRemoved(id, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::RegistryObserver::registryInit(const ::IceGrid::RegistryInfoSeq& registries, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__RegistryObserver__registryInit_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::RegistryObserver* __servant = dynamic_cast< ::IceGrid::RegistryObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->registryInit(registries, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::RegistryObserver::registryUp(const ::IceGrid::RegistryInfo& node, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__RegistryObserver__registryUp_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::RegistryObserver* __servant = dynamic_cast< ::IceGrid::RegistryObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->registryUp(node, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::RegistryObserver::registryDown(const ::std::string& name, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__RegistryObserver__registryDown_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::RegistryObserver* __servant = dynamic_cast< ::IceGrid::RegistryObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->registryDown(name, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::Ice::ObjectPtr
IceGrid::NodeObserver::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__NodeObserver_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::NodeObserver"
};

bool
IceGrid::NodeObserver::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__NodeObserver_ids, __IceGrid__NodeObserver_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::NodeObserver::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__NodeObserver_ids[0], &__IceGrid__NodeObserver_ids[2]);
}

const ::std::string&
IceGrid::NodeObserver::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__NodeObserver_ids[1];
}

const ::std::string&
IceGrid::NodeObserver::ice_staticId()
{
    return __IceGrid__NodeObserver_ids[1];
}

::IceInternal::DispatchStatus
IceGrid::NodeObserver::___nodeInit(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::NodeDynamicInfoSeq nodes;
    ::IceGrid::__read(__is, nodes, ::IceGrid::__U__NodeDynamicInfoSeq());
    nodeInit(nodes, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::NodeObserver::___nodeUp(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::NodeDynamicInfo node;
    node.__read(__is);
    nodeUp(node, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::NodeObserver::___nodeDown(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::std::string name;
    __is->read(name);
    nodeDown(name, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::NodeObserver::___updateServer(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::std::string node;
    ::IceGrid::ServerDynamicInfo updatedInfo;
    __is->read(node);
    updatedInfo.__read(__is);
    updateServer(node, updatedInfo, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::NodeObserver::___updateAdapter(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::std::string node;
    ::IceGrid::AdapterDynamicInfo updatedInfo;
    __is->read(node);
    updatedInfo.__read(__is);
    updateAdapter(node, updatedInfo, __current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__NodeObserver_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "nodeDown",
    "nodeInit",
    "nodeUp",
    "updateAdapter",
    "updateServer"
};

::IceInternal::DispatchStatus
IceGrid::NodeObserver::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__NodeObserver_all, __IceGrid__NodeObserver_all + 9, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__NodeObserver_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___nodeDown(in, current);
        }
        case 5:
        {
            return ___nodeInit(in, current);
        }
        case 6:
        {
            return ___nodeUp(in, current);
        }
        case 7:
        {
            return ___updateAdapter(in, current);
        }
        case 8:
        {
            return ___updateServer(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::NodeObserver::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::NodeObserver::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::NodeObserver::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::NodeObserver was not generated with stream support";
    throw ex;
}

void
IceGrid::NodeObserver::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::NodeObserver was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__NodeObserverPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::NodeObserverPtr* p = static_cast< ::IceGrid::NodeObserverPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::NodeObserverPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::NodeObserver::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::NodeObserver& l, const ::IceGrid::NodeObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::NodeObserver& l, const ::IceGrid::NodeObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::NodeObserver& l, const ::IceGrid::NodeObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::NodeObserver& l, const ::IceGrid::NodeObserver& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::NodeObserver& l, const ::IceGrid::NodeObserver& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::NodeObserver& l, const ::IceGrid::NodeObserver& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceGrid::ApplicationObserver::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__ApplicationObserver_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::ApplicationObserver"
};

bool
IceGrid::ApplicationObserver::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__ApplicationObserver_ids, __IceGrid__ApplicationObserver_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::ApplicationObserver::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__ApplicationObserver_ids[0], &__IceGrid__ApplicationObserver_ids[2]);
}

const ::std::string&
IceGrid::ApplicationObserver::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__ApplicationObserver_ids[1];
}

const ::std::string&
IceGrid::ApplicationObserver::ice_staticId()
{
    return __IceGrid__ApplicationObserver_ids[1];
}

::IceInternal::DispatchStatus
IceGrid::ApplicationObserver::___applicationInit(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::Ice::Int serial;
    ::IceGrid::ApplicationInfoSeq applications;
    __is->read(serial);
    ::IceGrid::__read(__is, applications, ::IceGrid::__U__ApplicationInfoSeq());
    __is->readPendingObjects();
    applicationInit(serial, applications, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::ApplicationObserver::___applicationAdded(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::Ice::Int serial;
    ::IceGrid::ApplicationInfo desc;
    __is->read(serial);
    desc.__read(__is);
    __is->readPendingObjects();
    applicationAdded(serial, desc, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::ApplicationObserver::___applicationRemoved(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::Ice::Int serial;
    ::std::string name;
    __is->read(serial);
    __is->read(name);
    applicationRemoved(serial, name, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::ApplicationObserver::___applicationUpdated(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::Ice::Int serial;
    ::IceGrid::ApplicationUpdateInfo desc;
    __is->read(serial);
    desc.__read(__is);
    __is->readPendingObjects();
    applicationUpdated(serial, desc, __current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__ApplicationObserver_all[] =
{
    "applicationAdded",
    "applicationInit",
    "applicationRemoved",
    "applicationUpdated",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
IceGrid::ApplicationObserver::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__ApplicationObserver_all, __IceGrid__ApplicationObserver_all + 8, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__ApplicationObserver_all)
    {
        case 0:
        {
            return ___applicationAdded(in, current);
        }
        case 1:
        {
            return ___applicationInit(in, current);
        }
        case 2:
        {
            return ___applicationRemoved(in, current);
        }
        case 3:
        {
            return ___applicationUpdated(in, current);
        }
        case 4:
        {
            return ___ice_id(in, current);
        }
        case 5:
        {
            return ___ice_ids(in, current);
        }
        case 6:
        {
            return ___ice_isA(in, current);
        }
        case 7:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::ApplicationObserver::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::ApplicationObserver::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::ApplicationObserver::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ApplicationObserver was not generated with stream support";
    throw ex;
}

void
IceGrid::ApplicationObserver::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ApplicationObserver was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__ApplicationObserverPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::ApplicationObserverPtr* p = static_cast< ::IceGrid::ApplicationObserverPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::ApplicationObserverPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::ApplicationObserver::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::ApplicationObserver& l, const ::IceGrid::ApplicationObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::ApplicationObserver& l, const ::IceGrid::ApplicationObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::ApplicationObserver& l, const ::IceGrid::ApplicationObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::ApplicationObserver& l, const ::IceGrid::ApplicationObserver& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::ApplicationObserver& l, const ::IceGrid::ApplicationObserver& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::ApplicationObserver& l, const ::IceGrid::ApplicationObserver& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceGrid::AdapterObserver::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__AdapterObserver_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::AdapterObserver"
};

bool
IceGrid::AdapterObserver::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__AdapterObserver_ids, __IceGrid__AdapterObserver_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::AdapterObserver::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__AdapterObserver_ids[0], &__IceGrid__AdapterObserver_ids[2]);
}

const ::std::string&
IceGrid::AdapterObserver::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__AdapterObserver_ids[1];
}

const ::std::string&
IceGrid::AdapterObserver::ice_staticId()
{
    return __IceGrid__AdapterObserver_ids[1];
}

::IceInternal::DispatchStatus
IceGrid::AdapterObserver::___adapterInit(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::AdapterInfoSeq adpts;
    ::IceGrid::__read(__is, adpts, ::IceGrid::__U__AdapterInfoSeq());
    adapterInit(adpts, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::AdapterObserver::___adapterAdded(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::AdapterInfo info;
    info.__read(__is);
    adapterAdded(info, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::AdapterObserver::___adapterUpdated(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::AdapterInfo info;
    info.__read(__is);
    adapterUpdated(info, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::AdapterObserver::___adapterRemoved(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::std::string id;
    __is->read(id);
    adapterRemoved(id, __current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__AdapterObserver_all[] =
{
    "adapterAdded",
    "adapterInit",
    "adapterRemoved",
    "adapterUpdated",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
IceGrid::AdapterObserver::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__AdapterObserver_all, __IceGrid__AdapterObserver_all + 8, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__AdapterObserver_all)
    {
        case 0:
        {
            return ___adapterAdded(in, current);
        }
        case 1:
        {
            return ___adapterInit(in, current);
        }
        case 2:
        {
            return ___adapterRemoved(in, current);
        }
        case 3:
        {
            return ___adapterUpdated(in, current);
        }
        case 4:
        {
            return ___ice_id(in, current);
        }
        case 5:
        {
            return ___ice_ids(in, current);
        }
        case 6:
        {
            return ___ice_isA(in, current);
        }
        case 7:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::AdapterObserver::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::AdapterObserver::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::AdapterObserver::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::AdapterObserver was not generated with stream support";
    throw ex;
}

void
IceGrid::AdapterObserver::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::AdapterObserver was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__AdapterObserverPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::AdapterObserverPtr* p = static_cast< ::IceGrid::AdapterObserverPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::AdapterObserverPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::AdapterObserver::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::AdapterObserver& l, const ::IceGrid::AdapterObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::AdapterObserver& l, const ::IceGrid::AdapterObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::AdapterObserver& l, const ::IceGrid::AdapterObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::AdapterObserver& l, const ::IceGrid::AdapterObserver& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::AdapterObserver& l, const ::IceGrid::AdapterObserver& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::AdapterObserver& l, const ::IceGrid::AdapterObserver& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceGrid::ObjectObserver::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__ObjectObserver_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::ObjectObserver"
};

bool
IceGrid::ObjectObserver::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__ObjectObserver_ids, __IceGrid__ObjectObserver_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::ObjectObserver::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__ObjectObserver_ids[0], &__IceGrid__ObjectObserver_ids[2]);
}

const ::std::string&
IceGrid::ObjectObserver::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__ObjectObserver_ids[1];
}

const ::std::string&
IceGrid::ObjectObserver::ice_staticId()
{
    return __IceGrid__ObjectObserver_ids[1];
}

::IceInternal::DispatchStatus
IceGrid::ObjectObserver::___objectInit(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::ObjectInfoSeq objects;
    ::IceGrid::__read(__is, objects, ::IceGrid::__U__ObjectInfoSeq());
    objectInit(objects, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::ObjectObserver::___objectAdded(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::ObjectInfo info;
    info.__read(__is);
    objectAdded(info, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::ObjectObserver::___objectUpdated(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::ObjectInfo info;
    info.__read(__is);
    objectUpdated(info, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::ObjectObserver::___objectRemoved(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::Ice::Identity id;
    id.__read(__is);
    objectRemoved(id, __current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__ObjectObserver_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "objectAdded",
    "objectInit",
    "objectRemoved",
    "objectUpdated"
};

::IceInternal::DispatchStatus
IceGrid::ObjectObserver::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__ObjectObserver_all, __IceGrid__ObjectObserver_all + 8, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__ObjectObserver_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___objectAdded(in, current);
        }
        case 5:
        {
            return ___objectInit(in, current);
        }
        case 6:
        {
            return ___objectRemoved(in, current);
        }
        case 7:
        {
            return ___objectUpdated(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::ObjectObserver::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::ObjectObserver::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::ObjectObserver::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ObjectObserver was not generated with stream support";
    throw ex;
}

void
IceGrid::ObjectObserver::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ObjectObserver was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__ObjectObserverPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::ObjectObserverPtr* p = static_cast< ::IceGrid::ObjectObserverPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::ObjectObserverPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::ObjectObserver::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::ObjectObserver& l, const ::IceGrid::ObjectObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::ObjectObserver& l, const ::IceGrid::ObjectObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::ObjectObserver& l, const ::IceGrid::ObjectObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::ObjectObserver& l, const ::IceGrid::ObjectObserver& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::ObjectObserver& l, const ::IceGrid::ObjectObserver& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::ObjectObserver& l, const ::IceGrid::ObjectObserver& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceGrid::RegistryObserver::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__RegistryObserver_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::RegistryObserver"
};

bool
IceGrid::RegistryObserver::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__RegistryObserver_ids, __IceGrid__RegistryObserver_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::RegistryObserver::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__RegistryObserver_ids[0], &__IceGrid__RegistryObserver_ids[2]);
}

const ::std::string&
IceGrid::RegistryObserver::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__RegistryObserver_ids[1];
}

const ::std::string&
IceGrid::RegistryObserver::ice_staticId()
{
    return __IceGrid__RegistryObserver_ids[1];
}

::IceInternal::DispatchStatus
IceGrid::RegistryObserver::___registryInit(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::RegistryInfoSeq registries;
    ::IceGrid::__read(__is, registries, ::IceGrid::__U__RegistryInfoSeq());
    registryInit(registries, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::RegistryObserver::___registryUp(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::RegistryInfo node;
    node.__read(__is);
    registryUp(node, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::RegistryObserver::___registryDown(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::std::string name;
    __is->read(name);
    registryDown(name, __current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__RegistryObserver_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "registryDown",
    "registryInit",
    "registryUp"
};

::IceInternal::DispatchStatus
IceGrid::RegistryObserver::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__RegistryObserver_all, __IceGrid__RegistryObserver_all + 7, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__RegistryObserver_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___registryDown(in, current);
        }
        case 5:
        {
            return ___registryInit(in, current);
        }
        case 6:
        {
            return ___registryUp(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::RegistryObserver::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::RegistryObserver::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::RegistryObserver::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::RegistryObserver was not generated with stream support";
    throw ex;
}

void
IceGrid::RegistryObserver::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::RegistryObserver was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__RegistryObserverPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::RegistryObserverPtr* p = static_cast< ::IceGrid::RegistryObserverPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::RegistryObserverPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::RegistryObserver::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::RegistryObserver& l, const ::IceGrid::RegistryObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::RegistryObserver& l, const ::IceGrid::RegistryObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::RegistryObserver& l, const ::IceGrid::RegistryObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::RegistryObserver& l, const ::IceGrid::RegistryObserver& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::RegistryObserver& l, const ::IceGrid::RegistryObserver& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::RegistryObserver& l, const ::IceGrid::RegistryObserver& r)
{
    return !(l < r);
}

static const char* __sliceChecksums[] =
{
    "::IceGrid::AdapterDynamicInfo", "b371e9a58f115e6ebfbcda735fee57f7",
    "::IceGrid::AdapterDynamicInfoSeq", "54465843167a2f93fa96d13b7f41ea32",
    "::IceGrid::AdapterObserver", "7f4ed59e236da9d6c35ad7e6ad9cb0",
    "::IceGrid::ApplicationObserver", "2862cdcba54714282f68b13a8fb4ae",
    "::IceGrid::NodeDynamicInfo", "3ad52341f32973212d26a9a6dda08b",
    "::IceGrid::NodeDynamicInfoSeq", "f61633c5e3992f718dba78b7f165c2",
    "::IceGrid::NodeObserver", "e06c1ad6807d2876de9e818855a65738",
    "::IceGrid::ObjectObserver", "5364683a872f127e46cc5e215d98c3c",
    "::IceGrid::RegistryObserver", "fd83b1558e7c77f2d322b25449518",
    "::IceGrid::ServerDynamicInfo", "fd4b9177ca54ae4688b51fa51d6870",
    "::IceGrid::ServerDynamicInfoSeq", "e3fda58997d5cd946e78cae739174cb",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
