// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `Registry.ice'

#include <IceGrid/Registry.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceGrid__Registry__createSession_name = "createSession";

static const ::std::string __IceGrid__Registry__createAdminSession_name = "createAdminSession";

static const ::std::string __IceGrid__Registry__createSessionFromSecureConnection_name = "createSessionFromSecureConnection";

static const ::std::string __IceGrid__Registry__createAdminSessionFromSecureConnection_name = "createAdminSessionFromSecureConnection";

static const ::std::string __IceGrid__Registry__getSessionTimeout_name = "getSessionTimeout";

void
IceInternal::incRef(::IceGrid::Registry* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::Registry* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::Registry* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::Registry* p)
{
    p->__decRef();
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::RegistryPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::RegistryPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::Registry;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::RegistryPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__addObject(const RegistryPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const RegistryPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const RegistryPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(RegistryPtr& p)
{
    p.__clearHandleUnsafe();
}

::IceGrid::SessionPrx
IceProxy::IceGrid::Registry::createSession(const ::std::string& userId, const ::std::string& password, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Registry__createSession_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Registry* __del = dynamic_cast< ::IceDelegate::IceGrid::Registry*>(__delBase.get());
            return __del->createSession(userId, password, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::IceGrid::AdminSessionPrx
IceProxy::IceGrid::Registry::createAdminSession(const ::std::string& userId, const ::std::string& password, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Registry__createAdminSession_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Registry* __del = dynamic_cast< ::IceDelegate::IceGrid::Registry*>(__delBase.get());
            return __del->createAdminSession(userId, password, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::IceGrid::SessionPrx
IceProxy::IceGrid::Registry::createSessionFromSecureConnection(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Registry__createSessionFromSecureConnection_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Registry* __del = dynamic_cast< ::IceDelegate::IceGrid::Registry*>(__delBase.get());
            return __del->createSessionFromSecureConnection(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::IceGrid::AdminSessionPrx
IceProxy::IceGrid::Registry::createAdminSessionFromSecureConnection(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Registry__createAdminSessionFromSecureConnection_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Registry* __del = dynamic_cast< ::IceDelegate::IceGrid::Registry*>(__delBase.get());
            return __del->createAdminSessionFromSecureConnection(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Ice::Int
IceProxy::IceGrid::Registry::getSessionTimeout(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Registry__getSessionTimeout_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Registry* __del = dynamic_cast< ::IceDelegate::IceGrid::Registry*>(__delBase.get());
            return __del->getSessionTimeout(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::Registry::ice_staticId()
{
    return ::IceGrid::Registry::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::Registry::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::Registry);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::Registry::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::Registry);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::Registry& l, const ::IceProxy::IceGrid::Registry& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::Registry& l, const ::IceProxy::IceGrid::Registry& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::Registry& l, const ::IceProxy::IceGrid::Registry& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::Registry& l, const ::IceProxy::IceGrid::Registry& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::Registry& l, const ::IceProxy::IceGrid::Registry& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::Registry& l, const ::IceProxy::IceGrid::Registry& r)
{
    return !(l < r);
}

::IceGrid::SessionPrx
IceDelegateM::IceGrid::Registry::createSession(const ::std::string& userId, const ::std::string& password, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Registry__createSession_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(userId);
        __os->write(password);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::PermissionDeniedException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::SessionPrx __ret;
        ::IceGrid::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::AdminSessionPrx
IceDelegateM::IceGrid::Registry::createAdminSession(const ::std::string& userId, const ::std::string& password, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Registry__createAdminSession_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(userId);
        __os->write(password);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::PermissionDeniedException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::AdminSessionPrx __ret;
        ::IceGrid::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::SessionPrx
IceDelegateM::IceGrid::Registry::createSessionFromSecureConnection(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Registry__createSessionFromSecureConnection_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::PermissionDeniedException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::SessionPrx __ret;
        ::IceGrid::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::AdminSessionPrx
IceDelegateM::IceGrid::Registry::createAdminSessionFromSecureConnection(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Registry__createAdminSessionFromSecureConnection_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::PermissionDeniedException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::AdminSessionPrx __ret;
        ::IceGrid::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::Int
IceDelegateM::IceGrid::Registry::getSessionTimeout(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Registry__getSessionTimeout_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::Int __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::SessionPrx
IceDelegateD::IceGrid::Registry::createSession(const ::std::string& userId, const ::std::string& password, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Registry__createSession_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceGrid::SessionPrx __ret;
        try
        {
            ::IceGrid::Registry* __servant = dynamic_cast< ::IceGrid::Registry*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->createSession(userId, password, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::IceGrid::AdminSessionPrx
IceDelegateD::IceGrid::Registry::createAdminSession(const ::std::string& userId, const ::std::string& password, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Registry__createAdminSession_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceGrid::AdminSessionPrx __ret;
        try
        {
            ::IceGrid::Registry* __servant = dynamic_cast< ::IceGrid::Registry*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->createAdminSession(userId, password, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::IceGrid::SessionPrx
IceDelegateD::IceGrid::Registry::createSessionFromSecureConnection(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Registry__createSessionFromSecureConnection_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceGrid::SessionPrx __ret;
        try
        {
            ::IceGrid::Registry* __servant = dynamic_cast< ::IceGrid::Registry*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->createSessionFromSecureConnection(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::IceGrid::AdminSessionPrx
IceDelegateD::IceGrid::Registry::createAdminSessionFromSecureConnection(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Registry__createAdminSessionFromSecureConnection_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceGrid::AdminSessionPrx __ret;
        try
        {
            ::IceGrid::Registry* __servant = dynamic_cast< ::IceGrid::Registry*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->createAdminSessionFromSecureConnection(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::Int
IceDelegateD::IceGrid::Registry::getSessionTimeout(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Registry__getSessionTimeout_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::Int __ret;
        try
        {
            ::IceGrid::Registry* __servant = dynamic_cast< ::IceGrid::Registry*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getSessionTimeout(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::ObjectPtr
IceGrid::Registry::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__Registry_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::Registry"
};

bool
IceGrid::Registry::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__Registry_ids, __IceGrid__Registry_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::Registry::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__Registry_ids[0], &__IceGrid__Registry_ids[2]);
}

const ::std::string&
IceGrid::Registry::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__Registry_ids[1];
}

const ::std::string&
IceGrid::Registry::ice_staticId()
{
    return __IceGrid__Registry_ids[1];
}

::IceInternal::DispatchStatus
IceGrid::Registry::___createSession(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string userId;
    ::std::string password;
    __is->read(userId);
    __is->read(password);
    try
    {
        ::IceGrid::SessionPrx __ret = createSession(userId, password, __current);
        ::IceGrid::__write(__os, __ret);
    }
    catch(const ::IceGrid::PermissionDeniedException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Registry::___createAdminSession(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string userId;
    ::std::string password;
    __is->read(userId);
    __is->read(password);
    try
    {
        ::IceGrid::AdminSessionPrx __ret = createAdminSession(userId, password, __current);
        ::IceGrid::__write(__os, __ret);
    }
    catch(const ::IceGrid::PermissionDeniedException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Registry::___createSessionFromSecureConnection(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::IceGrid::SessionPrx __ret = createSessionFromSecureConnection(__current);
        ::IceGrid::__write(__os, __ret);
    }
    catch(const ::IceGrid::PermissionDeniedException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Registry::___createAdminSessionFromSecureConnection(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::IceGrid::AdminSessionPrx __ret = createAdminSessionFromSecureConnection(__current);
        ::IceGrid::__write(__os, __ret);
    }
    catch(const ::IceGrid::PermissionDeniedException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Registry::___getSessionTimeout(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Int __ret = getSessionTimeout(__current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__Registry_all[] =
{
    "createAdminSession",
    "createAdminSessionFromSecureConnection",
    "createSession",
    "createSessionFromSecureConnection",
    "getSessionTimeout",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
IceGrid::Registry::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__Registry_all, __IceGrid__Registry_all + 9, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__Registry_all)
    {
        case 0:
        {
            return ___createAdminSession(in, current);
        }
        case 1:
        {
            return ___createAdminSessionFromSecureConnection(in, current);
        }
        case 2:
        {
            return ___createSession(in, current);
        }
        case 3:
        {
            return ___createSessionFromSecureConnection(in, current);
        }
        case 4:
        {
            return ___getSessionTimeout(in, current);
        }
        case 5:
        {
            return ___ice_id(in, current);
        }
        case 6:
        {
            return ___ice_ids(in, current);
        }
        case 7:
        {
            return ___ice_isA(in, current);
        }
        case 8:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::Registry::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::Registry::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::Registry::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Registry was not generated with stream support";
    throw ex;
}

void
IceGrid::Registry::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Registry was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__RegistryPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::RegistryPtr* p = static_cast< ::IceGrid::RegistryPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::RegistryPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::Registry::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::Registry& l, const ::IceGrid::Registry& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::Registry& l, const ::IceGrid::Registry& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::Registry& l, const ::IceGrid::Registry& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::Registry& l, const ::IceGrid::Registry& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::Registry& l, const ::IceGrid::Registry& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::Registry& l, const ::IceGrid::Registry& r)
{
    return !(l < r);
}

static const char* __sliceChecksums[] =
{
    "::IceGrid::Registry", "c78158c7cf2552d132645cd358d74c",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
