// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `Session.ice'

#include <IceGrid/Session.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceGrid__Session__keepAlive_name = "keepAlive";

static const ::std::string __IceGrid__Session__allocateObjectById_name = "allocateObjectById";

static const ::std::string __IceGrid__Session__allocateObjectByType_name = "allocateObjectByType";

static const ::std::string __IceGrid__Session__releaseObject_name = "releaseObject";

static const ::std::string __IceGrid__Session__setAllocationTimeout_name = "setAllocationTimeout";

void
IceInternal::incRef(::IceGrid::Session* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::Session* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::Session* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::Session* p)
{
    p->__decRef();
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::SessionPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::SessionPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::Session;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::SessionPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__addObject(const SessionPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const SessionPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const SessionPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(SessionPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::AMI_Session_allocateObjectById::__invoke(const ::IceGrid::SessionPrx& __prx, const ::Ice::Identity& id, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__Session__allocateObjectById_name, ::Ice::Normal, __ctx);
        id.__write(__os);
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_Session_allocateObjectById::__response(bool __ok)
{
    ::Ice::ObjectPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::AllocationException& __ex)
            {
                ice_exception(__ex);
                return;
            }
            catch(const ::IceGrid::ObjectNotRegisteredException& __ex)
            {
                ice_exception(__ex);
                return;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        __is->read(__ret);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
}

void
IceGrid::AMI_Session_allocateObjectByType::__invoke(const ::IceGrid::SessionPrx& __prx, const ::std::string& type, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__Session__allocateObjectByType_name, ::Ice::Normal, __ctx);
        __os->write(type);
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_Session_allocateObjectByType::__response(bool __ok)
{
    ::Ice::ObjectPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::AllocationException& __ex)
            {
                ice_exception(__ex);
                return;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        __is->read(__ret);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
}

IceAsync::IceGrid::AMD_Session_allocateObjectById::AMD_Session_allocateObjectById(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Session_allocateObjectById::ice_response(const ::Ice::ObjectPrx& __ret)
{
    try
    {
        ::IceInternal::BasicStream* __os = this->__os();
        __os->write(__ret);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __exception(__ex);
        return;
    }
    __response(true);
}

void
IceAsync::IceGrid::AMD_Session_allocateObjectById::ice_exception(const ::Ice::Exception& ex)
{
    try
    {
        ex.ice_throw();
    }
    catch(const ::IceGrid::AllocationException& __ex)
    {
        __os()->write(__ex);
        __response(false);
    }
    catch(const ::IceGrid::ObjectNotRegisteredException& __ex)
    {
        __os()->write(__ex);
        __response(false);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __exception(__ex);
    }
}

void
IceAsync::IceGrid::AMD_Session_allocateObjectById::ice_exception(const ::std::exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_Session_allocateObjectById::ice_exception()
{
    __exception();
}

IceAsync::IceGrid::AMD_Session_allocateObjectByType::AMD_Session_allocateObjectByType(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Session_allocateObjectByType::ice_response(const ::Ice::ObjectPrx& __ret)
{
    try
    {
        ::IceInternal::BasicStream* __os = this->__os();
        __os->write(__ret);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __exception(__ex);
        return;
    }
    __response(true);
}

void
IceAsync::IceGrid::AMD_Session_allocateObjectByType::ice_exception(const ::Ice::Exception& ex)
{
    try
    {
        ex.ice_throw();
    }
    catch(const ::IceGrid::AllocationException& __ex)
    {
        __os()->write(__ex);
        __response(false);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __exception(__ex);
    }
}

void
IceAsync::IceGrid::AMD_Session_allocateObjectByType::ice_exception(const ::std::exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_Session_allocateObjectByType::ice_exception()
{
    __exception();
}

void
IceProxy::IceGrid::Session::keepAlive(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Session* __del = dynamic_cast< ::IceDelegate::IceGrid::Session*>(__delBase.get());
            __del->keepAlive(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Ice::ObjectPrx
IceProxy::IceGrid::Session::allocateObjectById(const ::Ice::Identity& id, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Session__allocateObjectById_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Session* __del = dynamic_cast< ::IceDelegate::IceGrid::Session*>(__delBase.get());
            return __del->allocateObjectById(id, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Session::allocateObjectById_async(const ::IceGrid::AMI_Session_allocateObjectByIdPtr& __cb, const ::Ice::Identity& id)
{
    __cb->__invoke(this, id, 0);
}

void
IceProxy::IceGrid::Session::allocateObjectById_async(const ::IceGrid::AMI_Session_allocateObjectByIdPtr& __cb, const ::Ice::Identity& id, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, id, &__ctx);
}

::Ice::ObjectPrx
IceProxy::IceGrid::Session::allocateObjectByType(const ::std::string& type, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Session__allocateObjectByType_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Session* __del = dynamic_cast< ::IceDelegate::IceGrid::Session*>(__delBase.get());
            return __del->allocateObjectByType(type, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Session::allocateObjectByType_async(const ::IceGrid::AMI_Session_allocateObjectByTypePtr& __cb, const ::std::string& type)
{
    __cb->__invoke(this, type, 0);
}

void
IceProxy::IceGrid::Session::allocateObjectByType_async(const ::IceGrid::AMI_Session_allocateObjectByTypePtr& __cb, const ::std::string& type, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, type, &__ctx);
}

void
IceProxy::IceGrid::Session::releaseObject(const ::Ice::Identity& id, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Session__releaseObject_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Session* __del = dynamic_cast< ::IceDelegate::IceGrid::Session*>(__delBase.get());
            __del->releaseObject(id, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Session::setAllocationTimeout(::Ice::Int timeout, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Session* __del = dynamic_cast< ::IceDelegate::IceGrid::Session*>(__delBase.get());
            __del->setAllocationTimeout(timeout, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::Session::ice_staticId()
{
    return ::IceGrid::Session::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::Session::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::Session);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::Session::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::Session);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::Session& l, const ::IceProxy::IceGrid::Session& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::Session& l, const ::IceProxy::IceGrid::Session& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::Session& l, const ::IceProxy::IceGrid::Session& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::Session& l, const ::IceProxy::IceGrid::Session& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::Session& l, const ::IceProxy::IceGrid::Session& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::Session& l, const ::IceProxy::IceGrid::Session& r)
{
    return !(l < r);
}

void
IceDelegateM::IceGrid::Session::keepAlive(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Session__keepAlive_name, ::Ice::Idempotent, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ObjectPrx
IceDelegateM::IceGrid::Session::allocateObjectById(const ::Ice::Identity& id, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Session__allocateObjectById_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        id.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::AllocationException&)
            {
                throw;
            }
            catch(const ::IceGrid::ObjectNotRegisteredException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::ObjectPrx __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ObjectPrx
IceDelegateM::IceGrid::Session::allocateObjectByType(const ::std::string& type, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Session__allocateObjectByType_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(type);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::AllocationException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::ObjectPrx __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Session::releaseObject(const ::Ice::Identity& id, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Session__releaseObject_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        id.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::AllocationException&)
            {
                throw;
            }
            catch(const ::IceGrid::ObjectNotRegisteredException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Session::setAllocationTimeout(::Ice::Int timeout, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Session__setAllocationTimeout_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(timeout);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateD::IceGrid::Session::keepAlive(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Session__keepAlive_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::Session* __servant = dynamic_cast< ::IceGrid::Session*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->keepAlive(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::Ice::ObjectPrx
IceDelegateD::IceGrid::Session::allocateObjectById(const ::Ice::Identity&, const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
    return ::Ice::ObjectPrx(); // to avoid a warning with some compilers;
}

::Ice::ObjectPrx
IceDelegateD::IceGrid::Session::allocateObjectByType(const ::std::string&, const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
    return ::Ice::ObjectPrx(); // to avoid a warning with some compilers;
}

void
IceDelegateD::IceGrid::Session::releaseObject(const ::Ice::Identity& id, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Session__releaseObject_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::Session* __servant = dynamic_cast< ::IceGrid::Session*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->releaseObject(id, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::Session::setAllocationTimeout(::Ice::Int timeout, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Session__setAllocationTimeout_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::Session* __servant = dynamic_cast< ::IceGrid::Session*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->setAllocationTimeout(timeout, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::Ice::ObjectPtr
IceGrid::Session::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__Session_ids[3] =
{
    "::Glacier2::Session",
    "::Ice::Object",
    "::IceGrid::Session"
};

bool
IceGrid::Session::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__Session_ids, __IceGrid__Session_ids + 3, _s);
}

::std::vector< ::std::string>
IceGrid::Session::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__Session_ids[0], &__IceGrid__Session_ids[3]);
}

const ::std::string&
IceGrid::Session::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__Session_ids[2];
}

const ::std::string&
IceGrid::Session::ice_staticId()
{
    return __IceGrid__Session_ids[2];
}

::IceInternal::DispatchStatus
IceGrid::Session::___keepAlive(::IceInternal::Incoming&, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    keepAlive(__current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Session::___allocateObjectById(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::Ice::Identity id;
    id.__read(__is);
    ::IceGrid::AMD_Session_allocateObjectByIdPtr __cb = new IceAsync::IceGrid::AMD_Session_allocateObjectById(__inS);
    try
    {
        allocateObjectById_async(__cb, id, __current);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::IceInternal::DispatchAsync;
}

::IceInternal::DispatchStatus
IceGrid::Session::___allocateObjectByType(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::std::string type;
    __is->read(type);
    ::IceGrid::AMD_Session_allocateObjectByTypePtr __cb = new IceAsync::IceGrid::AMD_Session_allocateObjectByType(__inS);
    try
    {
        allocateObjectByType_async(__cb, type, __current);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::IceInternal::DispatchAsync;
}

::IceInternal::DispatchStatus
IceGrid::Session::___releaseObject(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Identity id;
    id.__read(__is);
    try
    {
        releaseObject(id, __current);
    }
    catch(const ::IceGrid::AllocationException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    catch(const ::IceGrid::ObjectNotRegisteredException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Session::___setAllocationTimeout(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::Ice::Int timeout;
    __is->read(timeout);
    setAllocationTimeout(timeout, __current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__Session_all[] =
{
    "allocateObjectById",
    "allocateObjectByType",
    "destroy",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "keepAlive",
    "releaseObject",
    "setAllocationTimeout"
};

::IceInternal::DispatchStatus
IceGrid::Session::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__Session_all, __IceGrid__Session_all + 10, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__Session_all)
    {
        case 0:
        {
            return ___allocateObjectById(in, current);
        }
        case 1:
        {
            return ___allocateObjectByType(in, current);
        }
        case 2:
        {
            return ___destroy(in, current);
        }
        case 3:
        {
            return ___ice_id(in, current);
        }
        case 4:
        {
            return ___ice_ids(in, current);
        }
        case 5:
        {
            return ___ice_isA(in, current);
        }
        case 6:
        {
            return ___ice_ping(in, current);
        }
        case 7:
        {
            return ___keepAlive(in, current);
        }
        case 8:
        {
            return ___releaseObject(in, current);
        }
        case 9:
        {
            return ___setAllocationTimeout(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::Session::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::Session::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::Session::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Session was not generated with stream support";
    throw ex;
}

void
IceGrid::Session::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Session was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__SessionPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::SessionPtr* p = static_cast< ::IceGrid::SessionPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::SessionPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::Session::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::Session& l, const ::IceGrid::Session& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::Session& l, const ::IceGrid::Session& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::Session& l, const ::IceGrid::Session& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::Session& l, const ::IceGrid::Session& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::Session& l, const ::IceGrid::Session& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::Session& l, const ::IceGrid::Session& r)
{
    return !(l < r);
}

static const char* __sliceChecksums[] =
{
    "::IceGrid::Session", "cf4206d0a8aff6c1b0f2c437f34c5d",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
