// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `UserAccountMapper.ice'

#include <IceGrid/UserAccountMapper.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceGrid__UserAccountMapper__getUserAccount_name = "getUserAccount";

void
IceInternal::incRef(::IceGrid::UserAccountMapper* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::UserAccountMapper* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::UserAccountMapper* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::UserAccountMapper* p)
{
    p->__decRef();
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::UserAccountMapperPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::UserAccountMapperPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::UserAccountMapper;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::UserAccountMapperPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

IceGrid::UserAccountNotFoundException::~UserAccountNotFoundException() throw()
{
}

static const char* __IceGrid__UserAccountNotFoundException_name = "IceGrid::UserAccountNotFoundException";

::std::string
IceGrid::UserAccountNotFoundException::ice_name() const
{
    return __IceGrid__UserAccountNotFoundException_name;
}

::Ice::Exception*
IceGrid::UserAccountNotFoundException::ice_clone() const
{
    return new UserAccountNotFoundException(*this);
}

void
IceGrid::UserAccountNotFoundException::ice_throw() const
{
    throw *this;
}

void
IceGrid::UserAccountNotFoundException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::UserAccountNotFoundException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
}

void
IceGrid::UserAccountNotFoundException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
}

void
IceGrid::UserAccountNotFoundException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::UserAccountNotFoundException was not generated with stream support";
    throw ex;
}

void
IceGrid::UserAccountNotFoundException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::UserAccountNotFoundException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__UserAccountNotFoundException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::UserAccountNotFoundException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__UserAccountNotFoundException__Ptr = new __F__IceGrid__UserAccountNotFoundException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::UserAccountNotFoundException::ice_factory()
{
    return __F__IceGrid__UserAccountNotFoundException__Ptr;
}

class __F__IceGrid__UserAccountNotFoundException__Init
{
public:

    __F__IceGrid__UserAccountNotFoundException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::UserAccountNotFoundException", ::IceGrid::UserAccountNotFoundException::ice_factory());
    }

    ~__F__IceGrid__UserAccountNotFoundException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::UserAccountNotFoundException");
    }
};

static __F__IceGrid__UserAccountNotFoundException__Init __F__IceGrid__UserAccountNotFoundException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__UserAccountNotFoundException__initializer() {} }
#endif

void
IceGrid::__addObject(const UserAccountMapperPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const UserAccountMapperPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const UserAccountMapperPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(UserAccountMapperPtr& p)
{
    p.__clearHandleUnsafe();
}

::std::string
IceProxy::IceGrid::UserAccountMapper::getUserAccount(const ::std::string& user, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__UserAccountMapper__getUserAccount_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::UserAccountMapper* __del = dynamic_cast< ::IceDelegate::IceGrid::UserAccountMapper*>(__delBase.get());
            return __del->getUserAccount(user, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::UserAccountMapper::ice_staticId()
{
    return ::IceGrid::UserAccountMapper::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::UserAccountMapper::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::UserAccountMapper);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::UserAccountMapper::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::UserAccountMapper);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::UserAccountMapper& l, const ::IceProxy::IceGrid::UserAccountMapper& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::UserAccountMapper& l, const ::IceProxy::IceGrid::UserAccountMapper& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::UserAccountMapper& l, const ::IceProxy::IceGrid::UserAccountMapper& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::UserAccountMapper& l, const ::IceProxy::IceGrid::UserAccountMapper& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::UserAccountMapper& l, const ::IceProxy::IceGrid::UserAccountMapper& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::UserAccountMapper& l, const ::IceProxy::IceGrid::UserAccountMapper& r)
{
    return !(l < r);
}

::std::string
IceDelegateM::IceGrid::UserAccountMapper::getUserAccount(const ::std::string& user, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__UserAccountMapper__getUserAccount_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(user);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::UserAccountNotFoundException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::std::string __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::std::string
IceDelegateD::IceGrid::UserAccountMapper::getUserAccount(const ::std::string& user, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__UserAccountMapper__getUserAccount_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::std::string __ret;
        try
        {
            ::IceGrid::UserAccountMapper* __servant = dynamic_cast< ::IceGrid::UserAccountMapper*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getUserAccount(user, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::ObjectPtr
IceGrid::UserAccountMapper::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__UserAccountMapper_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::UserAccountMapper"
};

bool
IceGrid::UserAccountMapper::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__UserAccountMapper_ids, __IceGrid__UserAccountMapper_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::UserAccountMapper::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__UserAccountMapper_ids[0], &__IceGrid__UserAccountMapper_ids[2]);
}

const ::std::string&
IceGrid::UserAccountMapper::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__UserAccountMapper_ids[1];
}

const ::std::string&
IceGrid::UserAccountMapper::ice_staticId()
{
    return __IceGrid__UserAccountMapper_ids[1];
}

::IceInternal::DispatchStatus
IceGrid::UserAccountMapper::___getUserAccount(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string user;
    __is->read(user);
    try
    {
        ::std::string __ret = getUserAccount(user, __current);
        __os->write(__ret);
    }
    catch(const ::IceGrid::UserAccountNotFoundException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__UserAccountMapper_all[] =
{
    "getUserAccount",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
IceGrid::UserAccountMapper::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__UserAccountMapper_all, __IceGrid__UserAccountMapper_all + 5, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__UserAccountMapper_all)
    {
        case 0:
        {
            return ___getUserAccount(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::UserAccountMapper::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::UserAccountMapper::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::UserAccountMapper::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::UserAccountMapper was not generated with stream support";
    throw ex;
}

void
IceGrid::UserAccountMapper::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::UserAccountMapper was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__UserAccountMapperPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::UserAccountMapperPtr* p = static_cast< ::IceGrid::UserAccountMapperPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::UserAccountMapperPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::UserAccountMapper::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::UserAccountMapper& l, const ::IceGrid::UserAccountMapper& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::UserAccountMapper& l, const ::IceGrid::UserAccountMapper& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::UserAccountMapper& l, const ::IceGrid::UserAccountMapper& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::UserAccountMapper& l, const ::IceGrid::UserAccountMapper& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::UserAccountMapper& l, const ::IceGrid::UserAccountMapper& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::UserAccountMapper& l, const ::IceGrid::UserAccountMapper& r)
{
    return !(l < r);
}

static const char* __sliceChecksums[] =
{
    "::IceGrid::UserAccountMapper", "779fd561878e199444e04cdebaf9ffd4",
    "::IceGrid::UserAccountNotFoundException", "fe2dc4d87f21b9b2cf6f1339d1666281",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
