// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `FileInfo.ice'

#include <IcePatch2/FileInfo.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

bool
IcePatch2::FileInfo::operator==(const FileInfo& __rhs) const
{
    return !operator!=(__rhs);
}

bool
IcePatch2::FileInfo::operator!=(const FileInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(path != __rhs.path)
    {
        return true;
    }
    if(checksum != __rhs.checksum)
    {
        return true;
    }
    if(size != __rhs.size)
    {
        return true;
    }
    if(executable != __rhs.executable)
    {
        return true;
    }
    return false;
}

bool
IcePatch2::FileInfo::operator<(const FileInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(path < __rhs.path)
    {
        return true;
    }
    else if(__rhs.path < path)
    {
        return false;
    }
    if(checksum < __rhs.checksum)
    {
        return true;
    }
    else if(__rhs.checksum < checksum)
    {
        return false;
    }
    if(size < __rhs.size)
    {
        return true;
    }
    else if(__rhs.size < size)
    {
        return false;
    }
    if(executable < __rhs.executable)
    {
        return true;
    }
    else if(__rhs.executable < executable)
    {
        return false;
    }
    return false;
}

void
IcePatch2::FileInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(path);
    if(checksum.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&checksum[0], &checksum[0] + checksum.size());
    }
    __os->write(size);
    __os->write(executable);
}

void
IcePatch2::FileInfo::__read(::IceInternal::BasicStream* __is)
{
    __is->read(path);
    ::std::pair<const ::Ice::Byte*, const ::Ice::Byte*> ___checksum;
    __is->read(___checksum);
    ::std::vector< ::Ice::Byte>(___checksum.first, ___checksum.second).swap(checksum);
    __is->read(size);
    __is->read(executable);
}

void
IcePatch2::__write(::IceInternal::BasicStream* __os, const ::IcePatch2::FileInfo* begin, const ::IcePatch2::FileInfo* end, ::IcePatch2::__U__FileInfoSeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
IcePatch2::__read(::IceInternal::BasicStream* __is, ::IcePatch2::FileInfoSeq& v, ::IcePatch2::__U__FileInfoSeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 7);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}
