// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `FileServer.ice'

#include <IcePatch2/FileServer.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IcePatch2__FileServer__getFileInfoSeq_name = "getFileInfoSeq";

static const ::std::string __IcePatch2__FileServer__getChecksumSeq_name = "getChecksumSeq";

static const ::std::string __IcePatch2__FileServer__getChecksum_name = "getChecksum";

static const ::std::string __IcePatch2__FileServer__getFileCompressed_name = "getFileCompressed";

static const ::std::string __IcePatch2__Admin__shutdown_name = "shutdown";

void
IceInternal::incRef(::IcePatch2::FileServer* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IcePatch2::FileServer* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IcePatch2::FileServer* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IcePatch2::FileServer* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IcePatch2::Admin* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IcePatch2::Admin* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IcePatch2::Admin* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IcePatch2::Admin* p)
{
    p->__decRef();
}

void
IcePatch2::__write(::IceInternal::BasicStream* __os, const ::IcePatch2::FileServerPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IcePatch2::__read(::IceInternal::BasicStream* __is, ::IcePatch2::FileServerPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IcePatch2::FileServer;
        v->__copyFrom(proxy);
    }
}

void
IcePatch2::__write(::IceInternal::BasicStream* __os, const ::IcePatch2::FileServerPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IcePatch2::__write(::IceInternal::BasicStream* __os, const ::IcePatch2::AdminPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IcePatch2::__read(::IceInternal::BasicStream* __is, ::IcePatch2::AdminPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IcePatch2::Admin;
        v->__copyFrom(proxy);
    }
}

void
IcePatch2::__write(::IceInternal::BasicStream* __os, const ::IcePatch2::AdminPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IcePatch2::__write(::IceInternal::BasicStream* __os, const ::Ice::ByteSeq* begin, const ::Ice::ByteSeq* end, ::IcePatch2::__U__ByteSeqSeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        if(begin[i].size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            __os->write(&begin[i][0], &begin[i][0] + begin[i].size());
        }
    }
}

void
IcePatch2::__read(::IceInternal::BasicStream* __is, ::IcePatch2::ByteSeqSeq& v, ::IcePatch2::__U__ByteSeqSeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 1);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        ::std::pair<const ::Ice::Byte*, const ::Ice::Byte*> ___v;
        __is->read(___v);
        ::std::vector< ::Ice::Byte>(___v.first, ___v.second).swap(v[i]);
        __is->endElement();
    }
    __is->endSeq(sz);
}

IcePatch2::PartitionOutOfRangeException::~PartitionOutOfRangeException() throw()
{
}

static const char* __IcePatch2__PartitionOutOfRangeException_name = "IcePatch2::PartitionOutOfRangeException";

::std::string
IcePatch2::PartitionOutOfRangeException::ice_name() const
{
    return __IcePatch2__PartitionOutOfRangeException_name;
}

::Ice::Exception*
IcePatch2::PartitionOutOfRangeException::ice_clone() const
{
    return new PartitionOutOfRangeException(*this);
}

void
IcePatch2::PartitionOutOfRangeException::ice_throw() const
{
    throw *this;
}

void
IcePatch2::PartitionOutOfRangeException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IcePatch2::PartitionOutOfRangeException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
}

void
IcePatch2::PartitionOutOfRangeException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
}

void
IcePatch2::PartitionOutOfRangeException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IcePatch2::PartitionOutOfRangeException was not generated with stream support";
    throw ex;
}

void
IcePatch2::PartitionOutOfRangeException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IcePatch2::PartitionOutOfRangeException was not generated with stream support";
    throw ex;
}

struct __F__IcePatch2__PartitionOutOfRangeException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IcePatch2::PartitionOutOfRangeException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IcePatch2__PartitionOutOfRangeException__Ptr = new __F__IcePatch2__PartitionOutOfRangeException;

const ::IceInternal::UserExceptionFactoryPtr&
IcePatch2::PartitionOutOfRangeException::ice_factory()
{
    return __F__IcePatch2__PartitionOutOfRangeException__Ptr;
}

class __F__IcePatch2__PartitionOutOfRangeException__Init
{
public:

    __F__IcePatch2__PartitionOutOfRangeException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IcePatch2::PartitionOutOfRangeException", ::IcePatch2::PartitionOutOfRangeException::ice_factory());
    }

    ~__F__IcePatch2__PartitionOutOfRangeException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IcePatch2::PartitionOutOfRangeException");
    }
};

static __F__IcePatch2__PartitionOutOfRangeException__Init __F__IcePatch2__PartitionOutOfRangeException__i;

#ifdef __APPLE__
extern "C" { void __F__IcePatch2__PartitionOutOfRangeException__initializer() {} }
#endif

IcePatch2::FileAccessException::FileAccessException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

IcePatch2::FileAccessException::~FileAccessException() throw()
{
}

static const char* __IcePatch2__FileAccessException_name = "IcePatch2::FileAccessException";

::std::string
IcePatch2::FileAccessException::ice_name() const
{
    return __IcePatch2__FileAccessException_name;
}

::Ice::Exception*
IcePatch2::FileAccessException::ice_clone() const
{
    return new FileAccessException(*this);
}

void
IcePatch2::FileAccessException::ice_throw() const
{
    throw *this;
}

void
IcePatch2::FileAccessException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IcePatch2::FileAccessException"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
IcePatch2::FileAccessException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
IcePatch2::FileAccessException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IcePatch2::FileAccessException was not generated with stream support";
    throw ex;
}

void
IcePatch2::FileAccessException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IcePatch2::FileAccessException was not generated with stream support";
    throw ex;
}

struct __F__IcePatch2__FileAccessException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IcePatch2::FileAccessException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IcePatch2__FileAccessException__Ptr = new __F__IcePatch2__FileAccessException;

const ::IceInternal::UserExceptionFactoryPtr&
IcePatch2::FileAccessException::ice_factory()
{
    return __F__IcePatch2__FileAccessException__Ptr;
}

class __F__IcePatch2__FileAccessException__Init
{
public:

    __F__IcePatch2__FileAccessException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IcePatch2::FileAccessException", ::IcePatch2::FileAccessException::ice_factory());
    }

    ~__F__IcePatch2__FileAccessException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IcePatch2::FileAccessException");
    }
};

static __F__IcePatch2__FileAccessException__Init __F__IcePatch2__FileAccessException__i;

#ifdef __APPLE__
extern "C" { void __F__IcePatch2__FileAccessException__initializer() {} }
#endif

void
IcePatch2::__addObject(const FileServerPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IcePatch2::__usesClasses(const FileServerPtr& p)
{
    return p->__usesClasses();
}

void
IcePatch2::__decRefUnsafe(const FileServerPtr& p)
{
    p->__decRefUnsafe();
}

void
IcePatch2::__clearHandleUnsafe(FileServerPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IcePatch2::__addObject(const AdminPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IcePatch2::__usesClasses(const AdminPtr& p)
{
    return p->__usesClasses();
}

void
IcePatch2::__decRefUnsafe(const AdminPtr& p)
{
    p->__decRefUnsafe();
}

void
IcePatch2::__clearHandleUnsafe(AdminPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IcePatch2::AMI_FileServer_getFileInfoSeq::__invoke(const ::IcePatch2::FileServerPrx& __prx, ::Ice::Int partition, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IcePatch2__FileServer__getFileInfoSeq_name, ::Ice::Nonmutating, __ctx);
        __os->write(partition);
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IcePatch2::AMI_FileServer_getFileInfoSeq::__response(bool __ok)
{
    ::IcePatch2::FileInfoSeq __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IcePatch2::PartitionOutOfRangeException& __ex)
            {
                ice_exception(__ex);
                return;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IcePatch2::__read(__is, __ret, ::IcePatch2::__U__FileInfoSeq());
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
}

void
IcePatch2::AMI_FileServer_getFileCompressed::__invoke(const ::IcePatch2::FileServerPrx& __prx, const ::std::string& path, ::Ice::Int pos, ::Ice::Int num, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IcePatch2__FileServer__getFileCompressed_name, ::Ice::Nonmutating, __ctx);
        __os->write(path);
        __os->write(pos);
        __os->write(num);
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IcePatch2::AMI_FileServer_getFileCompressed::__response(bool __ok)
{
    ::std::pair<const ::Ice::Byte*, const ::Ice::Byte*> __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IcePatch2::FileAccessException& __ex)
            {
                ice_exception(__ex);
                return;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        __is->read(__ret);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
}

IceAsync::IcePatch2::AMD_FileServer_getFileCompressed::AMD_FileServer_getFileCompressed(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IcePatch2::AMD_FileServer_getFileCompressed::ice_response(const ::std::pair<const ::Ice::Byte*, const ::Ice::Byte*>& __ret)
{
    try
    {
        ::IceInternal::BasicStream* __os = this->__os();
        __os->write(__ret.first, __ret.second);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __exception(__ex);
        return;
    }
    __response(true);
}

void
IceAsync::IcePatch2::AMD_FileServer_getFileCompressed::ice_exception(const ::Ice::Exception& ex)
{
    try
    {
        ex.ice_throw();
    }
    catch(const ::IcePatch2::FileAccessException& __ex)
    {
        __os()->write(__ex);
        __response(false);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __exception(__ex);
    }
}

void
IceAsync::IcePatch2::AMD_FileServer_getFileCompressed::ice_exception(const ::std::exception& ex)
{
    __exception(ex);
}

void
IceAsync::IcePatch2::AMD_FileServer_getFileCompressed::ice_exception()
{
    __exception();
}

::IcePatch2::FileInfoSeq
IceProxy::IcePatch2::FileServer::getFileInfoSeq(::Ice::Int partition, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IcePatch2__FileServer__getFileInfoSeq_name);
            __delBase = __getDelegate();
            ::IceDelegate::IcePatch2::FileServer* __del = dynamic_cast< ::IceDelegate::IcePatch2::FileServer*>(__delBase.get());
            return __del->getFileInfoSeq(partition, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IcePatch2::FileServer::getFileInfoSeq_async(const ::IcePatch2::AMI_FileServer_getFileInfoSeqPtr& __cb, ::Ice::Int partition)
{
    __cb->__invoke(this, partition, 0);
}

void
IceProxy::IcePatch2::FileServer::getFileInfoSeq_async(const ::IcePatch2::AMI_FileServer_getFileInfoSeqPtr& __cb, ::Ice::Int partition, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, partition, &__ctx);
}

::IcePatch2::ByteSeqSeq
IceProxy::IcePatch2::FileServer::getChecksumSeq(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IcePatch2__FileServer__getChecksumSeq_name);
            __delBase = __getDelegate();
            ::IceDelegate::IcePatch2::FileServer* __del = dynamic_cast< ::IceDelegate::IcePatch2::FileServer*>(__delBase.get());
            return __del->getChecksumSeq(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Ice::ByteSeq
IceProxy::IcePatch2::FileServer::getChecksum(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IcePatch2__FileServer__getChecksum_name);
            __delBase = __getDelegate();
            ::IceDelegate::IcePatch2::FileServer* __del = dynamic_cast< ::IceDelegate::IcePatch2::FileServer*>(__delBase.get());
            return __del->getChecksum(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Ice::ByteSeq
IceProxy::IcePatch2::FileServer::getFileCompressed(const ::std::string& path, ::Ice::Int pos, ::Ice::Int num, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IcePatch2__FileServer__getFileCompressed_name);
            __delBase = __getDelegate();
            ::IceDelegate::IcePatch2::FileServer* __del = dynamic_cast< ::IceDelegate::IcePatch2::FileServer*>(__delBase.get());
            return __del->getFileCompressed(path, pos, num, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IcePatch2::FileServer::getFileCompressed_async(const ::IcePatch2::AMI_FileServer_getFileCompressedPtr& __cb, const ::std::string& path, ::Ice::Int pos, ::Ice::Int num)
{
    __cb->__invoke(this, path, pos, num, 0);
}

void
IceProxy::IcePatch2::FileServer::getFileCompressed_async(const ::IcePatch2::AMI_FileServer_getFileCompressedPtr& __cb, const ::std::string& path, ::Ice::Int pos, ::Ice::Int num, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, path, pos, num, &__ctx);
}

const ::std::string&
IceProxy::IcePatch2::FileServer::ice_staticId()
{
    return ::IcePatch2::FileServer::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IcePatch2::FileServer::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IcePatch2::FileServer);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IcePatch2::FileServer::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IcePatch2::FileServer);
}

bool
IceProxy::IcePatch2::operator==(const ::IceProxy::IcePatch2::FileServer& l, const ::IceProxy::IcePatch2::FileServer& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IcePatch2::operator!=(const ::IceProxy::IcePatch2::FileServer& l, const ::IceProxy::IcePatch2::FileServer& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IcePatch2::operator<(const ::IceProxy::IcePatch2::FileServer& l, const ::IceProxy::IcePatch2::FileServer& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IcePatch2::operator<=(const ::IceProxy::IcePatch2::FileServer& l, const ::IceProxy::IcePatch2::FileServer& r)
{
    return l < r || l == r;
}

bool
IceProxy::IcePatch2::operator>(const ::IceProxy::IcePatch2::FileServer& l, const ::IceProxy::IcePatch2::FileServer& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IcePatch2::operator>=(const ::IceProxy::IcePatch2::FileServer& l, const ::IceProxy::IcePatch2::FileServer& r)
{
    return !(l < r);
}

void
IceProxy::IcePatch2::Admin::shutdown(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IcePatch2::Admin* __del = dynamic_cast< ::IceDelegate::IcePatch2::Admin*>(__delBase.get());
            __del->shutdown(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IcePatch2::Admin::ice_staticId()
{
    return ::IcePatch2::Admin::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IcePatch2::Admin::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IcePatch2::Admin);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IcePatch2::Admin::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IcePatch2::Admin);
}

bool
IceProxy::IcePatch2::operator==(const ::IceProxy::IcePatch2::Admin& l, const ::IceProxy::IcePatch2::Admin& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IcePatch2::operator!=(const ::IceProxy::IcePatch2::Admin& l, const ::IceProxy::IcePatch2::Admin& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IcePatch2::operator<(const ::IceProxy::IcePatch2::Admin& l, const ::IceProxy::IcePatch2::Admin& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IcePatch2::operator<=(const ::IceProxy::IcePatch2::Admin& l, const ::IceProxy::IcePatch2::Admin& r)
{
    return l < r || l == r;
}

bool
IceProxy::IcePatch2::operator>(const ::IceProxy::IcePatch2::Admin& l, const ::IceProxy::IcePatch2::Admin& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IcePatch2::operator>=(const ::IceProxy::IcePatch2::Admin& l, const ::IceProxy::IcePatch2::Admin& r)
{
    return !(l < r);
}

::IcePatch2::FileInfoSeq
IceDelegateM::IcePatch2::FileServer::getFileInfoSeq(::Ice::Int partition, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IcePatch2__FileServer__getFileInfoSeq_name, ::Ice::Nonmutating, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(partition);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IcePatch2::PartitionOutOfRangeException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IcePatch2::FileInfoSeq __ret;
        ::IcePatch2::__read(__is, __ret, ::IcePatch2::__U__FileInfoSeq());
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IcePatch2::ByteSeqSeq
IceDelegateM::IcePatch2::FileServer::getChecksumSeq(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IcePatch2__FileServer__getChecksumSeq_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IcePatch2::ByteSeqSeq __ret;
        ::IcePatch2::__read(__is, __ret, ::IcePatch2::__U__ByteSeqSeq());
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ByteSeq
IceDelegateM::IcePatch2::FileServer::getChecksum(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IcePatch2__FileServer__getChecksum_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::ByteSeq __ret;
        ::std::pair<const ::Ice::Byte*, const ::Ice::Byte*> _____ret;
        __is->read(_____ret);
        ::std::vector< ::Ice::Byte>(_____ret.first, _____ret.second).swap(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ByteSeq
IceDelegateM::IcePatch2::FileServer::getFileCompressed(const ::std::string& path, ::Ice::Int pos, ::Ice::Int num, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IcePatch2__FileServer__getFileCompressed_name, ::Ice::Nonmutating, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(path);
        __os->write(pos);
        __os->write(num);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IcePatch2::FileAccessException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::ByteSeq __ret;
        ::std::pair<const ::Ice::Byte*, const ::Ice::Byte*> _____ret;
        __is->read(_____ret);
        ::std::vector< ::Ice::Byte>(_____ret.first, _____ret.second).swap(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IcePatch2::Admin::shutdown(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IcePatch2__Admin__shutdown_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IcePatch2::FileInfoSeq
IceDelegateD::IcePatch2::FileServer::getFileInfoSeq(::Ice::Int partition, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IcePatch2__FileServer__getFileInfoSeq_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IcePatch2::FileInfoSeq __ret;
        try
        {
            ::IcePatch2::FileServer* __servant = dynamic_cast< ::IcePatch2::FileServer*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getFileInfoSeq(partition, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::IcePatch2::ByteSeqSeq
IceDelegateD::IcePatch2::FileServer::getChecksumSeq(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IcePatch2__FileServer__getChecksumSeq_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IcePatch2::ByteSeqSeq __ret;
        try
        {
            ::IcePatch2::FileServer* __servant = dynamic_cast< ::IcePatch2::FileServer*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getChecksumSeq(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::ByteSeq
IceDelegateD::IcePatch2::FileServer::getChecksum(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IcePatch2__FileServer__getChecksum_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::ByteSeq __ret;
        try
        {
            ::IcePatch2::FileServer* __servant = dynamic_cast< ::IcePatch2::FileServer*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getChecksum(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::ByteSeq
IceDelegateD::IcePatch2::FileServer::getFileCompressed(const ::std::string&, ::Ice::Int, ::Ice::Int, const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
    return ::Ice::ByteSeq(); // to avoid a warning with some compilers;
}

void
IceDelegateD::IcePatch2::Admin::shutdown(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IcePatch2__Admin__shutdown_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IcePatch2::Admin* __servant = dynamic_cast< ::IcePatch2::Admin*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->shutdown(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::Ice::ObjectPtr
IcePatch2::FileServer::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IcePatch2__FileServer_ids[2] =
{
    "::Ice::Object",
    "::IcePatch2::FileServer"
};

bool
IcePatch2::FileServer::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IcePatch2__FileServer_ids, __IcePatch2__FileServer_ids + 2, _s);
}

::std::vector< ::std::string>
IcePatch2::FileServer::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IcePatch2__FileServer_ids[0], &__IcePatch2__FileServer_ids[2]);
}

const ::std::string&
IcePatch2::FileServer::ice_id(const ::Ice::Current&) const
{
    return __IcePatch2__FileServer_ids[1];
}

const ::std::string&
IcePatch2::FileServer::ice_staticId()
{
    return __IcePatch2__FileServer_ids[1];
}

::IceInternal::DispatchStatus
IcePatch2::FileServer::___getFileInfoSeq(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Int partition;
    __is->read(partition);
    try
    {
        ::IcePatch2::FileInfoSeq __ret = getFileInfoSeq(partition, __current);
        if(__ret.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IcePatch2::__write(__os, &__ret[0], &__ret[0] + __ret.size(), ::IcePatch2::__U__FileInfoSeq());
        }
    }
    catch(const ::IcePatch2::PartitionOutOfRangeException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IcePatch2::FileServer::___getChecksumSeq(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IcePatch2::ByteSeqSeq __ret = getChecksumSeq(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IcePatch2::__write(__os, &__ret[0], &__ret[0] + __ret.size(), ::IcePatch2::__U__ByteSeqSeq());
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IcePatch2::FileServer::___getChecksum(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::ByteSeq __ret = getChecksum(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&__ret[0], &__ret[0] + __ret.size());
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IcePatch2::FileServer::___getFileCompressed(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::std::string path;
    ::Ice::Int pos;
    ::Ice::Int num;
    __is->read(path);
    __is->read(pos);
    __is->read(num);
    ::IcePatch2::AMD_FileServer_getFileCompressedPtr __cb = new IceAsync::IcePatch2::AMD_FileServer_getFileCompressed(__inS);
    try
    {
        getFileCompressed_async(__cb, path, pos, num, __current);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::IceInternal::DispatchAsync;
}

static ::std::string __IcePatch2__FileServer_all[] =
{
    "getChecksum",
    "getChecksumSeq",
    "getFileCompressed",
    "getFileInfoSeq",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
IcePatch2::FileServer::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IcePatch2__FileServer_all, __IcePatch2__FileServer_all + 8, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IcePatch2__FileServer_all)
    {
        case 0:
        {
            return ___getChecksum(in, current);
        }
        case 1:
        {
            return ___getChecksumSeq(in, current);
        }
        case 2:
        {
            return ___getFileCompressed(in, current);
        }
        case 3:
        {
            return ___getFileInfoSeq(in, current);
        }
        case 4:
        {
            return ___ice_id(in, current);
        }
        case 5:
        {
            return ___ice_ids(in, current);
        }
        case 6:
        {
            return ___ice_isA(in, current);
        }
        case 7:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IcePatch2::FileServer::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IcePatch2::FileServer::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IcePatch2::FileServer::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IcePatch2::FileServer was not generated with stream support";
    throw ex;
}

void
IcePatch2::FileServer::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IcePatch2::FileServer was not generated with stream support";
    throw ex;
}

void ICE_PATCH2_API 
IcePatch2::__patch__FileServerPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IcePatch2::FileServerPtr* p = static_cast< ::IcePatch2::FileServerPtr*>(__addr);
    assert(p);
    *p = ::IcePatch2::FileServerPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IcePatch2::FileServer::ice_staticId();
        throw e;
    }
}

bool
IcePatch2::operator==(const ::IcePatch2::FileServer& l, const ::IcePatch2::FileServer& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IcePatch2::operator!=(const ::IcePatch2::FileServer& l, const ::IcePatch2::FileServer& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IcePatch2::operator<(const ::IcePatch2::FileServer& l, const ::IcePatch2::FileServer& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IcePatch2::operator<=(const ::IcePatch2::FileServer& l, const ::IcePatch2::FileServer& r)
{
    return l < r || l == r;
}

bool
IcePatch2::operator>(const ::IcePatch2::FileServer& l, const ::IcePatch2::FileServer& r)
{
    return !(l < r) && !(l == r);
}

bool
IcePatch2::operator>=(const ::IcePatch2::FileServer& l, const ::IcePatch2::FileServer& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IcePatch2::Admin::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IcePatch2__Admin_ids[2] =
{
    "::Ice::Object",
    "::IcePatch2::Admin"
};

bool
IcePatch2::Admin::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IcePatch2__Admin_ids, __IcePatch2__Admin_ids + 2, _s);
}

::std::vector< ::std::string>
IcePatch2::Admin::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IcePatch2__Admin_ids[0], &__IcePatch2__Admin_ids[2]);
}

const ::std::string&
IcePatch2::Admin::ice_id(const ::Ice::Current&) const
{
    return __IcePatch2__Admin_ids[1];
}

const ::std::string&
IcePatch2::Admin::ice_staticId()
{
    return __IcePatch2__Admin_ids[1];
}

::IceInternal::DispatchStatus
IcePatch2::Admin::___shutdown(::IceInternal::Incoming&, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    shutdown(__current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IcePatch2__Admin_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "shutdown"
};

::IceInternal::DispatchStatus
IcePatch2::Admin::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IcePatch2__Admin_all, __IcePatch2__Admin_all + 5, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IcePatch2__Admin_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___shutdown(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IcePatch2::Admin::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IcePatch2::Admin::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IcePatch2::Admin::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IcePatch2::Admin was not generated with stream support";
    throw ex;
}

void
IcePatch2::Admin::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IcePatch2::Admin was not generated with stream support";
    throw ex;
}

void ICE_PATCH2_API 
IcePatch2::__patch__AdminPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IcePatch2::AdminPtr* p = static_cast< ::IcePatch2::AdminPtr*>(__addr);
    assert(p);
    *p = ::IcePatch2::AdminPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IcePatch2::Admin::ice_staticId();
        throw e;
    }
}

bool
IcePatch2::operator==(const ::IcePatch2::Admin& l, const ::IcePatch2::Admin& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IcePatch2::operator!=(const ::IcePatch2::Admin& l, const ::IcePatch2::Admin& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IcePatch2::operator<(const ::IcePatch2::Admin& l, const ::IcePatch2::Admin& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IcePatch2::operator<=(const ::IcePatch2::Admin& l, const ::IcePatch2::Admin& r)
{
    return l < r || l == r;
}

bool
IcePatch2::operator>(const ::IcePatch2::Admin& l, const ::IcePatch2::Admin& r)
{
    return !(l < r) && !(l == r);
}

bool
IcePatch2::operator>=(const ::IcePatch2::Admin& l, const ::IcePatch2::Admin& r)
{
    return !(l < r);
}
