// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `IceStorm.ice'

#include <IceStorm/IceStorm.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceStorm__Topic__getName_name = "getName";

static const ::std::string __IceStorm__Topic__getPublisher_name = "getPublisher";

static const ::std::string __IceStorm__Topic__subscribe_name = "subscribe";

static const ::std::string __IceStorm__Topic__subscribeAndGetPublisher_name = "subscribeAndGetPublisher";

static const ::std::string __IceStorm__Topic__unsubscribe_name = "unsubscribe";

static const ::std::string __IceStorm__Topic__link_name = "link";

static const ::std::string __IceStorm__Topic__unlink_name = "unlink";

static const ::std::string __IceStorm__Topic__getLinkInfoSeq_name = "getLinkInfoSeq";

static const ::std::string __IceStorm__Topic__destroy_name = "destroy";

static const ::std::string __IceStorm__TopicManager__create_name = "create";

static const ::std::string __IceStorm__TopicManager__retrieve_name = "retrieve";

static const ::std::string __IceStorm__TopicManager__retrieveAll_name = "retrieveAll";

static const ::std::string __IceStorm__TopicManager__getSliceChecksums_name = "getSliceChecksums";

void
IceInternal::incRef(::IceStorm::Topic* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceStorm::Topic* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceStorm::Topic* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceStorm::Topic* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceStorm::TopicManager* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceStorm::TopicManager* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceStorm::TopicManager* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceStorm::TopicManager* p)
{
    p->__decRef();
}

void
IceStorm::__write(::IceInternal::BasicStream* __os, const ::IceStorm::TopicPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceStorm::__read(::IceInternal::BasicStream* __is, ::IceStorm::TopicPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceStorm::Topic;
        v->__copyFrom(proxy);
    }
}

void
IceStorm::__write(::IceInternal::BasicStream* __os, const ::IceStorm::TopicPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceStorm::__write(::IceInternal::BasicStream* __os, const ::IceStorm::TopicManagerPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceStorm::__read(::IceInternal::BasicStream* __is, ::IceStorm::TopicManagerPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceStorm::TopicManager;
        v->__copyFrom(proxy);
    }
}

void
IceStorm::__write(::IceInternal::BasicStream* __os, const ::IceStorm::TopicManagerPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

bool
IceStorm::LinkInfo::operator==(const LinkInfo& __rhs) const
{
    return !operator!=(__rhs);
}

bool
IceStorm::LinkInfo::operator!=(const LinkInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(theTopic != __rhs.theTopic)
    {
        return true;
    }
    if(name != __rhs.name)
    {
        return true;
    }
    if(cost != __rhs.cost)
    {
        return true;
    }
    return false;
}

bool
IceStorm::LinkInfo::operator<(const LinkInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(theTopic < __rhs.theTopic)
    {
        return true;
    }
    else if(__rhs.theTopic < theTopic)
    {
        return false;
    }
    if(name < __rhs.name)
    {
        return true;
    }
    else if(__rhs.name < name)
    {
        return false;
    }
    if(cost < __rhs.cost)
    {
        return true;
    }
    else if(__rhs.cost < cost)
    {
        return false;
    }
    return false;
}

void
IceStorm::LinkInfo::__write(::IceInternal::BasicStream* __os) const
{
    ::IceStorm::__write(__os, theTopic);
    __os->write(name);
    __os->write(cost);
}

void
IceStorm::LinkInfo::__read(::IceInternal::BasicStream* __is)
{
    ::IceStorm::__read(__is, theTopic);
    __is->read(name);
    __is->read(cost);
}

void
IceStorm::__write(::IceInternal::BasicStream* __os, const ::IceStorm::LinkInfo* begin, const ::IceStorm::LinkInfo* end, ::IceStorm::__U__LinkInfoSeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
IceStorm::__read(::IceInternal::BasicStream* __is, ::IceStorm::LinkInfoSeq& v, ::IceStorm::__U__LinkInfoSeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 7);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
IceStorm::__write(::IceInternal::BasicStream* __os, const ::IceStorm::QoS& v, ::IceStorm::__U__QoS)
{
    __os->writeSize(::Ice::Int(v.size()));
    ::IceStorm::QoS::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
        __os->write(p->first);
        __os->write(p->second);
    }
}

void
IceStorm::__read(::IceInternal::BasicStream* __is, ::IceStorm::QoS& v, ::IceStorm::__U__QoS)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    while(sz--)
    {
        ::std::pair<const  ::std::string, ::std::string> pair;
        __is->read(const_cast< ::std::string&>(pair.first));
        ::IceStorm::QoS::iterator __i = v.insert(v.end(), pair);
        __is->read(__i->second);
    }
}

IceStorm::LinkExists::LinkExists(const ::std::string& __ice_name) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    name(__ice_name)
{
}

IceStorm::LinkExists::~LinkExists() throw()
{
}

static const char* __IceStorm__LinkExists_name = "IceStorm::LinkExists";

::std::string
IceStorm::LinkExists::ice_name() const
{
    return __IceStorm__LinkExists_name;
}

::Ice::Exception*
IceStorm::LinkExists::ice_clone() const
{
    return new LinkExists(*this);
}

void
IceStorm::LinkExists::ice_throw() const
{
    throw *this;
}

void
IceStorm::LinkExists::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceStorm::LinkExists"), false);
    __os->startWriteSlice();
    __os->write(name);
    __os->endWriteSlice();
}

void
IceStorm::LinkExists::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(name);
    __is->endReadSlice();
}

void
IceStorm::LinkExists::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStorm::LinkExists was not generated with stream support";
    throw ex;
}

void
IceStorm::LinkExists::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStorm::LinkExists was not generated with stream support";
    throw ex;
}

struct __F__IceStorm__LinkExists : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceStorm::LinkExists();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceStorm__LinkExists__Ptr = new __F__IceStorm__LinkExists;

const ::IceInternal::UserExceptionFactoryPtr&
IceStorm::LinkExists::ice_factory()
{
    return __F__IceStorm__LinkExists__Ptr;
}

class __F__IceStorm__LinkExists__Init
{
public:

    __F__IceStorm__LinkExists__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceStorm::LinkExists", ::IceStorm::LinkExists::ice_factory());
    }

    ~__F__IceStorm__LinkExists__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceStorm::LinkExists");
    }
};

static __F__IceStorm__LinkExists__Init __F__IceStorm__LinkExists__i;

#ifdef __APPLE__
extern "C" { void __F__IceStorm__LinkExists__initializer() {} }
#endif

IceStorm::NoSuchLink::NoSuchLink(const ::std::string& __ice_name) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    name(__ice_name)
{
}

IceStorm::NoSuchLink::~NoSuchLink() throw()
{
}

static const char* __IceStorm__NoSuchLink_name = "IceStorm::NoSuchLink";

::std::string
IceStorm::NoSuchLink::ice_name() const
{
    return __IceStorm__NoSuchLink_name;
}

::Ice::Exception*
IceStorm::NoSuchLink::ice_clone() const
{
    return new NoSuchLink(*this);
}

void
IceStorm::NoSuchLink::ice_throw() const
{
    throw *this;
}

void
IceStorm::NoSuchLink::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceStorm::NoSuchLink"), false);
    __os->startWriteSlice();
    __os->write(name);
    __os->endWriteSlice();
}

void
IceStorm::NoSuchLink::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(name);
    __is->endReadSlice();
}

void
IceStorm::NoSuchLink::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStorm::NoSuchLink was not generated with stream support";
    throw ex;
}

void
IceStorm::NoSuchLink::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStorm::NoSuchLink was not generated with stream support";
    throw ex;
}

struct __F__IceStorm__NoSuchLink : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceStorm::NoSuchLink();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceStorm__NoSuchLink__Ptr = new __F__IceStorm__NoSuchLink;

const ::IceInternal::UserExceptionFactoryPtr&
IceStorm::NoSuchLink::ice_factory()
{
    return __F__IceStorm__NoSuchLink__Ptr;
}

class __F__IceStorm__NoSuchLink__Init
{
public:

    __F__IceStorm__NoSuchLink__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceStorm::NoSuchLink", ::IceStorm::NoSuchLink::ice_factory());
    }

    ~__F__IceStorm__NoSuchLink__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceStorm::NoSuchLink");
    }
};

static __F__IceStorm__NoSuchLink__Init __F__IceStorm__NoSuchLink__i;

#ifdef __APPLE__
extern "C" { void __F__IceStorm__NoSuchLink__initializer() {} }
#endif

IceStorm::AlreadySubscribed::~AlreadySubscribed() throw()
{
}

static const char* __IceStorm__AlreadySubscribed_name = "IceStorm::AlreadySubscribed";

::std::string
IceStorm::AlreadySubscribed::ice_name() const
{
    return __IceStorm__AlreadySubscribed_name;
}

::Ice::Exception*
IceStorm::AlreadySubscribed::ice_clone() const
{
    return new AlreadySubscribed(*this);
}

void
IceStorm::AlreadySubscribed::ice_throw() const
{
    throw *this;
}

void
IceStorm::AlreadySubscribed::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceStorm::AlreadySubscribed"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
}

void
IceStorm::AlreadySubscribed::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
}

void
IceStorm::AlreadySubscribed::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStorm::AlreadySubscribed was not generated with stream support";
    throw ex;
}

void
IceStorm::AlreadySubscribed::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStorm::AlreadySubscribed was not generated with stream support";
    throw ex;
}

struct __F__IceStorm__AlreadySubscribed : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceStorm::AlreadySubscribed();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceStorm__AlreadySubscribed__Ptr = new __F__IceStorm__AlreadySubscribed;

const ::IceInternal::UserExceptionFactoryPtr&
IceStorm::AlreadySubscribed::ice_factory()
{
    return __F__IceStorm__AlreadySubscribed__Ptr;
}

class __F__IceStorm__AlreadySubscribed__Init
{
public:

    __F__IceStorm__AlreadySubscribed__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceStorm::AlreadySubscribed", ::IceStorm::AlreadySubscribed::ice_factory());
    }

    ~__F__IceStorm__AlreadySubscribed__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceStorm::AlreadySubscribed");
    }
};

static __F__IceStorm__AlreadySubscribed__Init __F__IceStorm__AlreadySubscribed__i;

#ifdef __APPLE__
extern "C" { void __F__IceStorm__AlreadySubscribed__initializer() {} }
#endif

IceStorm::BadQoS::BadQoS(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

IceStorm::BadQoS::~BadQoS() throw()
{
}

static const char* __IceStorm__BadQoS_name = "IceStorm::BadQoS";

::std::string
IceStorm::BadQoS::ice_name() const
{
    return __IceStorm__BadQoS_name;
}

::Ice::Exception*
IceStorm::BadQoS::ice_clone() const
{
    return new BadQoS(*this);
}

void
IceStorm::BadQoS::ice_throw() const
{
    throw *this;
}

void
IceStorm::BadQoS::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceStorm::BadQoS"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
IceStorm::BadQoS::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
IceStorm::BadQoS::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStorm::BadQoS was not generated with stream support";
    throw ex;
}

void
IceStorm::BadQoS::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStorm::BadQoS was not generated with stream support";
    throw ex;
}

struct __F__IceStorm__BadQoS : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceStorm::BadQoS();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceStorm__BadQoS__Ptr = new __F__IceStorm__BadQoS;

const ::IceInternal::UserExceptionFactoryPtr&
IceStorm::BadQoS::ice_factory()
{
    return __F__IceStorm__BadQoS__Ptr;
}

class __F__IceStorm__BadQoS__Init
{
public:

    __F__IceStorm__BadQoS__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceStorm::BadQoS", ::IceStorm::BadQoS::ice_factory());
    }

    ~__F__IceStorm__BadQoS__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceStorm::BadQoS");
    }
};

static __F__IceStorm__BadQoS__Init __F__IceStorm__BadQoS__i;

#ifdef __APPLE__
extern "C" { void __F__IceStorm__BadQoS__initializer() {} }
#endif

void
IceStorm::__addObject(const TopicPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceStorm::__usesClasses(const TopicPtr& p)
{
    return p->__usesClasses();
}

void
IceStorm::__decRefUnsafe(const TopicPtr& p)
{
    p->__decRefUnsafe();
}

void
IceStorm::__clearHandleUnsafe(TopicPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceStorm::__write(::IceInternal::BasicStream* __os, const ::IceStorm::TopicDict& v, ::IceStorm::__U__TopicDict)
{
    __os->writeSize(::Ice::Int(v.size()));
    ::IceStorm::TopicDict::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
        __os->write(p->first);
        ::IceStorm::__write(__os, p->second);
    }
}

void
IceStorm::__read(::IceInternal::BasicStream* __is, ::IceStorm::TopicDict& v, ::IceStorm::__U__TopicDict)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    while(sz--)
    {
        ::std::pair<const  ::std::string, ::IceStorm::TopicPrx> pair;
        __is->read(const_cast< ::std::string&>(pair.first));
        ::IceStorm::TopicDict::iterator __i = v.insert(v.end(), pair);
        ::IceStorm::__read(__is, __i->second);
    }
}

IceStorm::TopicExists::TopicExists(const ::std::string& __ice_name) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    name(__ice_name)
{
}

IceStorm::TopicExists::~TopicExists() throw()
{
}

static const char* __IceStorm__TopicExists_name = "IceStorm::TopicExists";

::std::string
IceStorm::TopicExists::ice_name() const
{
    return __IceStorm__TopicExists_name;
}

::Ice::Exception*
IceStorm::TopicExists::ice_clone() const
{
    return new TopicExists(*this);
}

void
IceStorm::TopicExists::ice_throw() const
{
    throw *this;
}

void
IceStorm::TopicExists::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceStorm::TopicExists"), false);
    __os->startWriteSlice();
    __os->write(name);
    __os->endWriteSlice();
}

void
IceStorm::TopicExists::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(name);
    __is->endReadSlice();
}

void
IceStorm::TopicExists::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStorm::TopicExists was not generated with stream support";
    throw ex;
}

void
IceStorm::TopicExists::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStorm::TopicExists was not generated with stream support";
    throw ex;
}

struct __F__IceStorm__TopicExists : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceStorm::TopicExists();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceStorm__TopicExists__Ptr = new __F__IceStorm__TopicExists;

const ::IceInternal::UserExceptionFactoryPtr&
IceStorm::TopicExists::ice_factory()
{
    return __F__IceStorm__TopicExists__Ptr;
}

class __F__IceStorm__TopicExists__Init
{
public:

    __F__IceStorm__TopicExists__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceStorm::TopicExists", ::IceStorm::TopicExists::ice_factory());
    }

    ~__F__IceStorm__TopicExists__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceStorm::TopicExists");
    }
};

static __F__IceStorm__TopicExists__Init __F__IceStorm__TopicExists__i;

#ifdef __APPLE__
extern "C" { void __F__IceStorm__TopicExists__initializer() {} }
#endif

IceStorm::NoSuchTopic::NoSuchTopic(const ::std::string& __ice_name) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    name(__ice_name)
{
}

IceStorm::NoSuchTopic::~NoSuchTopic() throw()
{
}

static const char* __IceStorm__NoSuchTopic_name = "IceStorm::NoSuchTopic";

::std::string
IceStorm::NoSuchTopic::ice_name() const
{
    return __IceStorm__NoSuchTopic_name;
}

::Ice::Exception*
IceStorm::NoSuchTopic::ice_clone() const
{
    return new NoSuchTopic(*this);
}

void
IceStorm::NoSuchTopic::ice_throw() const
{
    throw *this;
}

void
IceStorm::NoSuchTopic::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceStorm::NoSuchTopic"), false);
    __os->startWriteSlice();
    __os->write(name);
    __os->endWriteSlice();
}

void
IceStorm::NoSuchTopic::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(name);
    __is->endReadSlice();
}

void
IceStorm::NoSuchTopic::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStorm::NoSuchTopic was not generated with stream support";
    throw ex;
}

void
IceStorm::NoSuchTopic::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceStorm::NoSuchTopic was not generated with stream support";
    throw ex;
}

struct __F__IceStorm__NoSuchTopic : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceStorm::NoSuchTopic();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceStorm__NoSuchTopic__Ptr = new __F__IceStorm__NoSuchTopic;

const ::IceInternal::UserExceptionFactoryPtr&
IceStorm::NoSuchTopic::ice_factory()
{
    return __F__IceStorm__NoSuchTopic__Ptr;
}

class __F__IceStorm__NoSuchTopic__Init
{
public:

    __F__IceStorm__NoSuchTopic__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceStorm::NoSuchTopic", ::IceStorm::NoSuchTopic::ice_factory());
    }

    ~__F__IceStorm__NoSuchTopic__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceStorm::NoSuchTopic");
    }
};

static __F__IceStorm__NoSuchTopic__Init __F__IceStorm__NoSuchTopic__i;

#ifdef __APPLE__
extern "C" { void __F__IceStorm__NoSuchTopic__initializer() {} }
#endif

void
IceStorm::__addObject(const TopicManagerPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceStorm::__usesClasses(const TopicManagerPtr& p)
{
    return p->__usesClasses();
}

void
IceStorm::__decRefUnsafe(const TopicManagerPtr& p)
{
    p->__decRefUnsafe();
}

void
IceStorm::__clearHandleUnsafe(TopicManagerPtr& p)
{
    p.__clearHandleUnsafe();
}

::std::string
IceProxy::IceStorm::Topic::getName(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceStorm__Topic__getName_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceStorm::Topic* __del = dynamic_cast< ::IceDelegate::IceStorm::Topic*>(__delBase.get());
            return __del->getName(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Ice::ObjectPrx
IceProxy::IceStorm::Topic::getPublisher(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceStorm__Topic__getPublisher_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceStorm::Topic* __del = dynamic_cast< ::IceDelegate::IceStorm::Topic*>(__delBase.get());
            return __del->getPublisher(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceStorm::Topic::subscribe(const ::IceStorm::QoS& theQoS, const ::Ice::ObjectPrx& subscriber, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceStorm::Topic* __del = dynamic_cast< ::IceDelegate::IceStorm::Topic*>(__delBase.get());
            __del->subscribe(theQoS, subscriber, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Ice::ObjectPrx
IceProxy::IceStorm::Topic::subscribeAndGetPublisher(const ::IceStorm::QoS& theQoS, const ::Ice::ObjectPrx& subscriber, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceStorm__Topic__subscribeAndGetPublisher_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceStorm::Topic* __del = dynamic_cast< ::IceDelegate::IceStorm::Topic*>(__delBase.get());
            return __del->subscribeAndGetPublisher(theQoS, subscriber, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceStorm::Topic::unsubscribe(const ::Ice::ObjectPrx& subscriber, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceStorm::Topic* __del = dynamic_cast< ::IceDelegate::IceStorm::Topic*>(__delBase.get());
            __del->unsubscribe(subscriber, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceStorm::Topic::link(const ::IceStorm::TopicPrx& linkTo, ::Ice::Int cost, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceStorm__Topic__link_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceStorm::Topic* __del = dynamic_cast< ::IceDelegate::IceStorm::Topic*>(__delBase.get());
            __del->link(linkTo, cost, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceStorm::Topic::unlink(const ::IceStorm::TopicPrx& linkTo, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceStorm__Topic__unlink_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceStorm::Topic* __del = dynamic_cast< ::IceDelegate::IceStorm::Topic*>(__delBase.get());
            __del->unlink(linkTo, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::IceStorm::LinkInfoSeq
IceProxy::IceStorm::Topic::getLinkInfoSeq(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceStorm__Topic__getLinkInfoSeq_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceStorm::Topic* __del = dynamic_cast< ::IceDelegate::IceStorm::Topic*>(__delBase.get());
            return __del->getLinkInfoSeq(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceStorm::Topic::destroy(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceStorm::Topic* __del = dynamic_cast< ::IceDelegate::IceStorm::Topic*>(__delBase.get());
            __del->destroy(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceStorm::Topic::ice_staticId()
{
    return ::IceStorm::Topic::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceStorm::Topic::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceStorm::Topic);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceStorm::Topic::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceStorm::Topic);
}

bool
IceProxy::IceStorm::operator==(const ::IceProxy::IceStorm::Topic& l, const ::IceProxy::IceStorm::Topic& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceStorm::operator!=(const ::IceProxy::IceStorm::Topic& l, const ::IceProxy::IceStorm::Topic& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceStorm::operator<(const ::IceProxy::IceStorm::Topic& l, const ::IceProxy::IceStorm::Topic& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceStorm::operator<=(const ::IceProxy::IceStorm::Topic& l, const ::IceProxy::IceStorm::Topic& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceStorm::operator>(const ::IceProxy::IceStorm::Topic& l, const ::IceProxy::IceStorm::Topic& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceStorm::operator>=(const ::IceProxy::IceStorm::Topic& l, const ::IceProxy::IceStorm::Topic& r)
{
    return !(l < r);
}

::IceStorm::TopicPrx
IceProxy::IceStorm::TopicManager::create(const ::std::string& name, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceStorm__TopicManager__create_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceStorm::TopicManager* __del = dynamic_cast< ::IceDelegate::IceStorm::TopicManager*>(__delBase.get());
            return __del->create(name, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::IceStorm::TopicPrx
IceProxy::IceStorm::TopicManager::retrieve(const ::std::string& name, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceStorm__TopicManager__retrieve_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceStorm::TopicManager* __del = dynamic_cast< ::IceDelegate::IceStorm::TopicManager*>(__delBase.get());
            return __del->retrieve(name, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::IceStorm::TopicDict
IceProxy::IceStorm::TopicManager::retrieveAll(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceStorm__TopicManager__retrieveAll_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceStorm::TopicManager* __del = dynamic_cast< ::IceDelegate::IceStorm::TopicManager*>(__delBase.get());
            return __del->retrieveAll(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Ice::SliceChecksumDict
IceProxy::IceStorm::TopicManager::getSliceChecksums(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceStorm__TopicManager__getSliceChecksums_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceStorm::TopicManager* __del = dynamic_cast< ::IceDelegate::IceStorm::TopicManager*>(__delBase.get());
            return __del->getSliceChecksums(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceStorm::TopicManager::ice_staticId()
{
    return ::IceStorm::TopicManager::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceStorm::TopicManager::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceStorm::TopicManager);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceStorm::TopicManager::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceStorm::TopicManager);
}

bool
IceProxy::IceStorm::operator==(const ::IceProxy::IceStorm::TopicManager& l, const ::IceProxy::IceStorm::TopicManager& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceStorm::operator!=(const ::IceProxy::IceStorm::TopicManager& l, const ::IceProxy::IceStorm::TopicManager& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceStorm::operator<(const ::IceProxy::IceStorm::TopicManager& l, const ::IceProxy::IceStorm::TopicManager& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceStorm::operator<=(const ::IceProxy::IceStorm::TopicManager& l, const ::IceProxy::IceStorm::TopicManager& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceStorm::operator>(const ::IceProxy::IceStorm::TopicManager& l, const ::IceProxy::IceStorm::TopicManager& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceStorm::operator>=(const ::IceProxy::IceStorm::TopicManager& l, const ::IceProxy::IceStorm::TopicManager& r)
{
    return !(l < r);
}

::std::string
IceDelegateM::IceStorm::Topic::getName(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceStorm__Topic__getName_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::std::string __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ObjectPrx
IceDelegateM::IceStorm::Topic::getPublisher(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceStorm__Topic__getPublisher_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::ObjectPrx __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceStorm::Topic::subscribe(const ::IceStorm::QoS& theQoS, const ::Ice::ObjectPrx& subscriber, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceStorm__Topic__subscribe_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceStorm::__write(__os, theQoS, ::IceStorm::__U__QoS());
        __os->write(subscriber);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ObjectPrx
IceDelegateM::IceStorm::Topic::subscribeAndGetPublisher(const ::IceStorm::QoS& theQoS, const ::Ice::ObjectPrx& subscriber, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceStorm__Topic__subscribeAndGetPublisher_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceStorm::__write(__os, theQoS, ::IceStorm::__U__QoS());
        __os->write(subscriber);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceStorm::AlreadySubscribed&)
            {
                throw;
            }
            catch(const ::IceStorm::BadQoS&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::ObjectPrx __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceStorm::Topic::unsubscribe(const ::Ice::ObjectPrx& subscriber, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceStorm__Topic__unsubscribe_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(subscriber);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceStorm::Topic::link(const ::IceStorm::TopicPrx& linkTo, ::Ice::Int cost, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceStorm__Topic__link_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceStorm::__write(__os, linkTo);
        __os->write(cost);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceStorm::LinkExists&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceStorm::Topic::unlink(const ::IceStorm::TopicPrx& linkTo, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceStorm__Topic__unlink_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceStorm::__write(__os, linkTo);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceStorm::NoSuchLink&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceStorm::LinkInfoSeq
IceDelegateM::IceStorm::Topic::getLinkInfoSeq(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceStorm__Topic__getLinkInfoSeq_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceStorm::LinkInfoSeq __ret;
        ::IceStorm::__read(__is, __ret, ::IceStorm::__U__LinkInfoSeq());
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceStorm::Topic::destroy(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceStorm__Topic__destroy_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceStorm::TopicPrx
IceDelegateM::IceStorm::TopicManager::create(const ::std::string& name, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceStorm__TopicManager__create_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(name);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceStorm::TopicExists&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceStorm::TopicPrx __ret;
        ::IceStorm::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceStorm::TopicPrx
IceDelegateM::IceStorm::TopicManager::retrieve(const ::std::string& name, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceStorm__TopicManager__retrieve_name, ::Ice::Nonmutating, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(name);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceStorm::NoSuchTopic&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceStorm::TopicPrx __ret;
        ::IceStorm::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceStorm::TopicDict
IceDelegateM::IceStorm::TopicManager::retrieveAll(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceStorm__TopicManager__retrieveAll_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceStorm::TopicDict __ret;
        ::IceStorm::__read(__is, __ret, ::IceStorm::__U__TopicDict());
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::SliceChecksumDict
IceDelegateM::IceStorm::TopicManager::getSliceChecksums(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceStorm__TopicManager__getSliceChecksums_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::SliceChecksumDict __ret;
        ::Ice::__read(__is, __ret, ::Ice::__U__SliceChecksumDict());
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::std::string
IceDelegateD::IceStorm::Topic::getName(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__Topic__getName_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::std::string __ret;
        try
        {
            ::IceStorm::Topic* __servant = dynamic_cast< ::IceStorm::Topic*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getName(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::ObjectPrx
IceDelegateD::IceStorm::Topic::getPublisher(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__Topic__getPublisher_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::ObjectPrx __ret;
        try
        {
            ::IceStorm::Topic* __servant = dynamic_cast< ::IceStorm::Topic*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getPublisher(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::IceStorm::Topic::subscribe(const ::IceStorm::QoS& theQoS, const ::Ice::ObjectPrx& subscriber, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__Topic__subscribe_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceStorm::Topic* __servant = dynamic_cast< ::IceStorm::Topic*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->subscribe(theQoS, subscriber, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::Ice::ObjectPrx
IceDelegateD::IceStorm::Topic::subscribeAndGetPublisher(const ::IceStorm::QoS& theQoS, const ::Ice::ObjectPrx& subscriber, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__Topic__subscribeAndGetPublisher_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::ObjectPrx __ret;
        try
        {
            ::IceStorm::Topic* __servant = dynamic_cast< ::IceStorm::Topic*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->subscribeAndGetPublisher(theQoS, subscriber, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::IceStorm::Topic::unsubscribe(const ::Ice::ObjectPrx& subscriber, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__Topic__unsubscribe_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceStorm::Topic* __servant = dynamic_cast< ::IceStorm::Topic*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->unsubscribe(subscriber, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceStorm::Topic::link(const ::IceStorm::TopicPrx& linkTo, ::Ice::Int cost, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__Topic__link_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceStorm::Topic* __servant = dynamic_cast< ::IceStorm::Topic*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->link(linkTo, cost, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceStorm::Topic::unlink(const ::IceStorm::TopicPrx& linkTo, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__Topic__unlink_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceStorm::Topic* __servant = dynamic_cast< ::IceStorm::Topic*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->unlink(linkTo, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::IceStorm::LinkInfoSeq
IceDelegateD::IceStorm::Topic::getLinkInfoSeq(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__Topic__getLinkInfoSeq_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceStorm::LinkInfoSeq __ret;
        try
        {
            ::IceStorm::Topic* __servant = dynamic_cast< ::IceStorm::Topic*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getLinkInfoSeq(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::IceStorm::Topic::destroy(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__Topic__destroy_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceStorm::Topic* __servant = dynamic_cast< ::IceStorm::Topic*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->destroy(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::IceStorm::TopicPrx
IceDelegateD::IceStorm::TopicManager::create(const ::std::string& name, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__TopicManager__create_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceStorm::TopicPrx __ret;
        try
        {
            ::IceStorm::TopicManager* __servant = dynamic_cast< ::IceStorm::TopicManager*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->create(name, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::IceStorm::TopicPrx
IceDelegateD::IceStorm::TopicManager::retrieve(const ::std::string& name, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__TopicManager__retrieve_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceStorm::TopicPrx __ret;
        try
        {
            ::IceStorm::TopicManager* __servant = dynamic_cast< ::IceStorm::TopicManager*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->retrieve(name, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::IceStorm::TopicDict
IceDelegateD::IceStorm::TopicManager::retrieveAll(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__TopicManager__retrieveAll_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceStorm::TopicDict __ret;
        try
        {
            ::IceStorm::TopicManager* __servant = dynamic_cast< ::IceStorm::TopicManager*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->retrieveAll(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::SliceChecksumDict
IceDelegateD::IceStorm::TopicManager::getSliceChecksums(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__TopicManager__getSliceChecksums_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::SliceChecksumDict __ret;
        try
        {
            ::IceStorm::TopicManager* __servant = dynamic_cast< ::IceStorm::TopicManager*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getSliceChecksums(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::ObjectPtr
IceStorm::Topic::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceStorm__Topic_ids[2] =
{
    "::Ice::Object",
    "::IceStorm::Topic"
};

bool
IceStorm::Topic::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceStorm__Topic_ids, __IceStorm__Topic_ids + 2, _s);
}

::std::vector< ::std::string>
IceStorm::Topic::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceStorm__Topic_ids[0], &__IceStorm__Topic_ids[2]);
}

const ::std::string&
IceStorm::Topic::ice_id(const ::Ice::Current&) const
{
    return __IceStorm__Topic_ids[1];
}

const ::std::string&
IceStorm::Topic::ice_staticId()
{
    return __IceStorm__Topic_ids[1];
}

::IceInternal::DispatchStatus
IceStorm::Topic::___getName(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string __ret = getName(__current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceStorm::Topic::___getPublisher(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::ObjectPrx __ret = getPublisher(__current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceStorm::Topic::___subscribe(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceStorm::QoS theQoS;
    ::Ice::ObjectPrx subscriber;
    ::IceStorm::__read(__is, theQoS, ::IceStorm::__U__QoS());
    __is->read(subscriber);
    subscribe(theQoS, subscriber, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceStorm::Topic::___subscribeAndGetPublisher(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceStorm::QoS theQoS;
    ::Ice::ObjectPrx subscriber;
    ::IceStorm::__read(__is, theQoS, ::IceStorm::__U__QoS());
    __is->read(subscriber);
    try
    {
        ::Ice::ObjectPrx __ret = subscribeAndGetPublisher(theQoS, subscriber, __current);
        __os->write(__ret);
    }
    catch(const ::IceStorm::AlreadySubscribed& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    catch(const ::IceStorm::BadQoS& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceStorm::Topic::___unsubscribe(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::Ice::ObjectPrx subscriber;
    __is->read(subscriber);
    unsubscribe(subscriber, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceStorm::Topic::___link(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceStorm::TopicPrx linkTo;
    ::Ice::Int cost;
    ::IceStorm::__read(__is, linkTo);
    __is->read(cost);
    try
    {
        link(linkTo, cost, __current);
    }
    catch(const ::IceStorm::LinkExists& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceStorm::Topic::___unlink(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceStorm::TopicPrx linkTo;
    ::IceStorm::__read(__is, linkTo);
    try
    {
        unlink(linkTo, __current);
    }
    catch(const ::IceStorm::NoSuchLink& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceStorm::Topic::___getLinkInfoSeq(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceStorm::LinkInfoSeq __ret = getLinkInfoSeq(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceStorm::__write(__os, &__ret[0], &__ret[0] + __ret.size(), ::IceStorm::__U__LinkInfoSeq());
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceStorm::Topic::___destroy(::IceInternal::Incoming&, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    destroy(__current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceStorm__Topic_all[] =
{
    "destroy",
    "getLinkInfoSeq",
    "getName",
    "getPublisher",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "link",
    "subscribe",
    "subscribeAndGetPublisher",
    "unlink",
    "unsubscribe"
};

::IceInternal::DispatchStatus
IceStorm::Topic::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceStorm__Topic_all, __IceStorm__Topic_all + 13, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceStorm__Topic_all)
    {
        case 0:
        {
            return ___destroy(in, current);
        }
        case 1:
        {
            return ___getLinkInfoSeq(in, current);
        }
        case 2:
        {
            return ___getName(in, current);
        }
        case 3:
        {
            return ___getPublisher(in, current);
        }
        case 4:
        {
            return ___ice_id(in, current);
        }
        case 5:
        {
            return ___ice_ids(in, current);
        }
        case 6:
        {
            return ___ice_isA(in, current);
        }
        case 7:
        {
            return ___ice_ping(in, current);
        }
        case 8:
        {
            return ___link(in, current);
        }
        case 9:
        {
            return ___subscribe(in, current);
        }
        case 10:
        {
            return ___subscribeAndGetPublisher(in, current);
        }
        case 11:
        {
            return ___unlink(in, current);
        }
        case 12:
        {
            return ___unsubscribe(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceStorm::Topic::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceStorm::Topic::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceStorm::Topic::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStorm::Topic was not generated with stream support";
    throw ex;
}

void
IceStorm::Topic::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStorm::Topic was not generated with stream support";
    throw ex;
}

void ICE_STORM_API 
IceStorm::__patch__TopicPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceStorm::TopicPtr* p = static_cast< ::IceStorm::TopicPtr*>(__addr);
    assert(p);
    *p = ::IceStorm::TopicPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceStorm::Topic::ice_staticId();
        throw e;
    }
}

bool
IceStorm::operator==(const ::IceStorm::Topic& l, const ::IceStorm::Topic& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceStorm::operator!=(const ::IceStorm::Topic& l, const ::IceStorm::Topic& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceStorm::operator<(const ::IceStorm::Topic& l, const ::IceStorm::Topic& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceStorm::operator<=(const ::IceStorm::Topic& l, const ::IceStorm::Topic& r)
{
    return l < r || l == r;
}

bool
IceStorm::operator>(const ::IceStorm::Topic& l, const ::IceStorm::Topic& r)
{
    return !(l < r) && !(l == r);
}

bool
IceStorm::operator>=(const ::IceStorm::Topic& l, const ::IceStorm::Topic& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceStorm::TopicManager::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceStorm__TopicManager_ids[2] =
{
    "::Ice::Object",
    "::IceStorm::TopicManager"
};

bool
IceStorm::TopicManager::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceStorm__TopicManager_ids, __IceStorm__TopicManager_ids + 2, _s);
}

::std::vector< ::std::string>
IceStorm::TopicManager::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceStorm__TopicManager_ids[0], &__IceStorm__TopicManager_ids[2]);
}

const ::std::string&
IceStorm::TopicManager::ice_id(const ::Ice::Current&) const
{
    return __IceStorm__TopicManager_ids[1];
}

const ::std::string&
IceStorm::TopicManager::ice_staticId()
{
    return __IceStorm__TopicManager_ids[1];
}

::IceInternal::DispatchStatus
IceStorm::TopicManager::___create(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string name;
    __is->read(name);
    try
    {
        ::IceStorm::TopicPrx __ret = create(name, __current);
        ::IceStorm::__write(__os, __ret);
    }
    catch(const ::IceStorm::TopicExists& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceStorm::TopicManager::___retrieve(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string name;
    __is->read(name);
    try
    {
        ::IceStorm::TopicPrx __ret = retrieve(name, __current);
        ::IceStorm::__write(__os, __ret);
    }
    catch(const ::IceStorm::NoSuchTopic& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceStorm::TopicManager::___retrieveAll(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceStorm::TopicDict __ret = retrieveAll(__current);
    ::IceStorm::__write(__os, __ret, ::IceStorm::__U__TopicDict());
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceStorm::TopicManager::___getSliceChecksums(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::SliceChecksumDict __ret = getSliceChecksums(__current);
    ::Ice::__write(__os, __ret, ::Ice::__U__SliceChecksumDict());
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceStorm__TopicManager_all[] =
{
    "create",
    "getSliceChecksums",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "retrieve",
    "retrieveAll"
};

::IceInternal::DispatchStatus
IceStorm::TopicManager::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceStorm__TopicManager_all, __IceStorm__TopicManager_all + 8, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceStorm__TopicManager_all)
    {
        case 0:
        {
            return ___create(in, current);
        }
        case 1:
        {
            return ___getSliceChecksums(in, current);
        }
        case 2:
        {
            return ___ice_id(in, current);
        }
        case 3:
        {
            return ___ice_ids(in, current);
        }
        case 4:
        {
            return ___ice_isA(in, current);
        }
        case 5:
        {
            return ___ice_ping(in, current);
        }
        case 6:
        {
            return ___retrieve(in, current);
        }
        case 7:
        {
            return ___retrieveAll(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceStorm::TopicManager::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceStorm::TopicManager::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceStorm::TopicManager::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStorm::TopicManager was not generated with stream support";
    throw ex;
}

void
IceStorm::TopicManager::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStorm::TopicManager was not generated with stream support";
    throw ex;
}

void ICE_STORM_API 
IceStorm::__patch__TopicManagerPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceStorm::TopicManagerPtr* p = static_cast< ::IceStorm::TopicManagerPtr*>(__addr);
    assert(p);
    *p = ::IceStorm::TopicManagerPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceStorm::TopicManager::ice_staticId();
        throw e;
    }
}

bool
IceStorm::operator==(const ::IceStorm::TopicManager& l, const ::IceStorm::TopicManager& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceStorm::operator!=(const ::IceStorm::TopicManager& l, const ::IceStorm::TopicManager& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceStorm::operator<(const ::IceStorm::TopicManager& l, const ::IceStorm::TopicManager& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceStorm::operator<=(const ::IceStorm::TopicManager& l, const ::IceStorm::TopicManager& r)
{
    return l < r || l == r;
}

bool
IceStorm::operator>(const ::IceStorm::TopicManager& l, const ::IceStorm::TopicManager& r)
{
    return !(l < r) && !(l == r);
}

bool
IceStorm::operator>=(const ::IceStorm::TopicManager& l, const ::IceStorm::TopicManager& r)
{
    return !(l < r);
}

static const char* __sliceChecksums[] =
{
    "::IceStorm::AlreadySubscribed", "5a82e77b38f02f3118c536f9446a889e",
    "::IceStorm::BadQoS", "44f2de592dd62e3f7f4ffdf043692d",
    "::IceStorm::LinkExists", "e11768febd56a8813729ce69be6c4c2",
    "::IceStorm::LinkInfo", "d0e073e5e0925ec95656f71d572e2e13",
    "::IceStorm::LinkInfoSeq", "a8921e43838692bbe6ca63f3dcf9b6",
    "::IceStorm::NoSuchLink", "fd8f652776796bffca2df1a3baf455a3",
    "::IceStorm::NoSuchTopic", "7a9479a5c39cdd32335d722bbc971176",
    "::IceStorm::QoS", "3e27cb32bc95cca7b013efbf5c254b35",
    "::IceStorm::Topic", "62726119e74a51cf559ef728869c339",
    "::IceStorm::TopicDict", "fff078a98be068c52d9e1d7d8f6df2a",
    "::IceStorm::TopicExists", "38e6913833539b8d616d114d4e7b28d",
    "::IceStorm::TopicManager", "ffc1baf19222891f8b432be6551fed5",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
