// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `IceStormInternal.ice'

#include <IceStorm/IceStormInternal.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceStorm__TopicLink__forward_name = "forward";

static const ::std::string __IceStorm__TopicInternal__getLinkProxy_name = "getLinkProxy";

void
IceInternal::incRef(::IceStorm::TopicLink* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceStorm::TopicLink* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceStorm::TopicLink* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceStorm::TopicLink* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceStorm::TopicInternal* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceStorm::TopicInternal* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceStorm::TopicInternal* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceStorm::TopicInternal* p)
{
    p->__decRef();
}

void
IceStorm::__write(::IceInternal::BasicStream* __os, const ::IceStorm::TopicLinkPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceStorm::__read(::IceInternal::BasicStream* __is, ::IceStorm::TopicLinkPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceStorm::TopicLink;
        v->__copyFrom(proxy);
    }
}

void
IceStorm::__write(::IceInternal::BasicStream* __os, const ::IceStorm::TopicLinkPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceStorm::__write(::IceInternal::BasicStream* __os, const ::IceStorm::TopicInternalPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceStorm::__read(::IceInternal::BasicStream* __is, ::IceStorm::TopicInternalPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceStorm::TopicInternal;
        v->__copyFrom(proxy);
    }
}

void
IceStorm::__write(::IceInternal::BasicStream* __os, const ::IceStorm::TopicInternalPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

IceStorm::EventData::EventData(const ::std::string& __ice_op, ::Ice::OperationMode __ice_mode, const ::Ice::ByteSeq& __ice_data, const ::Ice::Context& __ice_context) :op(__ice_op),
    mode(__ice_mode),
    data(__ice_data),
    context(__ice_context)
{
}

bool
IceStorm::EventData::operator==(const EventData& __rhs) const
{
    return !operator!=(__rhs);
}

bool
IceStorm::EventData::operator!=(const EventData& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(op != __rhs.op)
    {
        return true;
    }
    if(mode != __rhs.mode)
    {
        return true;
    }
    if(data != __rhs.data)
    {
        return true;
    }
    if(context != __rhs.context)
    {
        return true;
    }
    return false;
}

bool
IceStorm::EventData::operator<(const EventData& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(op < __rhs.op)
    {
        return true;
    }
    else if(__rhs.op < op)
    {
        return false;
    }
    if(mode < __rhs.mode)
    {
        return true;
    }
    else if(__rhs.mode < mode)
    {
        return false;
    }
    if(data < __rhs.data)
    {
        return true;
    }
    else if(__rhs.data < data)
    {
        return false;
    }
    if(context < __rhs.context)
    {
        return true;
    }
    else if(__rhs.context < context)
    {
        return false;
    }
    return false;
}

void
IceStorm::EventData::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(op);
    ::Ice::__write(__os, mode);
    if(data.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&data[0], &data[0] + data.size());
    }
    ::Ice::__write(__os, context, ::Ice::__U__Context());
}

void
IceStorm::EventData::__read(::IceInternal::BasicStream* __is)
{
    __is->read(op);
    ::Ice::__read(__is, mode);
    ::std::pair<const ::Ice::Byte*, const ::Ice::Byte*> ___data;
    __is->read(___data);
    ::std::vector< ::Ice::Byte>(___data.first, ___data.second).swap(data);
    ::Ice::__read(__is, context, ::Ice::__U__Context());
}

void
IceStorm::__write(::IceInternal::BasicStream* __os, const ::IceStorm::EventDataPtr* begin, const ::IceStorm::EventDataPtr* end, ::IceStorm::__U__EventDataSeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i]->__write(__os);
    }
}

void
IceStorm::__read(::IceInternal::BasicStream* __is, ::IceStorm::EventDataSeq& v, ::IceStorm::__U__EventDataSeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 4);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i] = new ::IceStorm::EventData;
        v[i]->__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
IceStorm::__addObject(const TopicLinkPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceStorm::__usesClasses(const TopicLinkPtr& p)
{
    return p->__usesClasses();
}

void
IceStorm::__decRefUnsafe(const TopicLinkPtr& p)
{
    p->__decRefUnsafe();
}

void
IceStorm::__clearHandleUnsafe(TopicLinkPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceStorm::__addObject(const TopicInternalPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceStorm::__usesClasses(const TopicInternalPtr& p)
{
    return p->__usesClasses();
}

void
IceStorm::__decRefUnsafe(const TopicInternalPtr& p)
{
    p->__decRefUnsafe();
}

void
IceStorm::__clearHandleUnsafe(TopicInternalPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceStorm::AMI_TopicLink_forward::__invoke(const ::IceStorm::TopicLinkPrx& __prx, const ::IceStorm::EventDataSeq& events, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceStorm__TopicLink__forward_name, ::Ice::Normal, __ctx);
        if(events.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceStorm::__write(__os, &events[0], &events[0] + events.size(), ::IceStorm::__U__EventDataSeq());
        }
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceStorm::AMI_TopicLink_forward::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
}

void
IceProxy::IceStorm::TopicLink::forward(const ::IceStorm::EventDataSeq& events, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceStorm::TopicLink* __del = dynamic_cast< ::IceDelegate::IceStorm::TopicLink*>(__delBase.get());
            __del->forward(events, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceStorm::TopicLink::forward_async(const ::IceStorm::AMI_TopicLink_forwardPtr& __cb, const ::IceStorm::EventDataSeq& events)
{
    __cb->__invoke(this, events, 0);
}

void
IceProxy::IceStorm::TopicLink::forward_async(const ::IceStorm::AMI_TopicLink_forwardPtr& __cb, const ::IceStorm::EventDataSeq& events, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, events, &__ctx);
}

const ::std::string&
IceProxy::IceStorm::TopicLink::ice_staticId()
{
    return ::IceStorm::TopicLink::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceStorm::TopicLink::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceStorm::TopicLink);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceStorm::TopicLink::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceStorm::TopicLink);
}

bool
IceProxy::IceStorm::operator==(const ::IceProxy::IceStorm::TopicLink& l, const ::IceProxy::IceStorm::TopicLink& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceStorm::operator!=(const ::IceProxy::IceStorm::TopicLink& l, const ::IceProxy::IceStorm::TopicLink& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceStorm::operator<(const ::IceProxy::IceStorm::TopicLink& l, const ::IceProxy::IceStorm::TopicLink& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceStorm::operator<=(const ::IceProxy::IceStorm::TopicLink& l, const ::IceProxy::IceStorm::TopicLink& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceStorm::operator>(const ::IceProxy::IceStorm::TopicLink& l, const ::IceProxy::IceStorm::TopicLink& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceStorm::operator>=(const ::IceProxy::IceStorm::TopicLink& l, const ::IceProxy::IceStorm::TopicLink& r)
{
    return !(l < r);
}

::IceStorm::TopicLinkPrx
IceProxy::IceStorm::TopicInternal::getLinkProxy(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceStorm__TopicInternal__getLinkProxy_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceStorm::TopicInternal* __del = dynamic_cast< ::IceDelegate::IceStorm::TopicInternal*>(__delBase.get());
            return __del->getLinkProxy(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceStorm::TopicInternal::ice_staticId()
{
    return ::IceStorm::TopicInternal::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceStorm::TopicInternal::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceStorm::TopicInternal);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceStorm::TopicInternal::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceStorm::TopicInternal);
}

bool
IceProxy::IceStorm::operator==(const ::IceProxy::IceStorm::TopicInternal& l, const ::IceProxy::IceStorm::TopicInternal& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceStorm::operator!=(const ::IceProxy::IceStorm::TopicInternal& l, const ::IceProxy::IceStorm::TopicInternal& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceStorm::operator<(const ::IceProxy::IceStorm::TopicInternal& l, const ::IceProxy::IceStorm::TopicInternal& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceStorm::operator<=(const ::IceProxy::IceStorm::TopicInternal& l, const ::IceProxy::IceStorm::TopicInternal& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceStorm::operator>(const ::IceProxy::IceStorm::TopicInternal& l, const ::IceProxy::IceStorm::TopicInternal& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceStorm::operator>=(const ::IceProxy::IceStorm::TopicInternal& l, const ::IceProxy::IceStorm::TopicInternal& r)
{
    return !(l < r);
}

void
IceDelegateM::IceStorm::TopicLink::forward(const ::IceStorm::EventDataSeq& events, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceStorm__TopicLink__forward_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(events.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceStorm::__write(__os, &events[0], &events[0] + events.size(), ::IceStorm::__U__EventDataSeq());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceStorm::TopicLinkPrx
IceDelegateM::IceStorm::TopicInternal::getLinkProxy(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceStorm__TopicInternal__getLinkProxy_name, ::Ice::Idempotent, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceStorm::TopicLinkPrx __ret;
        ::IceStorm::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateD::IceStorm::TopicLink::forward(const ::IceStorm::EventDataSeq& events, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__TopicLink__forward_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceStorm::TopicLink* __servant = dynamic_cast< ::IceStorm::TopicLink*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->forward(events, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::IceStorm::TopicLinkPrx
IceDelegateD::IceStorm::TopicInternal::getLinkProxy(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceStorm__TopicInternal__getLinkProxy_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceStorm::TopicLinkPrx __ret;
        try
        {
            ::IceStorm::TopicInternal* __servant = dynamic_cast< ::IceStorm::TopicInternal*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getLinkProxy(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::ObjectPtr
IceStorm::TopicLink::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceStorm__TopicLink_ids[2] =
{
    "::Ice::Object",
    "::IceStorm::TopicLink"
};

bool
IceStorm::TopicLink::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceStorm__TopicLink_ids, __IceStorm__TopicLink_ids + 2, _s);
}

::std::vector< ::std::string>
IceStorm::TopicLink::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceStorm__TopicLink_ids[0], &__IceStorm__TopicLink_ids[2]);
}

const ::std::string&
IceStorm::TopicLink::ice_id(const ::Ice::Current&) const
{
    return __IceStorm__TopicLink_ids[1];
}

const ::std::string&
IceStorm::TopicLink::ice_staticId()
{
    return __IceStorm__TopicLink_ids[1];
}

::IceInternal::DispatchStatus
IceStorm::TopicLink::___forward(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceStorm::EventDataSeq events;
    ::IceStorm::__read(__is, events, ::IceStorm::__U__EventDataSeq());
    forward(events, __current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceStorm__TopicLink_all[] =
{
    "forward",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
IceStorm::TopicLink::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceStorm__TopicLink_all, __IceStorm__TopicLink_all + 5, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceStorm__TopicLink_all)
    {
        case 0:
        {
            return ___forward(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceStorm::TopicLink::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceStorm::TopicLink::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceStorm::TopicLink::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStorm::TopicLink was not generated with stream support";
    throw ex;
}

void
IceStorm::TopicLink::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStorm::TopicLink was not generated with stream support";
    throw ex;
}

void ICE_STORM_API 
IceStorm::__patch__TopicLinkPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceStorm::TopicLinkPtr* p = static_cast< ::IceStorm::TopicLinkPtr*>(__addr);
    assert(p);
    *p = ::IceStorm::TopicLinkPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceStorm::TopicLink::ice_staticId();
        throw e;
    }
}

bool
IceStorm::operator==(const ::IceStorm::TopicLink& l, const ::IceStorm::TopicLink& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceStorm::operator!=(const ::IceStorm::TopicLink& l, const ::IceStorm::TopicLink& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceStorm::operator<(const ::IceStorm::TopicLink& l, const ::IceStorm::TopicLink& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceStorm::operator<=(const ::IceStorm::TopicLink& l, const ::IceStorm::TopicLink& r)
{
    return l < r || l == r;
}

bool
IceStorm::operator>(const ::IceStorm::TopicLink& l, const ::IceStorm::TopicLink& r)
{
    return !(l < r) && !(l == r);
}

bool
IceStorm::operator>=(const ::IceStorm::TopicLink& l, const ::IceStorm::TopicLink& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceStorm::TopicInternal::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceStorm__TopicInternal_ids[3] =
{
    "::Ice::Object",
    "::IceStorm::Topic",
    "::IceStorm::TopicInternal"
};

bool
IceStorm::TopicInternal::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceStorm__TopicInternal_ids, __IceStorm__TopicInternal_ids + 3, _s);
}

::std::vector< ::std::string>
IceStorm::TopicInternal::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceStorm__TopicInternal_ids[0], &__IceStorm__TopicInternal_ids[3]);
}

const ::std::string&
IceStorm::TopicInternal::ice_id(const ::Ice::Current&) const
{
    return __IceStorm__TopicInternal_ids[2];
}

const ::std::string&
IceStorm::TopicInternal::ice_staticId()
{
    return __IceStorm__TopicInternal_ids[2];
}

::IceInternal::DispatchStatus
IceStorm::TopicInternal::___getLinkProxy(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceStorm::TopicLinkPrx __ret = getLinkProxy(__current);
    ::IceStorm::__write(__os, __ret);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceStorm__TopicInternal_all[] =
{
    "destroy",
    "getLinkInfoSeq",
    "getLinkProxy",
    "getName",
    "getPublisher",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "link",
    "subscribe",
    "subscribeAndGetPublisher",
    "unlink",
    "unsubscribe"
};

::IceInternal::DispatchStatus
IceStorm::TopicInternal::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceStorm__TopicInternal_all, __IceStorm__TopicInternal_all + 14, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceStorm__TopicInternal_all)
    {
        case 0:
        {
            return ___destroy(in, current);
        }
        case 1:
        {
            return ___getLinkInfoSeq(in, current);
        }
        case 2:
        {
            return ___getLinkProxy(in, current);
        }
        case 3:
        {
            return ___getName(in, current);
        }
        case 4:
        {
            return ___getPublisher(in, current);
        }
        case 5:
        {
            return ___ice_id(in, current);
        }
        case 6:
        {
            return ___ice_ids(in, current);
        }
        case 7:
        {
            return ___ice_isA(in, current);
        }
        case 8:
        {
            return ___ice_ping(in, current);
        }
        case 9:
        {
            return ___link(in, current);
        }
        case 10:
        {
            return ___subscribe(in, current);
        }
        case 11:
        {
            return ___subscribeAndGetPublisher(in, current);
        }
        case 12:
        {
            return ___unlink(in, current);
        }
        case 13:
        {
            return ___unsubscribe(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceStorm::TopicInternal::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceStorm::TopicInternal::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceStorm::TopicInternal::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStorm::TopicInternal was not generated with stream support";
    throw ex;
}

void
IceStorm::TopicInternal::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceStorm::TopicInternal was not generated with stream support";
    throw ex;
}

void ICE_STORM_API 
IceStorm::__patch__TopicInternalPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceStorm::TopicInternalPtr* p = static_cast< ::IceStorm::TopicInternalPtr*>(__addr);
    assert(p);
    *p = ::IceStorm::TopicInternalPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceStorm::TopicInternal::ice_staticId();
        throw e;
    }
}

bool
IceStorm::operator==(const ::IceStorm::TopicInternal& l, const ::IceStorm::TopicInternal& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceStorm::operator!=(const ::IceStorm::TopicInternal& l, const ::IceStorm::TopicInternal& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceStorm::operator<(const ::IceStorm::TopicInternal& l, const ::IceStorm::TopicInternal& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceStorm::operator<=(const ::IceStorm::TopicInternal& l, const ::IceStorm::TopicInternal& r)
{
    return l < r || l == r;
}

bool
IceStorm::operator>(const ::IceStorm::TopicInternal& l, const ::IceStorm::TopicInternal& r)
{
    return !(l < r) && !(l == r);
}

bool
IceStorm::operator>=(const ::IceStorm::TopicInternal& l, const ::IceStorm::TopicInternal& r)
{
    return !(l < r);
}

static const char* __sliceChecksums[] =
{
    "::IceStorm::EventData", "f3823ca5cc9825791888508dbd70396e",
    "::IceStorm::EventDataSeq", "e732f16f992121e3785c62d88329",
    "::IceStorm::TopicInternal", "8c46554ee42b4ada2bec149adea73b",
    "::IceStorm::TopicLink", "4be888abcb10a18e51b8c2f71ae0afd0",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
