// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `LinkRecord.ice'

#include <IceStorm/LinkRecord.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

bool
IceStorm::LinkRecord::operator==(const LinkRecord& __rhs) const
{
    return !operator!=(__rhs);
}

bool
IceStorm::LinkRecord::operator!=(const LinkRecord& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(obj != __rhs.obj)
    {
        return true;
    }
    if(cost != __rhs.cost)
    {
        return true;
    }
    if(theTopic != __rhs.theTopic)
    {
        return true;
    }
    return false;
}

bool
IceStorm::LinkRecord::operator<(const LinkRecord& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(obj < __rhs.obj)
    {
        return true;
    }
    else if(__rhs.obj < obj)
    {
        return false;
    }
    if(cost < __rhs.cost)
    {
        return true;
    }
    else if(__rhs.cost < cost)
    {
        return false;
    }
    if(theTopic < __rhs.theTopic)
    {
        return true;
    }
    else if(__rhs.theTopic < theTopic)
    {
        return false;
    }
    return false;
}

void
IceStorm::LinkRecord::__write(::IceInternal::BasicStream* __os) const
{
    ::IceStorm::__write(__os, obj);
    __os->write(cost);
    ::IceStorm::__write(__os, theTopic);
}

void
IceStorm::LinkRecord::__read(::IceInternal::BasicStream* __is)
{
    ::IceStorm::__read(__is, obj);
    __is->read(cost);
    ::IceStorm::__read(__is, theTopic);
}

void
IceStorm::__write(::IceInternal::BasicStream* __os, const ::IceStorm::LinkRecord* begin, const ::IceStorm::LinkRecord* end, ::IceStorm::__U__LinkRecordSeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
IceStorm::__read(::IceInternal::BasicStream* __is, ::IceStorm::LinkRecordSeq& v, ::IceStorm::__U__LinkRecordSeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 8);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

static const char* __sliceChecksums[] =
{
    "::IceStorm::LinkRecord", "4c7f372c7633a12177704ab0909ea4a",
    "::IceStorm::LinkRecordSeq", "5f327d48a8daf5e2389e29f6f66dc7a",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
