// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1

// Freeze types in this file:
// name="IceStorm::PersistentTopicMap", key="Ice::Identity", value="IceStorm::LinkRecordSeq"

#ifndef __PersistentTopicMap_h__
#define __PersistentTopicMap_h__

#include <Freeze/Map.h>
#include <IceStorm/LinkRecord.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceStorm
{

class PersistentTopicMapKeyCodec
{
public:

    static void write(const ::Ice::Identity&, Freeze::Key&, const ::Ice::CommunicatorPtr&);
    static void read(::Ice::Identity&, const Freeze::Key&, const ::Ice::CommunicatorPtr&);
    static const std::string& typeId();
};

class PersistentTopicMapValueCodec
{
public:

    static void write(const ::IceStorm::LinkRecordSeq&, Freeze::Value&, const ::Ice::CommunicatorPtr&);
    static void read(::IceStorm::LinkRecordSeq&, const Freeze::Value&, const ::Ice::CommunicatorPtr&);
    static const std::string& typeId();
};

typedef Freeze::Map< ::Ice::Identity, ::IceStorm::LinkRecordSeq, PersistentTopicMapKeyCodec, PersistentTopicMapValueCodec, Freeze::IceEncodingCompare > PersistentTopicMap;

}

#endif
