// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `PermissionsVerifier.ice'

#ifndef __Glacier2_PermissionsVerifier_h__
#define __Glacier2_PermissionsVerifier_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/StreamF.h>
#include <Glacier2/SSLInfo.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

#ifndef GLACIER2_API
#   ifdef GLACIER2_API_EXPORTS
#       define GLACIER2_API ICE_DECLSPEC_EXPORT
#   else
#       define GLACIER2_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace Glacier2
{

class PermissionsVerifier;
GLACIER2_API bool operator==(const PermissionsVerifier&, const PermissionsVerifier&);
GLACIER2_API bool operator!=(const PermissionsVerifier&, const PermissionsVerifier&);
GLACIER2_API bool operator<(const PermissionsVerifier&, const PermissionsVerifier&);
GLACIER2_API bool operator<=(const PermissionsVerifier&, const PermissionsVerifier&);
GLACIER2_API bool operator>(const PermissionsVerifier&, const PermissionsVerifier&);
GLACIER2_API bool operator>=(const PermissionsVerifier&, const PermissionsVerifier&);

class SSLPermissionsVerifier;
GLACIER2_API bool operator==(const SSLPermissionsVerifier&, const SSLPermissionsVerifier&);
GLACIER2_API bool operator!=(const SSLPermissionsVerifier&, const SSLPermissionsVerifier&);
GLACIER2_API bool operator<(const SSLPermissionsVerifier&, const SSLPermissionsVerifier&);
GLACIER2_API bool operator<=(const SSLPermissionsVerifier&, const SSLPermissionsVerifier&);
GLACIER2_API bool operator>(const SSLPermissionsVerifier&, const SSLPermissionsVerifier&);
GLACIER2_API bool operator>=(const SSLPermissionsVerifier&, const SSLPermissionsVerifier&);

}

}

namespace Glacier2
{

class PermissionsVerifier;
GLACIER2_API bool operator==(const PermissionsVerifier&, const PermissionsVerifier&);
GLACIER2_API bool operator!=(const PermissionsVerifier&, const PermissionsVerifier&);
GLACIER2_API bool operator<(const PermissionsVerifier&, const PermissionsVerifier&);
GLACIER2_API bool operator<=(const PermissionsVerifier&, const PermissionsVerifier&);
GLACIER2_API bool operator>(const PermissionsVerifier&, const PermissionsVerifier&);
GLACIER2_API bool operator>=(const PermissionsVerifier&, const PermissionsVerifier&);

class SSLPermissionsVerifier;
GLACIER2_API bool operator==(const SSLPermissionsVerifier&, const SSLPermissionsVerifier&);
GLACIER2_API bool operator!=(const SSLPermissionsVerifier&, const SSLPermissionsVerifier&);
GLACIER2_API bool operator<(const SSLPermissionsVerifier&, const SSLPermissionsVerifier&);
GLACIER2_API bool operator<=(const SSLPermissionsVerifier&, const SSLPermissionsVerifier&);
GLACIER2_API bool operator>(const SSLPermissionsVerifier&, const SSLPermissionsVerifier&);
GLACIER2_API bool operator>=(const SSLPermissionsVerifier&, const SSLPermissionsVerifier&);

}

namespace IceInternal
{

GLACIER2_API void incRef(::Glacier2::PermissionsVerifier*);
GLACIER2_API void decRef(::Glacier2::PermissionsVerifier*);

GLACIER2_API void incRef(::IceProxy::Glacier2::PermissionsVerifier*);
GLACIER2_API void decRef(::IceProxy::Glacier2::PermissionsVerifier*);

GLACIER2_API void incRef(::Glacier2::SSLPermissionsVerifier*);
GLACIER2_API void decRef(::Glacier2::SSLPermissionsVerifier*);

GLACIER2_API void incRef(::IceProxy::Glacier2::SSLPermissionsVerifier*);
GLACIER2_API void decRef(::IceProxy::Glacier2::SSLPermissionsVerifier*);

}

namespace Glacier2
{

typedef ::IceInternal::Handle< ::Glacier2::PermissionsVerifier> PermissionsVerifierPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Glacier2::PermissionsVerifier> PermissionsVerifierPrx;

GLACIER2_API void __write(::IceInternal::BasicStream*, const PermissionsVerifierPrx&);
GLACIER2_API void __read(::IceInternal::BasicStream*, PermissionsVerifierPrx&);
GLACIER2_API void __write(::IceInternal::BasicStream*, const PermissionsVerifierPtr&);
GLACIER2_API void __patch__PermissionsVerifierPtr(void*, ::Ice::ObjectPtr&);

GLACIER2_API void __addObject(const PermissionsVerifierPtr&, ::IceInternal::GCCountMap&);
GLACIER2_API bool __usesClasses(const PermissionsVerifierPtr&);
GLACIER2_API void __decRefUnsafe(const PermissionsVerifierPtr&);
GLACIER2_API void __clearHandleUnsafe(PermissionsVerifierPtr&);

typedef ::IceInternal::Handle< ::Glacier2::SSLPermissionsVerifier> SSLPermissionsVerifierPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Glacier2::SSLPermissionsVerifier> SSLPermissionsVerifierPrx;

GLACIER2_API void __write(::IceInternal::BasicStream*, const SSLPermissionsVerifierPrx&);
GLACIER2_API void __read(::IceInternal::BasicStream*, SSLPermissionsVerifierPrx&);
GLACIER2_API void __write(::IceInternal::BasicStream*, const SSLPermissionsVerifierPtr&);
GLACIER2_API void __patch__SSLPermissionsVerifierPtr(void*, ::Ice::ObjectPtr&);

GLACIER2_API void __addObject(const SSLPermissionsVerifierPtr&, ::IceInternal::GCCountMap&);
GLACIER2_API bool __usesClasses(const SSLPermissionsVerifierPtr&);
GLACIER2_API void __decRefUnsafe(const SSLPermissionsVerifierPtr&);
GLACIER2_API void __clearHandleUnsafe(SSLPermissionsVerifierPtr&);

}

namespace Glacier2
{

}

namespace IceProxy
{

namespace Glacier2
{

class GLACIER2_API PermissionsVerifier : virtual public ::IceProxy::Ice::Object
{
public:

    bool checkPermissions(const ::std::string& userId, const ::std::string& password, ::std::string& reason)
    {
        return checkPermissions(userId, password, reason, 0);
    }
    bool checkPermissions(const ::std::string& userId, const ::std::string& password, ::std::string& reason, const ::Ice::Context& __ctx)
    {
        return checkPermissions(userId, password, reason, &__ctx);
    }
    
private:

    bool checkPermissions(const ::std::string&, const ::std::string&, ::std::string&, const ::Ice::Context*);
    
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class GLACIER2_API SSLPermissionsVerifier : virtual public ::IceProxy::Ice::Object
{
public:

    bool authorize(const ::Glacier2::SSLInfo& info, ::std::string& reason)
    {
        return authorize(info, reason, 0);
    }
    bool authorize(const ::Glacier2::SSLInfo& info, ::std::string& reason, const ::Ice::Context& __ctx)
    {
        return authorize(info, reason, &__ctx);
    }
    
private:

    bool authorize(const ::Glacier2::SSLInfo&, ::std::string&, const ::Ice::Context*);
    
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace Glacier2
{

class GLACIER2_API PermissionsVerifier : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual bool checkPermissions(const ::std::string&, const ::std::string&, ::std::string&, const ::Ice::Context*) = 0;
};

class GLACIER2_API SSLPermissionsVerifier : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual bool authorize(const ::Glacier2::SSLInfo&, ::std::string&, const ::Ice::Context*) = 0;
};

}

}

namespace IceDelegateM
{

namespace Glacier2
{

class GLACIER2_API PermissionsVerifier : virtual public ::IceDelegate::Glacier2::PermissionsVerifier,
                                         virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual bool checkPermissions(const ::std::string&, const ::std::string&, ::std::string&, const ::Ice::Context*);
};

class GLACIER2_API SSLPermissionsVerifier : virtual public ::IceDelegate::Glacier2::SSLPermissionsVerifier,
                                            virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual bool authorize(const ::Glacier2::SSLInfo&, ::std::string&, const ::Ice::Context*);
};

}

}

namespace IceDelegateD
{

namespace Glacier2
{

class GLACIER2_API PermissionsVerifier : virtual public ::IceDelegate::Glacier2::PermissionsVerifier,
                                         virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual bool checkPermissions(const ::std::string&, const ::std::string&, ::std::string&, const ::Ice::Context*);
};

class GLACIER2_API SSLPermissionsVerifier : virtual public ::IceDelegate::Glacier2::SSLPermissionsVerifier,
                                            virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual bool authorize(const ::Glacier2::SSLInfo&, ::std::string&, const ::Ice::Context*);
};

}

}

namespace Glacier2
{

class GLACIER2_API PermissionsVerifier : virtual public ::Ice::Object
{
public:

    typedef PermissionsVerifierPrx ProxyType;
    typedef PermissionsVerifierPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual bool checkPermissions(const ::std::string&, const ::std::string&, ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___checkPermissions(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void GLACIER2_API __patch__PermissionsVerifierPtr(void*, ::Ice::ObjectPtr&);

class GLACIER2_API SSLPermissionsVerifier : virtual public ::Ice::Object
{
public:

    typedef SSLPermissionsVerifierPrx ProxyType;
    typedef SSLPermissionsVerifierPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual bool authorize(const ::Glacier2::SSLInfo&, ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___authorize(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void GLACIER2_API __patch__SSLPermissionsVerifierPtr(void*, ::Ice::ObjectPtr&);

}

#endif
