// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `PingObject.ice'

#ifndef __Freeze_PingObject_h__
#define __Freeze_PingObject_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

#ifndef FREEZE_API
#   ifdef FREEZE_API_EXPORTS
#       define FREEZE_API ICE_DECLSPEC_EXPORT
#   else
#       define FREEZE_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace Freeze
{

class PingObject;
FREEZE_API bool operator==(const PingObject&, const PingObject&);
FREEZE_API bool operator!=(const PingObject&, const PingObject&);
FREEZE_API bool operator<(const PingObject&, const PingObject&);
FREEZE_API bool operator<=(const PingObject&, const PingObject&);
FREEZE_API bool operator>(const PingObject&, const PingObject&);
FREEZE_API bool operator>=(const PingObject&, const PingObject&);

}

}

namespace Freeze
{

class PingObject;
FREEZE_API bool operator==(const PingObject&, const PingObject&);
FREEZE_API bool operator!=(const PingObject&, const PingObject&);
FREEZE_API bool operator<(const PingObject&, const PingObject&);
FREEZE_API bool operator<=(const PingObject&, const PingObject&);
FREEZE_API bool operator>(const PingObject&, const PingObject&);
FREEZE_API bool operator>=(const PingObject&, const PingObject&);

}

namespace IceInternal
{

FREEZE_API void incRef(::Freeze::PingObject*);
FREEZE_API void decRef(::Freeze::PingObject*);

FREEZE_API void incRef(::IceProxy::Freeze::PingObject*);
FREEZE_API void decRef(::IceProxy::Freeze::PingObject*);

}

namespace Freeze
{

typedef ::IceInternal::Handle< ::Freeze::PingObject> PingObjectPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Freeze::PingObject> PingObjectPrx;

FREEZE_API void __write(::IceInternal::BasicStream*, const PingObjectPrx&);
FREEZE_API void __read(::IceInternal::BasicStream*, PingObjectPrx&);
FREEZE_API void __write(::IceInternal::BasicStream*, const PingObjectPtr&);
FREEZE_API void __patch__PingObjectPtr(void*, ::Ice::ObjectPtr&);

FREEZE_API void __addObject(const PingObjectPtr&, ::IceInternal::GCCountMap&);
FREEZE_API bool __usesClasses(const PingObjectPtr&);
FREEZE_API void __decRefUnsafe(const PingObjectPtr&);
FREEZE_API void __clearHandleUnsafe(PingObjectPtr&);

}

namespace Freeze
{

}

namespace IceProxy
{

namespace Freeze
{

class FREEZE_API PingObject : virtual public ::IceProxy::Ice::Object
{
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace Freeze
{

class FREEZE_API PingObject : virtual public ::IceDelegate::Ice::Object
{
public:
};

}

}

namespace IceDelegateM
{

namespace Freeze
{

class FREEZE_API PingObject : virtual public ::IceDelegate::Freeze::PingObject,
                              virtual public ::IceDelegateM::Ice::Object
{
public:
};

}

}

namespace IceDelegateD
{

namespace Freeze
{

class FREEZE_API PingObject : virtual public ::IceDelegate::Freeze::PingObject,
                              virtual public ::IceDelegateD::Ice::Object
{
public:
};

}

}

namespace Freeze
{

class FREEZE_API PingObject : virtual public ::Ice::Object
{
public:

    typedef PingObjectPrx ProxyType;
    typedef PingObjectPtr PointerType;
    
    PingObject() {}
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);

    static const ::Ice::ObjectFactoryPtr& ice_factory();

protected:

    virtual ~PingObject() {}

    friend class PingObject__staticInit;
};

class PingObject__staticInit
{
public:

    ::Freeze::PingObject _init;
};

static ::Freeze::PingObject__staticInit _PingObject_init;

void FREEZE_API __patch__PingObjectPtr(void*, ::Ice::ObjectPtr&);

}

#endif
