// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `Internal.ice'

#include <IceGrid/Internal.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/DisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __IceGrid__Adapter__activate_name = "activate";

static const ::std::string __IceGrid__Adapter__getDirectProxy_name = "getDirectProxy";

static const ::std::string __IceGrid__Adapter__setDirectProxy_name = "setDirectProxy";

static const ::std::string __IceGrid__FileReader__getOffsetFromEnd_name = "getOffsetFromEnd";

static const ::std::string __IceGrid__FileReader__read_name = "read";

static const ::std::string __IceGrid__Server__start_name = "start";

static const ::std::string __IceGrid__Server__stop_name = "stop";

static const ::std::string __IceGrid__Server__setEnabled_name = "setEnabled";

static const ::std::string __IceGrid__Server__isEnabled_name = "isEnabled";

static const ::std::string __IceGrid__Server__sendSignal_name = "sendSignal";

static const ::std::string __IceGrid__Server__writeMessage_name = "writeMessage";

static const ::std::string __IceGrid__Server__getState_name = "getState";

static const ::std::string __IceGrid__Server__getPid_name = "getPid";

static const ::std::string __IceGrid__Server__setProcess_name = "setProcess";

static const ::std::string __IceGrid__ReplicaObserver__replicaInit_name = "replicaInit";

static const ::std::string __IceGrid__ReplicaObserver__replicaAdded_name = "replicaAdded";

static const ::std::string __IceGrid__ReplicaObserver__replicaRemoved_name = "replicaRemoved";

static const ::std::string __IceGrid__PatcherFeedback__finished_name = "finished";

static const ::std::string __IceGrid__PatcherFeedback__failed_name = "failed";

static const ::std::string __IceGrid__Node__loadServer_name = "loadServer";

static const ::std::string __IceGrid__Node__destroyServer_name = "destroyServer";

static const ::std::string __IceGrid__Node__patch_name = "patch";

static const ::std::string __IceGrid__Node__registerWithReplica_name = "registerWithReplica";

static const ::std::string __IceGrid__Node__getName_name = "getName";

static const ::std::string __IceGrid__Node__getHostname_name = "getHostname";

static const ::std::string __IceGrid__Node__getLoad_name = "getLoad";

static const ::std::string __IceGrid__Node__shutdown_name = "shutdown";

static const ::std::string __IceGrid__NodeSession__keepAlive_name = "keepAlive";

static const ::std::string __IceGrid__NodeSession__setReplicaObserver_name = "setReplicaObserver";

static const ::std::string __IceGrid__NodeSession__getTimeout_name = "getTimeout";

static const ::std::string __IceGrid__NodeSession__getObserver_name = "getObserver";

static const ::std::string __IceGrid__NodeSession__loadServers_name = "loadServers";

static const ::std::string __IceGrid__NodeSession__getServers_name = "getServers";

static const ::std::string __IceGrid__NodeSession__waitForApplicationUpdate_name = "waitForApplicationUpdate";

static const ::std::string __IceGrid__NodeSession__destroy_name = "destroy";

static const ::std::string __IceGrid__ReplicaSession__keepAlive_name = "keepAlive";

static const ::std::string __IceGrid__ReplicaSession__getTimeout_name = "getTimeout";

static const ::std::string __IceGrid__ReplicaSession__setDatabaseObserver_name = "setDatabaseObserver";

static const ::std::string __IceGrid__ReplicaSession__setEndpoints_name = "setEndpoints";

static const ::std::string __IceGrid__ReplicaSession__registerWellKnownObjects_name = "registerWellKnownObjects";

static const ::std::string __IceGrid__ReplicaSession__setAdapterDirectProxy_name = "setAdapterDirectProxy";

static const ::std::string __IceGrid__ReplicaSession__receivedUpdate_name = "receivedUpdate";

static const ::std::string __IceGrid__ReplicaSession__destroy_name = "destroy";

static const ::std::string __IceGrid__InternalRegistry__registerNode_name = "registerNode";

static const ::std::string __IceGrid__InternalRegistry__registerReplica_name = "registerReplica";

static const ::std::string __IceGrid__InternalRegistry__registerWithReplica_name = "registerWithReplica";

static const ::std::string __IceGrid__InternalRegistry__getNodes_name = "getNodes";

static const ::std::string __IceGrid__InternalRegistry__getReplicas_name = "getReplicas";

static const ::std::string __IceGrid__InternalRegistry__shutdown_name = "shutdown";

void
IceInternal::incRef(::IceGrid::InternalDbEnvDescriptor* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::InternalDbEnvDescriptor* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::InternalDbEnvDescriptor* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::InternalDbEnvDescriptor* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::InternalAdapterDescriptor* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::InternalAdapterDescriptor* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::InternalAdapterDescriptor* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::InternalAdapterDescriptor* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::InternalDistributionDescriptor* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::InternalDistributionDescriptor* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::InternalDistributionDescriptor* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::InternalDistributionDescriptor* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::InternalServerDescriptor* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::InternalServerDescriptor* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::InternalServerDescriptor* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::InternalServerDescriptor* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::Adapter* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::Adapter* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::Adapter* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::Adapter* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::FileReader* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::FileReader* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::FileReader* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::FileReader* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::Server* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::Server* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::Server* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::Server* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::ReplicaObserver* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::ReplicaObserver* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::ReplicaObserver* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::ReplicaObserver* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::PatcherFeedback* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::PatcherFeedback* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::PatcherFeedback* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::PatcherFeedback* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::Node* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::Node* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::Node* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::Node* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::NodeSession* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::NodeSession* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::NodeSession* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::NodeSession* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::DatabaseObserver* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::DatabaseObserver* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::DatabaseObserver* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::DatabaseObserver* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::ReplicaSession* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::ReplicaSession* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::ReplicaSession* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::ReplicaSession* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::InternalNodeInfo* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::InternalNodeInfo* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::InternalNodeInfo* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::InternalNodeInfo* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::InternalReplicaInfo* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::InternalReplicaInfo* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::InternalReplicaInfo* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::InternalReplicaInfo* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceGrid::InternalRegistry* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceGrid::InternalRegistry* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::IceGrid::InternalRegistry* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::IceGrid::InternalRegistry* p)
{
    p->__decRef();
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalDbEnvDescriptorPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalDbEnvDescriptorPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::InternalDbEnvDescriptor;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalDbEnvDescriptorPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalAdapterDescriptorPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalAdapterDescriptorPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::InternalAdapterDescriptor;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalAdapterDescriptorPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalDistributionDescriptorPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalDistributionDescriptorPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::InternalDistributionDescriptor;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalDistributionDescriptorPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalServerDescriptorPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalServerDescriptorPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::InternalServerDescriptor;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalServerDescriptorPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::AdapterPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::AdapterPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::Adapter;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::AdapterPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::FileReaderPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::FileReaderPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::FileReader;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::FileReaderPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::ServerPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::ServerPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::Server;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::ServerPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::ReplicaObserverPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::ReplicaObserverPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::ReplicaObserver;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::ReplicaObserverPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::PatcherFeedbackPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::PatcherFeedbackPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::PatcherFeedback;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::PatcherFeedbackPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::NodePrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::NodePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::Node;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::NodePtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::NodeSessionPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::NodeSessionPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::NodeSession;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::NodeSessionPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::DatabaseObserverPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::DatabaseObserverPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::DatabaseObserver;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::DatabaseObserverPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::ReplicaSessionPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::ReplicaSessionPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::ReplicaSession;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::ReplicaSessionPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalNodeInfoPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalNodeInfoPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::InternalNodeInfo;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalNodeInfoPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalReplicaInfoPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalReplicaInfoPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::InternalReplicaInfo;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalReplicaInfoPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalRegistryPrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalRegistryPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::InternalRegistry;
        v->__copyFrom(proxy);
    }
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalRegistryPtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

void
IceGrid::__addObject(const InternalDbEnvDescriptorPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const InternalDbEnvDescriptorPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const InternalDbEnvDescriptorPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(InternalDbEnvDescriptorPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalDbEnvDescriptorPtr* begin, const ::IceGrid::InternalDbEnvDescriptorPtr* end, ::IceGrid::__U__InternalDbEnvDescriptorSeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        ::IceGrid::__write(__os, begin[i]);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalDbEnvDescriptorSeq& v, ::IceGrid::__U__InternalDbEnvDescriptorSeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 4);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        __is->read(::IceGrid::__patch__InternalDbEnvDescriptorPtr, &v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
IceGrid::__addObject(const InternalAdapterDescriptorPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const InternalAdapterDescriptorPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const InternalAdapterDescriptorPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(InternalAdapterDescriptorPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalAdapterDescriptorPtr* begin, const ::IceGrid::InternalAdapterDescriptorPtr* end, ::IceGrid::__U__InternalAdapterDescriptorSeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        ::IceGrid::__write(__os, begin[i]);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalAdapterDescriptorSeq& v, ::IceGrid::__U__InternalAdapterDescriptorSeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 4);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        __is->read(::IceGrid::__patch__InternalAdapterDescriptorPtr, &v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
IceGrid::__addObject(const InternalDistributionDescriptorPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const InternalDistributionDescriptorPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const InternalDistributionDescriptorPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(InternalDistributionDescriptorPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::PropertyDescriptorSeqDict& v, ::IceGrid::__U__PropertyDescriptorSeqDict)
{
    __os->writeSize(::Ice::Int(v.size()));
    ::IceGrid::PropertyDescriptorSeqDict::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
        __os->write(p->first);
        if(p->second.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__write(__os, &p->second[0], &p->second[0] + p->second.size(), ::IceGrid::__U__PropertyDescriptorSeq());
        }
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::PropertyDescriptorSeqDict& v, ::IceGrid::__U__PropertyDescriptorSeqDict)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    while(sz--)
    {
        ::std::pair<const  ::std::string, ::IceGrid::PropertyDescriptorSeq> pair;
        __is->read(const_cast< ::std::string&>(pair.first));
        ::IceGrid::PropertyDescriptorSeqDict::iterator __i = v.insert(v.end(), pair);
        ::IceGrid::__read(__is, __i->second, ::IceGrid::__U__PropertyDescriptorSeq());
    }
}

void
IceGrid::__addObject(const InternalServerDescriptorPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const InternalServerDescriptorPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const InternalServerDescriptorPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(InternalServerDescriptorPtr& p)
{
    p.__clearHandleUnsafe();
}

IceGrid::AdapterActiveException::~AdapterActiveException() throw()
{
}

static const char* __IceGrid__AdapterActiveException_name = "IceGrid::AdapterActiveException";

::std::string
IceGrid::AdapterActiveException::ice_name() const
{
    return __IceGrid__AdapterActiveException_name;
}

::Ice::Exception*
IceGrid::AdapterActiveException::ice_clone() const
{
    return new AdapterActiveException(*this);
}

void
IceGrid::AdapterActiveException::ice_throw() const
{
    throw *this;
}

void
IceGrid::AdapterActiveException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::AdapterActiveException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
}

void
IceGrid::AdapterActiveException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
}

void
IceGrid::AdapterActiveException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AdapterActiveException was not generated with stream support";
    throw ex;
}

void
IceGrid::AdapterActiveException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AdapterActiveException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__AdapterActiveException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::AdapterActiveException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__AdapterActiveException__Ptr = new __F__IceGrid__AdapterActiveException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::AdapterActiveException::ice_factory()
{
    return __F__IceGrid__AdapterActiveException__Ptr;
}

class __F__IceGrid__AdapterActiveException__Init
{
public:

    __F__IceGrid__AdapterActiveException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::AdapterActiveException", ::IceGrid::AdapterActiveException::ice_factory());
    }

    ~__F__IceGrid__AdapterActiveException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::AdapterActiveException");
    }
};

static __F__IceGrid__AdapterActiveException__Init __F__IceGrid__AdapterActiveException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__AdapterActiveException__initializer() {} }
#endif

IceGrid::AdapterNotActiveException::AdapterNotActiveException(bool __ice_activatable) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    activatable(__ice_activatable)
{
}

IceGrid::AdapterNotActiveException::~AdapterNotActiveException() throw()
{
}

static const char* __IceGrid__AdapterNotActiveException_name = "IceGrid::AdapterNotActiveException";

::std::string
IceGrid::AdapterNotActiveException::ice_name() const
{
    return __IceGrid__AdapterNotActiveException_name;
}

::Ice::Exception*
IceGrid::AdapterNotActiveException::ice_clone() const
{
    return new AdapterNotActiveException(*this);
}

void
IceGrid::AdapterNotActiveException::ice_throw() const
{
    throw *this;
}

void
IceGrid::AdapterNotActiveException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::AdapterNotActiveException"), false);
    __os->startWriteSlice();
    __os->write(activatable);
    __os->endWriteSlice();
}

void
IceGrid::AdapterNotActiveException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(activatable);
    __is->endReadSlice();
}

void
IceGrid::AdapterNotActiveException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AdapterNotActiveException was not generated with stream support";
    throw ex;
}

void
IceGrid::AdapterNotActiveException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AdapterNotActiveException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__AdapterNotActiveException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::AdapterNotActiveException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__AdapterNotActiveException__Ptr = new __F__IceGrid__AdapterNotActiveException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::AdapterNotActiveException::ice_factory()
{
    return __F__IceGrid__AdapterNotActiveException__Ptr;
}

class __F__IceGrid__AdapterNotActiveException__Init
{
public:

    __F__IceGrid__AdapterNotActiveException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::AdapterNotActiveException", ::IceGrid::AdapterNotActiveException::ice_factory());
    }

    ~__F__IceGrid__AdapterNotActiveException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::AdapterNotActiveException");
    }
};

static __F__IceGrid__AdapterNotActiveException__Init __F__IceGrid__AdapterNotActiveException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__AdapterNotActiveException__initializer() {} }
#endif

void
IceGrid::__addObject(const AdapterPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const AdapterPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const AdapterPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(AdapterPtr& p)
{
    p.__clearHandleUnsafe();
}

IceGrid::AdapterExistsException::AdapterExistsException(const ::std::string& __ice_id) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    id(__ice_id)
{
}

IceGrid::AdapterExistsException::~AdapterExistsException() throw()
{
}

static const char* __IceGrid__AdapterExistsException_name = "IceGrid::AdapterExistsException";

::std::string
IceGrid::AdapterExistsException::ice_name() const
{
    return __IceGrid__AdapterExistsException_name;
}

::Ice::Exception*
IceGrid::AdapterExistsException::ice_clone() const
{
    return new AdapterExistsException(*this);
}

void
IceGrid::AdapterExistsException::ice_throw() const
{
    throw *this;
}

void
IceGrid::AdapterExistsException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::AdapterExistsException"), false);
    __os->startWriteSlice();
    __os->write(id);
    __os->endWriteSlice();
}

void
IceGrid::AdapterExistsException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(id);
    __is->endReadSlice();
}

void
IceGrid::AdapterExistsException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AdapterExistsException was not generated with stream support";
    throw ex;
}

void
IceGrid::AdapterExistsException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::AdapterExistsException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__AdapterExistsException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::AdapterExistsException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__AdapterExistsException__Ptr = new __F__IceGrid__AdapterExistsException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::AdapterExistsException::ice_factory()
{
    return __F__IceGrid__AdapterExistsException__Ptr;
}

class __F__IceGrid__AdapterExistsException__Init
{
public:

    __F__IceGrid__AdapterExistsException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::AdapterExistsException", ::IceGrid::AdapterExistsException::ice_factory());
    }

    ~__F__IceGrid__AdapterExistsException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::AdapterExistsException");
    }
};

static __F__IceGrid__AdapterExistsException__Init __F__IceGrid__AdapterExistsException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__AdapterExistsException__initializer() {} }
#endif

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::AdapterPrxDict& v, ::IceGrid::__U__AdapterPrxDict)
{
    __os->writeSize(::Ice::Int(v.size()));
    ::IceGrid::AdapterPrxDict::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
        __os->write(p->first);
        ::IceGrid::__write(__os, p->second);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::AdapterPrxDict& v, ::IceGrid::__U__AdapterPrxDict)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    while(sz--)
    {
        ::std::pair<const  ::std::string, ::IceGrid::AdapterPrx> pair;
        __is->read(const_cast< ::std::string&>(pair.first));
        ::IceGrid::AdapterPrxDict::iterator __i = v.insert(v.end(), pair);
        ::IceGrid::__read(__is, __i->second);
    }
}

void
IceGrid::__addObject(const FileReaderPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const FileReaderPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const FileReaderPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(FileReaderPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__addObject(const ServerPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const ServerPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const ServerPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(ServerPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::InternalRegistryPrx* begin, const ::IceGrid::InternalRegistryPrx* end, ::IceGrid::__U__InternalRegistryPrxSeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        ::IceGrid::__write(__os, begin[i]);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::InternalRegistryPrxSeq& v, ::IceGrid::__U__InternalRegistryPrxSeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 2);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        ::IceGrid::__read(__is, v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
IceGrid::__addObject(const ReplicaObserverPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const ReplicaObserverPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const ReplicaObserverPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(ReplicaObserverPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__addObject(const PatcherFeedbackPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const PatcherFeedbackPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const PatcherFeedbackPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(PatcherFeedbackPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__addObject(const NodePtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const NodePtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const NodePtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(NodePtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__write(::IceInternal::BasicStream* __os, const ::IceGrid::NodePrx* begin, const ::IceGrid::NodePrx* end, ::IceGrid::__U__NodePrxSeq)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        ::IceGrid::__write(__os, begin[i]);
    }
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::NodePrxSeq& v, ::IceGrid::__U__NodePrxSeq)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 2);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        ::IceGrid::__read(__is, v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

IceGrid::NodeActiveException::~NodeActiveException() throw()
{
}

static const char* __IceGrid__NodeActiveException_name = "IceGrid::NodeActiveException";

::std::string
IceGrid::NodeActiveException::ice_name() const
{
    return __IceGrid__NodeActiveException_name;
}

::Ice::Exception*
IceGrid::NodeActiveException::ice_clone() const
{
    return new NodeActiveException(*this);
}

void
IceGrid::NodeActiveException::ice_throw() const
{
    throw *this;
}

void
IceGrid::NodeActiveException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::NodeActiveException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
}

void
IceGrid::NodeActiveException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
}

void
IceGrid::NodeActiveException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::NodeActiveException was not generated with stream support";
    throw ex;
}

void
IceGrid::NodeActiveException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::NodeActiveException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__NodeActiveException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::NodeActiveException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__NodeActiveException__Ptr = new __F__IceGrid__NodeActiveException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::NodeActiveException::ice_factory()
{
    return __F__IceGrid__NodeActiveException__Ptr;
}

class __F__IceGrid__NodeActiveException__Init
{
public:

    __F__IceGrid__NodeActiveException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::NodeActiveException", ::IceGrid::NodeActiveException::ice_factory());
    }

    ~__F__IceGrid__NodeActiveException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::NodeActiveException");
    }
};

static __F__IceGrid__NodeActiveException__Init __F__IceGrid__NodeActiveException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__NodeActiveException__initializer() {} }
#endif

void
IceGrid::__addObject(const NodeSessionPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const NodeSessionPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const NodeSessionPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(NodeSessionPtr& p)
{
    p.__clearHandleUnsafe();
}

IceGrid::ReplicaActiveException::~ReplicaActiveException() throw()
{
}

static const char* __IceGrid__ReplicaActiveException_name = "IceGrid::ReplicaActiveException";

::std::string
IceGrid::ReplicaActiveException::ice_name() const
{
    return __IceGrid__ReplicaActiveException_name;
}

::Ice::Exception*
IceGrid::ReplicaActiveException::ice_clone() const
{
    return new ReplicaActiveException(*this);
}

void
IceGrid::ReplicaActiveException::ice_throw() const
{
    throw *this;
}

void
IceGrid::ReplicaActiveException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::IceGrid::ReplicaActiveException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
}

void
IceGrid::ReplicaActiveException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
}

void
IceGrid::ReplicaActiveException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ReplicaActiveException was not generated with stream support";
    throw ex;
}

void
IceGrid::ReplicaActiveException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception IceGrid::ReplicaActiveException was not generated with stream support";
    throw ex;
}

struct __F__IceGrid__ReplicaActiveException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::IceGrid::ReplicaActiveException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__IceGrid__ReplicaActiveException__Ptr = new __F__IceGrid__ReplicaActiveException;

const ::IceInternal::UserExceptionFactoryPtr&
IceGrid::ReplicaActiveException::ice_factory()
{
    return __F__IceGrid__ReplicaActiveException__Ptr;
}

class __F__IceGrid__ReplicaActiveException__Init
{
public:

    __F__IceGrid__ReplicaActiveException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::IceGrid::ReplicaActiveException", ::IceGrid::ReplicaActiveException::ice_factory());
    }

    ~__F__IceGrid__ReplicaActiveException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::IceGrid::ReplicaActiveException");
    }
};

static __F__IceGrid__ReplicaActiveException__Init __F__IceGrid__ReplicaActiveException__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__ReplicaActiveException__initializer() {} }
#endif

void
IceGrid::__write(::IceInternal::BasicStream* __os, ::IceGrid::TopicName v)
{
    __os->write(static_cast< ::Ice::Byte>(v));
}

void
IceGrid::__read(::IceInternal::BasicStream* __is, ::IceGrid::TopicName& v)
{
    ::Ice::Byte val;
    __is->read(val);
    v = static_cast< ::IceGrid::TopicName>(val);
}

void
IceGrid::__addObject(const DatabaseObserverPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const DatabaseObserverPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const DatabaseObserverPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(DatabaseObserverPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__addObject(const ReplicaSessionPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const ReplicaSessionPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const ReplicaSessionPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(ReplicaSessionPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__addObject(const InternalNodeInfoPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const InternalNodeInfoPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const InternalNodeInfoPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(InternalNodeInfoPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__addObject(const InternalReplicaInfoPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const InternalReplicaInfoPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const InternalReplicaInfoPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(InternalReplicaInfoPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::__addObject(const InternalRegistryPtr& p, ::IceInternal::GCCountMap& c)
{
    p->__addObject(c);
}

bool
IceGrid::__usesClasses(const InternalRegistryPtr& p)
{
    return p->__usesClasses();
}

void
IceGrid::__decRefUnsafe(const InternalRegistryPtr& p)
{
    p->__decRefUnsafe();
}

void
IceGrid::__clearHandleUnsafe(InternalRegistryPtr& p)
{
    p.__clearHandleUnsafe();
}

void
IceGrid::AMI_Adapter_activate::__invoke(const ::IceGrid::AdapterPrx& __prx, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__Adapter__activate_name, ::Ice::Normal, __ctx);
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_Adapter_activate::__response(bool __ok)
{
    ::Ice::ObjectPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        __is->read(__ret);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
}

void
IceGrid::AMI_Adapter_getDirectProxy::__invoke(const ::IceGrid::AdapterPrx& __prx, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__Adapter__getDirectProxy_name, ::Ice::Nonmutating, __ctx);
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_Adapter_getDirectProxy::__response(bool __ok)
{
    ::Ice::ObjectPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::AdapterNotActiveException& __ex)
            {
                ice_exception(__ex);
                return;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        __is->read(__ret);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
}

void
IceGrid::AMI_Adapter_setDirectProxy::__invoke(const ::IceGrid::AdapterPrx& __prx, const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__Adapter__setDirectProxy_name, ::Ice::Normal, __ctx);
        __os->write(proxy);
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_Adapter_setDirectProxy::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::AdapterActiveException& __ex)
            {
                ice_exception(__ex);
                return;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
}

void
IceGrid::AMI_Server_setProcess::__invoke(const ::IceGrid::ServerPrx& __prx, const ::Ice::ProcessPrx& proc, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__Server__setProcess_name, ::Ice::Normal, __ctx);
        ::Ice::__write(__os, proc);
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_Server_setProcess::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
}

void
IceGrid::AMI_Node_loadServer::__invoke(const ::IceGrid::NodePrx& __prx, const ::IceGrid::InternalServerDescriptorPtr& svr, const ::std::string& replicaName, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__Node__loadServer_name, ::Ice::Idempotent, __ctx);
        ::IceGrid::__write(__os, svr);
        __os->write(replicaName);
        __os->writePendingObjects();
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_Node_loadServer::__response(bool __ok)
{
    ::IceGrid::AdapterPrxDict adapters;
    ::Ice::Int actTimeout;
    ::Ice::Int deactTimeout;
    ::IceGrid::ServerPrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::DeploymentException& __ex)
            {
                ice_exception(__ex);
                return;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::__read(__is, adapters, ::IceGrid::__U__AdapterPrxDict());
        __is->read(actTimeout);
        __is->read(deactTimeout);
        ::IceGrid::__read(__is, __ret);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret, adapters, actTimeout, deactTimeout);
}

void
IceGrid::AMI_Node_destroyServer::__invoke(const ::IceGrid::NodePrx& __prx, const ::std::string& name, const ::std::string& uuid, ::Ice::Int revision, const ::std::string& replicaName, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__Node__destroyServer_name, ::Ice::Idempotent, __ctx);
        __os->write(name);
        __os->write(uuid);
        __os->write(revision);
        __os->write(replicaName);
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_Node_destroyServer::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::DeploymentException& __ex)
            {
                ice_exception(__ex);
                return;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
}

void
IceGrid::AMI_Node_registerWithReplica::__invoke(const ::IceGrid::NodePrx& __prx, const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__Node__registerWithReplica_name, ::Ice::Normal, __ctx);
        ::IceGrid::__write(__os, replica);
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_Node_registerWithReplica::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
}

void
IceGrid::AMI_NodeSession_waitForApplicationUpdate::__invoke(const ::IceGrid::NodeSessionPrx& __prx, const ::std::string& application, ::Ice::Int revision, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__NodeSession__waitForApplicationUpdate_name, ::Ice::Normal, __ctx);
        __os->write(application);
        __os->write(revision);
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_NodeSession_waitForApplicationUpdate::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
}

void
IceGrid::AMI_ReplicaSession_setAdapterDirectProxy::__invoke(const ::IceGrid::ReplicaSessionPrx& __prx, const ::std::string& adapterId, const ::std::string& replicaGroupId, const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __ctx)
{
    try
    {
        __prepare(__prx, __IceGrid__ReplicaSession__setAdapterDirectProxy_name, ::Ice::Idempotent, __ctx);
        __os->write(adapterId);
        __os->write(replicaGroupId);
        __os->write(proxy);
        __os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    __send();
}

void
IceGrid::AMI_ReplicaSession_setAdapterDirectProxy::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::AdapterExistsException& __ex)
            {
                ice_exception(__ex);
                return;
            }
            catch(const ::IceGrid::AdapterNotExistException& __ex)
            {
                ice_exception(__ex);
                return;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
}

IceAsync::IceGrid::AMD_Adapter_activate::AMD_Adapter_activate(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Adapter_activate::ice_response(const ::Ice::ObjectPrx& __ret)
{
    try
    {
        ::IceInternal::BasicStream* __os = this->__os();
        __os->write(__ret);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __exception(__ex);
        return;
    }
    __response(true);
}

void
IceAsync::IceGrid::AMD_Adapter_activate::ice_exception(const ::Ice::Exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_Adapter_activate::ice_exception(const ::std::exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_Adapter_activate::ice_exception()
{
    __exception();
}

IceAsync::IceGrid::AMD_Server_start::AMD_Server_start(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Server_start::ice_response()
{
    __response(true);
}

void
IceAsync::IceGrid::AMD_Server_start::ice_exception(const ::Ice::Exception& ex)
{
    try
    {
        ex.ice_throw();
    }
    catch(const ::IceGrid::ServerStartException& __ex)
    {
        __os()->write(__ex);
        __response(false);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __exception(__ex);
    }
}

void
IceAsync::IceGrid::AMD_Server_start::ice_exception(const ::std::exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_Server_start::ice_exception()
{
    __exception();
}

IceAsync::IceGrid::AMD_Server_stop::AMD_Server_stop(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Server_stop::ice_response()
{
    __response(true);
}

void
IceAsync::IceGrid::AMD_Server_stop::ice_exception(const ::Ice::Exception& ex)
{
    try
    {
        ex.ice_throw();
    }
    catch(const ::IceGrid::ServerStopException& __ex)
    {
        __os()->write(__ex);
        __response(false);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __exception(__ex);
    }
}

void
IceAsync::IceGrid::AMD_Server_stop::ice_exception(const ::std::exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_Server_stop::ice_exception()
{
    __exception();
}

IceAsync::IceGrid::AMD_Server_setProcess::AMD_Server_setProcess(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Server_setProcess::ice_response()
{
    __response(true);
}

void
IceAsync::IceGrid::AMD_Server_setProcess::ice_exception(const ::Ice::Exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_Server_setProcess::ice_exception(const ::std::exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_Server_setProcess::ice_exception()
{
    __exception();
}

IceAsync::IceGrid::AMD_Node_loadServer::AMD_Node_loadServer(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Node_loadServer::ice_response(const ::IceGrid::ServerPrx& __ret, const ::IceGrid::AdapterPrxDict& adapters, ::Ice::Int actTimeout, ::Ice::Int deactTimeout)
{
    try
    {
        ::IceInternal::BasicStream* __os = this->__os();
        ::IceGrid::__write(__os, adapters, ::IceGrid::__U__AdapterPrxDict());
        __os->write(actTimeout);
        __os->write(deactTimeout);
        ::IceGrid::__write(__os, __ret);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __exception(__ex);
        return;
    }
    __response(true);
}

void
IceAsync::IceGrid::AMD_Node_loadServer::ice_exception(const ::Ice::Exception& ex)
{
    try
    {
        ex.ice_throw();
    }
    catch(const ::IceGrid::DeploymentException& __ex)
    {
        __os()->write(__ex);
        __response(false);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __exception(__ex);
    }
}

void
IceAsync::IceGrid::AMD_Node_loadServer::ice_exception(const ::std::exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_Node_loadServer::ice_exception()
{
    __exception();
}

IceAsync::IceGrid::AMD_Node_destroyServer::AMD_Node_destroyServer(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Node_destroyServer::ice_response()
{
    __response(true);
}

void
IceAsync::IceGrid::AMD_Node_destroyServer::ice_exception(const ::Ice::Exception& ex)
{
    try
    {
        ex.ice_throw();
    }
    catch(const ::IceGrid::DeploymentException& __ex)
    {
        __os()->write(__ex);
        __response(false);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __exception(__ex);
    }
}

void
IceAsync::IceGrid::AMD_Node_destroyServer::ice_exception(const ::std::exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_Node_destroyServer::ice_exception()
{
    __exception();
}

IceAsync::IceGrid::AMD_Node_patch::AMD_Node_patch(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_Node_patch::ice_response()
{
    __response(true);
}

void
IceAsync::IceGrid::AMD_Node_patch::ice_exception(const ::Ice::Exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_Node_patch::ice_exception(const ::std::exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_Node_patch::ice_exception()
{
    __exception();
}

IceAsync::IceGrid::AMD_NodeSession_loadServers::AMD_NodeSession_loadServers(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_NodeSession_loadServers::ice_response()
{
    __response(true);
}

void
IceAsync::IceGrid::AMD_NodeSession_loadServers::ice_exception(const ::Ice::Exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_NodeSession_loadServers::ice_exception(const ::std::exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_NodeSession_loadServers::ice_exception()
{
    __exception();
}

IceAsync::IceGrid::AMD_NodeSession_waitForApplicationUpdate::AMD_NodeSession_waitForApplicationUpdate(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::IceGrid::AMD_NodeSession_waitForApplicationUpdate::ice_response()
{
    __response(true);
}

void
IceAsync::IceGrid::AMD_NodeSession_waitForApplicationUpdate::ice_exception(const ::Ice::Exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_NodeSession_waitForApplicationUpdate::ice_exception(const ::std::exception& ex)
{
    __exception(ex);
}

void
IceAsync::IceGrid::AMD_NodeSession_waitForApplicationUpdate::ice_exception()
{
    __exception();
}

const ::std::string&
IceProxy::IceGrid::InternalDbEnvDescriptor::ice_staticId()
{
    return ::IceGrid::InternalDbEnvDescriptor::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::InternalDbEnvDescriptor::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::InternalDbEnvDescriptor);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::InternalDbEnvDescriptor::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::InternalDbEnvDescriptor);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::InternalDbEnvDescriptor& l, const ::IceProxy::IceGrid::InternalDbEnvDescriptor& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::InternalDbEnvDescriptor& l, const ::IceProxy::IceGrid::InternalDbEnvDescriptor& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::InternalDbEnvDescriptor& l, const ::IceProxy::IceGrid::InternalDbEnvDescriptor& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::InternalDbEnvDescriptor& l, const ::IceProxy::IceGrid::InternalDbEnvDescriptor& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::InternalDbEnvDescriptor& l, const ::IceProxy::IceGrid::InternalDbEnvDescriptor& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::InternalDbEnvDescriptor& l, const ::IceProxy::IceGrid::InternalDbEnvDescriptor& r)
{
    return !(l < r);
}

const ::std::string&
IceProxy::IceGrid::InternalAdapterDescriptor::ice_staticId()
{
    return ::IceGrid::InternalAdapterDescriptor::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::InternalAdapterDescriptor::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::InternalAdapterDescriptor);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::InternalAdapterDescriptor::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::InternalAdapterDescriptor);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::InternalAdapterDescriptor& l, const ::IceProxy::IceGrid::InternalAdapterDescriptor& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::InternalAdapterDescriptor& l, const ::IceProxy::IceGrid::InternalAdapterDescriptor& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::InternalAdapterDescriptor& l, const ::IceProxy::IceGrid::InternalAdapterDescriptor& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::InternalAdapterDescriptor& l, const ::IceProxy::IceGrid::InternalAdapterDescriptor& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::InternalAdapterDescriptor& l, const ::IceProxy::IceGrid::InternalAdapterDescriptor& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::InternalAdapterDescriptor& l, const ::IceProxy::IceGrid::InternalAdapterDescriptor& r)
{
    return !(l < r);
}

const ::std::string&
IceProxy::IceGrid::InternalDistributionDescriptor::ice_staticId()
{
    return ::IceGrid::InternalDistributionDescriptor::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::InternalDistributionDescriptor::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::InternalDistributionDescriptor);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::InternalDistributionDescriptor::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::InternalDistributionDescriptor);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::InternalDistributionDescriptor& l, const ::IceProxy::IceGrid::InternalDistributionDescriptor& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::InternalDistributionDescriptor& l, const ::IceProxy::IceGrid::InternalDistributionDescriptor& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::InternalDistributionDescriptor& l, const ::IceProxy::IceGrid::InternalDistributionDescriptor& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::InternalDistributionDescriptor& l, const ::IceProxy::IceGrid::InternalDistributionDescriptor& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::InternalDistributionDescriptor& l, const ::IceProxy::IceGrid::InternalDistributionDescriptor& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::InternalDistributionDescriptor& l, const ::IceProxy::IceGrid::InternalDistributionDescriptor& r)
{
    return !(l < r);
}

const ::std::string&
IceProxy::IceGrid::InternalServerDescriptor::ice_staticId()
{
    return ::IceGrid::InternalServerDescriptor::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::InternalServerDescriptor::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::InternalServerDescriptor);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::InternalServerDescriptor::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::InternalServerDescriptor);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::InternalServerDescriptor& l, const ::IceProxy::IceGrid::InternalServerDescriptor& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::InternalServerDescriptor& l, const ::IceProxy::IceGrid::InternalServerDescriptor& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::InternalServerDescriptor& l, const ::IceProxy::IceGrid::InternalServerDescriptor& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::InternalServerDescriptor& l, const ::IceProxy::IceGrid::InternalServerDescriptor& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::InternalServerDescriptor& l, const ::IceProxy::IceGrid::InternalServerDescriptor& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::InternalServerDescriptor& l, const ::IceProxy::IceGrid::InternalServerDescriptor& r)
{
    return !(l < r);
}

::Ice::ObjectPrx
IceProxy::IceGrid::Adapter::activate(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Adapter__activate_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Adapter* __del = dynamic_cast< ::IceDelegate::IceGrid::Adapter*>(__delBase.get());
            return __del->activate(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Adapter::activate_async(const ::IceGrid::AMI_Adapter_activatePtr& __cb)
{
    __cb->__invoke(this, 0);
}

void
IceProxy::IceGrid::Adapter::activate_async(const ::IceGrid::AMI_Adapter_activatePtr& __cb, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, &__ctx);
}

::Ice::ObjectPrx
IceProxy::IceGrid::Adapter::getDirectProxy(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Adapter__getDirectProxy_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Adapter* __del = dynamic_cast< ::IceDelegate::IceGrid::Adapter*>(__delBase.get());
            return __del->getDirectProxy(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Adapter::getDirectProxy_async(const ::IceGrid::AMI_Adapter_getDirectProxyPtr& __cb)
{
    __cb->__invoke(this, 0);
}

void
IceProxy::IceGrid::Adapter::getDirectProxy_async(const ::IceGrid::AMI_Adapter_getDirectProxyPtr& __cb, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, &__ctx);
}

void
IceProxy::IceGrid::Adapter::setDirectProxy(const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Adapter__setDirectProxy_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Adapter* __del = dynamic_cast< ::IceDelegate::IceGrid::Adapter*>(__delBase.get());
            __del->setDirectProxy(proxy, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Adapter::setDirectProxy_async(const ::IceGrid::AMI_Adapter_setDirectProxyPtr& __cb, const ::Ice::ObjectPrx& proxy)
{
    __cb->__invoke(this, proxy, 0);
}

void
IceProxy::IceGrid::Adapter::setDirectProxy_async(const ::IceGrid::AMI_Adapter_setDirectProxyPtr& __cb, const ::Ice::ObjectPrx& proxy, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, proxy, &__ctx);
}

const ::std::string&
IceProxy::IceGrid::Adapter::ice_staticId()
{
    return ::IceGrid::Adapter::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::Adapter::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::Adapter);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::Adapter::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::Adapter);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::Adapter& l, const ::IceProxy::IceGrid::Adapter& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::Adapter& l, const ::IceProxy::IceGrid::Adapter& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::Adapter& l, const ::IceProxy::IceGrid::Adapter& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::Adapter& l, const ::IceProxy::IceGrid::Adapter& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::Adapter& l, const ::IceProxy::IceGrid::Adapter& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::Adapter& l, const ::IceProxy::IceGrid::Adapter& r)
{
    return !(l < r);
}

::Ice::Long
IceProxy::IceGrid::FileReader::getOffsetFromEnd(const ::std::string& filename, ::Ice::Int lines, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__FileReader__getOffsetFromEnd_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::FileReader* __del = dynamic_cast< ::IceDelegate::IceGrid::FileReader*>(__delBase.get());
            return __del->getOffsetFromEnd(filename, lines, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::FileReader::read(const ::std::string& filename, ::Ice::Long pos, ::Ice::Int size, ::Ice::Long& newPos, ::Ice::StringSeq& lines, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__FileReader__read_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::FileReader* __del = dynamic_cast< ::IceDelegate::IceGrid::FileReader*>(__delBase.get());
            return __del->read(filename, pos, size, newPos, lines, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::FileReader::ice_staticId()
{
    return ::IceGrid::FileReader::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::FileReader::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::FileReader);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::FileReader::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::FileReader);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::FileReader& l, const ::IceProxy::IceGrid::FileReader& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::FileReader& l, const ::IceProxy::IceGrid::FileReader& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::FileReader& l, const ::IceProxy::IceGrid::FileReader& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::FileReader& l, const ::IceProxy::IceGrid::FileReader& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::FileReader& l, const ::IceProxy::IceGrid::FileReader& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::FileReader& l, const ::IceProxy::IceGrid::FileReader& r)
{
    return !(l < r);
}

void
IceProxy::IceGrid::Server::start(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Server__start_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            __del->start(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Server::stop(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Server__stop_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            __del->stop(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Server::setEnabled(bool enable, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            __del->setEnabled(enable, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

bool
IceProxy::IceGrid::Server::isEnabled(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Server__isEnabled_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            return __del->isEnabled(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Server::sendSignal(const ::std::string& signal, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Server__sendSignal_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            __del->sendSignal(signal, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Server::writeMessage(const ::std::string& message, ::Ice::Int fd, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            __del->writeMessage(message, fd, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::IceGrid::ServerState
IceProxy::IceGrid::Server::getState(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Server__getState_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            return __del->getState(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Ice::Int
IceProxy::IceGrid::Server::getPid(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Server__getPid_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            return __del->getPid(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Server::setProcess(const ::Ice::ProcessPrx& proc, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Server* __del = dynamic_cast< ::IceDelegate::IceGrid::Server*>(__delBase.get());
            __del->setProcess(proc, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Server::setProcess_async(const ::IceGrid::AMI_Server_setProcessPtr& __cb, const ::Ice::ProcessPrx& proc)
{
    __cb->__invoke(this, proc, 0);
}

void
IceProxy::IceGrid::Server::setProcess_async(const ::IceGrid::AMI_Server_setProcessPtr& __cb, const ::Ice::ProcessPrx& proc, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, proc, &__ctx);
}

const ::std::string&
IceProxy::IceGrid::Server::ice_staticId()
{
    return ::IceGrid::Server::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::Server::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::Server);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::Server::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::Server);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::Server& l, const ::IceProxy::IceGrid::Server& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::Server& l, const ::IceProxy::IceGrid::Server& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::Server& l, const ::IceProxy::IceGrid::Server& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::Server& l, const ::IceProxy::IceGrid::Server& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::Server& l, const ::IceProxy::IceGrid::Server& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::Server& l, const ::IceProxy::IceGrid::Server& r)
{
    return !(l < r);
}

void
IceProxy::IceGrid::ReplicaObserver::replicaInit(const ::IceGrid::InternalRegistryPrxSeq& replicas, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ReplicaObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaObserver*>(__delBase.get());
            __del->replicaInit(replicas, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ReplicaObserver::replicaAdded(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ReplicaObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaObserver*>(__delBase.get());
            __del->replicaAdded(replica, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ReplicaObserver::replicaRemoved(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ReplicaObserver* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaObserver*>(__delBase.get());
            __del->replicaRemoved(replica, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::ReplicaObserver::ice_staticId()
{
    return ::IceGrid::ReplicaObserver::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::ReplicaObserver::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::ReplicaObserver);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::ReplicaObserver::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::ReplicaObserver);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::ReplicaObserver& l, const ::IceProxy::IceGrid::ReplicaObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::ReplicaObserver& l, const ::IceProxy::IceGrid::ReplicaObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::ReplicaObserver& l, const ::IceProxy::IceGrid::ReplicaObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::ReplicaObserver& l, const ::IceProxy::IceGrid::ReplicaObserver& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::ReplicaObserver& l, const ::IceProxy::IceGrid::ReplicaObserver& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::ReplicaObserver& l, const ::IceProxy::IceGrid::ReplicaObserver& r)
{
    return !(l < r);
}

void
IceProxy::IceGrid::PatcherFeedback::finished(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::PatcherFeedback* __del = dynamic_cast< ::IceDelegate::IceGrid::PatcherFeedback*>(__delBase.get());
            __del->finished(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::PatcherFeedback::failed(const ::std::string& reason, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::PatcherFeedback* __del = dynamic_cast< ::IceDelegate::IceGrid::PatcherFeedback*>(__delBase.get());
            __del->failed(reason, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::PatcherFeedback::ice_staticId()
{
    return ::IceGrid::PatcherFeedback::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::PatcherFeedback::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::PatcherFeedback);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::PatcherFeedback::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::PatcherFeedback);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::PatcherFeedback& l, const ::IceProxy::IceGrid::PatcherFeedback& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::PatcherFeedback& l, const ::IceProxy::IceGrid::PatcherFeedback& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::PatcherFeedback& l, const ::IceProxy::IceGrid::PatcherFeedback& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::PatcherFeedback& l, const ::IceProxy::IceGrid::PatcherFeedback& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::PatcherFeedback& l, const ::IceProxy::IceGrid::PatcherFeedback& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::PatcherFeedback& l, const ::IceProxy::IceGrid::PatcherFeedback& r)
{
    return !(l < r);
}

::IceGrid::ServerPrx
IceProxy::IceGrid::Node::loadServer(const ::IceGrid::InternalServerDescriptorPtr& svr, const ::std::string& replicaName, ::IceGrid::AdapterPrxDict& adapters, ::Ice::Int& actTimeout, ::Ice::Int& deactTimeout, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Node__loadServer_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            return __del->loadServer(svr, replicaName, adapters, actTimeout, deactTimeout, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Node::loadServer_async(const ::IceGrid::AMI_Node_loadServerPtr& __cb, const ::IceGrid::InternalServerDescriptorPtr& svr, const ::std::string& replicaName)
{
    __cb->__invoke(this, svr, replicaName, 0);
}

void
IceProxy::IceGrid::Node::loadServer_async(const ::IceGrid::AMI_Node_loadServerPtr& __cb, const ::IceGrid::InternalServerDescriptorPtr& svr, const ::std::string& replicaName, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, svr, replicaName, &__ctx);
}

void
IceProxy::IceGrid::Node::destroyServer(const ::std::string& name, const ::std::string& uuid, ::Ice::Int revision, const ::std::string& replicaName, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Node__destroyServer_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            __del->destroyServer(name, uuid, revision, replicaName, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Node::destroyServer_async(const ::IceGrid::AMI_Node_destroyServerPtr& __cb, const ::std::string& name, const ::std::string& uuid, ::Ice::Int revision, const ::std::string& replicaName)
{
    __cb->__invoke(this, name, uuid, revision, replicaName, 0);
}

void
IceProxy::IceGrid::Node::destroyServer_async(const ::IceGrid::AMI_Node_destroyServerPtr& __cb, const ::std::string& name, const ::std::string& uuid, ::Ice::Int revision, const ::std::string& replicaName, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, name, uuid, revision, replicaName, &__ctx);
}

void
IceProxy::IceGrid::Node::patch(const ::IceGrid::PatcherFeedbackPrx& feedback, const ::std::string& application, const ::std::string& server, const ::IceGrid::InternalDistributionDescriptorPtr& appDistrib, bool shutdown, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            __del->patch(feedback, application, server, appDistrib, shutdown, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Node::registerWithReplica(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            __del->registerWithReplica(replica, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Node::registerWithReplica_async(const ::IceGrid::AMI_Node_registerWithReplicaPtr& __cb, const ::IceGrid::InternalRegistryPrx& replica)
{
    __cb->__invoke(this, replica, 0);
}

void
IceProxy::IceGrid::Node::registerWithReplica_async(const ::IceGrid::AMI_Node_registerWithReplicaPtr& __cb, const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, replica, &__ctx);
}

::std::string
IceProxy::IceGrid::Node::getName(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Node__getName_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            return __del->getName(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::std::string
IceProxy::IceGrid::Node::getHostname(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Node__getHostname_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            return __del->getHostname(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::IceGrid::LoadInfo
IceProxy::IceGrid::Node::getLoad(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__Node__getLoad_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            return __del->getLoad(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::Node::shutdown(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::Node* __del = dynamic_cast< ::IceDelegate::IceGrid::Node*>(__delBase.get());
            __del->shutdown(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::Node::ice_staticId()
{
    return ::IceGrid::Node::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::Node::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::Node);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::Node::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::Node);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::Node& l, const ::IceProxy::IceGrid::Node& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::Node& l, const ::IceProxy::IceGrid::Node& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::Node& l, const ::IceProxy::IceGrid::Node& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::Node& l, const ::IceProxy::IceGrid::Node& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::Node& l, const ::IceProxy::IceGrid::Node& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::Node& l, const ::IceProxy::IceGrid::Node& r)
{
    return !(l < r);
}

void
IceProxy::IceGrid::NodeSession::keepAlive(const ::IceGrid::LoadInfo& load, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            __del->keepAlive(load, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::NodeSession::setReplicaObserver(const ::IceGrid::ReplicaObserverPrx& observer, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            __del->setReplicaObserver(observer, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Ice::Int
IceProxy::IceGrid::NodeSession::getTimeout(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__NodeSession__getTimeout_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            return __del->getTimeout(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::IceGrid::NodeObserverPrx
IceProxy::IceGrid::NodeSession::getObserver(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__NodeSession__getObserver_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            return __del->getObserver(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::NodeSession::loadServers(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            __del->loadServers(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Ice::StringSeq
IceProxy::IceGrid::NodeSession::getServers(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__NodeSession__getServers_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            return __del->getServers(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::NodeSession::waitForApplicationUpdate(const ::std::string& application, ::Ice::Int revision, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            __del->waitForApplicationUpdate(application, revision, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::NodeSession::waitForApplicationUpdate_async(const ::IceGrid::AMI_NodeSession_waitForApplicationUpdatePtr& __cb, const ::std::string& application, ::Ice::Int revision)
{
    __cb->__invoke(this, application, revision, 0);
}

void
IceProxy::IceGrid::NodeSession::waitForApplicationUpdate_async(const ::IceGrid::AMI_NodeSession_waitForApplicationUpdatePtr& __cb, const ::std::string& application, ::Ice::Int revision, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, application, revision, &__ctx);
}

void
IceProxy::IceGrid::NodeSession::destroy(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::NodeSession* __del = dynamic_cast< ::IceDelegate::IceGrid::NodeSession*>(__delBase.get());
            __del->destroy(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::NodeSession::ice_staticId()
{
    return ::IceGrid::NodeSession::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::NodeSession::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::NodeSession);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::NodeSession::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::NodeSession);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::NodeSession& l, const ::IceProxy::IceGrid::NodeSession& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::NodeSession& l, const ::IceProxy::IceGrid::NodeSession& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::NodeSession& l, const ::IceProxy::IceGrid::NodeSession& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::NodeSession& l, const ::IceProxy::IceGrid::NodeSession& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::NodeSession& l, const ::IceProxy::IceGrid::NodeSession& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::NodeSession& l, const ::IceProxy::IceGrid::NodeSession& r)
{
    return !(l < r);
}

const ::std::string&
IceProxy::IceGrid::DatabaseObserver::ice_staticId()
{
    return ::IceGrid::DatabaseObserver::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::DatabaseObserver::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::DatabaseObserver);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::DatabaseObserver::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::DatabaseObserver);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::DatabaseObserver& l, const ::IceProxy::IceGrid::DatabaseObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::DatabaseObserver& l, const ::IceProxy::IceGrid::DatabaseObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::DatabaseObserver& l, const ::IceProxy::IceGrid::DatabaseObserver& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::DatabaseObserver& l, const ::IceProxy::IceGrid::DatabaseObserver& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::DatabaseObserver& l, const ::IceProxy::IceGrid::DatabaseObserver& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::DatabaseObserver& l, const ::IceProxy::IceGrid::DatabaseObserver& r)
{
    return !(l < r);
}

void
IceProxy::IceGrid::ReplicaSession::keepAlive(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            __del->keepAlive(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::Ice::Int
IceProxy::IceGrid::ReplicaSession::getTimeout(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__ReplicaSession__getTimeout_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            return __del->getTimeout(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ReplicaSession::setDatabaseObserver(const ::IceGrid::DatabaseObserverPrx& dbObs, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            __del->setDatabaseObserver(dbObs, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ReplicaSession::setEndpoints(const ::IceGrid::StringObjectProxyDict& endpoints, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            __del->setEndpoints(endpoints, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ReplicaSession::registerWellKnownObjects(const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            __del->registerWellKnownObjects(objects, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ReplicaSession::setAdapterDirectProxy(const ::std::string& adapterId, const ::std::string& replicaGroupId, const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__ReplicaSession__setAdapterDirectProxy_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            __del->setAdapterDirectProxy(adapterId, replicaGroupId, proxy, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ReplicaSession::setAdapterDirectProxy_async(const ::IceGrid::AMI_ReplicaSession_setAdapterDirectProxyPtr& __cb, const ::std::string& adapterId, const ::std::string& replicaGroupId, const ::Ice::ObjectPrx& proxy)
{
    __cb->__invoke(this, adapterId, replicaGroupId, proxy, 0);
}

void
IceProxy::IceGrid::ReplicaSession::setAdapterDirectProxy_async(const ::IceGrid::AMI_ReplicaSession_setAdapterDirectProxyPtr& __cb, const ::std::string& adapterId, const ::std::string& replicaGroupId, const ::Ice::ObjectPrx& proxy, const ::Ice::Context& __ctx)
{
    __cb->__invoke(this, adapterId, replicaGroupId, proxy, &__ctx);
}

void
IceProxy::IceGrid::ReplicaSession::receivedUpdate(::IceGrid::TopicName name, ::Ice::Int serial, const ::std::string& failure, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            __del->receivedUpdate(name, serial, failure, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::ReplicaSession::destroy(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::ReplicaSession* __del = dynamic_cast< ::IceDelegate::IceGrid::ReplicaSession*>(__delBase.get());
            __del->destroy(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::ReplicaSession::ice_staticId()
{
    return ::IceGrid::ReplicaSession::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::ReplicaSession::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::ReplicaSession);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::ReplicaSession::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::ReplicaSession);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::ReplicaSession& l, const ::IceProxy::IceGrid::ReplicaSession& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::ReplicaSession& l, const ::IceProxy::IceGrid::ReplicaSession& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::ReplicaSession& l, const ::IceProxy::IceGrid::ReplicaSession& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::ReplicaSession& l, const ::IceProxy::IceGrid::ReplicaSession& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::ReplicaSession& l, const ::IceProxy::IceGrid::ReplicaSession& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::ReplicaSession& l, const ::IceProxy::IceGrid::ReplicaSession& r)
{
    return !(l < r);
}

const ::std::string&
IceProxy::IceGrid::InternalNodeInfo::ice_staticId()
{
    return ::IceGrid::InternalNodeInfo::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::InternalNodeInfo::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::InternalNodeInfo);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::InternalNodeInfo::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::InternalNodeInfo);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::InternalNodeInfo& l, const ::IceProxy::IceGrid::InternalNodeInfo& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::InternalNodeInfo& l, const ::IceProxy::IceGrid::InternalNodeInfo& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::InternalNodeInfo& l, const ::IceProxy::IceGrid::InternalNodeInfo& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::InternalNodeInfo& l, const ::IceProxy::IceGrid::InternalNodeInfo& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::InternalNodeInfo& l, const ::IceProxy::IceGrid::InternalNodeInfo& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::InternalNodeInfo& l, const ::IceProxy::IceGrid::InternalNodeInfo& r)
{
    return !(l < r);
}

const ::std::string&
IceProxy::IceGrid::InternalReplicaInfo::ice_staticId()
{
    return ::IceGrid::InternalReplicaInfo::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::InternalReplicaInfo::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::InternalReplicaInfo);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::InternalReplicaInfo::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::InternalReplicaInfo);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::InternalReplicaInfo& l, const ::IceProxy::IceGrid::InternalReplicaInfo& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::InternalReplicaInfo& l, const ::IceProxy::IceGrid::InternalReplicaInfo& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::InternalReplicaInfo& l, const ::IceProxy::IceGrid::InternalReplicaInfo& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::InternalReplicaInfo& l, const ::IceProxy::IceGrid::InternalReplicaInfo& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::InternalReplicaInfo& l, const ::IceProxy::IceGrid::InternalReplicaInfo& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::InternalReplicaInfo& l, const ::IceProxy::IceGrid::InternalReplicaInfo& r)
{
    return !(l < r);
}

::IceGrid::NodeSessionPrx
IceProxy::IceGrid::InternalRegistry::registerNode(const ::IceGrid::InternalNodeInfoPtr& info, const ::IceGrid::NodePrx& prx, const ::IceGrid::LoadInfo& loadInf, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__InternalRegistry__registerNode_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::InternalRegistry* __del = dynamic_cast< ::IceDelegate::IceGrid::InternalRegistry*>(__delBase.get());
            return __del->registerNode(info, prx, loadInf, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::IceGrid::ReplicaSessionPrx
IceProxy::IceGrid::InternalRegistry::registerReplica(const ::IceGrid::InternalReplicaInfoPtr& info, const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__InternalRegistry__registerReplica_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::InternalRegistry* __del = dynamic_cast< ::IceDelegate::IceGrid::InternalRegistry*>(__delBase.get());
            return __del->registerReplica(info, prx, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::InternalRegistry::registerWithReplica(const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::InternalRegistry* __del = dynamic_cast< ::IceDelegate::IceGrid::InternalRegistry*>(__delBase.get());
            __del->registerWithReplica(prx, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::IceGrid::NodePrxSeq
IceProxy::IceGrid::InternalRegistry::getNodes(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__InternalRegistry__getNodes_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::InternalRegistry* __del = dynamic_cast< ::IceDelegate::IceGrid::InternalRegistry*>(__delBase.get());
            return __del->getNodes(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

::IceGrid::InternalRegistryPrxSeq
IceProxy::IceGrid::InternalRegistry::getReplicas(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__IceGrid__InternalRegistry__getReplicas_name);
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::InternalRegistry* __del = dynamic_cast< ::IceDelegate::IceGrid::InternalRegistry*>(__delBase.get());
            return __del->getReplicas(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

void
IceProxy::IceGrid::InternalRegistry::shutdown(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate();
            ::IceDelegate::IceGrid::InternalRegistry* __del = dynamic_cast< ::IceDelegate::IceGrid::InternalRegistry*>(__delBase.get());
            __del->shutdown(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, __cnt);
        }
    }
}

const ::std::string&
IceProxy::IceGrid::InternalRegistry::ice_staticId()
{
    return ::IceGrid::InternalRegistry::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::IceGrid::InternalRegistry::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::IceGrid::InternalRegistry);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::IceGrid::InternalRegistry::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::IceGrid::InternalRegistry);
}

bool
IceProxy::IceGrid::operator==(const ::IceProxy::IceGrid::InternalRegistry& l, const ::IceProxy::IceGrid::InternalRegistry& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator!=(const ::IceProxy::IceGrid::InternalRegistry& l, const ::IceProxy::IceGrid::InternalRegistry& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<(const ::IceProxy::IceGrid::InternalRegistry& l, const ::IceProxy::IceGrid::InternalRegistry& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::IceGrid::operator<=(const ::IceProxy::IceGrid::InternalRegistry& l, const ::IceProxy::IceGrid::InternalRegistry& r)
{
    return l < r || l == r;
}

bool
IceProxy::IceGrid::operator>(const ::IceProxy::IceGrid::InternalRegistry& l, const ::IceProxy::IceGrid::InternalRegistry& r)
{
    return !(l < r) && !(l == r);
}

bool
IceProxy::IceGrid::operator>=(const ::IceProxy::IceGrid::InternalRegistry& l, const ::IceProxy::IceGrid::InternalRegistry& r)
{
    return !(l < r);
}

::Ice::ObjectPrx
IceDelegateM::IceGrid::Adapter::activate(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Adapter__activate_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::ObjectPrx __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ObjectPrx
IceDelegateM::IceGrid::Adapter::getDirectProxy(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Adapter__getDirectProxy_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::AdapterNotActiveException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::ObjectPrx __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Adapter::setDirectProxy(const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Adapter__setDirectProxy_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(proxy);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::AdapterActiveException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::Long
IceDelegateM::IceGrid::FileReader::getOffsetFromEnd(const ::std::string& filename, ::Ice::Int lines, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__FileReader__getOffsetFromEnd_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(filename);
        __os->write(lines);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::FileNotAvailableException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::Long __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

bool
IceDelegateM::IceGrid::FileReader::read(const ::std::string& filename, ::Ice::Long pos, ::Ice::Int size, ::Ice::Long& newPos, ::Ice::StringSeq& lines, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__FileReader__read_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(filename);
        __os->write(pos);
        __os->write(size);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::FileNotAvailableException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        bool __ret;
        __is->read(newPos);
        __is->read(lines);
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Server::start(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Server__start_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::ServerStartException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Server::stop(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Server__stop_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::ServerStopException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Server::setEnabled(bool enable, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Server__setEnabled_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(enable);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

bool
IceDelegateM::IceGrid::Server::isEnabled(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Server__isEnabled_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        bool __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Server::sendSignal(const ::std::string& signal, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Server__sendSignal_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(signal);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::BadSignalException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Server::writeMessage(const ::std::string& message, ::Ice::Int fd, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Server__writeMessage_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(message);
        __os->write(fd);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::ServerState
IceDelegateM::IceGrid::Server::getState(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Server__getState_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::ServerState __ret;
        ::IceGrid::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::Int
IceDelegateM::IceGrid::Server::getPid(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Server__getPid_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::Int __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Server::setProcess(const ::Ice::ProcessPrx& proc, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Server__setProcess_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::Ice::__write(__os, proc);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ReplicaObserver::replicaInit(const ::IceGrid::InternalRegistryPrxSeq& replicas, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ReplicaObserver__replicaInit_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(replicas.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__write(__os, &replicas[0], &replicas[0] + replicas.size(), ::IceGrid::__U__InternalRegistryPrxSeq());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ReplicaObserver::replicaAdded(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ReplicaObserver__replicaAdded_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceGrid::__write(__os, replica);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ReplicaObserver::replicaRemoved(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ReplicaObserver__replicaRemoved_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceGrid::__write(__os, replica);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::PatcherFeedback::finished(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__PatcherFeedback__finished_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::PatcherFeedback::failed(const ::std::string& reason, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__PatcherFeedback__failed_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(reason);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::ServerPrx
IceDelegateM::IceGrid::Node::loadServer(const ::IceGrid::InternalServerDescriptorPtr& svr, const ::std::string& replicaName, ::IceGrid::AdapterPrxDict& adapters, ::Ice::Int& actTimeout, ::Ice::Int& deactTimeout, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Node__loadServer_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceGrid::__write(__os, svr);
        __os->write(replicaName);
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::DeploymentException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::ServerPrx __ret;
        ::IceGrid::__read(__is, adapters, ::IceGrid::__U__AdapterPrxDict());
        __is->read(actTimeout);
        __is->read(deactTimeout);
        ::IceGrid::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Node::destroyServer(const ::std::string& name, const ::std::string& uuid, ::Ice::Int revision, const ::std::string& replicaName, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Node__destroyServer_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(name);
        __os->write(uuid);
        __os->write(revision);
        __os->write(replicaName);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::DeploymentException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Node::patch(const ::IceGrid::PatcherFeedbackPrx& feedback, const ::std::string& application, const ::std::string& server, const ::IceGrid::InternalDistributionDescriptorPtr& appDistrib, bool shutdown, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Node__patch_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceGrid::__write(__os, feedback);
        __os->write(application);
        __os->write(server);
        ::IceGrid::__write(__os, appDistrib);
        __os->write(shutdown);
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Node::registerWithReplica(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Node__registerWithReplica_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceGrid::__write(__os, replica);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::std::string
IceDelegateM::IceGrid::Node::getName(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Node__getName_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::std::string __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::std::string
IceDelegateM::IceGrid::Node::getHostname(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Node__getHostname_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::std::string __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::LoadInfo
IceDelegateM::IceGrid::Node::getLoad(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Node__getLoad_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::LoadInfo __ret;
        __ret.__read(__is);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::Node::shutdown(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__Node__shutdown_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::NodeSession::keepAlive(const ::IceGrid::LoadInfo& load, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__NodeSession__keepAlive_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        load.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::NodeSession::setReplicaObserver(const ::IceGrid::ReplicaObserverPrx& observer, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__NodeSession__setReplicaObserver_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceGrid::__write(__os, observer);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::Int
IceDelegateM::IceGrid::NodeSession::getTimeout(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__NodeSession__getTimeout_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::Int __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::NodeObserverPrx
IceDelegateM::IceGrid::NodeSession::getObserver(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__NodeSession__getObserver_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::NodeObserverPrx __ret;
        ::IceGrid::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::NodeSession::loadServers(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__NodeSession__loadServers_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::StringSeq
IceDelegateM::IceGrid::NodeSession::getServers(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__NodeSession__getServers_name, ::Ice::Nonmutating, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::StringSeq __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::NodeSession::waitForApplicationUpdate(const ::std::string& application, ::Ice::Int revision, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__NodeSession__waitForApplicationUpdate_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(application);
        __os->write(revision);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::NodeSession::destroy(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__NodeSession__destroy_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ReplicaSession::keepAlive(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ReplicaSession__keepAlive_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::Int
IceDelegateM::IceGrid::ReplicaSession::getTimeout(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ReplicaSession__getTimeout_name, ::Ice::Idempotent, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::Ice::Int __ret;
        __is->read(__ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ReplicaSession::setDatabaseObserver(const ::IceGrid::DatabaseObserverPrx& dbObs, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ReplicaSession__setDatabaseObserver_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceGrid::__write(__os, dbObs);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ReplicaSession::setEndpoints(const ::IceGrid::StringObjectProxyDict& endpoints, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ReplicaSession__setEndpoints_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceGrid::__write(__os, endpoints, ::IceGrid::__U__StringObjectProxyDict());
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ReplicaSession::registerWellKnownObjects(const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ReplicaSession__registerWellKnownObjects_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(objects.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::IceGrid::__write(__os, &objects[0], &objects[0] + objects.size(), ::IceGrid::__U__ObjectInfoSeq());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ReplicaSession::setAdapterDirectProxy(const ::std::string& adapterId, const ::std::string& replicaGroupId, const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ReplicaSession__setAdapterDirectProxy_name, ::Ice::Idempotent, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(adapterId);
        __os->write(replicaGroupId);
        __os->write(proxy);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::AdapterExistsException&)
            {
                throw;
            }
            catch(const ::IceGrid::AdapterNotExistException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ReplicaSession::receivedUpdate(::IceGrid::TopicName name, ::Ice::Int serial, const ::std::string& failure, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ReplicaSession__receivedUpdate_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceGrid::__write(__os, name);
        __os->write(serial);
        __os->write(failure);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::ReplicaSession::destroy(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__ReplicaSession__destroy_name, ::Ice::Normal, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::NodeSessionPrx
IceDelegateM::IceGrid::InternalRegistry::registerNode(const ::IceGrid::InternalNodeInfoPtr& info, const ::IceGrid::NodePrx& prx, const ::IceGrid::LoadInfo& loadInf, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__InternalRegistry__registerNode_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceGrid::__write(__os, info);
        ::IceGrid::__write(__os, prx);
        loadInf.__write(__os);
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::NodeActiveException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::NodeSessionPrx __ret;
        ::IceGrid::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::ReplicaSessionPrx
IceDelegateM::IceGrid::InternalRegistry::registerReplica(const ::IceGrid::InternalReplicaInfoPtr& info, const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__InternalRegistry__registerReplica_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceGrid::__write(__os, info);
        ::IceGrid::__write(__os, prx);
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::IceGrid::ReplicaActiveException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::ReplicaSessionPrx __ret;
        ::IceGrid::__read(__is, __ret);
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::InternalRegistry::registerWithReplica(const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__InternalRegistry__registerWithReplica_name, ::Ice::Normal, __context, __compress);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::IceGrid::__write(__os, prx);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::NodePrxSeq
IceDelegateM::IceGrid::InternalRegistry::getNodes(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__InternalRegistry__getNodes_name, ::Ice::Idempotent, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::NodePrxSeq __ret;
        ::IceGrid::__read(__is, __ret, ::IceGrid::__U__NodePrxSeq());
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::IceGrid::InternalRegistryPrxSeq
IceDelegateM::IceGrid::InternalRegistry::getReplicas(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__InternalRegistry__getReplicas_name, ::Ice::Idempotent, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
        ::IceGrid::InternalRegistryPrxSeq __ret;
        ::IceGrid::__read(__is, __ret, ::IceGrid::__U__InternalRegistryPrxSeq());
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::IceGrid::InternalRegistry::shutdown(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__connection.get(), __reference.get(), __IceGrid__InternalRegistry__shutdown_name, ::Ice::Idempotent, __context, __compress);
    bool __ok = __og.invoke();
    try
    {
        ::IceInternal::BasicStream* __is = __og.is();
        if(!__ok)
        {
            try
            {
                __is->throwException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ObjectPrx
IceDelegateD::IceGrid::Adapter::activate(const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
    return ::Ice::ObjectPrx(); // to avoid a warning with some compilers;
}

::Ice::ObjectPrx
IceDelegateD::IceGrid::Adapter::getDirectProxy(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Adapter__getDirectProxy_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::ObjectPrx __ret;
        try
        {
            ::IceGrid::Adapter* __servant = dynamic_cast< ::IceGrid::Adapter*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getDirectProxy(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::IceGrid::Adapter::setDirectProxy(const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Adapter__setDirectProxy_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::Adapter* __servant = dynamic_cast< ::IceGrid::Adapter*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->setDirectProxy(proxy, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::Ice::Long
IceDelegateD::IceGrid::FileReader::getOffsetFromEnd(const ::std::string& filename, ::Ice::Int lines, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__FileReader__getOffsetFromEnd_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::Long __ret;
        try
        {
            ::IceGrid::FileReader* __servant = dynamic_cast< ::IceGrid::FileReader*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getOffsetFromEnd(filename, lines, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

bool
IceDelegateD::IceGrid::FileReader::read(const ::std::string& filename, ::Ice::Long pos, ::Ice::Int size, ::Ice::Long& newPos, ::Ice::StringSeq& lines, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__FileReader__read_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        bool __ret;
        try
        {
            ::IceGrid::FileReader* __servant = dynamic_cast< ::IceGrid::FileReader*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->read(filename, pos, size, newPos, lines, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::IceGrid::Server::start(const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

void
IceDelegateD::IceGrid::Server::stop(const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

void
IceDelegateD::IceGrid::Server::setEnabled(bool enable, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Server__setEnabled_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::Server* __servant = dynamic_cast< ::IceGrid::Server*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->setEnabled(enable, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

bool
IceDelegateD::IceGrid::Server::isEnabled(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Server__isEnabled_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        bool __ret;
        try
        {
            ::IceGrid::Server* __servant = dynamic_cast< ::IceGrid::Server*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->isEnabled(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::IceGrid::Server::sendSignal(const ::std::string& signal, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Server__sendSignal_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::Server* __servant = dynamic_cast< ::IceGrid::Server*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->sendSignal(signal, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::Server::writeMessage(const ::std::string& message, ::Ice::Int fd, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Server__writeMessage_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::Server* __servant = dynamic_cast< ::IceGrid::Server*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->writeMessage(message, fd, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::IceGrid::ServerState
IceDelegateD::IceGrid::Server::getState(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Server__getState_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceGrid::ServerState __ret;
        try
        {
            ::IceGrid::Server* __servant = dynamic_cast< ::IceGrid::Server*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getState(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::Ice::Int
IceDelegateD::IceGrid::Server::getPid(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Server__getPid_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::Int __ret;
        try
        {
            ::IceGrid::Server* __servant = dynamic_cast< ::IceGrid::Server*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getPid(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::IceGrid::Server::setProcess(const ::Ice::ProcessPrx&, const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

void
IceDelegateD::IceGrid::ReplicaObserver::replicaInit(const ::IceGrid::InternalRegistryPrxSeq& replicas, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaObserver__replicaInit_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ReplicaObserver* __servant = dynamic_cast< ::IceGrid::ReplicaObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->replicaInit(replicas, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ReplicaObserver::replicaAdded(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaObserver__replicaAdded_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ReplicaObserver* __servant = dynamic_cast< ::IceGrid::ReplicaObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->replicaAdded(replica, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ReplicaObserver::replicaRemoved(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaObserver__replicaRemoved_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ReplicaObserver* __servant = dynamic_cast< ::IceGrid::ReplicaObserver*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->replicaRemoved(replica, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::PatcherFeedback::finished(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__PatcherFeedback__finished_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::PatcherFeedback* __servant = dynamic_cast< ::IceGrid::PatcherFeedback*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->finished(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::PatcherFeedback::failed(const ::std::string& reason, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__PatcherFeedback__failed_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::PatcherFeedback* __servant = dynamic_cast< ::IceGrid::PatcherFeedback*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->failed(reason, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::IceGrid::ServerPrx
IceDelegateD::IceGrid::Node::loadServer(const ::IceGrid::InternalServerDescriptorPtr&, const ::std::string&, ::IceGrid::AdapterPrxDict&, ::Ice::Int&, ::Ice::Int&, const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
    return ::IceGrid::ServerPrx(); // to avoid a warning with some compilers;
}

void
IceDelegateD::IceGrid::Node::destroyServer(const ::std::string&, const ::std::string&, ::Ice::Int, const ::std::string&, const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

void
IceDelegateD::IceGrid::Node::patch(const ::IceGrid::PatcherFeedbackPrx&, const ::std::string&, const ::std::string&, const ::IceGrid::InternalDistributionDescriptorPtr&, bool, const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

void
IceDelegateD::IceGrid::Node::registerWithReplica(const ::IceGrid::InternalRegistryPrx& replica, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Node__registerWithReplica_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::Node* __servant = dynamic_cast< ::IceGrid::Node*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->registerWithReplica(replica, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::std::string
IceDelegateD::IceGrid::Node::getName(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Node__getName_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::std::string __ret;
        try
        {
            ::IceGrid::Node* __servant = dynamic_cast< ::IceGrid::Node*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getName(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::std::string
IceDelegateD::IceGrid::Node::getHostname(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Node__getHostname_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::std::string __ret;
        try
        {
            ::IceGrid::Node* __servant = dynamic_cast< ::IceGrid::Node*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getHostname(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::IceGrid::LoadInfo
IceDelegateD::IceGrid::Node::getLoad(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Node__getLoad_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceGrid::LoadInfo __ret;
        try
        {
            ::IceGrid::Node* __servant = dynamic_cast< ::IceGrid::Node*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getLoad(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::IceGrid::Node::shutdown(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__Node__shutdown_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::Node* __servant = dynamic_cast< ::IceGrid::Node*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->shutdown(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::NodeSession::keepAlive(const ::IceGrid::LoadInfo& load, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeSession__keepAlive_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::NodeSession* __servant = dynamic_cast< ::IceGrid::NodeSession*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->keepAlive(load, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::NodeSession::setReplicaObserver(const ::IceGrid::ReplicaObserverPrx& observer, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeSession__setReplicaObserver_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::NodeSession* __servant = dynamic_cast< ::IceGrid::NodeSession*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->setReplicaObserver(observer, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::Ice::Int
IceDelegateD::IceGrid::NodeSession::getTimeout(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeSession__getTimeout_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::Int __ret;
        try
        {
            ::IceGrid::NodeSession* __servant = dynamic_cast< ::IceGrid::NodeSession*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getTimeout(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::IceGrid::NodeObserverPrx
IceDelegateD::IceGrid::NodeSession::getObserver(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeSession__getObserver_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceGrid::NodeObserverPrx __ret;
        try
        {
            ::IceGrid::NodeSession* __servant = dynamic_cast< ::IceGrid::NodeSession*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getObserver(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::IceGrid::NodeSession::loadServers(const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

::Ice::StringSeq
IceDelegateD::IceGrid::NodeSession::getServers(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeSession__getServers_name, ::Ice::Nonmutating, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::StringSeq __ret;
        try
        {
            ::IceGrid::NodeSession* __servant = dynamic_cast< ::IceGrid::NodeSession*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getServers(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::IceGrid::NodeSession::waitForApplicationUpdate(const ::std::string&, ::Ice::Int, const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

void
IceDelegateD::IceGrid::NodeSession::destroy(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__NodeSession__destroy_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::NodeSession* __servant = dynamic_cast< ::IceGrid::NodeSession*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->destroy(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ReplicaSession::keepAlive(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__keepAlive_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ReplicaSession* __servant = dynamic_cast< ::IceGrid::ReplicaSession*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->keepAlive(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::Ice::Int
IceDelegateD::IceGrid::ReplicaSession::getTimeout(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__getTimeout_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::Ice::Int __ret;
        try
        {
            ::IceGrid::ReplicaSession* __servant = dynamic_cast< ::IceGrid::ReplicaSession*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getTimeout(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::IceGrid::ReplicaSession::setDatabaseObserver(const ::IceGrid::DatabaseObserverPrx& dbObs, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__setDatabaseObserver_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ReplicaSession* __servant = dynamic_cast< ::IceGrid::ReplicaSession*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->setDatabaseObserver(dbObs, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ReplicaSession::setEndpoints(const ::IceGrid::StringObjectProxyDict& endpoints, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__setEndpoints_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ReplicaSession* __servant = dynamic_cast< ::IceGrid::ReplicaSession*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->setEndpoints(endpoints, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ReplicaSession::registerWellKnownObjects(const ::IceGrid::ObjectInfoSeq& objects, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__registerWellKnownObjects_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ReplicaSession* __servant = dynamic_cast< ::IceGrid::ReplicaSession*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->registerWellKnownObjects(objects, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ReplicaSession::setAdapterDirectProxy(const ::std::string& adapterId, const ::std::string& replicaGroupId, const ::Ice::ObjectPrx& proxy, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__setAdapterDirectProxy_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ReplicaSession* __servant = dynamic_cast< ::IceGrid::ReplicaSession*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->setAdapterDirectProxy(adapterId, replicaGroupId, proxy, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ReplicaSession::receivedUpdate(::IceGrid::TopicName name, ::Ice::Int serial, const ::std::string& failure, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__receivedUpdate_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ReplicaSession* __servant = dynamic_cast< ::IceGrid::ReplicaSession*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->receivedUpdate(name, serial, failure, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

void
IceDelegateD::IceGrid::ReplicaSession::destroy(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__ReplicaSession__destroy_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::ReplicaSession* __servant = dynamic_cast< ::IceGrid::ReplicaSession*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->destroy(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::IceGrid::NodeSessionPrx
IceDelegateD::IceGrid::InternalRegistry::registerNode(const ::IceGrid::InternalNodeInfoPtr& info, const ::IceGrid::NodePrx& prx, const ::IceGrid::LoadInfo& loadInf, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__InternalRegistry__registerNode_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceGrid::NodeSessionPrx __ret;
        try
        {
            ::IceGrid::InternalRegistry* __servant = dynamic_cast< ::IceGrid::InternalRegistry*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->registerNode(info, prx, loadInf, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::IceGrid::ReplicaSessionPrx
IceDelegateD::IceGrid::InternalRegistry::registerReplica(const ::IceGrid::InternalReplicaInfoPtr& info, const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__InternalRegistry__registerReplica_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceGrid::ReplicaSessionPrx __ret;
        try
        {
            ::IceGrid::InternalRegistry* __servant = dynamic_cast< ::IceGrid::InternalRegistry*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->registerReplica(info, prx, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::IceGrid::InternalRegistry::registerWithReplica(const ::IceGrid::InternalRegistryPrx& prx, const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__InternalRegistry__registerWithReplica_name, ::Ice::Normal, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::InternalRegistry* __servant = dynamic_cast< ::IceGrid::InternalRegistry*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->registerWithReplica(prx, __current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

::IceGrid::NodePrxSeq
IceDelegateD::IceGrid::InternalRegistry::getNodes(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__InternalRegistry__getNodes_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceGrid::NodePrxSeq __ret;
        try
        {
            ::IceGrid::InternalRegistry* __servant = dynamic_cast< ::IceGrid::InternalRegistry*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getNodes(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

::IceGrid::InternalRegistryPrxSeq
IceDelegateD::IceGrid::InternalRegistry::getReplicas(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__InternalRegistry__getReplicas_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        ::IceGrid::InternalRegistryPrxSeq __ret;
        try
        {
            ::IceGrid::InternalRegistry* __servant = dynamic_cast< ::IceGrid::InternalRegistry*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __ret = __servant->getReplicas(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return __ret;
    }
}

void
IceDelegateD::IceGrid::InternalRegistry::shutdown(const ::Ice::Context* __context)
{
    ::Ice::Current __current;
    __initCurrent(__current, __IceGrid__InternalRegistry__shutdown_name, ::Ice::Idempotent, __context);
    while(true)
    {
        ::IceInternal::Direct __direct(__current);
        try
        {
            ::IceGrid::InternalRegistry* __servant = dynamic_cast< ::IceGrid::InternalRegistry*>(__direct.servant().get());
            if(!__servant)
            {
                ::Ice::OperationNotExistException __opEx(__FILE__, __LINE__);
                __opEx.id = __current.id;
                __opEx.facet = __current.facet;
                __opEx.operation = __current.operation;
                throw __opEx;
            }
            try
            {
                __servant->shutdown(__current);
            }
            catch(const ::Ice::LocalException& __ex)
            {
                throw ::IceInternal::LocalExceptionWrapper(__ex, false);
            }
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
        return;
    }
}

IceGrid::InternalDbEnvDescriptor::InternalDbEnvDescriptor(const ::std::string& __ice_name, const ::IceGrid::PropertyDescriptorSeq& __ice_properties) :
    name(__ice_name),
    properties(__ice_properties)
{
}

::Ice::ObjectPtr
IceGrid::InternalDbEnvDescriptor::ice_clone() const
{
    ::IceGrid::InternalDbEnvDescriptorPtr __p = new ::IceGrid::InternalDbEnvDescriptor(*this);
    return __p;
}

static const ::std::string __IceGrid__InternalDbEnvDescriptor_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::InternalDbEnvDescriptor"
};

bool
IceGrid::InternalDbEnvDescriptor::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__InternalDbEnvDescriptor_ids, __IceGrid__InternalDbEnvDescriptor_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::InternalDbEnvDescriptor::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__InternalDbEnvDescriptor_ids[0], &__IceGrid__InternalDbEnvDescriptor_ids[2]);
}

const ::std::string&
IceGrid::InternalDbEnvDescriptor::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__InternalDbEnvDescriptor_ids[1];
}

const ::std::string&
IceGrid::InternalDbEnvDescriptor::ice_staticId()
{
    return __IceGrid__InternalDbEnvDescriptor_ids[1];
}

void
IceGrid::InternalDbEnvDescriptor::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(name);
    if(properties.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceGrid::__write(__os, &properties[0], &properties[0] + properties.size(), ::IceGrid::__U__PropertyDescriptorSeq());
    }
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::InternalDbEnvDescriptor::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(name);
    ::IceGrid::__read(__is, properties, ::IceGrid::__U__PropertyDescriptorSeq());
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::InternalDbEnvDescriptor::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalDbEnvDescriptor was not generated with stream support";
    throw ex;
}

void
IceGrid::InternalDbEnvDescriptor::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalDbEnvDescriptor was not generated with stream support";
    throw ex;
}

class __F__IceGrid__InternalDbEnvDescriptor : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::IceGrid::InternalDbEnvDescriptor::ice_staticId());
        return new ::IceGrid::InternalDbEnvDescriptor;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__IceGrid__InternalDbEnvDescriptor_Ptr = new __F__IceGrid__InternalDbEnvDescriptor;

const ::Ice::ObjectFactoryPtr&
IceGrid::InternalDbEnvDescriptor::ice_factory()
{
    return __F__IceGrid__InternalDbEnvDescriptor_Ptr;
}

class __F__IceGrid__InternalDbEnvDescriptor__Init
{
public:

    __F__IceGrid__InternalDbEnvDescriptor__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::IceGrid::InternalDbEnvDescriptor::ice_staticId(), ::IceGrid::InternalDbEnvDescriptor::ice_factory());
    }

    ~__F__IceGrid__InternalDbEnvDescriptor__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::IceGrid::InternalDbEnvDescriptor::ice_staticId());
    }
};

static __F__IceGrid__InternalDbEnvDescriptor__Init __F__IceGrid__InternalDbEnvDescriptor__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__InternalDbEnvDescriptor__initializer() {} }
#endif

void ICE_GRID_API 
IceGrid::__patch__InternalDbEnvDescriptorPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::InternalDbEnvDescriptorPtr* p = static_cast< ::IceGrid::InternalDbEnvDescriptorPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::InternalDbEnvDescriptorPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::InternalDbEnvDescriptor::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::InternalDbEnvDescriptor& l, const ::IceGrid::InternalDbEnvDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::InternalDbEnvDescriptor& l, const ::IceGrid::InternalDbEnvDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::InternalDbEnvDescriptor& l, const ::IceGrid::InternalDbEnvDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::InternalDbEnvDescriptor& l, const ::IceGrid::InternalDbEnvDescriptor& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::InternalDbEnvDescriptor& l, const ::IceGrid::InternalDbEnvDescriptor& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::InternalDbEnvDescriptor& l, const ::IceGrid::InternalDbEnvDescriptor& r)
{
    return !(l < r);
}

IceGrid::InternalAdapterDescriptor::InternalAdapterDescriptor(const ::std::string& __ice_id, bool __ice_serverLifetime) :
    id(__ice_id),
    serverLifetime(__ice_serverLifetime)
{
}

::Ice::ObjectPtr
IceGrid::InternalAdapterDescriptor::ice_clone() const
{
    ::IceGrid::InternalAdapterDescriptorPtr __p = new ::IceGrid::InternalAdapterDescriptor(*this);
    return __p;
}

static const ::std::string __IceGrid__InternalAdapterDescriptor_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::InternalAdapterDescriptor"
};

bool
IceGrid::InternalAdapterDescriptor::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__InternalAdapterDescriptor_ids, __IceGrid__InternalAdapterDescriptor_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::InternalAdapterDescriptor::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__InternalAdapterDescriptor_ids[0], &__IceGrid__InternalAdapterDescriptor_ids[2]);
}

const ::std::string&
IceGrid::InternalAdapterDescriptor::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__InternalAdapterDescriptor_ids[1];
}

const ::std::string&
IceGrid::InternalAdapterDescriptor::ice_staticId()
{
    return __IceGrid__InternalAdapterDescriptor_ids[1];
}

void
IceGrid::InternalAdapterDescriptor::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(id);
    __os->write(serverLifetime);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::InternalAdapterDescriptor::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(id);
    __is->read(serverLifetime);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::InternalAdapterDescriptor::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalAdapterDescriptor was not generated with stream support";
    throw ex;
}

void
IceGrid::InternalAdapterDescriptor::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalAdapterDescriptor was not generated with stream support";
    throw ex;
}

class __F__IceGrid__InternalAdapterDescriptor : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::IceGrid::InternalAdapterDescriptor::ice_staticId());
        return new ::IceGrid::InternalAdapterDescriptor;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__IceGrid__InternalAdapterDescriptor_Ptr = new __F__IceGrid__InternalAdapterDescriptor;

const ::Ice::ObjectFactoryPtr&
IceGrid::InternalAdapterDescriptor::ice_factory()
{
    return __F__IceGrid__InternalAdapterDescriptor_Ptr;
}

class __F__IceGrid__InternalAdapterDescriptor__Init
{
public:

    __F__IceGrid__InternalAdapterDescriptor__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::IceGrid::InternalAdapterDescriptor::ice_staticId(), ::IceGrid::InternalAdapterDescriptor::ice_factory());
    }

    ~__F__IceGrid__InternalAdapterDescriptor__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::IceGrid::InternalAdapterDescriptor::ice_staticId());
    }
};

static __F__IceGrid__InternalAdapterDescriptor__Init __F__IceGrid__InternalAdapterDescriptor__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__InternalAdapterDescriptor__initializer() {} }
#endif

void ICE_GRID_API 
IceGrid::__patch__InternalAdapterDescriptorPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::InternalAdapterDescriptorPtr* p = static_cast< ::IceGrid::InternalAdapterDescriptorPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::InternalAdapterDescriptorPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::InternalAdapterDescriptor::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::InternalAdapterDescriptor& l, const ::IceGrid::InternalAdapterDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::InternalAdapterDescriptor& l, const ::IceGrid::InternalAdapterDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::InternalAdapterDescriptor& l, const ::IceGrid::InternalAdapterDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::InternalAdapterDescriptor& l, const ::IceGrid::InternalAdapterDescriptor& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::InternalAdapterDescriptor& l, const ::IceGrid::InternalAdapterDescriptor& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::InternalAdapterDescriptor& l, const ::IceGrid::InternalAdapterDescriptor& r)
{
    return !(l < r);
}

IceGrid::InternalDistributionDescriptor::InternalDistributionDescriptor(const ::std::string& __ice_icepatch, const ::Ice::StringSeq& __ice_directories) :
    icepatch(__ice_icepatch),
    directories(__ice_directories)
{
}

::Ice::ObjectPtr
IceGrid::InternalDistributionDescriptor::ice_clone() const
{
    ::IceGrid::InternalDistributionDescriptorPtr __p = new ::IceGrid::InternalDistributionDescriptor(*this);
    return __p;
}

static const ::std::string __IceGrid__InternalDistributionDescriptor_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::InternalDistributionDescriptor"
};

bool
IceGrid::InternalDistributionDescriptor::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__InternalDistributionDescriptor_ids, __IceGrid__InternalDistributionDescriptor_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::InternalDistributionDescriptor::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__InternalDistributionDescriptor_ids[0], &__IceGrid__InternalDistributionDescriptor_ids[2]);
}

const ::std::string&
IceGrid::InternalDistributionDescriptor::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__InternalDistributionDescriptor_ids[1];
}

const ::std::string&
IceGrid::InternalDistributionDescriptor::ice_staticId()
{
    return __IceGrid__InternalDistributionDescriptor_ids[1];
}

void
IceGrid::InternalDistributionDescriptor::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(icepatch);
    if(directories.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&directories[0], &directories[0] + directories.size());
    }
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::InternalDistributionDescriptor::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(icepatch);
    __is->read(directories);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::InternalDistributionDescriptor::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalDistributionDescriptor was not generated with stream support";
    throw ex;
}

void
IceGrid::InternalDistributionDescriptor::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalDistributionDescriptor was not generated with stream support";
    throw ex;
}

class __F__IceGrid__InternalDistributionDescriptor : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::IceGrid::InternalDistributionDescriptor::ice_staticId());
        return new ::IceGrid::InternalDistributionDescriptor;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__IceGrid__InternalDistributionDescriptor_Ptr = new __F__IceGrid__InternalDistributionDescriptor;

const ::Ice::ObjectFactoryPtr&
IceGrid::InternalDistributionDescriptor::ice_factory()
{
    return __F__IceGrid__InternalDistributionDescriptor_Ptr;
}

class __F__IceGrid__InternalDistributionDescriptor__Init
{
public:

    __F__IceGrid__InternalDistributionDescriptor__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::IceGrid::InternalDistributionDescriptor::ice_staticId(), ::IceGrid::InternalDistributionDescriptor::ice_factory());
    }

    ~__F__IceGrid__InternalDistributionDescriptor__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::IceGrid::InternalDistributionDescriptor::ice_staticId());
    }
};

static __F__IceGrid__InternalDistributionDescriptor__Init __F__IceGrid__InternalDistributionDescriptor__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__InternalDistributionDescriptor__initializer() {} }
#endif

void ICE_GRID_API 
IceGrid::__patch__InternalDistributionDescriptorPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::InternalDistributionDescriptorPtr* p = static_cast< ::IceGrid::InternalDistributionDescriptorPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::InternalDistributionDescriptorPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::InternalDistributionDescriptor::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::InternalDistributionDescriptor& l, const ::IceGrid::InternalDistributionDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::InternalDistributionDescriptor& l, const ::IceGrid::InternalDistributionDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::InternalDistributionDescriptor& l, const ::IceGrid::InternalDistributionDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::InternalDistributionDescriptor& l, const ::IceGrid::InternalDistributionDescriptor& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::InternalDistributionDescriptor& l, const ::IceGrid::InternalDistributionDescriptor& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::InternalDistributionDescriptor& l, const ::IceGrid::InternalDistributionDescriptor& r)
{
    return !(l < r);
}

IceGrid::InternalServerDescriptor::InternalServerDescriptor(const ::std::string& __ice_id, const ::std::string& __ice_application, const ::std::string& __ice_uuid, ::Ice::Int __ice_revision, const ::std::string& __ice_sessionId, const ::std::string& __ice_exe, const ::std::string& __ice_pwd, const ::std::string& __ice_user, const ::std::string& __ice_activation, const ::std::string& __ice_activationTimeout, const ::std::string& __ice_deactivationTimeout, bool __ice_applicationDistrib, const ::IceGrid::InternalDistributionDescriptorPtr& __ice_distrib, bool __ice_processRegistered, const ::Ice::StringSeq& __ice_options, const ::Ice::StringSeq& __ice_envs, const ::Ice::StringSeq& __ice_logs, const ::IceGrid::InternalAdapterDescriptorSeq& __ice_adapters, const ::IceGrid::InternalDbEnvDescriptorSeq& __ice_dbEnvs, const ::IceGrid::PropertyDescriptorSeqDict& __ice_properties) :
    id(__ice_id),
    application(__ice_application),
    uuid(__ice_uuid),
    revision(__ice_revision),
    sessionId(__ice_sessionId),
    exe(__ice_exe),
    pwd(__ice_pwd),
    user(__ice_user),
    activation(__ice_activation),
    activationTimeout(__ice_activationTimeout),
    deactivationTimeout(__ice_deactivationTimeout),
    applicationDistrib(__ice_applicationDistrib),
    distrib(__ice_distrib),
    processRegistered(__ice_processRegistered),
    options(__ice_options),
    envs(__ice_envs),
    logs(__ice_logs),
    adapters(__ice_adapters),
    dbEnvs(__ice_dbEnvs),
    properties(__ice_properties)
{
}

::Ice::ObjectPtr
IceGrid::InternalServerDescriptor::ice_clone() const
{
    ::IceGrid::InternalServerDescriptorPtr __p = new ::IceGrid::InternalServerDescriptor(*this);
    return __p;
}

static const ::std::string __IceGrid__InternalServerDescriptor_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::InternalServerDescriptor"
};

bool
IceGrid::InternalServerDescriptor::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__InternalServerDescriptor_ids, __IceGrid__InternalServerDescriptor_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::InternalServerDescriptor::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__InternalServerDescriptor_ids[0], &__IceGrid__InternalServerDescriptor_ids[2]);
}

const ::std::string&
IceGrid::InternalServerDescriptor::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__InternalServerDescriptor_ids[1];
}

const ::std::string&
IceGrid::InternalServerDescriptor::ice_staticId()
{
    return __IceGrid__InternalServerDescriptor_ids[1];
}

void
IceGrid::InternalServerDescriptor::__incRef()
{
    __gcIncRef();
}

void
IceGrid::InternalServerDescriptor::__decRef()
{
    __gcDecRef();
}

void
IceGrid::InternalServerDescriptor::__addObject(::IceInternal::GCCountMap& _c)
{
    ::IceInternal::GCCountMap::iterator pos = _c.find(this);
    if(pos == _c.end())
    {
        _c[this] = 1;
    }
    else
    {
        ++pos->second;
    }
}

bool
IceGrid::InternalServerDescriptor::__usesClasses()
{
    return true;
}

void
IceGrid::InternalServerDescriptor::__gcReachable(::IceInternal::GCCountMap& _c) const
{
    if(distrib)
    {
        ::IceGrid::__addObject(distrib, _c);
    }
    {
        for(::IceGrid::InternalAdapterDescriptorSeq::const_iterator _i0 = adapters.begin(); _i0 != adapters.end(); ++_i0)
        {
            if((*_i0))
            {
                ::IceGrid::__addObject((*_i0), _c);
            }
        }
    }
    {
        for(::IceGrid::InternalDbEnvDescriptorSeq::const_iterator _i0 = dbEnvs.begin(); _i0 != dbEnvs.end(); ++_i0)
        {
            if((*_i0))
            {
                ::IceGrid::__addObject((*_i0), _c);
            }
        }
    }
}

void
IceGrid::InternalServerDescriptor::__gcClear()
{
    if(distrib)
    {
        if(::IceGrid::__usesClasses(distrib))
        {
            ::IceGrid::__decRefUnsafe(distrib);
            ::IceGrid::__clearHandleUnsafe(distrib);
        }
        else
        {
            distrib = 0;
        }
    }
    {
        for(::IceGrid::InternalAdapterDescriptorSeq::iterator _i0 = adapters.begin(); _i0 != adapters.end(); ++_i0)
        {
            if((*_i0))
            {
                if(::IceGrid::__usesClasses((*_i0)))
                {
                    ::IceGrid::__decRefUnsafe((*_i0));
                    ::IceGrid::__clearHandleUnsafe((*_i0));
                }
                else
                {
                    (*_i0) = 0;
                }
            }
        }
    }
    {
        for(::IceGrid::InternalDbEnvDescriptorSeq::iterator _i0 = dbEnvs.begin(); _i0 != dbEnvs.end(); ++_i0)
        {
            if((*_i0))
            {
                if(::IceGrid::__usesClasses((*_i0)))
                {
                    ::IceGrid::__decRefUnsafe((*_i0));
                    ::IceGrid::__clearHandleUnsafe((*_i0));
                }
                else
                {
                    (*_i0) = 0;
                }
            }
        }
    }
}

void
IceGrid::InternalServerDescriptor::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(id);
    __os->write(application);
    __os->write(uuid);
    __os->write(revision);
    __os->write(sessionId);
    __os->write(exe);
    __os->write(pwd);
    __os->write(user);
    __os->write(activation);
    __os->write(activationTimeout);
    __os->write(deactivationTimeout);
    __os->write(applicationDistrib);
    ::IceGrid::__write(__os, distrib);
    __os->write(processRegistered);
    if(options.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&options[0], &options[0] + options.size());
    }
    if(envs.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&envs[0], &envs[0] + envs.size());
    }
    if(logs.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&logs[0], &logs[0] + logs.size());
    }
    if(adapters.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceGrid::__write(__os, &adapters[0], &adapters[0] + adapters.size(), ::IceGrid::__U__InternalAdapterDescriptorSeq());
    }
    if(dbEnvs.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceGrid::__write(__os, &dbEnvs[0], &dbEnvs[0] + dbEnvs.size(), ::IceGrid::__U__InternalDbEnvDescriptorSeq());
    }
    ::IceGrid::__write(__os, properties, ::IceGrid::__U__PropertyDescriptorSeqDict());
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::InternalServerDescriptor::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(id);
    __is->read(application);
    __is->read(uuid);
    __is->read(revision);
    __is->read(sessionId);
    __is->read(exe);
    __is->read(pwd);
    __is->read(user);
    __is->read(activation);
    __is->read(activationTimeout);
    __is->read(deactivationTimeout);
    __is->read(applicationDistrib);
    __is->read(::IceGrid::__patch__InternalDistributionDescriptorPtr, &distrib);
    __is->read(processRegistered);
    __is->read(options);
    __is->read(envs);
    __is->read(logs);
    ::IceGrid::__read(__is, adapters, ::IceGrid::__U__InternalAdapterDescriptorSeq());
    ::IceGrid::__read(__is, dbEnvs, ::IceGrid::__U__InternalDbEnvDescriptorSeq());
    ::IceGrid::__read(__is, properties, ::IceGrid::__U__PropertyDescriptorSeqDict());
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::InternalServerDescriptor::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalServerDescriptor was not generated with stream support";
    throw ex;
}

void
IceGrid::InternalServerDescriptor::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalServerDescriptor was not generated with stream support";
    throw ex;
}

class __F__IceGrid__InternalServerDescriptor : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::IceGrid::InternalServerDescriptor::ice_staticId());
        return new ::IceGrid::InternalServerDescriptor;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__IceGrid__InternalServerDescriptor_Ptr = new __F__IceGrid__InternalServerDescriptor;

const ::Ice::ObjectFactoryPtr&
IceGrid::InternalServerDescriptor::ice_factory()
{
    return __F__IceGrid__InternalServerDescriptor_Ptr;
}

class __F__IceGrid__InternalServerDescriptor__Init
{
public:

    __F__IceGrid__InternalServerDescriptor__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::IceGrid::InternalServerDescriptor::ice_staticId(), ::IceGrid::InternalServerDescriptor::ice_factory());
    }

    ~__F__IceGrid__InternalServerDescriptor__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::IceGrid::InternalServerDescriptor::ice_staticId());
    }
};

static __F__IceGrid__InternalServerDescriptor__Init __F__IceGrid__InternalServerDescriptor__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__InternalServerDescriptor__initializer() {} }
#endif

void ICE_GRID_API 
IceGrid::__patch__InternalServerDescriptorPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::InternalServerDescriptorPtr* p = static_cast< ::IceGrid::InternalServerDescriptorPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::InternalServerDescriptorPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::InternalServerDescriptor::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::InternalServerDescriptor& l, const ::IceGrid::InternalServerDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::InternalServerDescriptor& l, const ::IceGrid::InternalServerDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::InternalServerDescriptor& l, const ::IceGrid::InternalServerDescriptor& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::InternalServerDescriptor& l, const ::IceGrid::InternalServerDescriptor& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::InternalServerDescriptor& l, const ::IceGrid::InternalServerDescriptor& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::InternalServerDescriptor& l, const ::IceGrid::InternalServerDescriptor& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceGrid::Adapter::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__Adapter_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::Adapter"
};

bool
IceGrid::Adapter::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__Adapter_ids, __IceGrid__Adapter_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::Adapter::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__Adapter_ids[0], &__IceGrid__Adapter_ids[2]);
}

const ::std::string&
IceGrid::Adapter::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__Adapter_ids[1];
}

const ::std::string&
IceGrid::Adapter::ice_staticId()
{
    return __IceGrid__Adapter_ids[1];
}

::IceInternal::DispatchStatus
IceGrid::Adapter::___activate(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceGrid::AMD_Adapter_activatePtr __cb = new IceAsync::IceGrid::AMD_Adapter_activate(__inS);
    try
    {
        activate_async(__cb, __current);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::IceInternal::DispatchAsync;
}

::IceInternal::DispatchStatus
IceGrid::Adapter::___getDirectProxy(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Ice::ObjectPrx __ret = getDirectProxy(__current);
        __os->write(__ret);
    }
    catch(const ::IceGrid::AdapterNotActiveException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Adapter::___setDirectProxy(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    try
    {
        setDirectProxy(proxy, __current);
    }
    catch(const ::IceGrid::AdapterActiveException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__Adapter_all[] =
{
    "activate",
    "getDirectProxy",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "setDirectProxy"
};

::IceInternal::DispatchStatus
IceGrid::Adapter::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__Adapter_all, __IceGrid__Adapter_all + 7, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__Adapter_all)
    {
        case 0:
        {
            return ___activate(in, current);
        }
        case 1:
        {
            return ___getDirectProxy(in, current);
        }
        case 2:
        {
            return ___ice_id(in, current);
        }
        case 3:
        {
            return ___ice_ids(in, current);
        }
        case 4:
        {
            return ___ice_isA(in, current);
        }
        case 5:
        {
            return ___ice_ping(in, current);
        }
        case 6:
        {
            return ___setDirectProxy(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::Adapter::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::Adapter::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::Adapter::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Adapter was not generated with stream support";
    throw ex;
}

void
IceGrid::Adapter::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Adapter was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__AdapterPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::AdapterPtr* p = static_cast< ::IceGrid::AdapterPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::AdapterPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::Adapter::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::Adapter& l, const ::IceGrid::Adapter& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::Adapter& l, const ::IceGrid::Adapter& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::Adapter& l, const ::IceGrid::Adapter& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::Adapter& l, const ::IceGrid::Adapter& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::Adapter& l, const ::IceGrid::Adapter& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::Adapter& l, const ::IceGrid::Adapter& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceGrid::FileReader::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__FileReader_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::FileReader"
};

bool
IceGrid::FileReader::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__FileReader_ids, __IceGrid__FileReader_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::FileReader::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__FileReader_ids[0], &__IceGrid__FileReader_ids[2]);
}

const ::std::string&
IceGrid::FileReader::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__FileReader_ids[1];
}

const ::std::string&
IceGrid::FileReader::ice_staticId()
{
    return __IceGrid__FileReader_ids[1];
}

::IceInternal::DispatchStatus
IceGrid::FileReader::___getOffsetFromEnd(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string filename;
    ::Ice::Int lines;
    __is->read(filename);
    __is->read(lines);
    try
    {
        ::Ice::Long __ret = getOffsetFromEnd(filename, lines, __current);
        __os->write(__ret);
    }
    catch(const ::IceGrid::FileNotAvailableException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::FileReader::___read(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string filename;
    ::Ice::Long pos;
    ::Ice::Int size;
    __is->read(filename);
    __is->read(pos);
    __is->read(size);
    ::Ice::Long newPos;
    ::Ice::StringSeq lines;
    try
    {
        bool __ret = read(filename, pos, size, newPos, lines, __current);
        __os->write(newPos);
        if(lines.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            __os->write(&lines[0], &lines[0] + lines.size());
        }
        __os->write(__ret);
    }
    catch(const ::IceGrid::FileNotAvailableException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__FileReader_all[] =
{
    "getOffsetFromEnd",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "read"
};

::IceInternal::DispatchStatus
IceGrid::FileReader::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__FileReader_all, __IceGrid__FileReader_all + 6, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__FileReader_all)
    {
        case 0:
        {
            return ___getOffsetFromEnd(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
        case 5:
        {
            return ___read(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::FileReader::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::FileReader::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::FileReader::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::FileReader was not generated with stream support";
    throw ex;
}

void
IceGrid::FileReader::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::FileReader was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__FileReaderPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::FileReaderPtr* p = static_cast< ::IceGrid::FileReaderPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::FileReaderPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::FileReader::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::FileReader& l, const ::IceGrid::FileReader& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::FileReader& l, const ::IceGrid::FileReader& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::FileReader& l, const ::IceGrid::FileReader& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::FileReader& l, const ::IceGrid::FileReader& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::FileReader& l, const ::IceGrid::FileReader& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::FileReader& l, const ::IceGrid::FileReader& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceGrid::Server::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__Server_ids[3] =
{
    "::Ice::Object",
    "::IceGrid::FileReader",
    "::IceGrid::Server"
};

bool
IceGrid::Server::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__Server_ids, __IceGrid__Server_ids + 3, _s);
}

::std::vector< ::std::string>
IceGrid::Server::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__Server_ids[0], &__IceGrid__Server_ids[3]);
}

const ::std::string&
IceGrid::Server::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__Server_ids[2];
}

const ::std::string&
IceGrid::Server::ice_staticId()
{
    return __IceGrid__Server_ids[2];
}

::IceInternal::DispatchStatus
IceGrid::Server::___start(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceGrid::AMD_Server_startPtr __cb = new IceAsync::IceGrid::AMD_Server_start(__inS);
    try
    {
        start_async(__cb, __current);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::IceInternal::DispatchAsync;
}

::IceInternal::DispatchStatus
IceGrid::Server::___stop(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceGrid::AMD_Server_stopPtr __cb = new IceAsync::IceGrid::AMD_Server_stop(__inS);
    try
    {
        stop_async(__cb, __current);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::IceInternal::DispatchAsync;
}

::IceInternal::DispatchStatus
IceGrid::Server::___setEnabled(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    bool enable;
    __is->read(enable);
    setEnabled(enable, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Server::___isEnabled(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    bool __ret = isEnabled(__current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Server::___sendSignal(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string signal;
    __is->read(signal);
    try
    {
        sendSignal(signal, __current);
    }
    catch(const ::IceGrid::BadSignalException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Server::___writeMessage(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::std::string message;
    ::Ice::Int fd;
    __is->read(message);
    __is->read(fd);
    writeMessage(message, fd, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Server::___getState(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceGrid::ServerState __ret = getState(__current);
    ::IceGrid::__write(__os, __ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Server::___getPid(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Int __ret = getPid(__current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Server::___setProcess(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::Ice::ProcessPrx proc;
    ::Ice::__read(__is, proc);
    ::IceGrid::AMD_Server_setProcessPtr __cb = new IceAsync::IceGrid::AMD_Server_setProcess(__inS);
    try
    {
        setProcess_async(__cb, proc, __current);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::IceInternal::DispatchAsync;
}

static ::std::string __IceGrid__Server_all[] =
{
    "getOffsetFromEnd",
    "getPid",
    "getState",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "isEnabled",
    "read",
    "sendSignal",
    "setEnabled",
    "setProcess",
    "start",
    "stop",
    "writeMessage"
};

::IceInternal::DispatchStatus
IceGrid::Server::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__Server_all, __IceGrid__Server_all + 15, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__Server_all)
    {
        case 0:
        {
            return ___getOffsetFromEnd(in, current);
        }
        case 1:
        {
            return ___getPid(in, current);
        }
        case 2:
        {
            return ___getState(in, current);
        }
        case 3:
        {
            return ___ice_id(in, current);
        }
        case 4:
        {
            return ___ice_ids(in, current);
        }
        case 5:
        {
            return ___ice_isA(in, current);
        }
        case 6:
        {
            return ___ice_ping(in, current);
        }
        case 7:
        {
            return ___isEnabled(in, current);
        }
        case 8:
        {
            return ___read(in, current);
        }
        case 9:
        {
            return ___sendSignal(in, current);
        }
        case 10:
        {
            return ___setEnabled(in, current);
        }
        case 11:
        {
            return ___setProcess(in, current);
        }
        case 12:
        {
            return ___start(in, current);
        }
        case 13:
        {
            return ___stop(in, current);
        }
        case 14:
        {
            return ___writeMessage(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::Server::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::Server::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::Server::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Server was not generated with stream support";
    throw ex;
}

void
IceGrid::Server::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Server was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__ServerPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::ServerPtr* p = static_cast< ::IceGrid::ServerPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::ServerPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::Server::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::Server& l, const ::IceGrid::Server& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::Server& l, const ::IceGrid::Server& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::Server& l, const ::IceGrid::Server& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::Server& l, const ::IceGrid::Server& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::Server& l, const ::IceGrid::Server& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::Server& l, const ::IceGrid::Server& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceGrid::ReplicaObserver::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__ReplicaObserver_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::ReplicaObserver"
};

bool
IceGrid::ReplicaObserver::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__ReplicaObserver_ids, __IceGrid__ReplicaObserver_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::ReplicaObserver::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__ReplicaObserver_ids[0], &__IceGrid__ReplicaObserver_ids[2]);
}

const ::std::string&
IceGrid::ReplicaObserver::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__ReplicaObserver_ids[1];
}

const ::std::string&
IceGrid::ReplicaObserver::ice_staticId()
{
    return __IceGrid__ReplicaObserver_ids[1];
}

::IceInternal::DispatchStatus
IceGrid::ReplicaObserver::___replicaInit(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::InternalRegistryPrxSeq replicas;
    ::IceGrid::__read(__is, replicas, ::IceGrid::__U__InternalRegistryPrxSeq());
    replicaInit(replicas, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::ReplicaObserver::___replicaAdded(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::InternalRegistryPrx replica;
    ::IceGrid::__read(__is, replica);
    replicaAdded(replica, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::ReplicaObserver::___replicaRemoved(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::InternalRegistryPrx replica;
    ::IceGrid::__read(__is, replica);
    replicaRemoved(replica, __current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__ReplicaObserver_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "replicaAdded",
    "replicaInit",
    "replicaRemoved"
};

::IceInternal::DispatchStatus
IceGrid::ReplicaObserver::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__ReplicaObserver_all, __IceGrid__ReplicaObserver_all + 7, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__ReplicaObserver_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___replicaAdded(in, current);
        }
        case 5:
        {
            return ___replicaInit(in, current);
        }
        case 6:
        {
            return ___replicaRemoved(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::ReplicaObserver::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::ReplicaObserver::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::ReplicaObserver::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ReplicaObserver was not generated with stream support";
    throw ex;
}

void
IceGrid::ReplicaObserver::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ReplicaObserver was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__ReplicaObserverPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::ReplicaObserverPtr* p = static_cast< ::IceGrid::ReplicaObserverPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::ReplicaObserverPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::ReplicaObserver::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::ReplicaObserver& l, const ::IceGrid::ReplicaObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::ReplicaObserver& l, const ::IceGrid::ReplicaObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::ReplicaObserver& l, const ::IceGrid::ReplicaObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::ReplicaObserver& l, const ::IceGrid::ReplicaObserver& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::ReplicaObserver& l, const ::IceGrid::ReplicaObserver& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::ReplicaObserver& l, const ::IceGrid::ReplicaObserver& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceGrid::PatcherFeedback::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__PatcherFeedback_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::PatcherFeedback"
};

bool
IceGrid::PatcherFeedback::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__PatcherFeedback_ids, __IceGrid__PatcherFeedback_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::PatcherFeedback::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__PatcherFeedback_ids[0], &__IceGrid__PatcherFeedback_ids[2]);
}

const ::std::string&
IceGrid::PatcherFeedback::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__PatcherFeedback_ids[1];
}

const ::std::string&
IceGrid::PatcherFeedback::ice_staticId()
{
    return __IceGrid__PatcherFeedback_ids[1];
}

::IceInternal::DispatchStatus
IceGrid::PatcherFeedback::___finished(::IceInternal::Incoming&, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    finished(__current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::PatcherFeedback::___failed(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::std::string reason;
    __is->read(reason);
    failed(reason, __current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__PatcherFeedback_all[] =
{
    "failed",
    "finished",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
IceGrid::PatcherFeedback::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__PatcherFeedback_all, __IceGrid__PatcherFeedback_all + 6, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__PatcherFeedback_all)
    {
        case 0:
        {
            return ___failed(in, current);
        }
        case 1:
        {
            return ___finished(in, current);
        }
        case 2:
        {
            return ___ice_id(in, current);
        }
        case 3:
        {
            return ___ice_ids(in, current);
        }
        case 4:
        {
            return ___ice_isA(in, current);
        }
        case 5:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::PatcherFeedback::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::PatcherFeedback::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::PatcherFeedback::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::PatcherFeedback was not generated with stream support";
    throw ex;
}

void
IceGrid::PatcherFeedback::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::PatcherFeedback was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__PatcherFeedbackPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::PatcherFeedbackPtr* p = static_cast< ::IceGrid::PatcherFeedbackPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::PatcherFeedbackPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::PatcherFeedback::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::PatcherFeedback& l, const ::IceGrid::PatcherFeedback& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::PatcherFeedback& l, const ::IceGrid::PatcherFeedback& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::PatcherFeedback& l, const ::IceGrid::PatcherFeedback& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::PatcherFeedback& l, const ::IceGrid::PatcherFeedback& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::PatcherFeedback& l, const ::IceGrid::PatcherFeedback& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::PatcherFeedback& l, const ::IceGrid::PatcherFeedback& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceGrid::Node::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__Node_ids[4] =
{
    "::Ice::Object",
    "::IceGrid::FileReader",
    "::IceGrid::Node",
    "::IceGrid::ReplicaObserver"
};

bool
IceGrid::Node::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__Node_ids, __IceGrid__Node_ids + 4, _s);
}

::std::vector< ::std::string>
IceGrid::Node::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__Node_ids[0], &__IceGrid__Node_ids[4]);
}

const ::std::string&
IceGrid::Node::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__Node_ids[2];
}

const ::std::string&
IceGrid::Node::ice_staticId()
{
    return __IceGrid__Node_ids[2];
}

::IceInternal::DispatchStatus
IceGrid::Node::___loadServer(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::InternalServerDescriptorPtr svr;
    ::std::string replicaName;
    __is->read(::IceGrid::__patch__InternalServerDescriptorPtr, &svr);
    __is->read(replicaName);
    __is->readPendingObjects();
    ::IceGrid::AMD_Node_loadServerPtr __cb = new IceAsync::IceGrid::AMD_Node_loadServer(__inS);
    try
    {
        loadServer_async(__cb, svr, replicaName, __current);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::IceInternal::DispatchAsync;
}

::IceInternal::DispatchStatus
IceGrid::Node::___destroyServer(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::std::string name;
    ::std::string uuid;
    ::Ice::Int revision;
    ::std::string replicaName;
    __is->read(name);
    __is->read(uuid);
    __is->read(revision);
    __is->read(replicaName);
    ::IceGrid::AMD_Node_destroyServerPtr __cb = new IceAsync::IceGrid::AMD_Node_destroyServer(__inS);
    try
    {
        destroyServer_async(__cb, name, uuid, revision, replicaName, __current);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::IceInternal::DispatchAsync;
}

::IceInternal::DispatchStatus
IceGrid::Node::___patch(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::PatcherFeedbackPrx feedback;
    ::std::string application;
    ::std::string server;
    ::IceGrid::InternalDistributionDescriptorPtr appDistrib;
    bool shutdown;
    ::IceGrid::__read(__is, feedback);
    __is->read(application);
    __is->read(server);
    __is->read(::IceGrid::__patch__InternalDistributionDescriptorPtr, &appDistrib);
    __is->read(shutdown);
    __is->readPendingObjects();
    ::IceGrid::AMD_Node_patchPtr __cb = new IceAsync::IceGrid::AMD_Node_patch(__inS);
    try
    {
        patch_async(__cb, feedback, application, server, appDistrib, shutdown, __current);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::IceInternal::DispatchAsync;
}

::IceInternal::DispatchStatus
IceGrid::Node::___registerWithReplica(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::InternalRegistryPrx replica;
    ::IceGrid::__read(__is, replica);
    registerWithReplica(replica, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Node::___getName(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string __ret = getName(__current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Node::___getHostname(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string __ret = getHostname(__current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Node::___getLoad(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceGrid::LoadInfo __ret = getLoad(__current);
    __ret.__write(__os);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::Node::___shutdown(::IceInternal::Incoming&, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    shutdown(__current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__Node_all[] =
{
    "destroyServer",
    "getHostname",
    "getLoad",
    "getName",
    "getOffsetFromEnd",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "loadServer",
    "patch",
    "read",
    "registerWithReplica",
    "replicaAdded",
    "replicaInit",
    "replicaRemoved",
    "shutdown"
};

::IceInternal::DispatchStatus
IceGrid::Node::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__Node_all, __IceGrid__Node_all + 17, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__Node_all)
    {
        case 0:
        {
            return ___destroyServer(in, current);
        }
        case 1:
        {
            return ___getHostname(in, current);
        }
        case 2:
        {
            return ___getLoad(in, current);
        }
        case 3:
        {
            return ___getName(in, current);
        }
        case 4:
        {
            return ___getOffsetFromEnd(in, current);
        }
        case 5:
        {
            return ___ice_id(in, current);
        }
        case 6:
        {
            return ___ice_ids(in, current);
        }
        case 7:
        {
            return ___ice_isA(in, current);
        }
        case 8:
        {
            return ___ice_ping(in, current);
        }
        case 9:
        {
            return ___loadServer(in, current);
        }
        case 10:
        {
            return ___patch(in, current);
        }
        case 11:
        {
            return ___read(in, current);
        }
        case 12:
        {
            return ___registerWithReplica(in, current);
        }
        case 13:
        {
            return ___replicaAdded(in, current);
        }
        case 14:
        {
            return ___replicaInit(in, current);
        }
        case 15:
        {
            return ___replicaRemoved(in, current);
        }
        case 16:
        {
            return ___shutdown(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::Node::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::Node::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::Node::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Node was not generated with stream support";
    throw ex;
}

void
IceGrid::Node::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::Node was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__NodePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::NodePtr* p = static_cast< ::IceGrid::NodePtr*>(__addr);
    assert(p);
    *p = ::IceGrid::NodePtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::Node::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::Node& l, const ::IceGrid::Node& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::Node& l, const ::IceGrid::Node& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::Node& l, const ::IceGrid::Node& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::Node& l, const ::IceGrid::Node& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::Node& l, const ::IceGrid::Node& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::Node& l, const ::IceGrid::Node& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceGrid::NodeSession::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__NodeSession_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::NodeSession"
};

bool
IceGrid::NodeSession::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__NodeSession_ids, __IceGrid__NodeSession_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::NodeSession::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__NodeSession_ids[0], &__IceGrid__NodeSession_ids[2]);
}

const ::std::string&
IceGrid::NodeSession::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__NodeSession_ids[1];
}

const ::std::string&
IceGrid::NodeSession::ice_staticId()
{
    return __IceGrid__NodeSession_ids[1];
}

::IceInternal::DispatchStatus
IceGrid::NodeSession::___keepAlive(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::LoadInfo load;
    load.__read(__is);
    keepAlive(load, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::NodeSession::___setReplicaObserver(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::ReplicaObserverPrx observer;
    ::IceGrid::__read(__is, observer);
    setReplicaObserver(observer, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::NodeSession::___getTimeout(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Int __ret = getTimeout(__current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::NodeSession::___getObserver(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceGrid::NodeObserverPrx __ret = getObserver(__current);
    ::IceGrid::__write(__os, __ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::NodeSession::___loadServers(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceGrid::AMD_NodeSession_loadServersPtr __cb = new IceAsync::IceGrid::AMD_NodeSession_loadServers(__inS);
    try
    {
        loadServers_async(__cb, __current);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::IceInternal::DispatchAsync;
}

::IceInternal::DispatchStatus
IceGrid::NodeSession::___getServers(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::StringSeq __ret = getServers(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&__ret[0], &__ret[0] + __ret.size());
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::NodeSession::___waitForApplicationUpdate(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::std::string application;
    ::Ice::Int revision;
    __is->read(application);
    __is->read(revision);
    ::IceGrid::AMD_NodeSession_waitForApplicationUpdatePtr __cb = new IceAsync::IceGrid::AMD_NodeSession_waitForApplicationUpdate(__inS);
    try
    {
        waitForApplicationUpdate_async(__cb, application, revision, __current);
    }
    catch(const ::Ice::Exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::IceInternal::DispatchAsync;
}

::IceInternal::DispatchStatus
IceGrid::NodeSession::___destroy(::IceInternal::Incoming&, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    destroy(__current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__NodeSession_all[] =
{
    "destroy",
    "getObserver",
    "getServers",
    "getTimeout",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "keepAlive",
    "loadServers",
    "setReplicaObserver",
    "waitForApplicationUpdate"
};

::IceInternal::DispatchStatus
IceGrid::NodeSession::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__NodeSession_all, __IceGrid__NodeSession_all + 12, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__NodeSession_all)
    {
        case 0:
        {
            return ___destroy(in, current);
        }
        case 1:
        {
            return ___getObserver(in, current);
        }
        case 2:
        {
            return ___getServers(in, current);
        }
        case 3:
        {
            return ___getTimeout(in, current);
        }
        case 4:
        {
            return ___ice_id(in, current);
        }
        case 5:
        {
            return ___ice_ids(in, current);
        }
        case 6:
        {
            return ___ice_isA(in, current);
        }
        case 7:
        {
            return ___ice_ping(in, current);
        }
        case 8:
        {
            return ___keepAlive(in, current);
        }
        case 9:
        {
            return ___loadServers(in, current);
        }
        case 10:
        {
            return ___setReplicaObserver(in, current);
        }
        case 11:
        {
            return ___waitForApplicationUpdate(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::NodeSession::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::NodeSession::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::NodeSession::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::NodeSession was not generated with stream support";
    throw ex;
}

void
IceGrid::NodeSession::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::NodeSession was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__NodeSessionPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::NodeSessionPtr* p = static_cast< ::IceGrid::NodeSessionPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::NodeSessionPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::NodeSession::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::NodeSession& l, const ::IceGrid::NodeSession& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::NodeSession& l, const ::IceGrid::NodeSession& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::NodeSession& l, const ::IceGrid::NodeSession& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::NodeSession& l, const ::IceGrid::NodeSession& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::NodeSession& l, const ::IceGrid::NodeSession& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::NodeSession& l, const ::IceGrid::NodeSession& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceGrid::DatabaseObserver::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__DatabaseObserver_ids[5] =
{
    "::Ice::Object",
    "::IceGrid::AdapterObserver",
    "::IceGrid::ApplicationObserver",
    "::IceGrid::DatabaseObserver",
    "::IceGrid::ObjectObserver"
};

bool
IceGrid::DatabaseObserver::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__DatabaseObserver_ids, __IceGrid__DatabaseObserver_ids + 5, _s);
}

::std::vector< ::std::string>
IceGrid::DatabaseObserver::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__DatabaseObserver_ids[0], &__IceGrid__DatabaseObserver_ids[5]);
}

const ::std::string&
IceGrid::DatabaseObserver::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__DatabaseObserver_ids[3];
}

const ::std::string&
IceGrid::DatabaseObserver::ice_staticId()
{
    return __IceGrid__DatabaseObserver_ids[3];
}

static ::std::string __IceGrid__DatabaseObserver_all[] =
{
    "adapterAdded",
    "adapterInit",
    "adapterRemoved",
    "adapterUpdated",
    "applicationAdded",
    "applicationInit",
    "applicationRemoved",
    "applicationUpdated",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "objectAdded",
    "objectInit",
    "objectRemoved",
    "objectUpdated"
};

::IceInternal::DispatchStatus
IceGrid::DatabaseObserver::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__DatabaseObserver_all, __IceGrid__DatabaseObserver_all + 16, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__DatabaseObserver_all)
    {
        case 0:
        {
            return ___adapterAdded(in, current);
        }
        case 1:
        {
            return ___adapterInit(in, current);
        }
        case 2:
        {
            return ___adapterRemoved(in, current);
        }
        case 3:
        {
            return ___adapterUpdated(in, current);
        }
        case 4:
        {
            return ___applicationAdded(in, current);
        }
        case 5:
        {
            return ___applicationInit(in, current);
        }
        case 6:
        {
            return ___applicationRemoved(in, current);
        }
        case 7:
        {
            return ___applicationUpdated(in, current);
        }
        case 8:
        {
            return ___ice_id(in, current);
        }
        case 9:
        {
            return ___ice_ids(in, current);
        }
        case 10:
        {
            return ___ice_isA(in, current);
        }
        case 11:
        {
            return ___ice_ping(in, current);
        }
        case 12:
        {
            return ___objectAdded(in, current);
        }
        case 13:
        {
            return ___objectInit(in, current);
        }
        case 14:
        {
            return ___objectRemoved(in, current);
        }
        case 15:
        {
            return ___objectUpdated(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::DatabaseObserver::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::DatabaseObserver::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::DatabaseObserver::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::DatabaseObserver was not generated with stream support";
    throw ex;
}

void
IceGrid::DatabaseObserver::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::DatabaseObserver was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__DatabaseObserverPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::DatabaseObserverPtr* p = static_cast< ::IceGrid::DatabaseObserverPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::DatabaseObserverPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::DatabaseObserver::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::DatabaseObserver& l, const ::IceGrid::DatabaseObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::DatabaseObserver& l, const ::IceGrid::DatabaseObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::DatabaseObserver& l, const ::IceGrid::DatabaseObserver& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::DatabaseObserver& l, const ::IceGrid::DatabaseObserver& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::DatabaseObserver& l, const ::IceGrid::DatabaseObserver& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::DatabaseObserver& l, const ::IceGrid::DatabaseObserver& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceGrid::ReplicaSession::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__ReplicaSession_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::ReplicaSession"
};

bool
IceGrid::ReplicaSession::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__ReplicaSession_ids, __IceGrid__ReplicaSession_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::ReplicaSession::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__ReplicaSession_ids[0], &__IceGrid__ReplicaSession_ids[2]);
}

const ::std::string&
IceGrid::ReplicaSession::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__ReplicaSession_ids[1];
}

const ::std::string&
IceGrid::ReplicaSession::ice_staticId()
{
    return __IceGrid__ReplicaSession_ids[1];
}

::IceInternal::DispatchStatus
IceGrid::ReplicaSession::___keepAlive(::IceInternal::Incoming&, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    keepAlive(__current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::ReplicaSession::___getTimeout(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::Int __ret = getTimeout(__current);
    __os->write(__ret);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::ReplicaSession::___setDatabaseObserver(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::DatabaseObserverPrx dbObs;
    ::IceGrid::__read(__is, dbObs);
    setDatabaseObserver(dbObs, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::ReplicaSession::___setEndpoints(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::StringObjectProxyDict endpoints;
    ::IceGrid::__read(__is, endpoints, ::IceGrid::__U__StringObjectProxyDict());
    setEndpoints(endpoints, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::ReplicaSession::___registerWellKnownObjects(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::ObjectInfoSeq objects;
    ::IceGrid::__read(__is, objects, ::IceGrid::__U__ObjectInfoSeq());
    registerWellKnownObjects(objects, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::ReplicaSession::___setAdapterDirectProxy(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string adapterId;
    ::std::string replicaGroupId;
    ::Ice::ObjectPrx proxy;
    __is->read(adapterId);
    __is->read(replicaGroupId);
    __is->read(proxy);
    try
    {
        setAdapterDirectProxy(adapterId, replicaGroupId, proxy, __current);
    }
    catch(const ::IceGrid::AdapterExistsException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    catch(const ::IceGrid::AdapterNotExistException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::ReplicaSession::___receivedUpdate(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::TopicName name;
    ::Ice::Int serial;
    ::std::string failure;
    ::IceGrid::__read(__is, name);
    __is->read(serial);
    __is->read(failure);
    receivedUpdate(name, serial, failure, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::ReplicaSession::___destroy(::IceInternal::Incoming&, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    destroy(__current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__ReplicaSession_all[] =
{
    "destroy",
    "getTimeout",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "keepAlive",
    "receivedUpdate",
    "registerWellKnownObjects",
    "setAdapterDirectProxy",
    "setDatabaseObserver",
    "setEndpoints"
};

::IceInternal::DispatchStatus
IceGrid::ReplicaSession::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__ReplicaSession_all, __IceGrid__ReplicaSession_all + 12, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__ReplicaSession_all)
    {
        case 0:
        {
            return ___destroy(in, current);
        }
        case 1:
        {
            return ___getTimeout(in, current);
        }
        case 2:
        {
            return ___ice_id(in, current);
        }
        case 3:
        {
            return ___ice_ids(in, current);
        }
        case 4:
        {
            return ___ice_isA(in, current);
        }
        case 5:
        {
            return ___ice_ping(in, current);
        }
        case 6:
        {
            return ___keepAlive(in, current);
        }
        case 7:
        {
            return ___receivedUpdate(in, current);
        }
        case 8:
        {
            return ___registerWellKnownObjects(in, current);
        }
        case 9:
        {
            return ___setAdapterDirectProxy(in, current);
        }
        case 10:
        {
            return ___setDatabaseObserver(in, current);
        }
        case 11:
        {
            return ___setEndpoints(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::ReplicaSession::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::ReplicaSession::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::ReplicaSession::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ReplicaSession was not generated with stream support";
    throw ex;
}

void
IceGrid::ReplicaSession::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::ReplicaSession was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__ReplicaSessionPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::ReplicaSessionPtr* p = static_cast< ::IceGrid::ReplicaSessionPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::ReplicaSessionPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::ReplicaSession::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::ReplicaSession& l, const ::IceGrid::ReplicaSession& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::ReplicaSession& l, const ::IceGrid::ReplicaSession& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::ReplicaSession& l, const ::IceGrid::ReplicaSession& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::ReplicaSession& l, const ::IceGrid::ReplicaSession& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::ReplicaSession& l, const ::IceGrid::ReplicaSession& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::ReplicaSession& l, const ::IceGrid::ReplicaSession& r)
{
    return !(l < r);
}

IceGrid::InternalNodeInfo::InternalNodeInfo(const ::std::string& __ice_name, const ::std::string& __ice_os, const ::std::string& __ice_hostname, const ::std::string& __ice_release, const ::std::string& __ice_version, const ::std::string& __ice_machine, ::Ice::Int __ice_nProcessors, const ::std::string& __ice_dataDir) :
    name(__ice_name),
    os(__ice_os),
    hostname(__ice_hostname),
    release(__ice_release),
    version(__ice_version),
    machine(__ice_machine),
    nProcessors(__ice_nProcessors),
    dataDir(__ice_dataDir)
{
}

::Ice::ObjectPtr
IceGrid::InternalNodeInfo::ice_clone() const
{
    ::IceGrid::InternalNodeInfoPtr __p = new ::IceGrid::InternalNodeInfo(*this);
    return __p;
}

static const ::std::string __IceGrid__InternalNodeInfo_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::InternalNodeInfo"
};

bool
IceGrid::InternalNodeInfo::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__InternalNodeInfo_ids, __IceGrid__InternalNodeInfo_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::InternalNodeInfo::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__InternalNodeInfo_ids[0], &__IceGrid__InternalNodeInfo_ids[2]);
}

const ::std::string&
IceGrid::InternalNodeInfo::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__InternalNodeInfo_ids[1];
}

const ::std::string&
IceGrid::InternalNodeInfo::ice_staticId()
{
    return __IceGrid__InternalNodeInfo_ids[1];
}

void
IceGrid::InternalNodeInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(name);
    __os->write(os);
    __os->write(hostname);
    __os->write(release);
    __os->write(version);
    __os->write(machine);
    __os->write(nProcessors);
    __os->write(dataDir);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::InternalNodeInfo::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(name);
    __is->read(os);
    __is->read(hostname);
    __is->read(release);
    __is->read(version);
    __is->read(machine);
    __is->read(nProcessors);
    __is->read(dataDir);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::InternalNodeInfo::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalNodeInfo was not generated with stream support";
    throw ex;
}

void
IceGrid::InternalNodeInfo::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalNodeInfo was not generated with stream support";
    throw ex;
}

class __F__IceGrid__InternalNodeInfo : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::IceGrid::InternalNodeInfo::ice_staticId());
        return new ::IceGrid::InternalNodeInfo;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__IceGrid__InternalNodeInfo_Ptr = new __F__IceGrid__InternalNodeInfo;

const ::Ice::ObjectFactoryPtr&
IceGrid::InternalNodeInfo::ice_factory()
{
    return __F__IceGrid__InternalNodeInfo_Ptr;
}

class __F__IceGrid__InternalNodeInfo__Init
{
public:

    __F__IceGrid__InternalNodeInfo__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::IceGrid::InternalNodeInfo::ice_staticId(), ::IceGrid::InternalNodeInfo::ice_factory());
    }

    ~__F__IceGrid__InternalNodeInfo__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::IceGrid::InternalNodeInfo::ice_staticId());
    }
};

static __F__IceGrid__InternalNodeInfo__Init __F__IceGrid__InternalNodeInfo__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__InternalNodeInfo__initializer() {} }
#endif

void ICE_GRID_API 
IceGrid::__patch__InternalNodeInfoPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::InternalNodeInfoPtr* p = static_cast< ::IceGrid::InternalNodeInfoPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::InternalNodeInfoPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::InternalNodeInfo::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::InternalNodeInfo& l, const ::IceGrid::InternalNodeInfo& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::InternalNodeInfo& l, const ::IceGrid::InternalNodeInfo& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::InternalNodeInfo& l, const ::IceGrid::InternalNodeInfo& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::InternalNodeInfo& l, const ::IceGrid::InternalNodeInfo& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::InternalNodeInfo& l, const ::IceGrid::InternalNodeInfo& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::InternalNodeInfo& l, const ::IceGrid::InternalNodeInfo& r)
{
    return !(l < r);
}

IceGrid::InternalReplicaInfo::InternalReplicaInfo(const ::std::string& __ice_name, const ::std::string& __ice_hostname) :
    name(__ice_name),
    hostname(__ice_hostname)
{
}

::Ice::ObjectPtr
IceGrid::InternalReplicaInfo::ice_clone() const
{
    ::IceGrid::InternalReplicaInfoPtr __p = new ::IceGrid::InternalReplicaInfo(*this);
    return __p;
}

static const ::std::string __IceGrid__InternalReplicaInfo_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::InternalReplicaInfo"
};

bool
IceGrid::InternalReplicaInfo::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__InternalReplicaInfo_ids, __IceGrid__InternalReplicaInfo_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::InternalReplicaInfo::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__InternalReplicaInfo_ids[0], &__IceGrid__InternalReplicaInfo_ids[2]);
}

const ::std::string&
IceGrid::InternalReplicaInfo::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__InternalReplicaInfo_ids[1];
}

const ::std::string&
IceGrid::InternalReplicaInfo::ice_staticId()
{
    return __IceGrid__InternalReplicaInfo_ids[1];
}

void
IceGrid::InternalReplicaInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(name);
    __os->write(hostname);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::InternalReplicaInfo::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(name);
    __is->read(hostname);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::InternalReplicaInfo::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalReplicaInfo was not generated with stream support";
    throw ex;
}

void
IceGrid::InternalReplicaInfo::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalReplicaInfo was not generated with stream support";
    throw ex;
}

class __F__IceGrid__InternalReplicaInfo : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::IceGrid::InternalReplicaInfo::ice_staticId());
        return new ::IceGrid::InternalReplicaInfo;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__IceGrid__InternalReplicaInfo_Ptr = new __F__IceGrid__InternalReplicaInfo;

const ::Ice::ObjectFactoryPtr&
IceGrid::InternalReplicaInfo::ice_factory()
{
    return __F__IceGrid__InternalReplicaInfo_Ptr;
}

class __F__IceGrid__InternalReplicaInfo__Init
{
public:

    __F__IceGrid__InternalReplicaInfo__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::IceGrid::InternalReplicaInfo::ice_staticId(), ::IceGrid::InternalReplicaInfo::ice_factory());
    }

    ~__F__IceGrid__InternalReplicaInfo__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::IceGrid::InternalReplicaInfo::ice_staticId());
    }
};

static __F__IceGrid__InternalReplicaInfo__Init __F__IceGrid__InternalReplicaInfo__i;

#ifdef __APPLE__
extern "C" { void __F__IceGrid__InternalReplicaInfo__initializer() {} }
#endif

void ICE_GRID_API 
IceGrid::__patch__InternalReplicaInfoPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::InternalReplicaInfoPtr* p = static_cast< ::IceGrid::InternalReplicaInfoPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::InternalReplicaInfoPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::InternalReplicaInfo::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::InternalReplicaInfo& l, const ::IceGrid::InternalReplicaInfo& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::InternalReplicaInfo& l, const ::IceGrid::InternalReplicaInfo& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::InternalReplicaInfo& l, const ::IceGrid::InternalReplicaInfo& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::InternalReplicaInfo& l, const ::IceGrid::InternalReplicaInfo& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::InternalReplicaInfo& l, const ::IceGrid::InternalReplicaInfo& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::InternalReplicaInfo& l, const ::IceGrid::InternalReplicaInfo& r)
{
    return !(l < r);
}

::Ice::ObjectPtr
IceGrid::InternalRegistry::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __IceGrid__InternalRegistry_ids[3] =
{
    "::Ice::Object",
    "::IceGrid::FileReader",
    "::IceGrid::InternalRegistry"
};

bool
IceGrid::InternalRegistry::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__InternalRegistry_ids, __IceGrid__InternalRegistry_ids + 3, _s);
}

::std::vector< ::std::string>
IceGrid::InternalRegistry::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__InternalRegistry_ids[0], &__IceGrid__InternalRegistry_ids[3]);
}

const ::std::string&
IceGrid::InternalRegistry::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__InternalRegistry_ids[2];
}

const ::std::string&
IceGrid::InternalRegistry::ice_staticId()
{
    return __IceGrid__InternalRegistry_ids[2];
}

::IceInternal::DispatchStatus
IceGrid::InternalRegistry::___registerNode(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceGrid::InternalNodeInfoPtr info;
    ::IceGrid::NodePrx prx;
    ::IceGrid::LoadInfo loadInf;
    __is->read(::IceGrid::__patch__InternalNodeInfoPtr, &info);
    ::IceGrid::__read(__is, prx);
    loadInf.__read(__is);
    __is->readPendingObjects();
    try
    {
        ::IceGrid::NodeSessionPrx __ret = registerNode(info, prx, loadInf, __current);
        ::IceGrid::__write(__os, __ret);
    }
    catch(const ::IceGrid::NodeActiveException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::InternalRegistry::___registerReplica(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceGrid::InternalReplicaInfoPtr info;
    ::IceGrid::InternalRegistryPrx prx;
    __is->read(::IceGrid::__patch__InternalReplicaInfoPtr, &info);
    ::IceGrid::__read(__is, prx);
    __is->readPendingObjects();
    try
    {
        ::IceGrid::ReplicaSessionPrx __ret = registerReplica(info, prx, __current);
        ::IceGrid::__write(__os, __ret);
    }
    catch(const ::IceGrid::ReplicaActiveException& __ex)
    {
        __os->write(__ex);
        return ::IceInternal::DispatchUserException;
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::InternalRegistry::___registerWithReplica(::IceInternal::Incoming&__inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    ::IceGrid::InternalRegistryPrx prx;
    ::IceGrid::__read(__is, prx);
    registerWithReplica(prx, __current);
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::InternalRegistry::___getNodes(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceGrid::NodePrxSeq __ret = getNodes(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceGrid::__write(__os, &__ret[0], &__ret[0] + __ret.size(), ::IceGrid::__U__NodePrxSeq());
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::InternalRegistry::___getReplicas(::IceInternal::Incoming&__inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __os = __inS.os();
    ::IceGrid::InternalRegistryPrxSeq __ret = getReplicas(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::IceGrid::__write(__os, &__ret[0], &__ret[0] + __ret.size(), ::IceGrid::__U__InternalRegistryPrxSeq());
    }
    return ::IceInternal::DispatchOK;
}

::IceInternal::DispatchStatus
IceGrid::InternalRegistry::___shutdown(::IceInternal::Incoming&, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    shutdown(__current);
    return ::IceInternal::DispatchOK;
}

static ::std::string __IceGrid__InternalRegistry_all[] =
{
    "getNodes",
    "getOffsetFromEnd",
    "getReplicas",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "read",
    "registerNode",
    "registerReplica",
    "registerWithReplica",
    "shutdown"
};

::IceInternal::DispatchStatus
IceGrid::InternalRegistry::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__IceGrid__InternalRegistry_all, __IceGrid__InternalRegistry_all + 12, current.operation);
    if(r.first == r.second)
    {
        return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __IceGrid__InternalRegistry_all)
    {
        case 0:
        {
            return ___getNodes(in, current);
        }
        case 1:
        {
            return ___getOffsetFromEnd(in, current);
        }
        case 2:
        {
            return ___getReplicas(in, current);
        }
        case 3:
        {
            return ___ice_id(in, current);
        }
        case 4:
        {
            return ___ice_ids(in, current);
        }
        case 5:
        {
            return ___ice_isA(in, current);
        }
        case 6:
        {
            return ___ice_ping(in, current);
        }
        case 7:
        {
            return ___read(in, current);
        }
        case 8:
        {
            return ___registerNode(in, current);
        }
        case 9:
        {
            return ___registerReplica(in, current);
        }
        case 10:
        {
            return ___registerWithReplica(in, current);
        }
        case 11:
        {
            return ___shutdown(in, current);
        }
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
IceGrid::InternalRegistry::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
IceGrid::InternalRegistry::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
IceGrid::InternalRegistry::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalRegistry was not generated with stream support";
    throw ex;
}

void
IceGrid::InternalRegistry::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type IceGrid::InternalRegistry was not generated with stream support";
    throw ex;
}

void ICE_GRID_API 
IceGrid::__patch__InternalRegistryPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::IceGrid::InternalRegistryPtr* p = static_cast< ::IceGrid::InternalRegistryPtr*>(__addr);
    assert(p);
    *p = ::IceGrid::InternalRegistryPtr::dynamicCast(v);
    if(v && !*p)
    {
        ::Ice::UnexpectedObjectException e(__FILE__, __LINE__);
        e.type = v->ice_id();
        e.expectedType = ::IceGrid::InternalRegistry::ice_staticId();
        throw e;
    }
}

bool
IceGrid::operator==(const ::IceGrid::InternalRegistry& l, const ::IceGrid::InternalRegistry& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator!=(const ::IceGrid::InternalRegistry& l, const ::IceGrid::InternalRegistry& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<(const ::IceGrid::InternalRegistry& l, const ::IceGrid::InternalRegistry& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

bool
IceGrid::operator<=(const ::IceGrid::InternalRegistry& l, const ::IceGrid::InternalRegistry& r)
{
    return l < r || l == r;
}

bool
IceGrid::operator>(const ::IceGrid::InternalRegistry& l, const ::IceGrid::InternalRegistry& r)
{
    return !(l < r) && !(l == r);
}

bool
IceGrid::operator>=(const ::IceGrid::InternalRegistry& l, const ::IceGrid::InternalRegistry& r)
{
    return !(l < r);
}

static const char* __sliceChecksums[] =
{
    "::IceGrid::Adapter", "cdcea08d3ac862a3f37b45e93d3516cf",
    "::IceGrid::AdapterActiveException", "9e82c6f52ae5b9b3dded4da03c1e68e8",
    "::IceGrid::AdapterExistsException", "103296618e9b935090172ac4b2a3cd6",
    "::IceGrid::AdapterNotActiveException", "7632b297a062f716b967442ccdeb1d5",
    "::IceGrid::AdapterPrxDict", "b1ad556aafdb114dc2761db172cf99a",
    "::IceGrid::DatabaseObserver", "53301c4475ff93212867232dc1dc3279",
    "::IceGrid::FileReader", "34d7c15576824a7bb03f3a9bdebe9d3e",
    "::IceGrid::InternalAdapterDescriptor", "4f5dff85cb69f8828588d994955b9",
    "::IceGrid::InternalAdapterDescriptorSeq", "c8e25d41d9125509ce869edc97951ea",
    "::IceGrid::InternalDbEnvDescriptor", "43b063bd2ede5da688de887658298f6d",
    "::IceGrid::InternalDbEnvDescriptorSeq", "0c74f576958516b314146ab4522f90",
    "::IceGrid::InternalDistributionDescriptor", "6993cce3aedd64cff0c1be09f51663d",
    "::IceGrid::InternalNodeInfo", "f4c1cad7a934c6a5405e542f5597a6f",
    "::IceGrid::InternalRegistry", "14d2efbd9b5fa23d33f6efb89307d20",
    "::IceGrid::InternalRegistryPrxSeq", "58708c5e95bc51953e8aa915ef989f7a",
    "::IceGrid::InternalReplicaInfo", "83a38a194bb3a225b57fa7d3232c4f6",
    "::IceGrid::InternalServerDescriptor", "59ac3e29239c6da932b4d6d222a759",
    "::IceGrid::Node", "1f3cc38ffdecb75cfd2a32febf50a7",
    "::IceGrid::NodeActiveException", "ab256cead26199fac7d4cbaac2a372d",
    "::IceGrid::NodePrxSeq", "613421b8e9538ceadd9baeb198c83716",
    "::IceGrid::NodeSession", "b5106acfb96f34efc3f872265f179a7",
    "::IceGrid::PatcherFeedback", "b89b6c26e96a271336302120d3abb5b1",
    "::IceGrid::PropertyDescriptorSeqDict", "ff2c8d165b85af94f3869734b1477b0",
    "::IceGrid::ReplicaActiveException", "9a58f1c394a8e4356971cbb8c9aa27e6",
    "::IceGrid::ReplicaObserver", "282c75598b4b27f617e712d4c82610bf",
    "::IceGrid::ReplicaSession", "d8e4954160aa713ecaebe52b47de3fe",
    "::IceGrid::Server", "ba99f1c9bc43f2b99c6285e18aa27e10",
    "::IceGrid::TopicName", "81b0c4d6778ad5390ac9867409d486",
    0
};
static IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);
