// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `IceStormInternal.ice'

#ifndef __IceStorm_IceStormInternal_h__
#define __IceStorm_IceStormInternal_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/OutgoingAsync.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <IceStorm/IceStorm.h>
#include <Ice/Current.h>
#include <Ice/BuiltinSequences.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

#ifndef ICE_STORM_API
#   ifdef ICE_STORM_API_EXPORTS
#       define ICE_STORM_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_STORM_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace IceStorm
{

class TopicLink;
ICE_STORM_API bool operator==(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator!=(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator<(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator<=(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator>(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator>=(const TopicLink&, const TopicLink&);

class TopicInternal;
ICE_STORM_API bool operator==(const TopicInternal&, const TopicInternal&);
ICE_STORM_API bool operator!=(const TopicInternal&, const TopicInternal&);
ICE_STORM_API bool operator<(const TopicInternal&, const TopicInternal&);
ICE_STORM_API bool operator<=(const TopicInternal&, const TopicInternal&);
ICE_STORM_API bool operator>(const TopicInternal&, const TopicInternal&);
ICE_STORM_API bool operator>=(const TopicInternal&, const TopicInternal&);

}

}

namespace IceStorm
{

class TopicLink;
ICE_STORM_API bool operator==(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator!=(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator<(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator<=(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator>(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator>=(const TopicLink&, const TopicLink&);

class TopicInternal;
ICE_STORM_API bool operator==(const TopicInternal&, const TopicInternal&);
ICE_STORM_API bool operator!=(const TopicInternal&, const TopicInternal&);
ICE_STORM_API bool operator<(const TopicInternal&, const TopicInternal&);
ICE_STORM_API bool operator<=(const TopicInternal&, const TopicInternal&);
ICE_STORM_API bool operator>(const TopicInternal&, const TopicInternal&);
ICE_STORM_API bool operator>=(const TopicInternal&, const TopicInternal&);

}

namespace IceInternal
{

ICE_STORM_API void incRef(::IceStorm::TopicLink*);
ICE_STORM_API void decRef(::IceStorm::TopicLink*);

ICE_STORM_API void incRef(::IceProxy::IceStorm::TopicLink*);
ICE_STORM_API void decRef(::IceProxy::IceStorm::TopicLink*);

ICE_STORM_API void incRef(::IceStorm::TopicInternal*);
ICE_STORM_API void decRef(::IceStorm::TopicInternal*);

ICE_STORM_API void incRef(::IceProxy::IceStorm::TopicInternal*);
ICE_STORM_API void decRef(::IceProxy::IceStorm::TopicInternal*);

}

namespace IceStorm
{

typedef ::IceInternal::Handle< ::IceStorm::TopicLink> TopicLinkPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceStorm::TopicLink> TopicLinkPrx;

ICE_STORM_API void __write(::IceInternal::BasicStream*, const TopicLinkPrx&);
ICE_STORM_API void __read(::IceInternal::BasicStream*, TopicLinkPrx&);
ICE_STORM_API void __write(::IceInternal::BasicStream*, const TopicLinkPtr&);
ICE_STORM_API void __patch__TopicLinkPtr(void*, ::Ice::ObjectPtr&);

ICE_STORM_API void __addObject(const TopicLinkPtr&, ::IceInternal::GCCountMap&);
ICE_STORM_API bool __usesClasses(const TopicLinkPtr&);
ICE_STORM_API void __decRefUnsafe(const TopicLinkPtr&);
ICE_STORM_API void __clearHandleUnsafe(TopicLinkPtr&);

typedef ::IceInternal::Handle< ::IceStorm::TopicInternal> TopicInternalPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceStorm::TopicInternal> TopicInternalPrx;

ICE_STORM_API void __write(::IceInternal::BasicStream*, const TopicInternalPrx&);
ICE_STORM_API void __read(::IceInternal::BasicStream*, TopicInternalPrx&);
ICE_STORM_API void __write(::IceInternal::BasicStream*, const TopicInternalPtr&);
ICE_STORM_API void __patch__TopicInternalPtr(void*, ::Ice::ObjectPtr&);

ICE_STORM_API void __addObject(const TopicInternalPtr&, ::IceInternal::GCCountMap&);
ICE_STORM_API bool __usesClasses(const TopicInternalPtr&);
ICE_STORM_API void __decRefUnsafe(const TopicInternalPtr&);
ICE_STORM_API void __clearHandleUnsafe(TopicInternalPtr&);

}

namespace IceStorm
{

class ICE_STORM_API EventData : public IceUtil::Shared
{
public:
    
    EventData() {}
    EventData(const ::std::string&, ::Ice::OperationMode, const ::Ice::ByteSeq&, const ::Ice::Context&);
    ::std::string op;
    ::Ice::OperationMode mode;
    ::Ice::ByteSeq data;
    ::Ice::Context context;

    bool operator==(const EventData&) const;
    bool operator!=(const EventData&) const;
    bool operator<(const EventData&) const;
    bool operator<=(const EventData& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const EventData& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const EventData& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::IceUtil::Handle< ::IceStorm::EventData> EventDataPtr;

typedef ::std::vector< ::IceStorm::EventDataPtr> EventDataSeq;

class __U__EventDataSeq { };
ICE_STORM_API void __write(::IceInternal::BasicStream*, const ::IceStorm::EventDataPtr*, const ::IceStorm::EventDataPtr*, __U__EventDataSeq);
ICE_STORM_API void __read(::IceInternal::BasicStream*, EventDataSeq&, __U__EventDataSeq);

}

namespace IceStorm
{

class ICE_STORM_API AMI_TopicLink_forward : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::IceStorm::TopicLinkPrx&, const ::IceStorm::EventDataSeq&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceStorm::AMI_TopicLink_forward> AMI_TopicLink_forwardPtr;

}

namespace IceProxy
{

namespace IceStorm
{

class ICE_STORM_API TopicLink : virtual public ::IceProxy::Ice::Object
{
public:

    void forward(const ::IceStorm::EventDataSeq& events)
    {
        forward(events, 0);
    }
    void forward(const ::IceStorm::EventDataSeq& events, const ::Ice::Context& __ctx)
    {
        forward(events, &__ctx);
    }
    
private:

    void forward(const ::IceStorm::EventDataSeq&, const ::Ice::Context*);
    
public:
    void forward_async(const ::IceStorm::AMI_TopicLink_forwardPtr&, const ::IceStorm::EventDataSeq&);
    void forward_async(const ::IceStorm::AMI_TopicLink_forwardPtr&, const ::IceStorm::EventDataSeq&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class ICE_STORM_API TopicInternal : virtual public ::IceProxy::IceStorm::Topic
{
public:

    ::IceStorm::TopicLinkPrx getLinkProxy()
    {
        return getLinkProxy(0);
    }
    ::IceStorm::TopicLinkPrx getLinkProxy(const ::Ice::Context& __ctx)
    {
        return getLinkProxy(&__ctx);
    }
    
private:

    ::IceStorm::TopicLinkPrx getLinkProxy(const ::Ice::Context*);
    
public:
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace IceStorm
{

class ICE_STORM_API TopicLink : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void forward(const ::IceStorm::EventDataSeq&, const ::Ice::Context*) = 0;
};

class ICE_STORM_API TopicInternal : virtual public ::IceDelegate::IceStorm::Topic
{
public:

    virtual ::IceStorm::TopicLinkPrx getLinkProxy(const ::Ice::Context*) = 0;
};

}

}

namespace IceDelegateM
{

namespace IceStorm
{

class ICE_STORM_API TopicLink : virtual public ::IceDelegate::IceStorm::TopicLink,
                                virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void forward(const ::IceStorm::EventDataSeq&, const ::Ice::Context*);
};

class ICE_STORM_API TopicInternal : virtual public ::IceDelegate::IceStorm::TopicInternal,
                                    virtual public ::IceDelegateM::IceStorm::Topic
{
public:

    virtual ::IceStorm::TopicLinkPrx getLinkProxy(const ::Ice::Context*);
};

}

}

namespace IceDelegateD
{

namespace IceStorm
{

class ICE_STORM_API TopicLink : virtual public ::IceDelegate::IceStorm::TopicLink,
                                virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void forward(const ::IceStorm::EventDataSeq&, const ::Ice::Context*);
};

class ICE_STORM_API TopicInternal : virtual public ::IceDelegate::IceStorm::TopicInternal,
                                    virtual public ::IceDelegateD::IceStorm::Topic
{
public:

    virtual ::IceStorm::TopicLinkPrx getLinkProxy(const ::Ice::Context*);
};

}

}

namespace IceStorm
{

class ICE_STORM_API TopicLink : virtual public ::Ice::Object
{
public:

    typedef TopicLinkPrx ProxyType;
    typedef TopicLinkPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void forward(const ::IceStorm::EventDataSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___forward(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void ICE_STORM_API __patch__TopicLinkPtr(void*, ::Ice::ObjectPtr&);

class ICE_STORM_API TopicInternal : virtual public ::IceStorm::Topic
{
public:

    typedef TopicInternalPrx ProxyType;
    typedef TopicInternalPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::IceStorm::TopicLinkPrx getLinkProxy(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___getLinkProxy(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void ICE_STORM_API __patch__TopicInternalPtr(void*, ::Ice::ObjectPtr&);

}

#endif
