// **********************************************************************
//
// Copyright (c) 2003-2007 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.2.1
// Generated from file `LinkRecord.ice'

#ifndef __IceStorm_LinkRecord_h__
#define __IceStorm_LinkRecord_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Identity.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 302
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

#ifndef ICE_STORM_API
#   ifdef ICE_STORM_API_EXPORTS
#       define ICE_STORM_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_STORM_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace IceStorm
{

class TopicLink;
ICE_STORM_API bool operator==(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator!=(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator<(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator<=(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator>(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator>=(const TopicLink&, const TopicLink&);

class Topic;
ICE_STORM_API bool operator==(const Topic&, const Topic&);
ICE_STORM_API bool operator!=(const Topic&, const Topic&);
ICE_STORM_API bool operator<(const Topic&, const Topic&);
ICE_STORM_API bool operator<=(const Topic&, const Topic&);
ICE_STORM_API bool operator>(const Topic&, const Topic&);
ICE_STORM_API bool operator>=(const Topic&, const Topic&);

}

}

namespace IceStorm
{

class TopicLink;
ICE_STORM_API bool operator==(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator!=(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator<(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator<=(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator>(const TopicLink&, const TopicLink&);
ICE_STORM_API bool operator>=(const TopicLink&, const TopicLink&);

class Topic;
ICE_STORM_API bool operator==(const Topic&, const Topic&);
ICE_STORM_API bool operator!=(const Topic&, const Topic&);
ICE_STORM_API bool operator<(const Topic&, const Topic&);
ICE_STORM_API bool operator<=(const Topic&, const Topic&);
ICE_STORM_API bool operator>(const Topic&, const Topic&);
ICE_STORM_API bool operator>=(const Topic&, const Topic&);

}

namespace IceInternal
{

ICE_STORM_API void incRef(::IceStorm::TopicLink*);
ICE_STORM_API void decRef(::IceStorm::TopicLink*);

ICE_STORM_API void incRef(::IceProxy::IceStorm::TopicLink*);
ICE_STORM_API void decRef(::IceProxy::IceStorm::TopicLink*);

ICE_STORM_API void incRef(::IceStorm::Topic*);
ICE_STORM_API void decRef(::IceStorm::Topic*);

ICE_STORM_API void incRef(::IceProxy::IceStorm::Topic*);
ICE_STORM_API void decRef(::IceProxy::IceStorm::Topic*);

}

namespace IceStorm
{

typedef ::IceInternal::Handle< ::IceStorm::TopicLink> TopicLinkPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceStorm::TopicLink> TopicLinkPrx;

ICE_STORM_API void __write(::IceInternal::BasicStream*, const TopicLinkPrx&);
ICE_STORM_API void __read(::IceInternal::BasicStream*, TopicLinkPrx&);
ICE_STORM_API void __write(::IceInternal::BasicStream*, const TopicLinkPtr&);
ICE_STORM_API void __patch__TopicLinkPtr(void*, ::Ice::ObjectPtr&);

ICE_STORM_API void __addObject(const TopicLinkPtr&, ::IceInternal::GCCountMap&);
ICE_STORM_API bool __usesClasses(const TopicLinkPtr&);
ICE_STORM_API void __decRefUnsafe(const TopicLinkPtr&);
ICE_STORM_API void __clearHandleUnsafe(TopicLinkPtr&);

typedef ::IceInternal::Handle< ::IceStorm::Topic> TopicPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceStorm::Topic> TopicPrx;

ICE_STORM_API void __write(::IceInternal::BasicStream*, const TopicPrx&);
ICE_STORM_API void __read(::IceInternal::BasicStream*, TopicPrx&);
ICE_STORM_API void __write(::IceInternal::BasicStream*, const TopicPtr&);
ICE_STORM_API void __patch__TopicPtr(void*, ::Ice::ObjectPtr&);

ICE_STORM_API void __addObject(const TopicPtr&, ::IceInternal::GCCountMap&);
ICE_STORM_API bool __usesClasses(const TopicPtr&);
ICE_STORM_API void __decRefUnsafe(const TopicPtr&);
ICE_STORM_API void __clearHandleUnsafe(TopicPtr&);

}

namespace IceStorm
{

struct LinkRecord
{
    ::IceStorm::TopicLinkPrx obj;
    ::Ice::Int cost;
    ::IceStorm::TopicPrx theTopic;

    ICE_STORM_API bool operator==(const LinkRecord&) const;
    ICE_STORM_API bool operator!=(const LinkRecord&) const;
    ICE_STORM_API bool operator<(const LinkRecord&) const;
    ICE_STORM_API bool operator<=(const LinkRecord& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    ICE_STORM_API bool operator>(const LinkRecord& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    ICE_STORM_API bool operator>=(const LinkRecord& __rhs) const
    {
        return !operator<(__rhs);
    }

    ICE_STORM_API void __write(::IceInternal::BasicStream*) const;
    ICE_STORM_API void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::IceStorm::LinkRecord> LinkRecordSeq;

class __U__LinkRecordSeq { };
ICE_STORM_API void __write(::IceInternal::BasicStream*, const ::IceStorm::LinkRecord*, const ::IceStorm::LinkRecord*, __U__LinkRecordSeq);
ICE_STORM_API void __read(::IceInternal::BasicStream*, LinkRecordSeq&, __U__LinkRecordSeq);

}

namespace IceProxy
{

namespace IceStorm
{

}

}

namespace IceDelegate
{

namespace IceStorm
{

}

}

namespace IceDelegateM
{

namespace IceStorm
{

}

}

namespace IceDelegateD
{

namespace IceStorm
{

}

}

#endif
